/*
 * This file was generated automatically by ExtUtils::ParseXS version 3.51 from the
 * contents of Guestfs.xs. Do not edit this file, edit Guestfs.xs instead.
 *
 *    ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "lib/Sys/Guestfs.xs"
/* libguestfs generated file
 * WARNING: THIS FILE IS GENERATED FROM THE FOLLOWING FILES:
 *          generator/perl.ml
 *          and from the code in the generator/ subdirectory.
 * ANY CHANGES YOU MAKE TO THIS FILE WILL BE LOST.
 *
 * Copyright (C) 2009-2023 Red Hat Inc.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 */

#include <config.h>

/* It is safe to call deprecated functions from this file. */
#define GUESTFS_NO_WARN_DEPRECATED
#undef GUESTFS_NO_DEPRECATED

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <inttypes.h>
#include <errno.h>

#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

/* perl CORE/config.h defines '_' to something completely bonkers. */
#ifdef _
#undef _
#endif

#include <guestfs.h>
#include "guestfs-internal-all.h"

static SV *
my_newSVll(long long val) {
#ifdef USE_64_BIT_ALL
  return newSViv(val);
#else
  char buf[100];
  int len;
  len = snprintf(buf, 100, "%" PRId64, val);
  return newSVpv(buf, len);
#endif
}

static SV *
my_newSVull(unsigned long long val) {
#ifdef USE_64_BIT_ALL
  return newSVuv(val);
#else
  char buf[100];
  int len;
  len = snprintf(buf, 100, "%" PRIu64, val);
  return newSVpv(buf, len);
#endif
}

/* Convert a 64 bit int on input.  To cope with the case of having
 * a 32 bit Perl interpreter, we allow the user to pass a string
 * here which is scanned as a 64 bit integer.
 */
static int64_t
my_SvIV64 (SV *sv)
{
#ifdef USE_64_BIT_ALL
  return SvIV (sv);
#else
  if (SvTYPE (sv) == SVt_PV) {
    const char *str = SvPV_nolen (sv);
    int64_t r;

    sscanf (str, "%" SCNi64, &r);
    return r;
  }
  else
    return SvIV (sv);
#endif
}

/* http://www.perlmonks.org/?node_id=680842 */
static char **
XS_unpack_charPtrPtr (SV *arg) {
  char **ret;
  AV *av;
  I32 i;

  if (!arg || !SvOK (arg) || !SvROK (arg) || SvTYPE (SvRV (arg)) != SVt_PVAV)
    croak ("array reference expected");

  av = (AV *)SvRV (arg);
  ret = malloc ((av_len (av) + 1 + 1) * sizeof (char *));
  if (!ret)
    croak ("malloc failed");

  for (i = 0; i <= av_len (av); i++) {
    SV **elem = av_fetch (av, i, 0);

    if (!elem || !*elem) {
      free (ret);
      croak ("missing element in list");
    }

    ret[i] = SvPV_nolen (*elem);
  }

  ret[i] = NULL;

  return ret;
}

/* http://www.perlmonks.org/?node=338857 */
static void
_event_callback_wrapper (guestfs_h *g,
                         void *cb,
                         uint64_t event,
                         int event_handle,
                         int flags,
                         const char *buf, size_t buf_len,
                         const uint64_t *array, size_t array_len)
{
  dSP;
  ENTER;
  SAVETMPS;
  PUSHMARK (SP);
  XPUSHs (sv_2mortal (my_newSVull (event)));
  XPUSHs (sv_2mortal (newSViv (event_handle)));
  XPUSHs (sv_2mortal (newSVpvn (buf ? buf : "", buf_len)));
  AV *av = newAV ();
  size_t i;
  for (i = 0; i < array_len; ++i)
    av_push (av, my_newSVull (array[i]));
  XPUSHs (sv_2mortal (newRV ((SV *) av)));
  PUTBACK;
  call_sv ((SV *) cb, G_VOID | G_DISCARD | G_EVAL);
  FREETMPS;
  LEAVE;
}

static SV **
get_all_event_callbacks (guestfs_h *g, size_t *len_rtn)
{
  SV **r;
  size_t i;
  const char *key;
  SV *cb;

  /* Count the length of the array that will be needed. */
  *len_rtn = 0;
  cb = guestfs_first_private (g, &key);
  while (cb != NULL) {
    if (strncmp (key, "_perl_event_", strlen ("_perl_event_")) == 0)
      (*len_rtn)++;
    cb = guestfs_next_private (g, &key);
  }

  /* Copy them into the return array. */
  r = malloc (sizeof (SV *) * (*len_rtn));
  if (r == NULL) croak ("malloc: %m");

  i = 0;
  cb = guestfs_first_private (g, &key);
  while (cb != NULL) {
    if (strncmp (key, "_perl_event_", strlen ("_perl_event_")) == 0) {
      r[i] = cb;
      i++;
    }
    cb = guestfs_next_private (g, &key);
  }

  return r;
}

static void
_close_handle (guestfs_h *g)
{
  size_t i, len;
  SV **cbs;

  assert (g != NULL);

  /* As in the OCaml bindings, there is a hard to solve case where the
   * caller can delete a callback from within the callback, resulting
   * in a double-free here.  XXX
   */
  cbs = get_all_event_callbacks (g, &len);

  guestfs_close (g);

  for (i = 0; i < len; ++i)
    SvREFCNT_dec (cbs[i]);
  free (cbs);
}

#line 218 "lib/Sys/Guestfs.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef dVAR
#  define dVAR		dNOOP
#endif


/* This stuff is not part of the API! You have been warned. */
#ifndef PERL_VERSION_DECIMAL
#  define PERL_VERSION_DECIMAL(r,v,s) (r*1000000 + v*1000 + s)
#endif
#ifndef PERL_DECIMAL_VERSION
#  define PERL_DECIMAL_VERSION \
	  PERL_VERSION_DECIMAL(PERL_REVISION,PERL_VERSION,PERL_SUBVERSION)
#endif
#ifndef PERL_VERSION_GE
#  define PERL_VERSION_GE(r,v,s) \
	  (PERL_DECIMAL_VERSION >= PERL_VERSION_DECIMAL(r,v,s))
#endif
#ifndef PERL_VERSION_LE
#  define PERL_VERSION_LE(r,v,s) \
	  (PERL_DECIMAL_VERSION <= PERL_VERSION_DECIMAL(r,v,s))
#endif

/* XS_INTERNAL is the explicit static-linkage variant of the default
 * XS macro.
 *
 * XS_EXTERNAL is the same as XS_INTERNAL except it does not include
 * "STATIC", ie. it exports XSUB symbols. You probably don't want that
 * for anything but the BOOT XSUB.
 *
 * See XSUB.h in core!
 */


/* TODO: This might be compatible further back than 5.10.0. */
#if PERL_VERSION_GE(5, 10, 0) && PERL_VERSION_LE(5, 15, 1)
#  undef XS_EXTERNAL
#  undef XS_INTERNAL
#  if defined(__CYGWIN__) && defined(USE_DYNAMIC_LOADING)
#    define XS_EXTERNAL(name) __declspec(dllexport) XSPROTO(name)
#    define XS_INTERNAL(name) STATIC XSPROTO(name)
#  endif
#  if defined(__SYMBIAN32__)
#    define XS_EXTERNAL(name) EXPORT_C XSPROTO(name)
#    define XS_INTERNAL(name) EXPORT_C STATIC XSPROTO(name)
#  endif
#  ifndef XS_EXTERNAL
#    if defined(HASATTRIBUTE_UNUSED) && !defined(__cplusplus)
#      define XS_EXTERNAL(name) void name(pTHX_ CV* cv __attribute__unused__)
#      define XS_INTERNAL(name) STATIC void name(pTHX_ CV* cv __attribute__unused__)
#    else
#      ifdef __cplusplus
#        define XS_EXTERNAL(name) extern "C" XSPROTO(name)
#        define XS_INTERNAL(name) static XSPROTO(name)
#      else
#        define XS_EXTERNAL(name) XSPROTO(name)
#        define XS_INTERNAL(name) STATIC XSPROTO(name)
#      endif
#    endif
#  endif
#endif

/* perl >= 5.10.0 && perl <= 5.15.1 */


/* The XS_EXTERNAL macro is used for functions that must not be static
 * like the boot XSUB of a module. If perl didn't have an XS_EXTERNAL
 * macro defined, the best we can do is assume XS is the same.
 * Dito for XS_INTERNAL.
 */
#ifndef XS_EXTERNAL
#  define XS_EXTERNAL(name) XS(name)
#endif
#ifndef XS_INTERNAL
#  define XS_INTERNAL(name) XS(name)
#endif

/* Now, finally, after all this mess, we want an ExtUtils::ParseXS
 * internal macro that we're free to redefine for varying linkage due
 * to the EXPORT_XSUB_SYMBOLS XS keyword. This is internal, use
 * XS_EXTERNAL(name) or XS_INTERNAL(name) in your code if you need to!
 */

#undef XS_EUPXS
#if defined(PERL_EUPXS_ALWAYS_EXPORT)
#  define XS_EUPXS(name) XS_EXTERNAL(name)
#else
   /* default to internal */
#  define XS_EUPXS(name) XS_INTERNAL(name)
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
	    Perl_croak_nocontext("Usage: %s::%s(%s)", hvname, gvname, params);
        else
	    Perl_croak_nocontext("Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
	Perl_croak_nocontext("Usage: CODE(0x%" UVxf ")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#define croak_xs_usage        S_croak_xs_usage

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#if PERL_VERSION_LE(5, 21, 5)
#  define newXS_deffile(a,b) Perl_newXS(aTHX_ a,b,file)
#else
#  define newXS_deffile(a,b) Perl_newXS_deffile(aTHX_ a,b)
#endif

#line 362 "lib/Sys/Guestfs.c"

XS_EUPXS(XS_Sys__Guestfs__create); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs__create)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "flags");
    {
	unsigned	flags = (unsigned)SvUV(ST(0))
;
	guestfs_h *	RETVAL;
	dXSTARG;
#line 216 "lib/Sys/Guestfs.xs"
      RETVAL = guestfs_create_flags (flags);
      if (!RETVAL)
        croak ("could not create guestfs handle");
      guestfs_set_error_handler (RETVAL, NULL, NULL);
#line 380 "lib/Sys/Guestfs.c"
	XSprePUSH;
	PUSHi(PTR2IV (RETVAL));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Guestfs_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "sv");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	sv = ST(0)
;
#line 227 "lib/Sys/Guestfs.xs"
      /* For the 'g' argument above we do the conversion explicitly and
       * don't rely on the typemap, because if the handle has been
       * explicitly closed we don't want the typemap conversion to
       * display an error.
       */
      HV *hv = (HV *) SvRV (sv);
      SV **svp = hv_fetch (hv, "_g", 2, 0);
      if (svp != NULL) {
        guestfs_h *g = INT2PTR (guestfs_h *, SvIV (*svp));
        _close_handle (g);
      }
#line 411 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_close); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_close)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "g");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::close(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::close(): g is not a blessed HV reference");
    }
;
#line 243 "lib/Sys/Guestfs.xs"
      _close_handle (g);
      /* Avoid double-free in DESTROY method. */
      HV *hv = (HV *) SvRV (ST(0));
      (void) hv_delete (hv, "_g", 2, G_DISCARD);
#line 446 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_set_event_callback); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_set_event_callback)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "g, cb, event_bitmask");
    {
	guestfs_h *	g;
	SV *	cb = ST(1)
;
	int	event_bitmask = (int)SvIV(ST(2))
;
#line 254 "lib/Sys/Guestfs.xs"
      int eh;
      char key[64];
#line 468 "lib/Sys/Guestfs.c"
	SV *	RETVAL;

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::set_event_callback(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::set_event_callback(): g is not a blessed HV reference");
    }
;
#line 257 "lib/Sys/Guestfs.xs"
      eh = guestfs_set_event_callback (g, _event_callback_wrapper,
                                       event_bitmask, 0, cb);
      if (eh == -1)
        croak ("%s", guestfs_last_error (g));

      /* Increase the refcount for this callback, since we are storing
       * it in the opaque C libguestfs handle.  We need to remember that
       * we did this, so we can decrease the refcount for all undeleted
       * callbacks left around at close time (see _close_handle).
       */
      SvREFCNT_inc (cb);

      snprintf (key, sizeof key, "_perl_event_%d", eh);
      guestfs_set_private (g, key, cb);

      RETVAL = newSViv (eh);
#line 500 "lib/Sys/Guestfs.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Guestfs_delete_event_callback); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_delete_event_callback)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, event_handle");
    {
	guestfs_h *	g;
	int	event_handle = (int)SvIV(ST(1))
;
#line 281 "lib/Sys/Guestfs.xs"
      char key[64];
      SV *cb;
#line 521 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::delete_event_callback(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::delete_event_callback(): g is not a blessed HV reference");
    }
;
#line 284 "lib/Sys/Guestfs.xs"
      snprintf (key, sizeof key, "_perl_event_%d", event_handle);
      cb = guestfs_get_private (g, key);
      if (cb) {
        SvREFCNT_dec (cb);
        guestfs_set_private (g, key, NULL);
        guestfs_delete_event_callback (g, event_handle);
      }
#line 543 "lib/Sys/Guestfs.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Sys__Guestfs_event_to_string); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_event_to_string)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "event_bitmask");
    {
	int	event_bitmask = (int)SvIV(ST(0))
;
#line 296 "lib/Sys/Guestfs.xs"
      char *str;
#line 560 "lib/Sys/Guestfs.c"
	SV *	RETVAL;
#line 298 "lib/Sys/Guestfs.xs"
      str = guestfs_event_to_string (event_bitmask);
      if (str == NULL)
        croak ("%m");
      RETVAL = newSVpv (str, 0);
      free (str);
#line 568 "lib/Sys/Guestfs.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Guestfs_last_errno); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_last_errno)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "g");
    {
	guestfs_h *	g;
#line 310 "lib/Sys/Guestfs.xs"
      int errnum;
#line 586 "lib/Sys/Guestfs.c"
	SV *	RETVAL;

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::last_errno(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::last_errno(): g is not a blessed HV reference");
    }
;
#line 312 "lib/Sys/Guestfs.xs"
      errnum = guestfs_last_errno (g);
      RETVAL = newSViv (errnum);
#line 604 "lib/Sys/Guestfs.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Guestfs_acl_delete_def_file); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_acl_delete_def_file)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, dir");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	dir = (char *)SvPV_nolen(ST(1))
;
#line 322 "lib/Sys/Guestfs.xs"
      int r;
#line 626 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::acl_delete_def_file(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::acl_delete_def_file(): g is not a blessed HV reference");
    }
;
#line 324 "lib/Sys/Guestfs.xs"
      r = guestfs_acl_delete_def_file (g, dir);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 644 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_acl_get_file); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_acl_get_file)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "g, path, acltype");
    {
	guestfs_h *	g;
	char *	path = (char *)SvPV_nolen(ST(1))
;
	char *	acltype = (char *)SvPV_nolen(ST(2))
;
#line 334 "lib/Sys/Guestfs.xs"
      char *r;
#line 665 "lib/Sys/Guestfs.c"
	SV *	RETVAL;

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::acl_get_file(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::acl_get_file(): g is not a blessed HV reference");
    }
;
#line 336 "lib/Sys/Guestfs.xs"
      r = guestfs_acl_get_file (g, path, acltype);
      if (r == NULL)
        croak ("%s", guestfs_last_error (g));
      RETVAL = newSVpv (r, 0);
      free (r);
#line 686 "lib/Sys/Guestfs.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Guestfs_acl_set_file); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_acl_set_file)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "g, path, acltype, acl");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	path = (char *)SvPV_nolen(ST(1))
;
	char *	acltype = (char *)SvPV_nolen(ST(2))
;
	char *	acl = (char *)SvPV_nolen(ST(3))
;
#line 351 "lib/Sys/Guestfs.xs"
      int r;
#line 712 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::acl_set_file(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::acl_set_file(): g is not a blessed HV reference");
    }
;
#line 353 "lib/Sys/Guestfs.xs"
      r = guestfs_acl_set_file (g, path, acltype, acl);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 730 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_add_cdrom); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_add_cdrom)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, filename");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	filename = (char *)SvPV_nolen(ST(1))
;
#line 362 "lib/Sys/Guestfs.xs"
      int r;
#line 751 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::add_cdrom(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::add_cdrom(): g is not a blessed HV reference");
    }
;
#line 364 "lib/Sys/Guestfs.xs"
      Perl_ck_warner (aTHX_ packWARN(WARN_DEPRECATED),
        "Sys::Guestfs::add_cdrom is deprecated; use Sys::Guestfs::add_drive_ro instead");
      r = guestfs_add_cdrom (g, filename);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 771 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_add_domain); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_add_domain)
{
    dVAR; dXSARGS;
    if (items < 2)
       croak_xs_usage(cv,  "g, dom, ...");
    {
	guestfs_h *	g;
	char *	dom = (char *)SvPV_nolen(ST(1))
;
#line 375 "lib/Sys/Guestfs.xs"
      int r;
      struct guestfs_add_domain_argv optargs_s = { .bitmask = 0 };
      struct guestfs_add_domain_argv *optargs = &optargs_s;
      size_t items_i;
#line 793 "lib/Sys/Guestfs.c"
	SV *	RETVAL;

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::add_domain(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::add_domain(): g is not a blessed HV reference");
    }
;
#line 380 "lib/Sys/Guestfs.xs"
      if (((items - 2) & 1) != 0)
        croak ("expecting an even number of extra parameters");
      for (items_i = 2; items_i < items; items_i += 2) {
        uint64_t this_mask;
        const char *this_arg;

        this_arg = SvPV_nolen (ST (items_i));
        if (STREQ (this_arg, "libvirturi")) {
          optargs_s.libvirturi = SvPV_nolen (ST (items_i+1));
          this_mask = GUESTFS_ADD_DOMAIN_LIBVIRTURI_BITMASK;
        }
        else if (STREQ (this_arg, "readonly")) {
          optargs_s.readonly = SvIV (ST (items_i+1));
          this_mask = GUESTFS_ADD_DOMAIN_READONLY_BITMASK;
        }
        else if (STREQ (this_arg, "iface")) {
          optargs_s.iface = SvPV_nolen (ST (items_i+1));
          this_mask = GUESTFS_ADD_DOMAIN_IFACE_BITMASK;
        }
        else if (STREQ (this_arg, "live")) {
          optargs_s.live = SvIV (ST (items_i+1));
          this_mask = GUESTFS_ADD_DOMAIN_LIVE_BITMASK;
        }
        else if (STREQ (this_arg, "allowuuid")) {
          optargs_s.allowuuid = SvIV (ST (items_i+1));
          this_mask = GUESTFS_ADD_DOMAIN_ALLOWUUID_BITMASK;
        }
        else if (STREQ (this_arg, "readonlydisk")) {
          optargs_s.readonlydisk = SvPV_nolen (ST (items_i+1));
          this_mask = GUESTFS_ADD_DOMAIN_READONLYDISK_BITMASK;
        }
        else if (STREQ (this_arg, "cachemode")) {
          optargs_s.cachemode = SvPV_nolen (ST (items_i+1));
          this_mask = GUESTFS_ADD_DOMAIN_CACHEMODE_BITMASK;
        }
        else if (STREQ (this_arg, "discard")) {
          optargs_s.discard = SvPV_nolen (ST (items_i+1));
          this_mask = GUESTFS_ADD_DOMAIN_DISCARD_BITMASK;
        }
        else if (STREQ (this_arg, "copyonread")) {
          optargs_s.copyonread = SvIV (ST (items_i+1));
          this_mask = GUESTFS_ADD_DOMAIN_COPYONREAD_BITMASK;
        }
        else croak ("unknown optional argument '%s'", this_arg);
        if (optargs_s.bitmask & this_mask)
          croak ("optional argument '%s' given more than once",
                 this_arg);
        optargs_s.bitmask |= this_mask;
      }

      r = guestfs_add_domain_argv (g, dom, optargs);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
      RETVAL = newSViv (r);
#line 863 "lib/Sys/Guestfs.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Guestfs_add_drive); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_add_drive)
{
    dVAR; dXSARGS;
    if (items < 2)
       croak_xs_usage(cv,  "g, filename, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	filename = (char *)SvPV_nolen(ST(1))
;
#line 442 "lib/Sys/Guestfs.xs"
      int r;
      struct guestfs_add_drive_opts_argv optargs_s = { .bitmask = 0 };
      struct guestfs_add_drive_opts_argv *optargs = &optargs_s;
      size_t items_i;
#line 888 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::add_drive(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::add_drive(): g is not a blessed HV reference");
    }
;
#line 447 "lib/Sys/Guestfs.xs"
      if (((items - 2) & 1) != 0)
        croak ("expecting an even number of extra parameters");
      for (items_i = 2; items_i < items; items_i += 2) {
        uint64_t this_mask;
        const char *this_arg;

        this_arg = SvPV_nolen (ST (items_i));
        if (STREQ (this_arg, "readonly")) {
          optargs_s.readonly = SvIV (ST (items_i+1));
          this_mask = GUESTFS_ADD_DRIVE_OPTS_READONLY_BITMASK;
        }
        else if (STREQ (this_arg, "format")) {
          optargs_s.format = SvPV_nolen (ST (items_i+1));
          this_mask = GUESTFS_ADD_DRIVE_OPTS_FORMAT_BITMASK;
        }
        else if (STREQ (this_arg, "iface")) {
          optargs_s.iface = SvPV_nolen (ST (items_i+1));
          this_mask = GUESTFS_ADD_DRIVE_OPTS_IFACE_BITMASK;
        }
        else if (STREQ (this_arg, "name")) {
          optargs_s.name = SvPV_nolen (ST (items_i+1));
          this_mask = GUESTFS_ADD_DRIVE_OPTS_NAME_BITMASK;
        }
        else if (STREQ (this_arg, "label")) {
          optargs_s.label = SvPV_nolen (ST (items_i+1));
          this_mask = GUESTFS_ADD_DRIVE_OPTS_LABEL_BITMASK;
        }
        else if (STREQ (this_arg, "protocol")) {
          optargs_s.protocol = SvPV_nolen (ST (items_i+1));
          this_mask = GUESTFS_ADD_DRIVE_OPTS_PROTOCOL_BITMASK;
        }
        else if (STREQ (this_arg, "server")) {
          size_t i, len;
          char **r;
          SV *arg;
          AV *av;
          SV **svp;

          arg = ST (items_i+1);
          if (!SvROK (arg) || SvTYPE (SvRV (arg)) != SVt_PVAV)
            croak ("array reference expected for '%s' argument", "server");
          av = (AV *) SvRV (ST (items_i+1));

          /* Note av_len returns index of final element. */
          len = av_len (av) + 1;

          r = malloc ((len+1) * sizeof (char *));
          if (r == NULL) croak ("malloc: %m");
          for (i = 0; i < len; ++i) {
            svp = av_fetch (av, i, 0);
            r[i] = SvPV_nolen (*svp);
          }
          r[i] = NULL;
          optargs_s.server = r;
          this_mask = GUESTFS_ADD_DRIVE_OPTS_SERVER_BITMASK;
        }
        else if (STREQ (this_arg, "username")) {
          optargs_s.username = SvPV_nolen (ST (items_i+1));
          this_mask = GUESTFS_ADD_DRIVE_OPTS_USERNAME_BITMASK;
        }
        else if (STREQ (this_arg, "secret")) {
          optargs_s.secret = SvPV_nolen (ST (items_i+1));
          this_mask = GUESTFS_ADD_DRIVE_OPTS_SECRET_BITMASK;
        }
        else if (STREQ (this_arg, "cachemode")) {
          optargs_s.cachemode = SvPV_nolen (ST (items_i+1));
          this_mask = GUESTFS_ADD_DRIVE_OPTS_CACHEMODE_BITMASK;
        }
        else if (STREQ (this_arg, "discard")) {
          optargs_s.discard = SvPV_nolen (ST (items_i+1));
          this_mask = GUESTFS_ADD_DRIVE_OPTS_DISCARD_BITMASK;
        }
        else if (STREQ (this_arg, "copyonread")) {
          optargs_s.copyonread = SvIV (ST (items_i+1));
          this_mask = GUESTFS_ADD_DRIVE_OPTS_COPYONREAD_BITMASK;
        }
        else if (STREQ (this_arg, "blocksize")) {
          optargs_s.blocksize = SvIV (ST (items_i+1));
          this_mask = GUESTFS_ADD_DRIVE_OPTS_BLOCKSIZE_BITMASK;
        }
        else croak ("unknown optional argument '%s'", this_arg);
        if (optargs_s.bitmask & this_mask)
          croak ("optional argument '%s' given more than once",
                 this_arg);
        optargs_s.bitmask |= this_mask;
      }

      r = guestfs_add_drive_opts_argv (g, filename, optargs);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 993 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_add_drive_ro); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_add_drive_ro)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, filename");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	filename = (char *)SvPV_nolen(ST(1))
;
#line 543 "lib/Sys/Guestfs.xs"
      int r;
#line 1014 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::add_drive_ro(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::add_drive_ro(): g is not a blessed HV reference");
    }
;
#line 545 "lib/Sys/Guestfs.xs"
      r = guestfs_add_drive_ro (g, filename);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 1032 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_add_drive_ro_with_if); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_add_drive_ro_with_if)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "g, filename, iface");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	filename = (char *)SvPV_nolen(ST(1))
;
	char *	iface = (char *)SvPV_nolen(ST(2))
;
#line 555 "lib/Sys/Guestfs.xs"
      int r;
#line 1055 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::add_drive_ro_with_if(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::add_drive_ro_with_if(): g is not a blessed HV reference");
    }
;
#line 557 "lib/Sys/Guestfs.xs"
      Perl_ck_warner (aTHX_ packWARN(WARN_DEPRECATED),
        "Sys::Guestfs::add_drive_ro_with_if is deprecated; use Sys::Guestfs::add_drive instead");
      r = guestfs_add_drive_ro_with_if (g, filename, iface);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 1075 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_add_drive_scratch); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_add_drive_scratch)
{
    dVAR; dXSARGS;
    if (items < 2)
       croak_xs_usage(cv,  "g, size, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	int64_t    size = my_SvIV64 (ST(1))
;
#line 568 "lib/Sys/Guestfs.xs"
      int r;
      struct guestfs_add_drive_scratch_argv optargs_s = { .bitmask = 0 };
      struct guestfs_add_drive_scratch_argv *optargs = &optargs_s;
      size_t items_i;
#line 1099 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::add_drive_scratch(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::add_drive_scratch(): g is not a blessed HV reference");
    }
;
#line 573 "lib/Sys/Guestfs.xs"
      if (((items - 2) & 1) != 0)
        croak ("expecting an even number of extra parameters");
      for (items_i = 2; items_i < items; items_i += 2) {
        uint64_t this_mask;
        const char *this_arg;

        this_arg = SvPV_nolen (ST (items_i));
        if (STREQ (this_arg, "name")) {
          optargs_s.name = SvPV_nolen (ST (items_i+1));
          this_mask = GUESTFS_ADD_DRIVE_SCRATCH_NAME_BITMASK;
        }
        else if (STREQ (this_arg, "label")) {
          optargs_s.label = SvPV_nolen (ST (items_i+1));
          this_mask = GUESTFS_ADD_DRIVE_SCRATCH_LABEL_BITMASK;
        }
        else if (STREQ (this_arg, "blocksize")) {
          optargs_s.blocksize = SvIV (ST (items_i+1));
          this_mask = GUESTFS_ADD_DRIVE_SCRATCH_BLOCKSIZE_BITMASK;
        }
        else croak ("unknown optional argument '%s'", this_arg);
        if (optargs_s.bitmask & this_mask)
          croak ("optional argument '%s' given more than once",
                 this_arg);
        optargs_s.bitmask |= this_mask;
      }

      r = guestfs_add_drive_scratch_argv (g, size, optargs);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 1143 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_add_drive_with_if); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_add_drive_with_if)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "g, filename, iface");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	filename = (char *)SvPV_nolen(ST(1))
;
	char *	iface = (char *)SvPV_nolen(ST(2))
;
#line 609 "lib/Sys/Guestfs.xs"
      int r;
#line 1166 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::add_drive_with_if(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::add_drive_with_if(): g is not a blessed HV reference");
    }
;
#line 611 "lib/Sys/Guestfs.xs"
      Perl_ck_warner (aTHX_ packWARN(WARN_DEPRECATED),
        "Sys::Guestfs::add_drive_with_if is deprecated; use Sys::Guestfs::add_drive instead");
      r = guestfs_add_drive_with_if (g, filename, iface);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 1186 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_add_libvirt_dom); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_add_libvirt_dom)
{
    dVAR; dXSARGS;
    if (items < 2)
       croak_xs_usage(cv,  "g, dom, ...");
    {
	guestfs_h *	g;
	void * /* virDomainPtr */	dom;
#line 622 "lib/Sys/Guestfs.xs"
      int r;
      struct guestfs_add_libvirt_dom_argv optargs_s = { .bitmask = 0 };
      struct guestfs_add_libvirt_dom_argv *optargs = &optargs_s;
      size_t items_i;
#line 1207 "lib/Sys/Guestfs.c"
	SV *	RETVAL;

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::add_libvirt_dom(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::add_libvirt_dom(): g is not a blessed HV reference");
    }
;

    /* This is copied directly from the Sys::Virt typemap.  Dan has assured
     * me that he doesn't intend to change this implementation!
     */
    if (sv_isobject (ST(1)) && SvTYPE (SvRV (ST(1))) == SVt_PVMG)
        dom = INT2PTR (void *, SvIV ((SV*) SvRV (ST(1))));
    else {
        warn ("Sys::Guestfs::add_libvirt_dom() -- dom is not a blessed SV reference");
        XSRETURN_UNDEF;
    }
;
#line 627 "lib/Sys/Guestfs.xs"
      if (((items - 2) & 1) != 0)
        croak ("expecting an even number of extra parameters");
      for (items_i = 2; items_i < items; items_i += 2) {
        uint64_t this_mask;
        const char *this_arg;

        this_arg = SvPV_nolen (ST (items_i));
        if (STREQ (this_arg, "readonly")) {
          optargs_s.readonly = SvIV (ST (items_i+1));
          this_mask = GUESTFS_ADD_LIBVIRT_DOM_READONLY_BITMASK;
        }
        else if (STREQ (this_arg, "iface")) {
          optargs_s.iface = SvPV_nolen (ST (items_i+1));
          this_mask = GUESTFS_ADD_LIBVIRT_DOM_IFACE_BITMASK;
        }
        else if (STREQ (this_arg, "live")) {
          optargs_s.live = SvIV (ST (items_i+1));
          this_mask = GUESTFS_ADD_LIBVIRT_DOM_LIVE_BITMASK;
        }
        else if (STREQ (this_arg, "readonlydisk")) {
          optargs_s.readonlydisk = SvPV_nolen (ST (items_i+1));
          this_mask = GUESTFS_ADD_LIBVIRT_DOM_READONLYDISK_BITMASK;
        }
        else if (STREQ (this_arg, "cachemode")) {
          optargs_s.cachemode = SvPV_nolen (ST (items_i+1));
          this_mask = GUESTFS_ADD_LIBVIRT_DOM_CACHEMODE_BITMASK;
        }
        else if (STREQ (this_arg, "discard")) {
          optargs_s.discard = SvPV_nolen (ST (items_i+1));
          this_mask = GUESTFS_ADD_LIBVIRT_DOM_DISCARD_BITMASK;
        }
        else if (STREQ (this_arg, "copyonread")) {
          optargs_s.copyonread = SvIV (ST (items_i+1));
          this_mask = GUESTFS_ADD_LIBVIRT_DOM_COPYONREAD_BITMASK;
        }
        else croak ("unknown optional argument '%s'", this_arg);
        if (optargs_s.bitmask & this_mask)
          croak ("optional argument '%s' given more than once",
                 this_arg);
        optargs_s.bitmask |= this_mask;
      }

      r = guestfs_add_libvirt_dom_argv (g, dom, optargs);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
      RETVAL = newSViv (r);
#line 1280 "lib/Sys/Guestfs.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Guestfs_aug_clear); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_aug_clear)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, augpath");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	augpath = (char *)SvPV_nolen(ST(1))
;
#line 681 "lib/Sys/Guestfs.xs"
      int r;
#line 1302 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::aug_clear(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::aug_clear(): g is not a blessed HV reference");
    }
;
#line 683 "lib/Sys/Guestfs.xs"
      r = guestfs_aug_clear (g, augpath);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 1320 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_aug_close); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_aug_close)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "g");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
#line 691 "lib/Sys/Guestfs.xs"
      int r;
#line 1339 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::aug_close(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::aug_close(): g is not a blessed HV reference");
    }
;
#line 693 "lib/Sys/Guestfs.xs"
      r = guestfs_aug_close (g);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 1357 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_aug_defnode); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_aug_defnode)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "g, name, expr, val");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	name = (char *)SvPV_nolen(ST(1))
;
	char *	expr = (char *)SvPV_nolen(ST(2))
;
	char *	val = (char *)SvPV_nolen(ST(3))
;
#line 704 "lib/Sys/Guestfs.xs"
      struct guestfs_int_bool *r;
#line 1382 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::aug_defnode(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::aug_defnode(): g is not a blessed HV reference");
    }
;
#line 706 "lib/Sys/Guestfs.xs"
      r = guestfs_aug_defnode (g, name, expr, val);
      if (r == NULL)
        croak ("%s", guestfs_last_error (g));
      EXTEND (SP, 2 * 2);
      PUSHs (sv_2mortal (newSVpv ("i", 0)));
      PUSHs (sv_2mortal (newSVnv (r->i)));
      PUSHs (sv_2mortal (newSVpv ("b", 0)));
      PUSHs (sv_2mortal (newSVnv (r->b)));
      guestfs_free_int_bool (r);
#line 1406 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_aug_defvar); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_aug_defvar)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "g, name, expr");
    {
	guestfs_h *	g;
	char *	name = (char *)SvPV_nolen(ST(1))
;
	char *	expr = SvOK(ST(2)) ? SvPV_nolen(ST(2)) : NULL;
#line 722 "lib/Sys/Guestfs.xs"
      int r;
#line 1426 "lib/Sys/Guestfs.c"
	SV *	RETVAL;

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::aug_defvar(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::aug_defvar(): g is not a blessed HV reference");
    }
;
#line 724 "lib/Sys/Guestfs.xs"
      r = guestfs_aug_defvar (g, name, expr);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
      RETVAL = newSViv (r);
#line 1446 "lib/Sys/Guestfs.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Guestfs_aug_get); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_aug_get)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, augpath");
    {
	guestfs_h *	g;
	char *	augpath = (char *)SvPV_nolen(ST(1))
;
#line 736 "lib/Sys/Guestfs.xs"
      char *r;
#line 1466 "lib/Sys/Guestfs.c"
	SV *	RETVAL;

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::aug_get(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::aug_get(): g is not a blessed HV reference");
    }
;
#line 738 "lib/Sys/Guestfs.xs"
      r = guestfs_aug_get (g, augpath);
      if (r == NULL)
        croak ("%s", guestfs_last_error (g));
      RETVAL = newSVpv (r, 0);
      free (r);
#line 1487 "lib/Sys/Guestfs.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Guestfs_aug_init); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_aug_init)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "g, root, flags");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	root = (char *)SvPV_nolen(ST(1))
;
	int	flags = (int)SvIV(ST(2))
;
#line 752 "lib/Sys/Guestfs.xs"
      int r;
#line 1511 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::aug_init(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::aug_init(): g is not a blessed HV reference");
    }
;
#line 754 "lib/Sys/Guestfs.xs"
      r = guestfs_aug_init (g, root, flags);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 1529 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_aug_insert); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_aug_insert)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "g, augpath, label, before");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	augpath = (char *)SvPV_nolen(ST(1))
;
	char *	label = (char *)SvPV_nolen(ST(2))
;
	int	before = (int)SvIV(ST(3))
;
#line 765 "lib/Sys/Guestfs.xs"
      int r;
#line 1554 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::aug_insert(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::aug_insert(): g is not a blessed HV reference");
    }
;
#line 767 "lib/Sys/Guestfs.xs"
      r = guestfs_aug_insert (g, augpath, label, before);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 1572 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_aug_label); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_aug_label)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, augpath");
    {
	guestfs_h *	g;
	char *	augpath = (char *)SvPV_nolen(ST(1))
;
#line 776 "lib/Sys/Guestfs.xs"
      char *r;
#line 1591 "lib/Sys/Guestfs.c"
	SV *	RETVAL;

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::aug_label(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::aug_label(): g is not a blessed HV reference");
    }
;
#line 778 "lib/Sys/Guestfs.xs"
      r = guestfs_aug_label (g, augpath);
      if (r == NULL)
        croak ("%s", guestfs_last_error (g));
      RETVAL = newSVpv (r, 0);
      free (r);
#line 1612 "lib/Sys/Guestfs.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Guestfs_aug_load); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_aug_load)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "g");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
#line 790 "lib/Sys/Guestfs.xs"
      int r;
#line 1632 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::aug_load(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::aug_load(): g is not a blessed HV reference");
    }
;
#line 792 "lib/Sys/Guestfs.xs"
      r = guestfs_aug_load (g);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 1650 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_aug_ls); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_aug_ls)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, augpath");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	augpath = (char *)SvPV_nolen(ST(1))
;
#line 801 "lib/Sys/Guestfs.xs"
      char **r;
      size_t i, n;
#line 1672 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::aug_ls(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::aug_ls(): g is not a blessed HV reference");
    }
;
#line 804 "lib/Sys/Guestfs.xs"
      r = guestfs_aug_ls (g, augpath);
      if (r == NULL)
        croak ("%s", guestfs_last_error (g));
      for (n = 0; r[n] != NULL; ++n) /**/;
      EXTEND (SP, n);
      for (i = 0; i < n; ++i) {
        PUSHs (sv_2mortal (newSVpv (r[i], 0)));
        free (r[i]);
      }
      free (r);
#line 1697 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_aug_match); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_aug_match)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, augpath");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	augpath = (char *)SvPV_nolen(ST(1))
;
#line 820 "lib/Sys/Guestfs.xs"
      char **r;
      size_t i, n;
#line 1719 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::aug_match(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::aug_match(): g is not a blessed HV reference");
    }
;
#line 823 "lib/Sys/Guestfs.xs"
      r = guestfs_aug_match (g, augpath);
      if (r == NULL)
        croak ("%s", guestfs_last_error (g));
      for (n = 0; r[n] != NULL; ++n) /**/;
      EXTEND (SP, n);
      for (i = 0; i < n; ++i) {
        PUSHs (sv_2mortal (newSVpv (r[i], 0)));
        free (r[i]);
      }
      free (r);
#line 1744 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_aug_mv); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_aug_mv)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "g, src, dest");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	src = (char *)SvPV_nolen(ST(1))
;
	char *	dest = (char *)SvPV_nolen(ST(2))
;
#line 840 "lib/Sys/Guestfs.xs"
      int r;
#line 1767 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::aug_mv(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::aug_mv(): g is not a blessed HV reference");
    }
;
#line 842 "lib/Sys/Guestfs.xs"
      r = guestfs_aug_mv (g, src, dest);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 1785 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_aug_rm); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_aug_rm)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, augpath");
    {
	guestfs_h *	g;
	char *	augpath = (char *)SvPV_nolen(ST(1))
;
#line 851 "lib/Sys/Guestfs.xs"
      int r;
#line 1804 "lib/Sys/Guestfs.c"
	SV *	RETVAL;

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::aug_rm(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::aug_rm(): g is not a blessed HV reference");
    }
;
#line 853 "lib/Sys/Guestfs.xs"
      r = guestfs_aug_rm (g, augpath);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
      RETVAL = newSViv (r);
#line 1824 "lib/Sys/Guestfs.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Guestfs_aug_save); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_aug_save)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "g");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
#line 864 "lib/Sys/Guestfs.xs"
      int r;
#line 1844 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::aug_save(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::aug_save(): g is not a blessed HV reference");
    }
;
#line 866 "lib/Sys/Guestfs.xs"
      r = guestfs_aug_save (g);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 1862 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_aug_set); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_aug_set)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "g, augpath, val");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	augpath = (char *)SvPV_nolen(ST(1))
;
	char *	val = (char *)SvPV_nolen(ST(2))
;
#line 876 "lib/Sys/Guestfs.xs"
      int r;
#line 1885 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::aug_set(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::aug_set(): g is not a blessed HV reference");
    }
;
#line 878 "lib/Sys/Guestfs.xs"
      r = guestfs_aug_set (g, augpath, val);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 1903 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_aug_setm); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_aug_setm)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "g, base, sub, val");
    {
	guestfs_h *	g;
	char *	base = (char *)SvPV_nolen(ST(1))
;
	char *	sub = SvOK(ST(2)) ? SvPV_nolen(ST(2)) : NULL;
	char *	val = (char *)SvPV_nolen(ST(3))
;
#line 889 "lib/Sys/Guestfs.xs"
      int r;
#line 1925 "lib/Sys/Guestfs.c"
	SV *	RETVAL;

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::aug_setm(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::aug_setm(): g is not a blessed HV reference");
    }
;
#line 891 "lib/Sys/Guestfs.xs"
      r = guestfs_aug_setm (g, base, sub, val);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
      RETVAL = newSViv (r);
#line 1945 "lib/Sys/Guestfs.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Guestfs_aug_transform); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_aug_transform)
{
    dVAR; dXSARGS;
    if (items < 3)
       croak_xs_usage(cv,  "g, lens, file, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	lens = (char *)SvPV_nolen(ST(1))
;
	char *	file = (char *)SvPV_nolen(ST(2))
;
#line 904 "lib/Sys/Guestfs.xs"
      int r;
      struct guestfs_aug_transform_argv optargs_s = { .bitmask = 0 };
      struct guestfs_aug_transform_argv *optargs = &optargs_s;
      size_t items_i;
#line 1972 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::aug_transform(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::aug_transform(): g is not a blessed HV reference");
    }
;
#line 909 "lib/Sys/Guestfs.xs"
      if (((items - 3) & 1) != 0)
        croak ("expecting an even number of extra parameters");
      for (items_i = 3; items_i < items; items_i += 2) {
        uint64_t this_mask;
        const char *this_arg;

        this_arg = SvPV_nolen (ST (items_i));
        if (STREQ (this_arg, "remove")) {
          optargs_s.remove = SvIV (ST (items_i+1));
          this_mask = GUESTFS_AUG_TRANSFORM_REMOVE_BITMASK;
        }
        else croak ("unknown optional argument '%s'", this_arg);
        if (optargs_s.bitmask & this_mask)
          croak ("optional argument '%s' given more than once",
                 this_arg);
        optargs_s.bitmask |= this_mask;
      }

      r = guestfs_aug_transform_argv (g, lens, file, optargs);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 2008 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_available); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_available)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, groups");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char **	groups = XS_unpack_charPtrPtr(ST(1))
;
#line 936 "lib/Sys/Guestfs.xs"
      int r;
#line 2029 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::available(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::available(): g is not a blessed HV reference");
    }
;
#line 938 "lib/Sys/Guestfs.xs"
      r = guestfs_available (g, groups);
      free (groups);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 2048 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_available_all_groups); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_available_all_groups)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "g");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
#line 947 "lib/Sys/Guestfs.xs"
      char **r;
      size_t i, n;
#line 2068 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::available_all_groups(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::available_all_groups(): g is not a blessed HV reference");
    }
;
#line 950 "lib/Sys/Guestfs.xs"
      r = guestfs_available_all_groups (g);
      if (r == NULL)
        croak ("%s", guestfs_last_error (g));
      for (n = 0; r[n] != NULL; ++n) /**/;
      EXTEND (SP, n);
      for (i = 0; i < n; ++i) {
        PUSHs (sv_2mortal (newSVpv (r[i], 0)));
        free (r[i]);
      }
      free (r);
#line 2093 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_base64_in); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_base64_in)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "g, base64file, filename");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	base64file = (char *)SvPV_nolen(ST(1))
;
	char *	filename = (char *)SvPV_nolen(ST(2))
;
#line 967 "lib/Sys/Guestfs.xs"
      int r;
#line 2116 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::base64_in(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::base64_in(): g is not a blessed HV reference");
    }
;
#line 969 "lib/Sys/Guestfs.xs"
      r = guestfs_base64_in (g, base64file, filename);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 2134 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_base64_out); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_base64_out)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "g, filename, base64file");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	filename = (char *)SvPV_nolen(ST(1))
;
	char *	base64file = (char *)SvPV_nolen(ST(2))
;
#line 979 "lib/Sys/Guestfs.xs"
      int r;
#line 2157 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::base64_out(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::base64_out(): g is not a blessed HV reference");
    }
;
#line 981 "lib/Sys/Guestfs.xs"
      r = guestfs_base64_out (g, filename, base64file);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 2175 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_blkdiscard); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_blkdiscard)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, device");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	device = (char *)SvPV_nolen(ST(1))
;
#line 990 "lib/Sys/Guestfs.xs"
      int r;
#line 2196 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::blkdiscard(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::blkdiscard(): g is not a blessed HV reference");
    }
;
#line 992 "lib/Sys/Guestfs.xs"
      r = guestfs_blkdiscard (g, device);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 2214 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_blkdiscardzeroes); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_blkdiscardzeroes)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, device");
    {
	guestfs_h *	g;
	char *	device = (char *)SvPV_nolen(ST(1))
;
#line 1001 "lib/Sys/Guestfs.xs"
      int r;
#line 2233 "lib/Sys/Guestfs.c"
	SV *	RETVAL;

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::blkdiscardzeroes(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::blkdiscardzeroes(): g is not a blessed HV reference");
    }
;
#line 1003 "lib/Sys/Guestfs.xs"
      r = guestfs_blkdiscardzeroes (g, device);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
      RETVAL = newSViv (r);
#line 2253 "lib/Sys/Guestfs.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Guestfs_blkid); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_blkid)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, device");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	device = (char *)SvPV_nolen(ST(1))
;
#line 1015 "lib/Sys/Guestfs.xs"
      char **r;
      size_t i, n;
#line 2276 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::blkid(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::blkid(): g is not a blessed HV reference");
    }
;
#line 1018 "lib/Sys/Guestfs.xs"
      r = guestfs_blkid (g, device);
      if (r == NULL)
        croak ("%s", guestfs_last_error (g));
      for (n = 0; r[n] != NULL; ++n) /**/;
      EXTEND (SP, n);
      for (i = 0; i < n; ++i) {
        PUSHs (sv_2mortal (newSVpv (r[i], 0)));
        free (r[i]);
      }
      free (r);
#line 2301 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_blockdev_flushbufs); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_blockdev_flushbufs)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, device");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	device = (char *)SvPV_nolen(ST(1))
;
#line 1034 "lib/Sys/Guestfs.xs"
      int r;
#line 2322 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::blockdev_flushbufs(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::blockdev_flushbufs(): g is not a blessed HV reference");
    }
;
#line 1036 "lib/Sys/Guestfs.xs"
      r = guestfs_blockdev_flushbufs (g, device);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 2340 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_blockdev_getbsz); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_blockdev_getbsz)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, device");
    {
	guestfs_h *	g;
	char *	device = (char *)SvPV_nolen(ST(1))
;
#line 1045 "lib/Sys/Guestfs.xs"
      int r;
#line 2359 "lib/Sys/Guestfs.c"
	SV *	RETVAL;

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::blockdev_getbsz(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::blockdev_getbsz(): g is not a blessed HV reference");
    }
;
#line 1047 "lib/Sys/Guestfs.xs"
      r = guestfs_blockdev_getbsz (g, device);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
      RETVAL = newSViv (r);
#line 2379 "lib/Sys/Guestfs.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Guestfs_blockdev_getro); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_blockdev_getro)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, device");
    {
	guestfs_h *	g;
	char *	device = (char *)SvPV_nolen(ST(1))
;
#line 1059 "lib/Sys/Guestfs.xs"
      int r;
#line 2399 "lib/Sys/Guestfs.c"
	SV *	RETVAL;

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::blockdev_getro(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::blockdev_getro(): g is not a blessed HV reference");
    }
;
#line 1061 "lib/Sys/Guestfs.xs"
      r = guestfs_blockdev_getro (g, device);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
      RETVAL = newSViv (r);
#line 2419 "lib/Sys/Guestfs.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Guestfs_blockdev_getsize64); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_blockdev_getsize64)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, device");
    {
	guestfs_h *	g;
	char *	device = (char *)SvPV_nolen(ST(1))
;
#line 1073 "lib/Sys/Guestfs.xs"
      int64_t r;
#line 2439 "lib/Sys/Guestfs.c"
	SV *	RETVAL;

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::blockdev_getsize64(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::blockdev_getsize64(): g is not a blessed HV reference");
    }
;
#line 1075 "lib/Sys/Guestfs.xs"
      r = guestfs_blockdev_getsize64 (g, device);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
      RETVAL = my_newSVll (r);
#line 2459 "lib/Sys/Guestfs.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Guestfs_blockdev_getss); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_blockdev_getss)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, device");
    {
	guestfs_h *	g;
	char *	device = (char *)SvPV_nolen(ST(1))
;
#line 1087 "lib/Sys/Guestfs.xs"
      int r;
#line 2479 "lib/Sys/Guestfs.c"
	SV *	RETVAL;

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::blockdev_getss(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::blockdev_getss(): g is not a blessed HV reference");
    }
;
#line 1089 "lib/Sys/Guestfs.xs"
      r = guestfs_blockdev_getss (g, device);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
      RETVAL = newSViv (r);
#line 2499 "lib/Sys/Guestfs.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Guestfs_blockdev_getsz); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_blockdev_getsz)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, device");
    {
	guestfs_h *	g;
	char *	device = (char *)SvPV_nolen(ST(1))
;
#line 1101 "lib/Sys/Guestfs.xs"
      int64_t r;
#line 2519 "lib/Sys/Guestfs.c"
	SV *	RETVAL;

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::blockdev_getsz(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::blockdev_getsz(): g is not a blessed HV reference");
    }
;
#line 1103 "lib/Sys/Guestfs.xs"
      r = guestfs_blockdev_getsz (g, device);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
      RETVAL = my_newSVll (r);
#line 2539 "lib/Sys/Guestfs.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Guestfs_blockdev_rereadpt); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_blockdev_rereadpt)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, device");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	device = (char *)SvPV_nolen(ST(1))
;
#line 1115 "lib/Sys/Guestfs.xs"
      int r;
#line 2561 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::blockdev_rereadpt(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::blockdev_rereadpt(): g is not a blessed HV reference");
    }
;
#line 1117 "lib/Sys/Guestfs.xs"
      r = guestfs_blockdev_rereadpt (g, device);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 2579 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_blockdev_setbsz); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_blockdev_setbsz)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "g, device, blocksize");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	device = (char *)SvPV_nolen(ST(1))
;
	int	blocksize = (int)SvIV(ST(2))
;
#line 1127 "lib/Sys/Guestfs.xs"
      int r;
#line 2602 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::blockdev_setbsz(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::blockdev_setbsz(): g is not a blessed HV reference");
    }
;
#line 1129 "lib/Sys/Guestfs.xs"
      Perl_ck_warner (aTHX_ packWARN(WARN_DEPRECATED),
        "Sys::Guestfs::blockdev_setbsz is deprecated");
      r = guestfs_blockdev_setbsz (g, device, blocksize);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 2622 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_blockdev_setra); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_blockdev_setra)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "g, device, sectors");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	device = (char *)SvPV_nolen(ST(1))
;
	int	sectors = (int)SvIV(ST(2))
;
#line 1141 "lib/Sys/Guestfs.xs"
      int r;
#line 2645 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::blockdev_setra(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::blockdev_setra(): g is not a blessed HV reference");
    }
;
#line 1143 "lib/Sys/Guestfs.xs"
      r = guestfs_blockdev_setra (g, device, sectors);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 2663 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_blockdev_setro); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_blockdev_setro)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, device");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	device = (char *)SvPV_nolen(ST(1))
;
#line 1152 "lib/Sys/Guestfs.xs"
      int r;
#line 2684 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::blockdev_setro(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::blockdev_setro(): g is not a blessed HV reference");
    }
;
#line 1154 "lib/Sys/Guestfs.xs"
      r = guestfs_blockdev_setro (g, device);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 2702 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_blockdev_setrw); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_blockdev_setrw)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, device");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	device = (char *)SvPV_nolen(ST(1))
;
#line 1163 "lib/Sys/Guestfs.xs"
      int r;
#line 2723 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::blockdev_setrw(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::blockdev_setrw(): g is not a blessed HV reference");
    }
;
#line 1165 "lib/Sys/Guestfs.xs"
      r = guestfs_blockdev_setrw (g, device);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 2741 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_btrfs_balance_cancel); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_btrfs_balance_cancel)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, path");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	path = (char *)SvPV_nolen(ST(1))
;
#line 1174 "lib/Sys/Guestfs.xs"
      int r;
#line 2762 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::btrfs_balance_cancel(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::btrfs_balance_cancel(): g is not a blessed HV reference");
    }
;
#line 1176 "lib/Sys/Guestfs.xs"
      r = guestfs_btrfs_balance_cancel (g, path);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 2780 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_btrfs_balance_pause); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_btrfs_balance_pause)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, path");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	path = (char *)SvPV_nolen(ST(1))
;
#line 1185 "lib/Sys/Guestfs.xs"
      int r;
#line 2801 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::btrfs_balance_pause(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::btrfs_balance_pause(): g is not a blessed HV reference");
    }
;
#line 1187 "lib/Sys/Guestfs.xs"
      r = guestfs_btrfs_balance_pause (g, path);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 2819 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_btrfs_balance_resume); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_btrfs_balance_resume)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, path");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	path = (char *)SvPV_nolen(ST(1))
;
#line 1196 "lib/Sys/Guestfs.xs"
      int r;
#line 2840 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::btrfs_balance_resume(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::btrfs_balance_resume(): g is not a blessed HV reference");
    }
;
#line 1198 "lib/Sys/Guestfs.xs"
      r = guestfs_btrfs_balance_resume (g, path);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 2858 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_btrfs_balance_status); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_btrfs_balance_status)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, path");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	path = (char *)SvPV_nolen(ST(1))
;
#line 1207 "lib/Sys/Guestfs.xs"
      struct guestfs_btrfsbalance *r;
#line 2879 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::btrfs_balance_status(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::btrfs_balance_status(): g is not a blessed HV reference");
    }
;
#line 1209 "lib/Sys/Guestfs.xs"
      r = guestfs_btrfs_balance_status (g, path);
      if (r == NULL)
        croak ("%s", guestfs_last_error (g));
      EXTEND (SP, 2 * 5);
      PUSHs (sv_2mortal (newSVpv ("btrfsbalance_status", 0)));
      PUSHs (sv_2mortal (newSVpv (r->btrfsbalance_status, 0)));
      PUSHs (sv_2mortal (newSVpv ("btrfsbalance_total", 0)));
      PUSHs (sv_2mortal (my_newSVull (r->btrfsbalance_total)));
      PUSHs (sv_2mortal (newSVpv ("btrfsbalance_balanced", 0)));
      PUSHs (sv_2mortal (my_newSVull (r->btrfsbalance_balanced)));
      PUSHs (sv_2mortal (newSVpv ("btrfsbalance_considered", 0)));
      PUSHs (sv_2mortal (my_newSVull (r->btrfsbalance_considered)));
      PUSHs (sv_2mortal (newSVpv ("btrfsbalance_left", 0)));
      PUSHs (sv_2mortal (my_newSVull (r->btrfsbalance_left)));
      guestfs_free_btrfsbalance (r);
#line 2909 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_btrfs_device_add); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_btrfs_device_add)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "g, devices, fs");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char **	devices = XS_unpack_charPtrPtr(ST(1))
;
	char *	fs = (char *)SvPV_nolen(ST(2))
;
#line 1231 "lib/Sys/Guestfs.xs"
      int r;
#line 2932 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::btrfs_device_add(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::btrfs_device_add(): g is not a blessed HV reference");
    }
;
#line 1233 "lib/Sys/Guestfs.xs"
      r = guestfs_btrfs_device_add (g, devices, fs);
      free (devices);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 2951 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_btrfs_device_delete); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_btrfs_device_delete)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "g, devices, fs");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char **	devices = XS_unpack_charPtrPtr(ST(1))
;
	char *	fs = (char *)SvPV_nolen(ST(2))
;
#line 1244 "lib/Sys/Guestfs.xs"
      int r;
#line 2974 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::btrfs_device_delete(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::btrfs_device_delete(): g is not a blessed HV reference");
    }
;
#line 1246 "lib/Sys/Guestfs.xs"
      r = guestfs_btrfs_device_delete (g, devices, fs);
      free (devices);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 2993 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_btrfs_filesystem_balance); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_btrfs_filesystem_balance)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, fs");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	fs = (char *)SvPV_nolen(ST(1))
;
#line 1256 "lib/Sys/Guestfs.xs"
      int r;
#line 3014 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::btrfs_filesystem_balance(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::btrfs_filesystem_balance(): g is not a blessed HV reference");
    }
;
#line 1258 "lib/Sys/Guestfs.xs"
      r = guestfs_btrfs_filesystem_balance (g, fs);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 3032 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_btrfs_filesystem_defragment); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_btrfs_filesystem_defragment)
{
    dVAR; dXSARGS;
    if (items < 2)
       croak_xs_usage(cv,  "g, path, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	path = (char *)SvPV_nolen(ST(1))
;
#line 1267 "lib/Sys/Guestfs.xs"
      int r;
      struct guestfs_btrfs_filesystem_defragment_argv optargs_s = { .bitmask = 0 };
      struct guestfs_btrfs_filesystem_defragment_argv *optargs = &optargs_s;
      size_t items_i;
#line 3056 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::btrfs_filesystem_defragment(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::btrfs_filesystem_defragment(): g is not a blessed HV reference");
    }
;
#line 1272 "lib/Sys/Guestfs.xs"
      if (((items - 2) & 1) != 0)
        croak ("expecting an even number of extra parameters");
      for (items_i = 2; items_i < items; items_i += 2) {
        uint64_t this_mask;
        const char *this_arg;

        this_arg = SvPV_nolen (ST (items_i));
        if (STREQ (this_arg, "flush")) {
          optargs_s.flush = SvIV (ST (items_i+1));
          this_mask = GUESTFS_BTRFS_FILESYSTEM_DEFRAGMENT_FLUSH_BITMASK;
        }
        else if (STREQ (this_arg, "compress")) {
          optargs_s.compress = SvPV_nolen (ST (items_i+1));
          this_mask = GUESTFS_BTRFS_FILESYSTEM_DEFRAGMENT_COMPRESS_BITMASK;
        }
        else croak ("unknown optional argument '%s'", this_arg);
        if (optargs_s.bitmask & this_mask)
          croak ("optional argument '%s' given more than once",
                 this_arg);
        optargs_s.bitmask |= this_mask;
      }

      r = guestfs_btrfs_filesystem_defragment_argv (g, path, optargs);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 3096 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_btrfs_filesystem_resize); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_btrfs_filesystem_resize)
{
    dVAR; dXSARGS;
    if (items < 2)
       croak_xs_usage(cv,  "g, mountpoint, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	mountpoint = (char *)SvPV_nolen(ST(1))
;
#line 1303 "lib/Sys/Guestfs.xs"
      int r;
      struct guestfs_btrfs_filesystem_resize_argv optargs_s = { .bitmask = 0 };
      struct guestfs_btrfs_filesystem_resize_argv *optargs = &optargs_s;
      size_t items_i;
#line 3120 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::btrfs_filesystem_resize(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::btrfs_filesystem_resize(): g is not a blessed HV reference");
    }
;
#line 1308 "lib/Sys/Guestfs.xs"
      if (((items - 2) & 1) != 0)
        croak ("expecting an even number of extra parameters");
      for (items_i = 2; items_i < items; items_i += 2) {
        uint64_t this_mask;
        const char *this_arg;

        this_arg = SvPV_nolen (ST (items_i));
        if (STREQ (this_arg, "size")) {
          optargs_s.size = my_SvIV64 (ST (items_i+1));
          this_mask = GUESTFS_BTRFS_FILESYSTEM_RESIZE_SIZE_BITMASK;
        }
        else croak ("unknown optional argument '%s'", this_arg);
        if (optargs_s.bitmask & this_mask)
          croak ("optional argument '%s' given more than once",
                 this_arg);
        optargs_s.bitmask |= this_mask;
      }

      r = guestfs_btrfs_filesystem_resize_argv (g, mountpoint, optargs);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 3156 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_btrfs_filesystem_show); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_btrfs_filesystem_show)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, device");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	device = (char *)SvPV_nolen(ST(1))
;
#line 1335 "lib/Sys/Guestfs.xs"
      char **r;
      size_t i, n;
#line 3178 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::btrfs_filesystem_show(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::btrfs_filesystem_show(): g is not a blessed HV reference");
    }
;
#line 1338 "lib/Sys/Guestfs.xs"
      r = guestfs_btrfs_filesystem_show (g, device);
      if (r == NULL)
        croak ("%s", guestfs_last_error (g));
      for (n = 0; r[n] != NULL; ++n) /**/;
      EXTEND (SP, n);
      for (i = 0; i < n; ++i) {
        PUSHs (sv_2mortal (newSVpv (r[i], 0)));
        free (r[i]);
      }
      free (r);
#line 3203 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_btrfs_filesystem_sync); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_btrfs_filesystem_sync)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, fs");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	fs = (char *)SvPV_nolen(ST(1))
;
#line 1354 "lib/Sys/Guestfs.xs"
      int r;
#line 3224 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::btrfs_filesystem_sync(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::btrfs_filesystem_sync(): g is not a blessed HV reference");
    }
;
#line 1356 "lib/Sys/Guestfs.xs"
      r = guestfs_btrfs_filesystem_sync (g, fs);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 3242 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_btrfs_fsck); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_btrfs_fsck)
{
    dVAR; dXSARGS;
    if (items < 2)
       croak_xs_usage(cv,  "g, device, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	device = (char *)SvPV_nolen(ST(1))
;
#line 1365 "lib/Sys/Guestfs.xs"
      int r;
      struct guestfs_btrfs_fsck_argv optargs_s = { .bitmask = 0 };
      struct guestfs_btrfs_fsck_argv *optargs = &optargs_s;
      size_t items_i;
#line 3266 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::btrfs_fsck(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::btrfs_fsck(): g is not a blessed HV reference");
    }
;
#line 1370 "lib/Sys/Guestfs.xs"
      if (((items - 2) & 1) != 0)
        croak ("expecting an even number of extra parameters");
      for (items_i = 2; items_i < items; items_i += 2) {
        uint64_t this_mask;
        const char *this_arg;

        this_arg = SvPV_nolen (ST (items_i));
        if (STREQ (this_arg, "superblock")) {
          optargs_s.superblock = my_SvIV64 (ST (items_i+1));
          this_mask = GUESTFS_BTRFS_FSCK_SUPERBLOCK_BITMASK;
        }
        else if (STREQ (this_arg, "repair")) {
          optargs_s.repair = SvIV (ST (items_i+1));
          this_mask = GUESTFS_BTRFS_FSCK_REPAIR_BITMASK;
        }
        else croak ("unknown optional argument '%s'", this_arg);
        if (optargs_s.bitmask & this_mask)
          croak ("optional argument '%s' given more than once",
                 this_arg);
        optargs_s.bitmask |= this_mask;
      }

      r = guestfs_btrfs_fsck_argv (g, device, optargs);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 3306 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_btrfs_image); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_btrfs_image)
{
    dVAR; dXSARGS;
    if (items < 3)
       croak_xs_usage(cv,  "g, source, image, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char **	source = XS_unpack_charPtrPtr(ST(1))
;
	char *	image = (char *)SvPV_nolen(ST(2))
;
#line 1402 "lib/Sys/Guestfs.xs"
      int r;
      struct guestfs_btrfs_image_argv optargs_s = { .bitmask = 0 };
      struct guestfs_btrfs_image_argv *optargs = &optargs_s;
      size_t items_i;
#line 3332 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::btrfs_image(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::btrfs_image(): g is not a blessed HV reference");
    }
;
#line 1407 "lib/Sys/Guestfs.xs"
      if (((items - 3) & 1) != 0)
        croak ("expecting an even number of extra parameters");
      for (items_i = 3; items_i < items; items_i += 2) {
        uint64_t this_mask;
        const char *this_arg;

        this_arg = SvPV_nolen (ST (items_i));
        if (STREQ (this_arg, "compresslevel")) {
          optargs_s.compresslevel = SvIV (ST (items_i+1));
          this_mask = GUESTFS_BTRFS_IMAGE_COMPRESSLEVEL_BITMASK;
        }
        else croak ("unknown optional argument '%s'", this_arg);
        if (optargs_s.bitmask & this_mask)
          croak ("optional argument '%s' given more than once",
                 this_arg);
        optargs_s.bitmask |= this_mask;
      }

      r = guestfs_btrfs_image_argv (g, source, image, optargs);
      free (source);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 3369 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_btrfs_qgroup_assign); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_btrfs_qgroup_assign)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "g, src, dst, path");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	src = (char *)SvPV_nolen(ST(1))
;
	char *	dst = (char *)SvPV_nolen(ST(2))
;
	char *	path = (char *)SvPV_nolen(ST(3))
;
#line 1437 "lib/Sys/Guestfs.xs"
      int r;
#line 3394 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::btrfs_qgroup_assign(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::btrfs_qgroup_assign(): g is not a blessed HV reference");
    }
;
#line 1439 "lib/Sys/Guestfs.xs"
      r = guestfs_btrfs_qgroup_assign (g, src, dst, path);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 3412 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_btrfs_qgroup_create); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_btrfs_qgroup_create)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "g, qgroupid, subvolume");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	qgroupid = (char *)SvPV_nolen(ST(1))
;
	char *	subvolume = (char *)SvPV_nolen(ST(2))
;
#line 1449 "lib/Sys/Guestfs.xs"
      int r;
#line 3435 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::btrfs_qgroup_create(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::btrfs_qgroup_create(): g is not a blessed HV reference");
    }
;
#line 1451 "lib/Sys/Guestfs.xs"
      r = guestfs_btrfs_qgroup_create (g, qgroupid, subvolume);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 3453 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_btrfs_qgroup_destroy); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_btrfs_qgroup_destroy)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "g, qgroupid, subvolume");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	qgroupid = (char *)SvPV_nolen(ST(1))
;
	char *	subvolume = (char *)SvPV_nolen(ST(2))
;
#line 1461 "lib/Sys/Guestfs.xs"
      int r;
#line 3476 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::btrfs_qgroup_destroy(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::btrfs_qgroup_destroy(): g is not a blessed HV reference");
    }
;
#line 1463 "lib/Sys/Guestfs.xs"
      r = guestfs_btrfs_qgroup_destroy (g, qgroupid, subvolume);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 3494 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_btrfs_qgroup_limit); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_btrfs_qgroup_limit)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "g, subvolume, size");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	subvolume = (char *)SvPV_nolen(ST(1))
;
	int64_t    size = my_SvIV64 (ST(2))
;
#line 1473 "lib/Sys/Guestfs.xs"
      int r;
#line 3517 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::btrfs_qgroup_limit(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::btrfs_qgroup_limit(): g is not a blessed HV reference");
    }
;
#line 1475 "lib/Sys/Guestfs.xs"
      r = guestfs_btrfs_qgroup_limit (g, subvolume, size);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 3535 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_btrfs_qgroup_remove); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_btrfs_qgroup_remove)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "g, src, dst, path");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	src = (char *)SvPV_nolen(ST(1))
;
	char *	dst = (char *)SvPV_nolen(ST(2))
;
	char *	path = (char *)SvPV_nolen(ST(3))
;
#line 1486 "lib/Sys/Guestfs.xs"
      int r;
#line 3560 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::btrfs_qgroup_remove(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::btrfs_qgroup_remove(): g is not a blessed HV reference");
    }
;
#line 1488 "lib/Sys/Guestfs.xs"
      r = guestfs_btrfs_qgroup_remove (g, src, dst, path);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 3578 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_btrfs_qgroup_show); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_btrfs_qgroup_show)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, path");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	path = (char *)SvPV_nolen(ST(1))
;
#line 1497 "lib/Sys/Guestfs.xs"
      struct guestfs_btrfsqgroup_list *r;
      size_t i;
      HV *hv;
#line 3601 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::btrfs_qgroup_show(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::btrfs_qgroup_show(): g is not a blessed HV reference");
    }
;
#line 1501 "lib/Sys/Guestfs.xs"
      r = guestfs_btrfs_qgroup_show (g, path);
      if (r == NULL)
        croak ("%s", guestfs_last_error (g));
      EXTEND (SP, r->len);
      for (i = 0; i < r->len; ++i) {
        hv = newHV ();
        (void) hv_store (hv, "btrfsqgroup_id", 14, newSVpv (r->val[i].btrfsqgroup_id, 0), 0);
        (void) hv_store (hv, "btrfsqgroup_rfer", 16, my_newSVull (r->val[i].btrfsqgroup_rfer), 0);
        (void) hv_store (hv, "btrfsqgroup_excl", 16, my_newSVull (r->val[i].btrfsqgroup_excl), 0);
        PUSHs (sv_2mortal (newRV ((SV *) hv)));
      }
      guestfs_free_btrfsqgroup_list (r);
#line 3628 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_btrfs_quota_enable); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_btrfs_quota_enable)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "g, fs, enable");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	fs = (char *)SvPV_nolen(ST(1))
;
	int	enable = (int)SvIV(ST(2))
;
#line 1520 "lib/Sys/Guestfs.xs"
      int r;
#line 3651 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::btrfs_quota_enable(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::btrfs_quota_enable(): g is not a blessed HV reference");
    }
;
#line 1522 "lib/Sys/Guestfs.xs"
      r = guestfs_btrfs_quota_enable (g, fs, enable);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 3669 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_btrfs_quota_rescan); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_btrfs_quota_rescan)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, fs");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	fs = (char *)SvPV_nolen(ST(1))
;
#line 1531 "lib/Sys/Guestfs.xs"
      int r;
#line 3690 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::btrfs_quota_rescan(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::btrfs_quota_rescan(): g is not a blessed HV reference");
    }
;
#line 1533 "lib/Sys/Guestfs.xs"
      r = guestfs_btrfs_quota_rescan (g, fs);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 3708 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_btrfs_replace); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_btrfs_replace)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "g, srcdev, targetdev, mntpoint");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	srcdev = (char *)SvPV_nolen(ST(1))
;
	char *	targetdev = (char *)SvPV_nolen(ST(2))
;
	char *	mntpoint = (char *)SvPV_nolen(ST(3))
;
#line 1544 "lib/Sys/Guestfs.xs"
      int r;
#line 3733 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::btrfs_replace(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::btrfs_replace(): g is not a blessed HV reference");
    }
;
#line 1546 "lib/Sys/Guestfs.xs"
      r = guestfs_btrfs_replace (g, srcdev, targetdev, mntpoint);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 3751 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_btrfs_rescue_chunk_recover); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_btrfs_rescue_chunk_recover)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, device");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	device = (char *)SvPV_nolen(ST(1))
;
#line 1555 "lib/Sys/Guestfs.xs"
      int r;
#line 3772 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::btrfs_rescue_chunk_recover(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::btrfs_rescue_chunk_recover(): g is not a blessed HV reference");
    }
;
#line 1557 "lib/Sys/Guestfs.xs"
      r = guestfs_btrfs_rescue_chunk_recover (g, device);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 3790 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_btrfs_rescue_super_recover); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_btrfs_rescue_super_recover)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, device");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	device = (char *)SvPV_nolen(ST(1))
;
#line 1566 "lib/Sys/Guestfs.xs"
      int r;
#line 3811 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::btrfs_rescue_super_recover(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::btrfs_rescue_super_recover(): g is not a blessed HV reference");
    }
;
#line 1568 "lib/Sys/Guestfs.xs"
      r = guestfs_btrfs_rescue_super_recover (g, device);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 3829 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_btrfs_scrub_cancel); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_btrfs_scrub_cancel)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, path");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	path = (char *)SvPV_nolen(ST(1))
;
#line 1577 "lib/Sys/Guestfs.xs"
      int r;
#line 3850 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::btrfs_scrub_cancel(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::btrfs_scrub_cancel(): g is not a blessed HV reference");
    }
;
#line 1579 "lib/Sys/Guestfs.xs"
      r = guestfs_btrfs_scrub_cancel (g, path);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 3868 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_btrfs_scrub_resume); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_btrfs_scrub_resume)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, path");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	path = (char *)SvPV_nolen(ST(1))
;
#line 1588 "lib/Sys/Guestfs.xs"
      int r;
#line 3889 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::btrfs_scrub_resume(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::btrfs_scrub_resume(): g is not a blessed HV reference");
    }
;
#line 1590 "lib/Sys/Guestfs.xs"
      r = guestfs_btrfs_scrub_resume (g, path);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 3907 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_btrfs_scrub_start); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_btrfs_scrub_start)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, path");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	path = (char *)SvPV_nolen(ST(1))
;
#line 1599 "lib/Sys/Guestfs.xs"
      int r;
#line 3928 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::btrfs_scrub_start(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::btrfs_scrub_start(): g is not a blessed HV reference");
    }
;
#line 1601 "lib/Sys/Guestfs.xs"
      r = guestfs_btrfs_scrub_start (g, path);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 3946 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_btrfs_scrub_status); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_btrfs_scrub_status)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, path");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	path = (char *)SvPV_nolen(ST(1))
;
#line 1610 "lib/Sys/Guestfs.xs"
      struct guestfs_btrfsscrub *r;
#line 3967 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::btrfs_scrub_status(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::btrfs_scrub_status(): g is not a blessed HV reference");
    }
;
#line 1612 "lib/Sys/Guestfs.xs"
      r = guestfs_btrfs_scrub_status (g, path);
      if (r == NULL)
        croak ("%s", guestfs_last_error (g));
      EXTEND (SP, 2 * 15);
      PUSHs (sv_2mortal (newSVpv ("btrfsscrub_data_extents_scrubbed", 0)));
      PUSHs (sv_2mortal (my_newSVull (r->btrfsscrub_data_extents_scrubbed)));
      PUSHs (sv_2mortal (newSVpv ("btrfsscrub_tree_extents_scrubbed", 0)));
      PUSHs (sv_2mortal (my_newSVull (r->btrfsscrub_tree_extents_scrubbed)));
      PUSHs (sv_2mortal (newSVpv ("btrfsscrub_data_bytes_scrubbed", 0)));
      PUSHs (sv_2mortal (my_newSVull (r->btrfsscrub_data_bytes_scrubbed)));
      PUSHs (sv_2mortal (newSVpv ("btrfsscrub_tree_bytes_scrubbed", 0)));
      PUSHs (sv_2mortal (my_newSVull (r->btrfsscrub_tree_bytes_scrubbed)));
      PUSHs (sv_2mortal (newSVpv ("btrfsscrub_read_errors", 0)));
      PUSHs (sv_2mortal (my_newSVull (r->btrfsscrub_read_errors)));
      PUSHs (sv_2mortal (newSVpv ("btrfsscrub_csum_errors", 0)));
      PUSHs (sv_2mortal (my_newSVull (r->btrfsscrub_csum_errors)));
      PUSHs (sv_2mortal (newSVpv ("btrfsscrub_verify_errors", 0)));
      PUSHs (sv_2mortal (my_newSVull (r->btrfsscrub_verify_errors)));
      PUSHs (sv_2mortal (newSVpv ("btrfsscrub_no_csum", 0)));
      PUSHs (sv_2mortal (my_newSVull (r->btrfsscrub_no_csum)));
      PUSHs (sv_2mortal (newSVpv ("btrfsscrub_csum_discards", 0)));
      PUSHs (sv_2mortal (my_newSVull (r->btrfsscrub_csum_discards)));
      PUSHs (sv_2mortal (newSVpv ("btrfsscrub_super_errors", 0)));
      PUSHs (sv_2mortal (my_newSVull (r->btrfsscrub_super_errors)));
      PUSHs (sv_2mortal (newSVpv ("btrfsscrub_malloc_errors", 0)));
      PUSHs (sv_2mortal (my_newSVull (r->btrfsscrub_malloc_errors)));
      PUSHs (sv_2mortal (newSVpv ("btrfsscrub_uncorrectable_errors", 0)));
      PUSHs (sv_2mortal (my_newSVull (r->btrfsscrub_uncorrectable_errors)));
      PUSHs (sv_2mortal (newSVpv ("btrfsscrub_unverified_errors", 0)));
      PUSHs (sv_2mortal (my_newSVull (r->btrfsscrub_unverified_errors)));
      PUSHs (sv_2mortal (newSVpv ("btrfsscrub_corrected_errors", 0)));
      PUSHs (sv_2mortal (my_newSVull (r->btrfsscrub_corrected_errors)));
      PUSHs (sv_2mortal (newSVpv ("btrfsscrub_last_physical", 0)));
      PUSHs (sv_2mortal (my_newSVull (r->btrfsscrub_last_physical)));
      guestfs_free_btrfsscrub (r);
#line 4017 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_btrfs_set_seeding); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_btrfs_set_seeding)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "g, device, seeding");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	device = (char *)SvPV_nolen(ST(1))
;
	int	seeding = (int)SvIV(ST(2))
;
#line 1654 "lib/Sys/Guestfs.xs"
      int r;
#line 4040 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::btrfs_set_seeding(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::btrfs_set_seeding(): g is not a blessed HV reference");
    }
;
#line 1656 "lib/Sys/Guestfs.xs"
      r = guestfs_btrfs_set_seeding (g, device, seeding);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 4058 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_btrfs_subvolume_create); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_btrfs_subvolume_create)
{
    dVAR; dXSARGS;
    if (items < 2)
       croak_xs_usage(cv,  "g, dest, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	dest = (char *)SvPV_nolen(ST(1))
;
#line 1665 "lib/Sys/Guestfs.xs"
      int r;
      struct guestfs_btrfs_subvolume_create_opts_argv optargs_s = { .bitmask = 0 };
      struct guestfs_btrfs_subvolume_create_opts_argv *optargs = &optargs_s;
      size_t items_i;
#line 4082 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::btrfs_subvolume_create(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::btrfs_subvolume_create(): g is not a blessed HV reference");
    }
;
#line 1670 "lib/Sys/Guestfs.xs"
      if (((items - 2) & 1) != 0)
        croak ("expecting an even number of extra parameters");
      for (items_i = 2; items_i < items; items_i += 2) {
        uint64_t this_mask;
        const char *this_arg;

        this_arg = SvPV_nolen (ST (items_i));
        if (STREQ (this_arg, "qgroupid")) {
          optargs_s.qgroupid = SvPV_nolen (ST (items_i+1));
          this_mask = GUESTFS_BTRFS_SUBVOLUME_CREATE_OPTS_QGROUPID_BITMASK;
        }
        else croak ("unknown optional argument '%s'", this_arg);
        if (optargs_s.bitmask & this_mask)
          croak ("optional argument '%s' given more than once",
                 this_arg);
        optargs_s.bitmask |= this_mask;
      }

      r = guestfs_btrfs_subvolume_create_opts_argv (g, dest, optargs);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 4118 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_btrfs_subvolume_delete); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_btrfs_subvolume_delete)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, subvolume");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	subvolume = (char *)SvPV_nolen(ST(1))
;
#line 1697 "lib/Sys/Guestfs.xs"
      int r;
#line 4139 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::btrfs_subvolume_delete(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::btrfs_subvolume_delete(): g is not a blessed HV reference");
    }
;
#line 1699 "lib/Sys/Guestfs.xs"
      r = guestfs_btrfs_subvolume_delete (g, subvolume);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 4157 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_btrfs_subvolume_get_default); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_btrfs_subvolume_get_default)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, fs");
    {
	guestfs_h *	g;
	char *	fs = (char *)SvPV_nolen(ST(1))
;
#line 1708 "lib/Sys/Guestfs.xs"
      int64_t r;
#line 4176 "lib/Sys/Guestfs.c"
	SV *	RETVAL;

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::btrfs_subvolume_get_default(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::btrfs_subvolume_get_default(): g is not a blessed HV reference");
    }
;
#line 1710 "lib/Sys/Guestfs.xs"
      r = guestfs_btrfs_subvolume_get_default (g, fs);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
      RETVAL = my_newSVll (r);
#line 4196 "lib/Sys/Guestfs.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Guestfs_btrfs_subvolume_list); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_btrfs_subvolume_list)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, fs");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	fs = (char *)SvPV_nolen(ST(1))
;
#line 1722 "lib/Sys/Guestfs.xs"
      struct guestfs_btrfssubvolume_list *r;
      size_t i;
      HV *hv;
#line 4220 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::btrfs_subvolume_list(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::btrfs_subvolume_list(): g is not a blessed HV reference");
    }
;
#line 1726 "lib/Sys/Guestfs.xs"
      r = guestfs_btrfs_subvolume_list (g, fs);
      if (r == NULL)
        croak ("%s", guestfs_last_error (g));
      EXTEND (SP, r->len);
      for (i = 0; i < r->len; ++i) {
        hv = newHV ();
        (void) hv_store (hv, "btrfssubvolume_id", 17, my_newSVull (r->val[i].btrfssubvolume_id), 0);
        (void) hv_store (hv, "btrfssubvolume_top_level_id", 27, my_newSVull (r->val[i].btrfssubvolume_top_level_id), 0);
        (void) hv_store (hv, "btrfssubvolume_path", 19, newSVpv (r->val[i].btrfssubvolume_path, 0), 0);
        PUSHs (sv_2mortal (newRV ((SV *) hv)));
      }
      guestfs_free_btrfssubvolume_list (r);
#line 4247 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_btrfs_subvolume_set_default); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_btrfs_subvolume_set_default)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "g, id, fs");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	int64_t    id = my_SvIV64 (ST(1))
;
	char *	fs = (char *)SvPV_nolen(ST(2))
;
#line 1745 "lib/Sys/Guestfs.xs"
      int r;
#line 4270 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::btrfs_subvolume_set_default(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::btrfs_subvolume_set_default(): g is not a blessed HV reference");
    }
;
#line 1747 "lib/Sys/Guestfs.xs"
      r = guestfs_btrfs_subvolume_set_default (g, id, fs);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 4288 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_btrfs_subvolume_show); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_btrfs_subvolume_show)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, subvolume");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	subvolume = (char *)SvPV_nolen(ST(1))
;
#line 1756 "lib/Sys/Guestfs.xs"
      char **r;
      size_t i, n;
#line 4310 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::btrfs_subvolume_show(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::btrfs_subvolume_show(): g is not a blessed HV reference");
    }
;
#line 1759 "lib/Sys/Guestfs.xs"
      r = guestfs_btrfs_subvolume_show (g, subvolume);
      if (r == NULL)
        croak ("%s", guestfs_last_error (g));
      for (n = 0; r[n] != NULL; ++n) /**/;
      EXTEND (SP, n);
      for (i = 0; i < n; ++i) {
        PUSHs (sv_2mortal (newSVpv (r[i], 0)));
        free (r[i]);
      }
      free (r);
#line 4335 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_btrfs_subvolume_snapshot); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_btrfs_subvolume_snapshot)
{
    dVAR; dXSARGS;
    if (items < 3)
       croak_xs_usage(cv,  "g, source, dest, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	source = (char *)SvPV_nolen(ST(1))
;
	char *	dest = (char *)SvPV_nolen(ST(2))
;
#line 1776 "lib/Sys/Guestfs.xs"
      int r;
      struct guestfs_btrfs_subvolume_snapshot_opts_argv optargs_s = { .bitmask = 0 };
      struct guestfs_btrfs_subvolume_snapshot_opts_argv *optargs = &optargs_s;
      size_t items_i;
#line 4361 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::btrfs_subvolume_snapshot(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::btrfs_subvolume_snapshot(): g is not a blessed HV reference");
    }
;
#line 1781 "lib/Sys/Guestfs.xs"
      if (((items - 3) & 1) != 0)
        croak ("expecting an even number of extra parameters");
      for (items_i = 3; items_i < items; items_i += 2) {
        uint64_t this_mask;
        const char *this_arg;

        this_arg = SvPV_nolen (ST (items_i));
        if (STREQ (this_arg, "ro")) {
          optargs_s.ro = SvIV (ST (items_i+1));
          this_mask = GUESTFS_BTRFS_SUBVOLUME_SNAPSHOT_OPTS_RO_BITMASK;
        }
        else if (STREQ (this_arg, "qgroupid")) {
          optargs_s.qgroupid = SvPV_nolen (ST (items_i+1));
          this_mask = GUESTFS_BTRFS_SUBVOLUME_SNAPSHOT_OPTS_QGROUPID_BITMASK;
        }
        else croak ("unknown optional argument '%s'", this_arg);
        if (optargs_s.bitmask & this_mask)
          croak ("optional argument '%s' given more than once",
                 this_arg);
        optargs_s.bitmask |= this_mask;
      }

      r = guestfs_btrfs_subvolume_snapshot_opts_argv (g, source, dest, optargs);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 4401 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_btrfstune_enable_extended_inode_refs); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_btrfstune_enable_extended_inode_refs)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, device");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	device = (char *)SvPV_nolen(ST(1))
;
#line 1812 "lib/Sys/Guestfs.xs"
      int r;
#line 4422 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::btrfstune_enable_extended_inode_refs(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::btrfstune_enable_extended_inode_refs(): g is not a blessed HV reference");
    }
;
#line 1814 "lib/Sys/Guestfs.xs"
      r = guestfs_btrfstune_enable_extended_inode_refs (g, device);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 4440 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_btrfstune_enable_skinny_metadata_extent_refs); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_btrfstune_enable_skinny_metadata_extent_refs)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, device");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	device = (char *)SvPV_nolen(ST(1))
;
#line 1823 "lib/Sys/Guestfs.xs"
      int r;
#line 4461 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::btrfstune_enable_skinny_metadata_extent_refs(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::btrfstune_enable_skinny_metadata_extent_refs(): g is not a blessed HV reference");
    }
;
#line 1825 "lib/Sys/Guestfs.xs"
      r = guestfs_btrfstune_enable_skinny_metadata_extent_refs (g, device);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 4479 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_btrfstune_seeding); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_btrfstune_seeding)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "g, device, seeding");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	device = (char *)SvPV_nolen(ST(1))
;
	int	seeding = (int)SvIV(ST(2))
;
#line 1835 "lib/Sys/Guestfs.xs"
      int r;
#line 4502 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::btrfstune_seeding(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::btrfstune_seeding(): g is not a blessed HV reference");
    }
;
#line 1837 "lib/Sys/Guestfs.xs"
      r = guestfs_btrfstune_seeding (g, device, seeding);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 4520 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_c_pointer); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_c_pointer)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "g");
    {
	guestfs_h *	g;
#line 1845 "lib/Sys/Guestfs.xs"
      int64_t r;
#line 4537 "lib/Sys/Guestfs.c"
	SV *	RETVAL;

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::c_pointer(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::c_pointer(): g is not a blessed HV reference");
    }
;
#line 1847 "lib/Sys/Guestfs.xs"
      r = guestfs_c_pointer (g);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
      RETVAL = my_newSVll (r);
#line 4557 "lib/Sys/Guestfs.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Guestfs_canonical_device_name); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_canonical_device_name)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, device");
    {
	guestfs_h *	g;
	char *	device = (char *)SvPV_nolen(ST(1))
;
#line 1859 "lib/Sys/Guestfs.xs"
      char *r;
#line 4577 "lib/Sys/Guestfs.c"
	SV *	RETVAL;

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::canonical_device_name(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::canonical_device_name(): g is not a blessed HV reference");
    }
;
#line 1861 "lib/Sys/Guestfs.xs"
      r = guestfs_canonical_device_name (g, device);
      if (r == NULL)
        croak ("%s", guestfs_last_error (g));
      RETVAL = newSVpv (r, 0);
      free (r);
#line 4598 "lib/Sys/Guestfs.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Guestfs_cap_get_file); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_cap_get_file)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, path");
    {
	guestfs_h *	g;
	char *	path = (char *)SvPV_nolen(ST(1))
;
#line 1874 "lib/Sys/Guestfs.xs"
      char *r;
#line 4618 "lib/Sys/Guestfs.c"
	SV *	RETVAL;

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::cap_get_file(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::cap_get_file(): g is not a blessed HV reference");
    }
;
#line 1876 "lib/Sys/Guestfs.xs"
      r = guestfs_cap_get_file (g, path);
      if (r == NULL)
        croak ("%s", guestfs_last_error (g));
      RETVAL = newSVpv (r, 0);
      free (r);
#line 4639 "lib/Sys/Guestfs.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Guestfs_cap_set_file); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_cap_set_file)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "g, path, cap");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	path = (char *)SvPV_nolen(ST(1))
;
	char *	cap = (char *)SvPV_nolen(ST(2))
;
#line 1890 "lib/Sys/Guestfs.xs"
      int r;
#line 4663 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::cap_set_file(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::cap_set_file(): g is not a blessed HV reference");
    }
;
#line 1892 "lib/Sys/Guestfs.xs"
      r = guestfs_cap_set_file (g, path, cap);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 4681 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_case_sensitive_path); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_case_sensitive_path)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, path");
    {
	guestfs_h *	g;
	char *	path = (char *)SvPV_nolen(ST(1))
;
#line 1901 "lib/Sys/Guestfs.xs"
      char *r;
#line 4700 "lib/Sys/Guestfs.c"
	SV *	RETVAL;

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::case_sensitive_path(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::case_sensitive_path(): g is not a blessed HV reference");
    }
;
#line 1903 "lib/Sys/Guestfs.xs"
      r = guestfs_case_sensitive_path (g, path);
      if (r == NULL)
        croak ("%s", guestfs_last_error (g));
      RETVAL = newSVpv (r, 0);
      free (r);
#line 4721 "lib/Sys/Guestfs.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Guestfs_cat); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_cat)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, path");
    {
	guestfs_h *	g;
	char *	path = (char *)SvPV_nolen(ST(1))
;
#line 1916 "lib/Sys/Guestfs.xs"
      char *r;
#line 4741 "lib/Sys/Guestfs.c"
	SV *	RETVAL;

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::cat(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::cat(): g is not a blessed HV reference");
    }
;
#line 1918 "lib/Sys/Guestfs.xs"
      r = guestfs_cat (g, path);
      if (r == NULL)
        croak ("%s", guestfs_last_error (g));
      RETVAL = newSVpv (r, 0);
      free (r);
#line 4762 "lib/Sys/Guestfs.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Guestfs_checksum); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_checksum)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "g, csumtype, path");
    {
	guestfs_h *	g;
	char *	csumtype = (char *)SvPV_nolen(ST(1))
;
	char *	path = (char *)SvPV_nolen(ST(2))
;
#line 1932 "lib/Sys/Guestfs.xs"
      char *r;
#line 4784 "lib/Sys/Guestfs.c"
	SV *	RETVAL;

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::checksum(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::checksum(): g is not a blessed HV reference");
    }
;
#line 1934 "lib/Sys/Guestfs.xs"
      r = guestfs_checksum (g, csumtype, path);
      if (r == NULL)
        croak ("%s", guestfs_last_error (g));
      RETVAL = newSVpv (r, 0);
      free (r);
#line 4805 "lib/Sys/Guestfs.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Guestfs_checksum_device); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_checksum_device)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "g, csumtype, device");
    {
	guestfs_h *	g;
	char *	csumtype = (char *)SvPV_nolen(ST(1))
;
	char *	device = (char *)SvPV_nolen(ST(2))
;
#line 1948 "lib/Sys/Guestfs.xs"
      char *r;
#line 4827 "lib/Sys/Guestfs.c"
	SV *	RETVAL;

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::checksum_device(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::checksum_device(): g is not a blessed HV reference");
    }
;
#line 1950 "lib/Sys/Guestfs.xs"
      r = guestfs_checksum_device (g, csumtype, device);
      if (r == NULL)
        croak ("%s", guestfs_last_error (g));
      RETVAL = newSVpv (r, 0);
      free (r);
#line 4848 "lib/Sys/Guestfs.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Guestfs_checksums_out); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_checksums_out)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "g, csumtype, directory, sumsfile");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	csumtype = (char *)SvPV_nolen(ST(1))
;
	char *	directory = (char *)SvPV_nolen(ST(2))
;
	char *	sumsfile = (char *)SvPV_nolen(ST(3))
;
#line 1965 "lib/Sys/Guestfs.xs"
      int r;
#line 4874 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::checksums_out(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::checksums_out(): g is not a blessed HV reference");
    }
;
#line 1967 "lib/Sys/Guestfs.xs"
      r = guestfs_checksums_out (g, csumtype, directory, sumsfile);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 4892 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_chmod); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_chmod)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "g, mode, path");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	int	mode = (int)SvIV(ST(1))
;
	char *	path = (char *)SvPV_nolen(ST(2))
;
#line 1977 "lib/Sys/Guestfs.xs"
      int r;
#line 4915 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::chmod(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::chmod(): g is not a blessed HV reference");
    }
;
#line 1979 "lib/Sys/Guestfs.xs"
      r = guestfs_chmod (g, mode, path);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 4933 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_chown); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_chown)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "g, owner, group, path");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	int	owner = (int)SvIV(ST(1))
;
	int	group = (int)SvIV(ST(2))
;
	char *	path = (char *)SvPV_nolen(ST(3))
;
#line 1990 "lib/Sys/Guestfs.xs"
      int r;
#line 4958 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::chown(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::chown(): g is not a blessed HV reference");
    }
;
#line 1992 "lib/Sys/Guestfs.xs"
      r = guestfs_chown (g, owner, group, path);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 4976 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_clear_backend_setting); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_clear_backend_setting)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, name");
    {
	guestfs_h *	g;
	char *	name = (char *)SvPV_nolen(ST(1))
;
#line 2001 "lib/Sys/Guestfs.xs"
      int r;
#line 4995 "lib/Sys/Guestfs.c"
	SV *	RETVAL;

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::clear_backend_setting(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::clear_backend_setting(): g is not a blessed HV reference");
    }
;
#line 2003 "lib/Sys/Guestfs.xs"
      r = guestfs_clear_backend_setting (g, name);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
      RETVAL = newSViv (r);
#line 5015 "lib/Sys/Guestfs.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Guestfs_clevis_luks_unlock); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_clevis_luks_unlock)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "g, device, mapname");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	device = (char *)SvPV_nolen(ST(1))
;
	char *	mapname = (char *)SvPV_nolen(ST(2))
;
#line 2016 "lib/Sys/Guestfs.xs"
      int r;
#line 5039 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::clevis_luks_unlock(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::clevis_luks_unlock(): g is not a blessed HV reference");
    }
;
#line 2018 "lib/Sys/Guestfs.xs"
      r = guestfs_clevis_luks_unlock (g, device, mapname);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 5057 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_command); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_command)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, arguments");
    {
	guestfs_h *	g;
	char **	arguments = XS_unpack_charPtrPtr(ST(1))
;
#line 2027 "lib/Sys/Guestfs.xs"
      char *r;
#line 5076 "lib/Sys/Guestfs.c"
	SV *	RETVAL;

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::command(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::command(): g is not a blessed HV reference");
    }
;
#line 2029 "lib/Sys/Guestfs.xs"
      r = guestfs_command (g, arguments);
      free (arguments);
      if (r == NULL)
        croak ("%s", guestfs_last_error (g));
      RETVAL = newSVpv (r, 0);
      free (r);
#line 5098 "lib/Sys/Guestfs.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Guestfs_command_lines); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_command_lines)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, arguments");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char **	arguments = XS_unpack_charPtrPtr(ST(1))
;
#line 2043 "lib/Sys/Guestfs.xs"
      char **r;
      size_t i, n;
#line 5121 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::command_lines(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::command_lines(): g is not a blessed HV reference");
    }
;
#line 2046 "lib/Sys/Guestfs.xs"
      r = guestfs_command_lines (g, arguments);
      free (arguments);
      if (r == NULL)
        croak ("%s", guestfs_last_error (g));
      for (n = 0; r[n] != NULL; ++n) /**/;
      EXTEND (SP, n);
      for (i = 0; i < n; ++i) {
        PUSHs (sv_2mortal (newSVpv (r[i], 0)));
        free (r[i]);
      }
      free (r);
#line 5147 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_compress_device_out); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_compress_device_out)
{
    dVAR; dXSARGS;
    if (items < 4)
       croak_xs_usage(cv,  "g, ctype, device, zdevice, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	ctype = (char *)SvPV_nolen(ST(1))
;
	char *	device = (char *)SvPV_nolen(ST(2))
;
	char *	zdevice = (char *)SvPV_nolen(ST(3))
;
#line 2065 "lib/Sys/Guestfs.xs"
      int r;
      struct guestfs_compress_device_out_argv optargs_s = { .bitmask = 0 };
      struct guestfs_compress_device_out_argv *optargs = &optargs_s;
      size_t items_i;
#line 5175 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::compress_device_out(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::compress_device_out(): g is not a blessed HV reference");
    }
;
#line 2070 "lib/Sys/Guestfs.xs"
      if (((items - 4) & 1) != 0)
        croak ("expecting an even number of extra parameters");
      for (items_i = 4; items_i < items; items_i += 2) {
        uint64_t this_mask;
        const char *this_arg;

        this_arg = SvPV_nolen (ST (items_i));
        if (STREQ (this_arg, "level")) {
          optargs_s.level = SvIV (ST (items_i+1));
          this_mask = GUESTFS_COMPRESS_DEVICE_OUT_LEVEL_BITMASK;
        }
        else croak ("unknown optional argument '%s'", this_arg);
        if (optargs_s.bitmask & this_mask)
          croak ("optional argument '%s' given more than once",
                 this_arg);
        optargs_s.bitmask |= this_mask;
      }

      r = guestfs_compress_device_out_argv (g, ctype, device, zdevice, optargs);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 5211 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_compress_out); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_compress_out)
{
    dVAR; dXSARGS;
    if (items < 4)
       croak_xs_usage(cv,  "g, ctype, file, zfile, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	ctype = (char *)SvPV_nolen(ST(1))
;
	char *	file = (char *)SvPV_nolen(ST(2))
;
	char *	zfile = (char *)SvPV_nolen(ST(3))
;
#line 2099 "lib/Sys/Guestfs.xs"
      int r;
      struct guestfs_compress_out_argv optargs_s = { .bitmask = 0 };
      struct guestfs_compress_out_argv *optargs = &optargs_s;
      size_t items_i;
#line 5239 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::compress_out(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::compress_out(): g is not a blessed HV reference");
    }
;
#line 2104 "lib/Sys/Guestfs.xs"
      if (((items - 4) & 1) != 0)
        croak ("expecting an even number of extra parameters");
      for (items_i = 4; items_i < items; items_i += 2) {
        uint64_t this_mask;
        const char *this_arg;

        this_arg = SvPV_nolen (ST (items_i));
        if (STREQ (this_arg, "level")) {
          optargs_s.level = SvIV (ST (items_i+1));
          this_mask = GUESTFS_COMPRESS_OUT_LEVEL_BITMASK;
        }
        else croak ("unknown optional argument '%s'", this_arg);
        if (optargs_s.bitmask & this_mask)
          croak ("optional argument '%s' given more than once",
                 this_arg);
        optargs_s.bitmask |= this_mask;
      }

      r = guestfs_compress_out_argv (g, ctype, file, zfile, optargs);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 5275 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_config); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_config)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "g, hvparam, hvvalue");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	hvparam = (char *)SvPV_nolen(ST(1))
;
	char *	hvvalue = SvOK(ST(2)) ? SvPV_nolen(ST(2)) : NULL;
#line 2132 "lib/Sys/Guestfs.xs"
      int r;
#line 5297 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::config(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::config(): g is not a blessed HV reference");
    }
;
#line 2134 "lib/Sys/Guestfs.xs"
      r = guestfs_config (g, hvparam, hvvalue);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 5315 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_copy_attributes); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_copy_attributes)
{
    dVAR; dXSARGS;
    if (items < 3)
       croak_xs_usage(cv,  "g, src, dest, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	src = (char *)SvPV_nolen(ST(1))
;
	char *	dest = (char *)SvPV_nolen(ST(2))
;
#line 2144 "lib/Sys/Guestfs.xs"
      int r;
      struct guestfs_copy_attributes_argv optargs_s = { .bitmask = 0 };
      struct guestfs_copy_attributes_argv *optargs = &optargs_s;
      size_t items_i;
#line 5341 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::copy_attributes(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::copy_attributes(): g is not a blessed HV reference");
    }
;
#line 2149 "lib/Sys/Guestfs.xs"
      if (((items - 3) & 1) != 0)
        croak ("expecting an even number of extra parameters");
      for (items_i = 3; items_i < items; items_i += 2) {
        uint64_t this_mask;
        const char *this_arg;

        this_arg = SvPV_nolen (ST (items_i));
        if (STREQ (this_arg, "all")) {
          optargs_s.all = SvIV (ST (items_i+1));
          this_mask = GUESTFS_COPY_ATTRIBUTES_ALL_BITMASK;
        }
        else if (STREQ (this_arg, "mode")) {
          optargs_s.mode = SvIV (ST (items_i+1));
          this_mask = GUESTFS_COPY_ATTRIBUTES_MODE_BITMASK;
        }
        else if (STREQ (this_arg, "xattributes")) {
          optargs_s.xattributes = SvIV (ST (items_i+1));
          this_mask = GUESTFS_COPY_ATTRIBUTES_XATTRIBUTES_BITMASK;
        }
        else if (STREQ (this_arg, "ownership")) {
          optargs_s.ownership = SvIV (ST (items_i+1));
          this_mask = GUESTFS_COPY_ATTRIBUTES_OWNERSHIP_BITMASK;
        }
        else croak ("unknown optional argument '%s'", this_arg);
        if (optargs_s.bitmask & this_mask)
          croak ("optional argument '%s' given more than once",
                 this_arg);
        optargs_s.bitmask |= this_mask;
      }

      r = guestfs_copy_attributes_argv (g, src, dest, optargs);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 5389 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_copy_device_to_device); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_copy_device_to_device)
{
    dVAR; dXSARGS;
    if (items < 3)
       croak_xs_usage(cv,  "g, src, dest, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	src = (char *)SvPV_nolen(ST(1))
;
	char *	dest = (char *)SvPV_nolen(ST(2))
;
#line 2189 "lib/Sys/Guestfs.xs"
      int r;
      struct guestfs_copy_device_to_device_argv optargs_s = { .bitmask = 0 };
      struct guestfs_copy_device_to_device_argv *optargs = &optargs_s;
      size_t items_i;
#line 5415 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::copy_device_to_device(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::copy_device_to_device(): g is not a blessed HV reference");
    }
;
#line 2194 "lib/Sys/Guestfs.xs"
      if (((items - 3) & 1) != 0)
        croak ("expecting an even number of extra parameters");
      for (items_i = 3; items_i < items; items_i += 2) {
        uint64_t this_mask;
        const char *this_arg;

        this_arg = SvPV_nolen (ST (items_i));
        if (STREQ (this_arg, "srcoffset")) {
          optargs_s.srcoffset = my_SvIV64 (ST (items_i+1));
          this_mask = GUESTFS_COPY_DEVICE_TO_DEVICE_SRCOFFSET_BITMASK;
        }
        else if (STREQ (this_arg, "destoffset")) {
          optargs_s.destoffset = my_SvIV64 (ST (items_i+1));
          this_mask = GUESTFS_COPY_DEVICE_TO_DEVICE_DESTOFFSET_BITMASK;
        }
        else if (STREQ (this_arg, "size")) {
          optargs_s.size = my_SvIV64 (ST (items_i+1));
          this_mask = GUESTFS_COPY_DEVICE_TO_DEVICE_SIZE_BITMASK;
        }
        else if (STREQ (this_arg, "sparse")) {
          optargs_s.sparse = SvIV (ST (items_i+1));
          this_mask = GUESTFS_COPY_DEVICE_TO_DEVICE_SPARSE_BITMASK;
        }
        else if (STREQ (this_arg, "append")) {
          optargs_s.append = SvIV (ST (items_i+1));
          this_mask = GUESTFS_COPY_DEVICE_TO_DEVICE_APPEND_BITMASK;
        }
        else croak ("unknown optional argument '%s'", this_arg);
        if (optargs_s.bitmask & this_mask)
          croak ("optional argument '%s' given more than once",
                 this_arg);
        optargs_s.bitmask |= this_mask;
      }

      r = guestfs_copy_device_to_device_argv (g, src, dest, optargs);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 5467 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_copy_device_to_file); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_copy_device_to_file)
{
    dVAR; dXSARGS;
    if (items < 3)
       croak_xs_usage(cv,  "g, src, dest, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	src = (char *)SvPV_nolen(ST(1))
;
	char *	dest = (char *)SvPV_nolen(ST(2))
;
#line 2238 "lib/Sys/Guestfs.xs"
      int r;
      struct guestfs_copy_device_to_file_argv optargs_s = { .bitmask = 0 };
      struct guestfs_copy_device_to_file_argv *optargs = &optargs_s;
      size_t items_i;
#line 5493 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::copy_device_to_file(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::copy_device_to_file(): g is not a blessed HV reference");
    }
;
#line 2243 "lib/Sys/Guestfs.xs"
      if (((items - 3) & 1) != 0)
        croak ("expecting an even number of extra parameters");
      for (items_i = 3; items_i < items; items_i += 2) {
        uint64_t this_mask;
        const char *this_arg;

        this_arg = SvPV_nolen (ST (items_i));
        if (STREQ (this_arg, "srcoffset")) {
          optargs_s.srcoffset = my_SvIV64 (ST (items_i+1));
          this_mask = GUESTFS_COPY_DEVICE_TO_FILE_SRCOFFSET_BITMASK;
        }
        else if (STREQ (this_arg, "destoffset")) {
          optargs_s.destoffset = my_SvIV64 (ST (items_i+1));
          this_mask = GUESTFS_COPY_DEVICE_TO_FILE_DESTOFFSET_BITMASK;
        }
        else if (STREQ (this_arg, "size")) {
          optargs_s.size = my_SvIV64 (ST (items_i+1));
          this_mask = GUESTFS_COPY_DEVICE_TO_FILE_SIZE_BITMASK;
        }
        else if (STREQ (this_arg, "sparse")) {
          optargs_s.sparse = SvIV (ST (items_i+1));
          this_mask = GUESTFS_COPY_DEVICE_TO_FILE_SPARSE_BITMASK;
        }
        else if (STREQ (this_arg, "append")) {
          optargs_s.append = SvIV (ST (items_i+1));
          this_mask = GUESTFS_COPY_DEVICE_TO_FILE_APPEND_BITMASK;
        }
        else croak ("unknown optional argument '%s'", this_arg);
        if (optargs_s.bitmask & this_mask)
          croak ("optional argument '%s' given more than once",
                 this_arg);
        optargs_s.bitmask |= this_mask;
      }

      r = guestfs_copy_device_to_file_argv (g, src, dest, optargs);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 5545 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_copy_file_to_device); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_copy_file_to_device)
{
    dVAR; dXSARGS;
    if (items < 3)
       croak_xs_usage(cv,  "g, src, dest, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	src = (char *)SvPV_nolen(ST(1))
;
	char *	dest = (char *)SvPV_nolen(ST(2))
;
#line 2287 "lib/Sys/Guestfs.xs"
      int r;
      struct guestfs_copy_file_to_device_argv optargs_s = { .bitmask = 0 };
      struct guestfs_copy_file_to_device_argv *optargs = &optargs_s;
      size_t items_i;
#line 5571 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::copy_file_to_device(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::copy_file_to_device(): g is not a blessed HV reference");
    }
;
#line 2292 "lib/Sys/Guestfs.xs"
      if (((items - 3) & 1) != 0)
        croak ("expecting an even number of extra parameters");
      for (items_i = 3; items_i < items; items_i += 2) {
        uint64_t this_mask;
        const char *this_arg;

        this_arg = SvPV_nolen (ST (items_i));
        if (STREQ (this_arg, "srcoffset")) {
          optargs_s.srcoffset = my_SvIV64 (ST (items_i+1));
          this_mask = GUESTFS_COPY_FILE_TO_DEVICE_SRCOFFSET_BITMASK;
        }
        else if (STREQ (this_arg, "destoffset")) {
          optargs_s.destoffset = my_SvIV64 (ST (items_i+1));
          this_mask = GUESTFS_COPY_FILE_TO_DEVICE_DESTOFFSET_BITMASK;
        }
        else if (STREQ (this_arg, "size")) {
          optargs_s.size = my_SvIV64 (ST (items_i+1));
          this_mask = GUESTFS_COPY_FILE_TO_DEVICE_SIZE_BITMASK;
        }
        else if (STREQ (this_arg, "sparse")) {
          optargs_s.sparse = SvIV (ST (items_i+1));
          this_mask = GUESTFS_COPY_FILE_TO_DEVICE_SPARSE_BITMASK;
        }
        else if (STREQ (this_arg, "append")) {
          optargs_s.append = SvIV (ST (items_i+1));
          this_mask = GUESTFS_COPY_FILE_TO_DEVICE_APPEND_BITMASK;
        }
        else croak ("unknown optional argument '%s'", this_arg);
        if (optargs_s.bitmask & this_mask)
          croak ("optional argument '%s' given more than once",
                 this_arg);
        optargs_s.bitmask |= this_mask;
      }

      r = guestfs_copy_file_to_device_argv (g, src, dest, optargs);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 5623 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_copy_file_to_file); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_copy_file_to_file)
{
    dVAR; dXSARGS;
    if (items < 3)
       croak_xs_usage(cv,  "g, src, dest, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	src = (char *)SvPV_nolen(ST(1))
;
	char *	dest = (char *)SvPV_nolen(ST(2))
;
#line 2336 "lib/Sys/Guestfs.xs"
      int r;
      struct guestfs_copy_file_to_file_argv optargs_s = { .bitmask = 0 };
      struct guestfs_copy_file_to_file_argv *optargs = &optargs_s;
      size_t items_i;
#line 5649 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::copy_file_to_file(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::copy_file_to_file(): g is not a blessed HV reference");
    }
;
#line 2341 "lib/Sys/Guestfs.xs"
      if (((items - 3) & 1) != 0)
        croak ("expecting an even number of extra parameters");
      for (items_i = 3; items_i < items; items_i += 2) {
        uint64_t this_mask;
        const char *this_arg;

        this_arg = SvPV_nolen (ST (items_i));
        if (STREQ (this_arg, "srcoffset")) {
          optargs_s.srcoffset = my_SvIV64 (ST (items_i+1));
          this_mask = GUESTFS_COPY_FILE_TO_FILE_SRCOFFSET_BITMASK;
        }
        else if (STREQ (this_arg, "destoffset")) {
          optargs_s.destoffset = my_SvIV64 (ST (items_i+1));
          this_mask = GUESTFS_COPY_FILE_TO_FILE_DESTOFFSET_BITMASK;
        }
        else if (STREQ (this_arg, "size")) {
          optargs_s.size = my_SvIV64 (ST (items_i+1));
          this_mask = GUESTFS_COPY_FILE_TO_FILE_SIZE_BITMASK;
        }
        else if (STREQ (this_arg, "sparse")) {
          optargs_s.sparse = SvIV (ST (items_i+1));
          this_mask = GUESTFS_COPY_FILE_TO_FILE_SPARSE_BITMASK;
        }
        else if (STREQ (this_arg, "append")) {
          optargs_s.append = SvIV (ST (items_i+1));
          this_mask = GUESTFS_COPY_FILE_TO_FILE_APPEND_BITMASK;
        }
        else croak ("unknown optional argument '%s'", this_arg);
        if (optargs_s.bitmask & this_mask)
          croak ("optional argument '%s' given more than once",
                 this_arg);
        optargs_s.bitmask |= this_mask;
      }

      r = guestfs_copy_file_to_file_argv (g, src, dest, optargs);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 5701 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_copy_in); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_copy_in)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "g, localpath, remotedir");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	localpath = (char *)SvPV_nolen(ST(1))
;
	char *	remotedir = (char *)SvPV_nolen(ST(2))
;
#line 2385 "lib/Sys/Guestfs.xs"
      int r;
#line 5724 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::copy_in(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::copy_in(): g is not a blessed HV reference");
    }
;
#line 2387 "lib/Sys/Guestfs.xs"
      r = guestfs_copy_in (g, localpath, remotedir);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 5742 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_copy_out); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_copy_out)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "g, remotepath, localdir");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	remotepath = (char *)SvPV_nolen(ST(1))
;
	char *	localdir = (char *)SvPV_nolen(ST(2))
;
#line 2397 "lib/Sys/Guestfs.xs"
      int r;
#line 5765 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::copy_out(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::copy_out(): g is not a blessed HV reference");
    }
;
#line 2399 "lib/Sys/Guestfs.xs"
      r = guestfs_copy_out (g, remotepath, localdir);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 5783 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_copy_size); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_copy_size)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "g, src, dest, size");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	src = (char *)SvPV_nolen(ST(1))
;
	char *	dest = (char *)SvPV_nolen(ST(2))
;
	int64_t    size = my_SvIV64 (ST(3))
;
#line 2410 "lib/Sys/Guestfs.xs"
      int r;
#line 5808 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::copy_size(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::copy_size(): g is not a blessed HV reference");
    }
;
#line 2412 "lib/Sys/Guestfs.xs"
      Perl_ck_warner (aTHX_ packWARN(WARN_DEPRECATED),
        "Sys::Guestfs::copy_size is deprecated; use Sys::Guestfs::copy_device_to_device instead");
      r = guestfs_copy_size (g, src, dest, size);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 5828 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_cp); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_cp)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "g, src, dest");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	src = (char *)SvPV_nolen(ST(1))
;
	char *	dest = (char *)SvPV_nolen(ST(2))
;
#line 2424 "lib/Sys/Guestfs.xs"
      int r;
#line 5851 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::cp(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::cp(): g is not a blessed HV reference");
    }
;
#line 2426 "lib/Sys/Guestfs.xs"
      r = guestfs_cp (g, src, dest);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 5869 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_cp_a); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_cp_a)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "g, src, dest");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	src = (char *)SvPV_nolen(ST(1))
;
	char *	dest = (char *)SvPV_nolen(ST(2))
;
#line 2436 "lib/Sys/Guestfs.xs"
      int r;
#line 5892 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::cp_a(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::cp_a(): g is not a blessed HV reference");
    }
;
#line 2438 "lib/Sys/Guestfs.xs"
      r = guestfs_cp_a (g, src, dest);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 5910 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_cp_r); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_cp_r)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "g, src, dest");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	src = (char *)SvPV_nolen(ST(1))
;
	char *	dest = (char *)SvPV_nolen(ST(2))
;
#line 2448 "lib/Sys/Guestfs.xs"
      int r;
#line 5933 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::cp_r(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::cp_r(): g is not a blessed HV reference");
    }
;
#line 2450 "lib/Sys/Guestfs.xs"
      r = guestfs_cp_r (g, src, dest);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 5951 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_cpio_out); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_cpio_out)
{
    dVAR; dXSARGS;
    if (items < 3)
       croak_xs_usage(cv,  "g, directory, cpiofile, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	directory = (char *)SvPV_nolen(ST(1))
;
	char *	cpiofile = (char *)SvPV_nolen(ST(2))
;
#line 2460 "lib/Sys/Guestfs.xs"
      int r;
      struct guestfs_cpio_out_argv optargs_s = { .bitmask = 0 };
      struct guestfs_cpio_out_argv *optargs = &optargs_s;
      size_t items_i;
#line 5977 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::cpio_out(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::cpio_out(): g is not a blessed HV reference");
    }
;
#line 2465 "lib/Sys/Guestfs.xs"
      if (((items - 3) & 1) != 0)
        croak ("expecting an even number of extra parameters");
      for (items_i = 3; items_i < items; items_i += 2) {
        uint64_t this_mask;
        const char *this_arg;

        this_arg = SvPV_nolen (ST (items_i));
        if (STREQ (this_arg, "format")) {
          optargs_s.format = SvPV_nolen (ST (items_i+1));
          this_mask = GUESTFS_CPIO_OUT_FORMAT_BITMASK;
        }
        else croak ("unknown optional argument '%s'", this_arg);
        if (optargs_s.bitmask & this_mask)
          croak ("optional argument '%s' given more than once",
                 this_arg);
        optargs_s.bitmask |= this_mask;
      }

      r = guestfs_cpio_out_argv (g, directory, cpiofile, optargs);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 6013 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_cryptsetup_close); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_cryptsetup_close)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, device");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	device = (char *)SvPV_nolen(ST(1))
;
#line 2492 "lib/Sys/Guestfs.xs"
      int r;
#line 6034 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::cryptsetup_close(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::cryptsetup_close(): g is not a blessed HV reference");
    }
;
#line 2494 "lib/Sys/Guestfs.xs"
      r = guestfs_cryptsetup_close (g, device);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 6052 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_cryptsetup_open); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_cryptsetup_open)
{
    dVAR; dXSARGS;
    if (items < 4)
       croak_xs_usage(cv,  "g, device, key, mapname, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	device = (char *)SvPV_nolen(ST(1))
;
	char *	key = (char *)SvPV_nolen(ST(2))
;
	char *	mapname = (char *)SvPV_nolen(ST(3))
;
#line 2505 "lib/Sys/Guestfs.xs"
      int r;
      struct guestfs_cryptsetup_open_argv optargs_s = { .bitmask = 0 };
      struct guestfs_cryptsetup_open_argv *optargs = &optargs_s;
      size_t items_i;
#line 6080 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::cryptsetup_open(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::cryptsetup_open(): g is not a blessed HV reference");
    }
;
#line 2510 "lib/Sys/Guestfs.xs"
      if (((items - 4) & 1) != 0)
        croak ("expecting an even number of extra parameters");
      for (items_i = 4; items_i < items; items_i += 2) {
        uint64_t this_mask;
        const char *this_arg;

        this_arg = SvPV_nolen (ST (items_i));
        if (STREQ (this_arg, "readonly")) {
          optargs_s.readonly = SvIV (ST (items_i+1));
          this_mask = GUESTFS_CRYPTSETUP_OPEN_READONLY_BITMASK;
        }
        else if (STREQ (this_arg, "crypttype")) {
          optargs_s.crypttype = SvPV_nolen (ST (items_i+1));
          this_mask = GUESTFS_CRYPTSETUP_OPEN_CRYPTTYPE_BITMASK;
        }
        else if (STREQ (this_arg, "cipher")) {
          optargs_s.cipher = SvPV_nolen (ST (items_i+1));
          this_mask = GUESTFS_CRYPTSETUP_OPEN_CIPHER_BITMASK;
        }
        else croak ("unknown optional argument '%s'", this_arg);
        if (optargs_s.bitmask & this_mask)
          croak ("optional argument '%s' given more than once",
                 this_arg);
        optargs_s.bitmask |= this_mask;
      }

      r = guestfs_cryptsetup_open_argv (g, device, key, mapname, optargs);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 6124 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_dd); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_dd)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "g, src, dest");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	src = (char *)SvPV_nolen(ST(1))
;
	char *	dest = (char *)SvPV_nolen(ST(2))
;
#line 2546 "lib/Sys/Guestfs.xs"
      int r;
#line 6147 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::dd(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::dd(): g is not a blessed HV reference");
    }
;
#line 2548 "lib/Sys/Guestfs.xs"
      Perl_ck_warner (aTHX_ packWARN(WARN_DEPRECATED),
        "Sys::Guestfs::dd is deprecated; use Sys::Guestfs::copy_device_to_device instead");
      r = guestfs_dd (g, src, dest);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 6167 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_debug); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_debug)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "g, subcmd, extraargs");
    {
	guestfs_h *	g;
	char *	subcmd = (char *)SvPV_nolen(ST(1))
;
	char **	extraargs = XS_unpack_charPtrPtr(ST(2))
;
#line 2560 "lib/Sys/Guestfs.xs"
      char *r;
#line 6188 "lib/Sys/Guestfs.c"
	SV *	RETVAL;

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::debug(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::debug(): g is not a blessed HV reference");
    }
;
#line 2562 "lib/Sys/Guestfs.xs"
      r = guestfs_debug (g, subcmd, extraargs);
      free (extraargs);
      if (r == NULL)
        croak ("%s", guestfs_last_error (g));
      RETVAL = newSVpv (r, 0);
      free (r);
#line 6210 "lib/Sys/Guestfs.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Guestfs_debug_drives); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_debug_drives)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "g");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
#line 2575 "lib/Sys/Guestfs.xs"
      char **r;
      size_t i, n;
#line 6231 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::debug_drives(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::debug_drives(): g is not a blessed HV reference");
    }
;
#line 2578 "lib/Sys/Guestfs.xs"
      r = guestfs_debug_drives (g);
      if (r == NULL)
        croak ("%s", guestfs_last_error (g));
      for (n = 0; r[n] != NULL; ++n) /**/;
      EXTEND (SP, n);
      for (i = 0; i < n; ++i) {
        PUSHs (sv_2mortal (newSVpv (r[i], 0)));
        free (r[i]);
      }
      free (r);
#line 6256 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_debug_upload); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_debug_upload)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "g, filename, tmpname, mode");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	filename = (char *)SvPV_nolen(ST(1))
;
	char *	tmpname = (char *)SvPV_nolen(ST(2))
;
	int	mode = (int)SvIV(ST(3))
;
#line 2596 "lib/Sys/Guestfs.xs"
      int r;
#line 6281 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::debug_upload(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::debug_upload(): g is not a blessed HV reference");
    }
;
#line 2598 "lib/Sys/Guestfs.xs"
      r = guestfs_debug_upload (g, filename, tmpname, mode);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 6299 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_device_index); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_device_index)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, device");
    {
	guestfs_h *	g;
	char *	device = (char *)SvPV_nolen(ST(1))
;
#line 2607 "lib/Sys/Guestfs.xs"
      int r;
#line 6318 "lib/Sys/Guestfs.c"
	SV *	RETVAL;

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::device_index(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::device_index(): g is not a blessed HV reference");
    }
;
#line 2609 "lib/Sys/Guestfs.xs"
      r = guestfs_device_index (g, device);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
      RETVAL = newSViv (r);
#line 6338 "lib/Sys/Guestfs.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Guestfs_device_name); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_device_name)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, index");
    {
	guestfs_h *	g;
	int	index = (int)SvIV(ST(1))
;
#line 2621 "lib/Sys/Guestfs.xs"
      char *r;
#line 6358 "lib/Sys/Guestfs.c"
	SV *	RETVAL;

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::device_name(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::device_name(): g is not a blessed HV reference");
    }
;
#line 2623 "lib/Sys/Guestfs.xs"
      r = guestfs_device_name (g, index);
      if (r == NULL)
        croak ("%s", guestfs_last_error (g));
      RETVAL = newSVpv (r, 0);
      free (r);
#line 6379 "lib/Sys/Guestfs.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Guestfs_df); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_df)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "g");
    {
	guestfs_h *	g;
#line 2635 "lib/Sys/Guestfs.xs"
      char *r;
#line 6397 "lib/Sys/Guestfs.c"
	SV *	RETVAL;

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::df(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::df(): g is not a blessed HV reference");
    }
;
#line 2637 "lib/Sys/Guestfs.xs"
      r = guestfs_df (g);
      if (r == NULL)
        croak ("%s", guestfs_last_error (g));
      RETVAL = newSVpv (r, 0);
      free (r);
#line 6418 "lib/Sys/Guestfs.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Guestfs_df_h); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_df_h)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "g");
    {
	guestfs_h *	g;
#line 2649 "lib/Sys/Guestfs.xs"
      char *r;
#line 6436 "lib/Sys/Guestfs.c"
	SV *	RETVAL;

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::df_h(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::df_h(): g is not a blessed HV reference");
    }
;
#line 2651 "lib/Sys/Guestfs.xs"
      r = guestfs_df_h (g);
      if (r == NULL)
        croak ("%s", guestfs_last_error (g));
      RETVAL = newSVpv (r, 0);
      free (r);
#line 6457 "lib/Sys/Guestfs.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Guestfs_disk_create); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_disk_create)
{
    dVAR; dXSARGS;
    if (items < 4)
       croak_xs_usage(cv,  "g, filename, format, size, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	filename = (char *)SvPV_nolen(ST(1))
;
	char *	format = (char *)SvPV_nolen(ST(2))
;
	int64_t    size = my_SvIV64 (ST(3))
;
#line 2666 "lib/Sys/Guestfs.xs"
      int r;
      struct guestfs_disk_create_argv optargs_s = { .bitmask = 0 };
      struct guestfs_disk_create_argv *optargs = &optargs_s;
      size_t items_i;
#line 6486 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::disk_create(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::disk_create(): g is not a blessed HV reference");
    }
;
#line 2671 "lib/Sys/Guestfs.xs"
      if (((items - 4) & 1) != 0)
        croak ("expecting an even number of extra parameters");
      for (items_i = 4; items_i < items; items_i += 2) {
        uint64_t this_mask;
        const char *this_arg;

        this_arg = SvPV_nolen (ST (items_i));
        if (STREQ (this_arg, "backingfile")) {
          optargs_s.backingfile = SvPV_nolen (ST (items_i+1));
          this_mask = GUESTFS_DISK_CREATE_BACKINGFILE_BITMASK;
        }
        else if (STREQ (this_arg, "backingformat")) {
          optargs_s.backingformat = SvPV_nolen (ST (items_i+1));
          this_mask = GUESTFS_DISK_CREATE_BACKINGFORMAT_BITMASK;
        }
        else if (STREQ (this_arg, "preallocation")) {
          optargs_s.preallocation = SvPV_nolen (ST (items_i+1));
          this_mask = GUESTFS_DISK_CREATE_PREALLOCATION_BITMASK;
        }
        else if (STREQ (this_arg, "compat")) {
          optargs_s.compat = SvPV_nolen (ST (items_i+1));
          this_mask = GUESTFS_DISK_CREATE_COMPAT_BITMASK;
        }
        else if (STREQ (this_arg, "clustersize")) {
          optargs_s.clustersize = SvIV (ST (items_i+1));
          this_mask = GUESTFS_DISK_CREATE_CLUSTERSIZE_BITMASK;
        }
        else croak ("unknown optional argument '%s'", this_arg);
        if (optargs_s.bitmask & this_mask)
          croak ("optional argument '%s' given more than once",
                 this_arg);
        optargs_s.bitmask |= this_mask;
      }

      r = guestfs_disk_create_argv (g, filename, format, size, optargs);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 6538 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_disk_format); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_disk_format)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, filename");
    {
	guestfs_h *	g;
	char *	filename = (char *)SvPV_nolen(ST(1))
;
#line 2714 "lib/Sys/Guestfs.xs"
      char *r;
#line 6557 "lib/Sys/Guestfs.c"
	SV *	RETVAL;

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::disk_format(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::disk_format(): g is not a blessed HV reference");
    }
;
#line 2716 "lib/Sys/Guestfs.xs"
      r = guestfs_disk_format (g, filename);
      if (r == NULL)
        croak ("%s", guestfs_last_error (g));
      RETVAL = newSVpv (r, 0);
      free (r);
#line 6578 "lib/Sys/Guestfs.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Guestfs_disk_has_backing_file); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_disk_has_backing_file)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, filename");
    {
	guestfs_h *	g;
	char *	filename = (char *)SvPV_nolen(ST(1))
;
#line 2729 "lib/Sys/Guestfs.xs"
      int r;
#line 6598 "lib/Sys/Guestfs.c"
	SV *	RETVAL;

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::disk_has_backing_file(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::disk_has_backing_file(): g is not a blessed HV reference");
    }
;
#line 2731 "lib/Sys/Guestfs.xs"
      r = guestfs_disk_has_backing_file (g, filename);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
      RETVAL = newSViv (r);
#line 6618 "lib/Sys/Guestfs.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Guestfs_disk_virtual_size); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_disk_virtual_size)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, filename");
    {
	guestfs_h *	g;
	char *	filename = (char *)SvPV_nolen(ST(1))
;
#line 2743 "lib/Sys/Guestfs.xs"
      int64_t r;
#line 6638 "lib/Sys/Guestfs.c"
	SV *	RETVAL;

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::disk_virtual_size(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::disk_virtual_size(): g is not a blessed HV reference");
    }
;
#line 2745 "lib/Sys/Guestfs.xs"
      r = guestfs_disk_virtual_size (g, filename);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
      RETVAL = my_newSVll (r);
#line 6658 "lib/Sys/Guestfs.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Guestfs_dmesg); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_dmesg)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "g");
    {
	guestfs_h *	g;
#line 2756 "lib/Sys/Guestfs.xs"
      char *r;
#line 6676 "lib/Sys/Guestfs.c"
	SV *	RETVAL;

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::dmesg(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::dmesg(): g is not a blessed HV reference");
    }
;
#line 2758 "lib/Sys/Guestfs.xs"
      r = guestfs_dmesg (g);
      if (r == NULL)
        croak ("%s", guestfs_last_error (g));
      RETVAL = newSVpv (r, 0);
      free (r);
#line 6697 "lib/Sys/Guestfs.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Guestfs_download); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_download)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "g, remotefilename, filename");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	remotefilename = (char *)SvPV_nolen(ST(1))
;
	char *	filename = (char *)SvPV_nolen(ST(2))
;
#line 2772 "lib/Sys/Guestfs.xs"
      int r;
#line 6721 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::download(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::download(): g is not a blessed HV reference");
    }
;
#line 2774 "lib/Sys/Guestfs.xs"
      r = guestfs_download (g, remotefilename, filename);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 6739 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_download_blocks); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_download_blocks)
{
    dVAR; dXSARGS;
    if (items < 5)
       croak_xs_usage(cv,  "g, device, start, stop, filename, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	device = (char *)SvPV_nolen(ST(1))
;
	int64_t    start = my_SvIV64 (ST(2))
;
	int64_t    stop = my_SvIV64 (ST(3))
;
	char *	filename = (char *)SvPV_nolen(ST(4))
;
#line 2786 "lib/Sys/Guestfs.xs"
      int r;
      struct guestfs_download_blocks_argv optargs_s = { .bitmask = 0 };
      struct guestfs_download_blocks_argv *optargs = &optargs_s;
      size_t items_i;
#line 6769 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::download_blocks(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::download_blocks(): g is not a blessed HV reference");
    }
;
#line 2791 "lib/Sys/Guestfs.xs"
      if (((items - 5) & 1) != 0)
        croak ("expecting an even number of extra parameters");
      for (items_i = 5; items_i < items; items_i += 2) {
        uint64_t this_mask;
        const char *this_arg;

        this_arg = SvPV_nolen (ST (items_i));
        if (STREQ (this_arg, "unallocated")) {
          optargs_s.unallocated = SvIV (ST (items_i+1));
          this_mask = GUESTFS_DOWNLOAD_BLOCKS_UNALLOCATED_BITMASK;
        }
        else croak ("unknown optional argument '%s'", this_arg);
        if (optargs_s.bitmask & this_mask)
          croak ("optional argument '%s' given more than once",
                 this_arg);
        optargs_s.bitmask |= this_mask;
      }

      r = guestfs_download_blocks_argv (g, device, start, stop, filename, optargs);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 6805 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_download_inode); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_download_inode)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "g, device, inode, filename");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	device = (char *)SvPV_nolen(ST(1))
;
	int64_t    inode = my_SvIV64 (ST(2))
;
	char *	filename = (char *)SvPV_nolen(ST(3))
;
#line 2820 "lib/Sys/Guestfs.xs"
      int r;
#line 6830 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::download_inode(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::download_inode(): g is not a blessed HV reference");
    }
;
#line 2822 "lib/Sys/Guestfs.xs"
      r = guestfs_download_inode (g, device, inode, filename);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 6848 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_download_offset); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_download_offset)
{
    dVAR; dXSARGS;
    if (items != 5)
       croak_xs_usage(cv,  "g, remotefilename, filename, offset, size");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	remotefilename = (char *)SvPV_nolen(ST(1))
;
	char *	filename = (char *)SvPV_nolen(ST(2))
;
	int64_t    offset = my_SvIV64 (ST(3))
;
	int64_t    size = my_SvIV64 (ST(4))
;
#line 2834 "lib/Sys/Guestfs.xs"
      int r;
#line 6875 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::download_offset(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::download_offset(): g is not a blessed HV reference");
    }
;
#line 2836 "lib/Sys/Guestfs.xs"
      r = guestfs_download_offset (g, remotefilename, filename, offset, size);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 6893 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_drop_caches); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_drop_caches)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, whattodrop");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	int	whattodrop = (int)SvIV(ST(1))
;
#line 2845 "lib/Sys/Guestfs.xs"
      int r;
#line 6914 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::drop_caches(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::drop_caches(): g is not a blessed HV reference");
    }
;
#line 2847 "lib/Sys/Guestfs.xs"
      r = guestfs_drop_caches (g, whattodrop);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 6932 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_du); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_du)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, path");
    {
	guestfs_h *	g;
	char *	path = (char *)SvPV_nolen(ST(1))
;
#line 2856 "lib/Sys/Guestfs.xs"
      int64_t r;
#line 6951 "lib/Sys/Guestfs.c"
	SV *	RETVAL;

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::du(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::du(): g is not a blessed HV reference");
    }
;
#line 2858 "lib/Sys/Guestfs.xs"
      r = guestfs_du (g, path);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
      RETVAL = my_newSVll (r);
#line 6971 "lib/Sys/Guestfs.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Guestfs_e2fsck); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_e2fsck)
{
    dVAR; dXSARGS;
    if (items < 2)
       croak_xs_usage(cv,  "g, device, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	device = (char *)SvPV_nolen(ST(1))
;
#line 2870 "lib/Sys/Guestfs.xs"
      int r;
      struct guestfs_e2fsck_argv optargs_s = { .bitmask = 0 };
      struct guestfs_e2fsck_argv *optargs = &optargs_s;
      size_t items_i;
#line 6996 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::e2fsck(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::e2fsck(): g is not a blessed HV reference");
    }
;
#line 2875 "lib/Sys/Guestfs.xs"
      if (((items - 2) & 1) != 0)
        croak ("expecting an even number of extra parameters");
      for (items_i = 2; items_i < items; items_i += 2) {
        uint64_t this_mask;
        const char *this_arg;

        this_arg = SvPV_nolen (ST (items_i));
        if (STREQ (this_arg, "correct")) {
          optargs_s.correct = SvIV (ST (items_i+1));
          this_mask = GUESTFS_E2FSCK_CORRECT_BITMASK;
        }
        else if (STREQ (this_arg, "forceall")) {
          optargs_s.forceall = SvIV (ST (items_i+1));
          this_mask = GUESTFS_E2FSCK_FORCEALL_BITMASK;
        }
        else croak ("unknown optional argument '%s'", this_arg);
        if (optargs_s.bitmask & this_mask)
          croak ("optional argument '%s' given more than once",
                 this_arg);
        optargs_s.bitmask |= this_mask;
      }

      r = guestfs_e2fsck_argv (g, device, optargs);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 7036 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_e2fsck_f); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_e2fsck_f)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, device");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	device = (char *)SvPV_nolen(ST(1))
;
#line 2906 "lib/Sys/Guestfs.xs"
      int r;
#line 7057 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::e2fsck_f(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::e2fsck_f(): g is not a blessed HV reference");
    }
;
#line 2908 "lib/Sys/Guestfs.xs"
      Perl_ck_warner (aTHX_ packWARN(WARN_DEPRECATED),
        "Sys::Guestfs::e2fsck_f is deprecated; use Sys::Guestfs::e2fsck instead");
      r = guestfs_e2fsck_f (g, device);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 7077 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_echo_daemon); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_echo_daemon)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, words");
    {
	guestfs_h *	g;
	char **	words = XS_unpack_charPtrPtr(ST(1))
;
#line 2919 "lib/Sys/Guestfs.xs"
      char *r;
#line 7096 "lib/Sys/Guestfs.c"
	SV *	RETVAL;

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::echo_daemon(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::echo_daemon(): g is not a blessed HV reference");
    }
;
#line 2921 "lib/Sys/Guestfs.xs"
      r = guestfs_echo_daemon (g, words);
      free (words);
      if (r == NULL)
        croak ("%s", guestfs_last_error (g));
      RETVAL = newSVpv (r, 0);
      free (r);
#line 7118 "lib/Sys/Guestfs.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Guestfs_egrep); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_egrep)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "g, regex, path");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	regex = (char *)SvPV_nolen(ST(1))
;
	char *	path = (char *)SvPV_nolen(ST(2))
;
#line 2936 "lib/Sys/Guestfs.xs"
      char **r;
      size_t i, n;
#line 7143 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::egrep(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::egrep(): g is not a blessed HV reference");
    }
;
#line 2939 "lib/Sys/Guestfs.xs"
      Perl_ck_warner (aTHX_ packWARN(WARN_DEPRECATED),
        "Sys::Guestfs::egrep is deprecated; use Sys::Guestfs::grep instead");
      r = guestfs_egrep (g, regex, path);
      if (r == NULL)
        croak ("%s", guestfs_last_error (g));
      for (n = 0; r[n] != NULL; ++n) /**/;
      EXTEND (SP, n);
      for (i = 0; i < n; ++i) {
        PUSHs (sv_2mortal (newSVpv (r[i], 0)));
        free (r[i]);
      }
      free (r);
#line 7170 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_egrepi); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_egrepi)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "g, regex, path");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	regex = (char *)SvPV_nolen(ST(1))
;
	char *	path = (char *)SvPV_nolen(ST(2))
;
#line 2958 "lib/Sys/Guestfs.xs"
      char **r;
      size_t i, n;
#line 7194 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::egrepi(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::egrepi(): g is not a blessed HV reference");
    }
;
#line 2961 "lib/Sys/Guestfs.xs"
      Perl_ck_warner (aTHX_ packWARN(WARN_DEPRECATED),
        "Sys::Guestfs::egrepi is deprecated; use Sys::Guestfs::grep instead");
      r = guestfs_egrepi (g, regex, path);
      if (r == NULL)
        croak ("%s", guestfs_last_error (g));
      for (n = 0; r[n] != NULL; ++n) /**/;
      EXTEND (SP, n);
      for (i = 0; i < n; ++i) {
        PUSHs (sv_2mortal (newSVpv (r[i], 0)));
        free (r[i]);
      }
      free (r);
#line 7221 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_equal); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_equal)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "g, file1, file2");
    {
	guestfs_h *	g;
	char *	file1 = (char *)SvPV_nolen(ST(1))
;
	char *	file2 = (char *)SvPV_nolen(ST(2))
;
#line 2980 "lib/Sys/Guestfs.xs"
      int r;
#line 7242 "lib/Sys/Guestfs.c"
	SV *	RETVAL;

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::equal(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::equal(): g is not a blessed HV reference");
    }
;
#line 2982 "lib/Sys/Guestfs.xs"
      r = guestfs_equal (g, file1, file2);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
      RETVAL = newSViv (r);
#line 7262 "lib/Sys/Guestfs.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Guestfs_exists); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_exists)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, path");
    {
	guestfs_h *	g;
	char *	path = (char *)SvPV_nolen(ST(1))
;
#line 2994 "lib/Sys/Guestfs.xs"
      int r;
#line 7282 "lib/Sys/Guestfs.c"
	SV *	RETVAL;

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::exists(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::exists(): g is not a blessed HV reference");
    }
;
#line 2996 "lib/Sys/Guestfs.xs"
      r = guestfs_exists (g, path);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
      RETVAL = newSViv (r);
#line 7302 "lib/Sys/Guestfs.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Guestfs_extlinux); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_extlinux)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, directory");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	directory = (char *)SvPV_nolen(ST(1))
;
#line 3008 "lib/Sys/Guestfs.xs"
      int r;
#line 7324 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::extlinux(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::extlinux(): g is not a blessed HV reference");
    }
;
#line 3010 "lib/Sys/Guestfs.xs"
      r = guestfs_extlinux (g, directory);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 7342 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_f2fs_expand); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_f2fs_expand)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, device");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	device = (char *)SvPV_nolen(ST(1))
;
#line 3019 "lib/Sys/Guestfs.xs"
      int r;
#line 7363 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::f2fs_expand(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::f2fs_expand(): g is not a blessed HV reference");
    }
;
#line 3021 "lib/Sys/Guestfs.xs"
      r = guestfs_f2fs_expand (g, device);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 7381 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_fallocate); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_fallocate)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "g, path, len");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	path = (char *)SvPV_nolen(ST(1))
;
	int	len = (int)SvIV(ST(2))
;
#line 3031 "lib/Sys/Guestfs.xs"
      int r;
#line 7404 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::fallocate(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::fallocate(): g is not a blessed HV reference");
    }
;
#line 3033 "lib/Sys/Guestfs.xs"
      Perl_ck_warner (aTHX_ packWARN(WARN_DEPRECATED),
        "Sys::Guestfs::fallocate is deprecated; use Sys::Guestfs::fallocate64 instead");
      r = guestfs_fallocate (g, path, len);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 7424 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_fallocate64); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_fallocate64)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "g, path, len");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	path = (char *)SvPV_nolen(ST(1))
;
	int64_t    len = my_SvIV64 (ST(2))
;
#line 3045 "lib/Sys/Guestfs.xs"
      int r;
#line 7447 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::fallocate64(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::fallocate64(): g is not a blessed HV reference");
    }
;
#line 3047 "lib/Sys/Guestfs.xs"
      r = guestfs_fallocate64 (g, path, len);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 7465 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_feature_available); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_feature_available)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, groups");
    {
	guestfs_h *	g;
	char **	groups = XS_unpack_charPtrPtr(ST(1))
;
#line 3056 "lib/Sys/Guestfs.xs"
      int r;
#line 7484 "lib/Sys/Guestfs.c"
	SV *	RETVAL;

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::feature_available(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::feature_available(): g is not a blessed HV reference");
    }
;
#line 3058 "lib/Sys/Guestfs.xs"
      r = guestfs_feature_available (g, groups);
      free (groups);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
      RETVAL = newSViv (r);
#line 7505 "lib/Sys/Guestfs.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Guestfs_fgrep); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_fgrep)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "g, pattern, path");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	pattern = (char *)SvPV_nolen(ST(1))
;
	char *	path = (char *)SvPV_nolen(ST(2))
;
#line 3072 "lib/Sys/Guestfs.xs"
      char **r;
      size_t i, n;
#line 7530 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::fgrep(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::fgrep(): g is not a blessed HV reference");
    }
;
#line 3075 "lib/Sys/Guestfs.xs"
      Perl_ck_warner (aTHX_ packWARN(WARN_DEPRECATED),
        "Sys::Guestfs::fgrep is deprecated; use Sys::Guestfs::grep instead");
      r = guestfs_fgrep (g, pattern, path);
      if (r == NULL)
        croak ("%s", guestfs_last_error (g));
      for (n = 0; r[n] != NULL; ++n) /**/;
      EXTEND (SP, n);
      for (i = 0; i < n; ++i) {
        PUSHs (sv_2mortal (newSVpv (r[i], 0)));
        free (r[i]);
      }
      free (r);
#line 7557 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_fgrepi); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_fgrepi)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "g, pattern, path");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	pattern = (char *)SvPV_nolen(ST(1))
;
	char *	path = (char *)SvPV_nolen(ST(2))
;
#line 3094 "lib/Sys/Guestfs.xs"
      char **r;
      size_t i, n;
#line 7581 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::fgrepi(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::fgrepi(): g is not a blessed HV reference");
    }
;
#line 3097 "lib/Sys/Guestfs.xs"
      Perl_ck_warner (aTHX_ packWARN(WARN_DEPRECATED),
        "Sys::Guestfs::fgrepi is deprecated; use Sys::Guestfs::grep instead");
      r = guestfs_fgrepi (g, pattern, path);
      if (r == NULL)
        croak ("%s", guestfs_last_error (g));
      for (n = 0; r[n] != NULL; ++n) /**/;
      EXTEND (SP, n);
      for (i = 0; i < n; ++i) {
        PUSHs (sv_2mortal (newSVpv (r[i], 0)));
        free (r[i]);
      }
      free (r);
#line 7608 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_file); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_file)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, path");
    {
	guestfs_h *	g;
	char *	path = (char *)SvPV_nolen(ST(1))
;
#line 3115 "lib/Sys/Guestfs.xs"
      char *r;
#line 7627 "lib/Sys/Guestfs.c"
	SV *	RETVAL;

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::file(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::file(): g is not a blessed HV reference");
    }
;
#line 3117 "lib/Sys/Guestfs.xs"
      r = guestfs_file (g, path);
      if (r == NULL)
        croak ("%s", guestfs_last_error (g));
      RETVAL = newSVpv (r, 0);
      free (r);
#line 7648 "lib/Sys/Guestfs.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Guestfs_file_architecture); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_file_architecture)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, filename");
    {
	guestfs_h *	g;
	char *	filename = (char *)SvPV_nolen(ST(1))
;
#line 3130 "lib/Sys/Guestfs.xs"
      char *r;
#line 7668 "lib/Sys/Guestfs.c"
	SV *	RETVAL;

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::file_architecture(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::file_architecture(): g is not a blessed HV reference");
    }
;
#line 3132 "lib/Sys/Guestfs.xs"
      r = guestfs_file_architecture (g, filename);
      if (r == NULL)
        croak ("%s", guestfs_last_error (g));
      RETVAL = newSVpv (r, 0);
      free (r);
#line 7689 "lib/Sys/Guestfs.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Guestfs_filesize); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_filesize)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, file");
    {
	guestfs_h *	g;
	char *	file = (char *)SvPV_nolen(ST(1))
;
#line 3145 "lib/Sys/Guestfs.xs"
      int64_t r;
#line 7709 "lib/Sys/Guestfs.c"
	SV *	RETVAL;

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::filesize(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::filesize(): g is not a blessed HV reference");
    }
;
#line 3147 "lib/Sys/Guestfs.xs"
      r = guestfs_filesize (g, file);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
      RETVAL = my_newSVll (r);
#line 7729 "lib/Sys/Guestfs.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Guestfs_filesystem_available); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_filesystem_available)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, filesystem");
    {
	guestfs_h *	g;
	char *	filesystem = (char *)SvPV_nolen(ST(1))
;
#line 3159 "lib/Sys/Guestfs.xs"
      int r;
#line 7749 "lib/Sys/Guestfs.c"
	SV *	RETVAL;

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::filesystem_available(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::filesystem_available(): g is not a blessed HV reference");
    }
;
#line 3161 "lib/Sys/Guestfs.xs"
      r = guestfs_filesystem_available (g, filesystem);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
      RETVAL = newSViv (r);
#line 7769 "lib/Sys/Guestfs.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Guestfs_filesystem_walk); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_filesystem_walk)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, device");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	device = (char *)SvPV_nolen(ST(1))
;
#line 3173 "lib/Sys/Guestfs.xs"
      struct guestfs_tsk_dirent_list *r;
      size_t i;
      HV *hv;
#line 7793 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::filesystem_walk(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::filesystem_walk(): g is not a blessed HV reference");
    }
;
#line 3177 "lib/Sys/Guestfs.xs"
      r = guestfs_filesystem_walk (g, device);
      if (r == NULL)
        croak ("%s", guestfs_last_error (g));
      EXTEND (SP, r->len);
      for (i = 0; i < r->len; ++i) {
        hv = newHV ();
        (void) hv_store (hv, "tsk_inode", 9, my_newSVull (r->val[i].tsk_inode), 0);
        (void) hv_store (hv, "tsk_type", 8, newSVpv (&r->val[i].tsk_type, 1), 0);
        (void) hv_store (hv, "tsk_size", 8, my_newSVll (r->val[i].tsk_size), 0);
        (void) hv_store (hv, "tsk_name", 8, newSVpv (r->val[i].tsk_name, 0), 0);
        (void) hv_store (hv, "tsk_flags", 9, newSVnv (r->val[i].tsk_flags), 0);
        (void) hv_store (hv, "tsk_atime_sec", 13, my_newSVll (r->val[i].tsk_atime_sec), 0);
        (void) hv_store (hv, "tsk_atime_nsec", 14, my_newSVll (r->val[i].tsk_atime_nsec), 0);
        (void) hv_store (hv, "tsk_mtime_sec", 13, my_newSVll (r->val[i].tsk_mtime_sec), 0);
        (void) hv_store (hv, "tsk_mtime_nsec", 14, my_newSVll (r->val[i].tsk_mtime_nsec), 0);
        (void) hv_store (hv, "tsk_ctime_sec", 13, my_newSVll (r->val[i].tsk_ctime_sec), 0);
        (void) hv_store (hv, "tsk_ctime_nsec", 14, my_newSVll (r->val[i].tsk_ctime_nsec), 0);
        (void) hv_store (hv, "tsk_crtime_sec", 14, my_newSVll (r->val[i].tsk_crtime_sec), 0);
        (void) hv_store (hv, "tsk_crtime_nsec", 15, my_newSVll (r->val[i].tsk_crtime_nsec), 0);
        (void) hv_store (hv, "tsk_nlink", 9, my_newSVll (r->val[i].tsk_nlink), 0);
        (void) hv_store (hv, "tsk_link", 8, newSVpv (r->val[i].tsk_link, 0), 0);
        (void) hv_store (hv, "tsk_spare1", 10, my_newSVll (r->val[i].tsk_spare1), 0);
        PUSHs (sv_2mortal (newRV ((SV *) hv)));
      }
      guestfs_free_tsk_dirent_list (r);
#line 7833 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_fill); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_fill)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "g, c, len, path");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	int	c = (int)SvIV(ST(1))
;
	int	len = (int)SvIV(ST(2))
;
	char *	path = (char *)SvPV_nolen(ST(3))
;
#line 3210 "lib/Sys/Guestfs.xs"
      int r;
#line 7858 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::fill(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::fill(): g is not a blessed HV reference");
    }
;
#line 3212 "lib/Sys/Guestfs.xs"
      r = guestfs_fill (g, c, len, path);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 7876 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_fill_dir); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_fill_dir)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "g, dir, nr");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	dir = (char *)SvPV_nolen(ST(1))
;
	int	nr = (int)SvIV(ST(2))
;
#line 3222 "lib/Sys/Guestfs.xs"
      int r;
#line 7899 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::fill_dir(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::fill_dir(): g is not a blessed HV reference");
    }
;
#line 3224 "lib/Sys/Guestfs.xs"
      r = guestfs_fill_dir (g, dir, nr);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 7917 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_fill_pattern); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_fill_pattern)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "g, pattern, len, path");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	pattern = (char *)SvPV_nolen(ST(1))
;
	int	len = (int)SvIV(ST(2))
;
	char *	path = (char *)SvPV_nolen(ST(3))
;
#line 3235 "lib/Sys/Guestfs.xs"
      int r;
#line 7942 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::fill_pattern(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::fill_pattern(): g is not a blessed HV reference");
    }
;
#line 3237 "lib/Sys/Guestfs.xs"
      r = guestfs_fill_pattern (g, pattern, len, path);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 7960 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_find); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_find)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, directory");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	directory = (char *)SvPV_nolen(ST(1))
;
#line 3246 "lib/Sys/Guestfs.xs"
      char **r;
      size_t i, n;
#line 7982 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::find(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::find(): g is not a blessed HV reference");
    }
;
#line 3249 "lib/Sys/Guestfs.xs"
      r = guestfs_find (g, directory);
      if (r == NULL)
        croak ("%s", guestfs_last_error (g));
      for (n = 0; r[n] != NULL; ++n) /**/;
      EXTEND (SP, n);
      for (i = 0; i < n; ++i) {
        PUSHs (sv_2mortal (newSVpv (r[i], 0)));
        free (r[i]);
      }
      free (r);
#line 8007 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_find0); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_find0)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "g, directory, files");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	directory = (char *)SvPV_nolen(ST(1))
;
	char *	files = (char *)SvPV_nolen(ST(2))
;
#line 3266 "lib/Sys/Guestfs.xs"
      int r;
#line 8030 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::find0(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::find0(): g is not a blessed HV reference");
    }
;
#line 3268 "lib/Sys/Guestfs.xs"
      r = guestfs_find0 (g, directory, files);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 8048 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_find_inode); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_find_inode)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "g, device, inode");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	device = (char *)SvPV_nolen(ST(1))
;
	int64_t    inode = my_SvIV64 (ST(2))
;
#line 3278 "lib/Sys/Guestfs.xs"
      struct guestfs_tsk_dirent_list *r;
      size_t i;
      HV *hv;
#line 8073 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::find_inode(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::find_inode(): g is not a blessed HV reference");
    }
;
#line 3282 "lib/Sys/Guestfs.xs"
      r = guestfs_find_inode (g, device, inode);
      if (r == NULL)
        croak ("%s", guestfs_last_error (g));
      EXTEND (SP, r->len);
      for (i = 0; i < r->len; ++i) {
        hv = newHV ();
        (void) hv_store (hv, "tsk_inode", 9, my_newSVull (r->val[i].tsk_inode), 0);
        (void) hv_store (hv, "tsk_type", 8, newSVpv (&r->val[i].tsk_type, 1), 0);
        (void) hv_store (hv, "tsk_size", 8, my_newSVll (r->val[i].tsk_size), 0);
        (void) hv_store (hv, "tsk_name", 8, newSVpv (r->val[i].tsk_name, 0), 0);
        (void) hv_store (hv, "tsk_flags", 9, newSVnv (r->val[i].tsk_flags), 0);
        (void) hv_store (hv, "tsk_atime_sec", 13, my_newSVll (r->val[i].tsk_atime_sec), 0);
        (void) hv_store (hv, "tsk_atime_nsec", 14, my_newSVll (r->val[i].tsk_atime_nsec), 0);
        (void) hv_store (hv, "tsk_mtime_sec", 13, my_newSVll (r->val[i].tsk_mtime_sec), 0);
        (void) hv_store (hv, "tsk_mtime_nsec", 14, my_newSVll (r->val[i].tsk_mtime_nsec), 0);
        (void) hv_store (hv, "tsk_ctime_sec", 13, my_newSVll (r->val[i].tsk_ctime_sec), 0);
        (void) hv_store (hv, "tsk_ctime_nsec", 14, my_newSVll (r->val[i].tsk_ctime_nsec), 0);
        (void) hv_store (hv, "tsk_crtime_sec", 14, my_newSVll (r->val[i].tsk_crtime_sec), 0);
        (void) hv_store (hv, "tsk_crtime_nsec", 15, my_newSVll (r->val[i].tsk_crtime_nsec), 0);
        (void) hv_store (hv, "tsk_nlink", 9, my_newSVll (r->val[i].tsk_nlink), 0);
        (void) hv_store (hv, "tsk_link", 8, newSVpv (r->val[i].tsk_link, 0), 0);
        (void) hv_store (hv, "tsk_spare1", 10, my_newSVll (r->val[i].tsk_spare1), 0);
        PUSHs (sv_2mortal (newRV ((SV *) hv)));
      }
      guestfs_free_tsk_dirent_list (r);
#line 8113 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_findfs_label); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_findfs_label)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, label");
    {
	guestfs_h *	g;
	char *	label = (char *)SvPV_nolen(ST(1))
;
#line 3313 "lib/Sys/Guestfs.xs"
      char *r;
#line 8132 "lib/Sys/Guestfs.c"
	SV *	RETVAL;

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::findfs_label(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::findfs_label(): g is not a blessed HV reference");
    }
;
#line 3315 "lib/Sys/Guestfs.xs"
      r = guestfs_findfs_label (g, label);
      if (r == NULL)
        croak ("%s", guestfs_last_error (g));
      RETVAL = newSVpv (r, 0);
      free (r);
#line 8153 "lib/Sys/Guestfs.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Guestfs_findfs_partlabel); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_findfs_partlabel)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, label");
    {
	guestfs_h *	g;
	char *	label = (char *)SvPV_nolen(ST(1))
;
#line 3328 "lib/Sys/Guestfs.xs"
      char *r;
#line 8173 "lib/Sys/Guestfs.c"
	SV *	RETVAL;

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::findfs_partlabel(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::findfs_partlabel(): g is not a blessed HV reference");
    }
;
#line 3330 "lib/Sys/Guestfs.xs"
      r = guestfs_findfs_partlabel (g, label);
      if (r == NULL)
        croak ("%s", guestfs_last_error (g));
      RETVAL = newSVpv (r, 0);
      free (r);
#line 8194 "lib/Sys/Guestfs.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Guestfs_findfs_partuuid); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_findfs_partuuid)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, uuid");
    {
	guestfs_h *	g;
	char *	uuid = (char *)SvPV_nolen(ST(1))
;
#line 3343 "lib/Sys/Guestfs.xs"
      char *r;
#line 8214 "lib/Sys/Guestfs.c"
	SV *	RETVAL;

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::findfs_partuuid(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::findfs_partuuid(): g is not a blessed HV reference");
    }
;
#line 3345 "lib/Sys/Guestfs.xs"
      r = guestfs_findfs_partuuid (g, uuid);
      if (r == NULL)
        croak ("%s", guestfs_last_error (g));
      RETVAL = newSVpv (r, 0);
      free (r);
#line 8235 "lib/Sys/Guestfs.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Guestfs_findfs_uuid); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_findfs_uuid)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, uuid");
    {
	guestfs_h *	g;
	char *	uuid = (char *)SvPV_nolen(ST(1))
;
#line 3358 "lib/Sys/Guestfs.xs"
      char *r;
#line 8255 "lib/Sys/Guestfs.c"
	SV *	RETVAL;

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::findfs_uuid(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::findfs_uuid(): g is not a blessed HV reference");
    }
;
#line 3360 "lib/Sys/Guestfs.xs"
      r = guestfs_findfs_uuid (g, uuid);
      if (r == NULL)
        croak ("%s", guestfs_last_error (g));
      RETVAL = newSVpv (r, 0);
      free (r);
#line 8276 "lib/Sys/Guestfs.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Guestfs_fsck); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_fsck)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "g, fstype, device");
    {
	guestfs_h *	g;
	char *	fstype = (char *)SvPV_nolen(ST(1))
;
	char *	device = (char *)SvPV_nolen(ST(2))
;
#line 3374 "lib/Sys/Guestfs.xs"
      int r;
#line 8298 "lib/Sys/Guestfs.c"
	SV *	RETVAL;

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::fsck(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::fsck(): g is not a blessed HV reference");
    }
;
#line 3376 "lib/Sys/Guestfs.xs"
      r = guestfs_fsck (g, fstype, device);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
      RETVAL = newSViv (r);
#line 8318 "lib/Sys/Guestfs.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Guestfs_fstrim); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_fstrim)
{
    dVAR; dXSARGS;
    if (items < 2)
       croak_xs_usage(cv,  "g, mountpoint, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	mountpoint = (char *)SvPV_nolen(ST(1))
;
#line 3388 "lib/Sys/Guestfs.xs"
      int r;
      struct guestfs_fstrim_argv optargs_s = { .bitmask = 0 };
      struct guestfs_fstrim_argv *optargs = &optargs_s;
      size_t items_i;
#line 8343 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::fstrim(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::fstrim(): g is not a blessed HV reference");
    }
;
#line 3393 "lib/Sys/Guestfs.xs"
      if (((items - 2) & 1) != 0)
        croak ("expecting an even number of extra parameters");
      for (items_i = 2; items_i < items; items_i += 2) {
        uint64_t this_mask;
        const char *this_arg;

        this_arg = SvPV_nolen (ST (items_i));
        if (STREQ (this_arg, "offset")) {
          optargs_s.offset = my_SvIV64 (ST (items_i+1));
          this_mask = GUESTFS_FSTRIM_OFFSET_BITMASK;
        }
        else if (STREQ (this_arg, "length")) {
          optargs_s.length = my_SvIV64 (ST (items_i+1));
          this_mask = GUESTFS_FSTRIM_LENGTH_BITMASK;
        }
        else if (STREQ (this_arg, "minimumfreeextent")) {
          optargs_s.minimumfreeextent = my_SvIV64 (ST (items_i+1));
          this_mask = GUESTFS_FSTRIM_MINIMUMFREEEXTENT_BITMASK;
        }
        else croak ("unknown optional argument '%s'", this_arg);
        if (optargs_s.bitmask & this_mask)
          croak ("optional argument '%s' given more than once",
                 this_arg);
        optargs_s.bitmask |= this_mask;
      }

      r = guestfs_fstrim_argv (g, mountpoint, optargs);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 8387 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_get_append); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_get_append)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "g");
    {
	guestfs_h *	g;
#line 3427 "lib/Sys/Guestfs.xs"
      const char *r;
#line 8404 "lib/Sys/Guestfs.c"
	SV *	RETVAL;

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::get_append(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::get_append(): g is not a blessed HV reference");
    }
;
#line 3429 "lib/Sys/Guestfs.xs"
      r = guestfs_get_append (g);
      if (r == NULL)
        RETVAL = &PL_sv_undef;
      else
        RETVAL = newSVpv (r, 0);
#line 8425 "lib/Sys/Guestfs.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Guestfs_get_attach_method); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_get_attach_method)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "g");
    {
	guestfs_h *	g;
#line 3441 "lib/Sys/Guestfs.xs"
      char *r;
#line 8443 "lib/Sys/Guestfs.c"
	SV *	RETVAL;

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::get_attach_method(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::get_attach_method(): g is not a blessed HV reference");
    }
;
#line 3443 "lib/Sys/Guestfs.xs"
      Perl_ck_warner (aTHX_ packWARN(WARN_DEPRECATED),
        "Sys::Guestfs::get_attach_method is deprecated; use Sys::Guestfs::get_backend instead");
      r = guestfs_get_attach_method (g);
      if (r == NULL)
        croak ("%s", guestfs_last_error (g));
      RETVAL = newSVpv (r, 0);
      free (r);
#line 8466 "lib/Sys/Guestfs.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Guestfs_get_autosync); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_get_autosync)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "g");
    {
	guestfs_h *	g;
#line 3457 "lib/Sys/Guestfs.xs"
      int r;
#line 8484 "lib/Sys/Guestfs.c"
	SV *	RETVAL;

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::get_autosync(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::get_autosync(): g is not a blessed HV reference");
    }
;
#line 3459 "lib/Sys/Guestfs.xs"
      r = guestfs_get_autosync (g);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
      RETVAL = newSViv (r);
#line 8504 "lib/Sys/Guestfs.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Guestfs_get_backend); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_get_backend)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "g");
    {
	guestfs_h *	g;
#line 3470 "lib/Sys/Guestfs.xs"
      char *r;
#line 8522 "lib/Sys/Guestfs.c"
	SV *	RETVAL;

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::get_backend(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::get_backend(): g is not a blessed HV reference");
    }
;
#line 3472 "lib/Sys/Guestfs.xs"
      r = guestfs_get_backend (g);
      if (r == NULL)
        croak ("%s", guestfs_last_error (g));
      RETVAL = newSVpv (r, 0);
      free (r);
#line 8543 "lib/Sys/Guestfs.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Guestfs_get_backend_setting); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_get_backend_setting)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, name");
    {
	guestfs_h *	g;
	char *	name = (char *)SvPV_nolen(ST(1))
;
#line 3485 "lib/Sys/Guestfs.xs"
      char *r;
#line 8563 "lib/Sys/Guestfs.c"
	SV *	RETVAL;

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::get_backend_setting(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::get_backend_setting(): g is not a blessed HV reference");
    }
;
#line 3487 "lib/Sys/Guestfs.xs"
      r = guestfs_get_backend_setting (g, name);
      if (r == NULL)
        croak ("%s", guestfs_last_error (g));
      RETVAL = newSVpv (r, 0);
      free (r);
#line 8584 "lib/Sys/Guestfs.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Guestfs_get_backend_settings); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_get_backend_settings)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "g");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
#line 3499 "lib/Sys/Guestfs.xs"
      char **r;
      size_t i, n;
#line 8605 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::get_backend_settings(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::get_backend_settings(): g is not a blessed HV reference");
    }
;
#line 3502 "lib/Sys/Guestfs.xs"
      r = guestfs_get_backend_settings (g);
      if (r == NULL)
        croak ("%s", guestfs_last_error (g));
      for (n = 0; r[n] != NULL; ++n) /**/;
      EXTEND (SP, n);
      for (i = 0; i < n; ++i) {
        PUSHs (sv_2mortal (newSVpv (r[i], 0)));
        free (r[i]);
      }
      free (r);
#line 8630 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_get_cachedir); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_get_cachedir)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "g");
    {
	guestfs_h *	g;
#line 3517 "lib/Sys/Guestfs.xs"
      char *r;
#line 8647 "lib/Sys/Guestfs.c"
	SV *	RETVAL;

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::get_cachedir(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::get_cachedir(): g is not a blessed HV reference");
    }
;
#line 3519 "lib/Sys/Guestfs.xs"
      r = guestfs_get_cachedir (g);
      if (r == NULL)
        croak ("%s", guestfs_last_error (g));
      RETVAL = newSVpv (r, 0);
      free (r);
#line 8668 "lib/Sys/Guestfs.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Guestfs_get_direct); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_get_direct)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "g");
    {
	guestfs_h *	g;
#line 3531 "lib/Sys/Guestfs.xs"
      int r;
#line 8686 "lib/Sys/Guestfs.c"
	SV *	RETVAL;

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::get_direct(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::get_direct(): g is not a blessed HV reference");
    }
;
#line 3533 "lib/Sys/Guestfs.xs"
      Perl_ck_warner (aTHX_ packWARN(WARN_DEPRECATED),
        "Sys::Guestfs::get_direct is deprecated; use Sys::Guestfs::internal_get_console_socket instead");
      r = guestfs_get_direct (g);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
      RETVAL = newSViv (r);
#line 8708 "lib/Sys/Guestfs.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Guestfs_get_e2attrs); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_get_e2attrs)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, file");
    {
	guestfs_h *	g;
	char *	file = (char *)SvPV_nolen(ST(1))
;
#line 3547 "lib/Sys/Guestfs.xs"
      char *r;
#line 8728 "lib/Sys/Guestfs.c"
	SV *	RETVAL;

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::get_e2attrs(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::get_e2attrs(): g is not a blessed HV reference");
    }
;
#line 3549 "lib/Sys/Guestfs.xs"
      r = guestfs_get_e2attrs (g, file);
      if (r == NULL)
        croak ("%s", guestfs_last_error (g));
      RETVAL = newSVpv (r, 0);
      free (r);
#line 8749 "lib/Sys/Guestfs.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Guestfs_get_e2generation); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_get_e2generation)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, file");
    {
	guestfs_h *	g;
	char *	file = (char *)SvPV_nolen(ST(1))
;
#line 3562 "lib/Sys/Guestfs.xs"
      int64_t r;
#line 8769 "lib/Sys/Guestfs.c"
	SV *	RETVAL;

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::get_e2generation(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::get_e2generation(): g is not a blessed HV reference");
    }
;
#line 3564 "lib/Sys/Guestfs.xs"
      r = guestfs_get_e2generation (g, file);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
      RETVAL = my_newSVll (r);
#line 8789 "lib/Sys/Guestfs.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Guestfs_get_e2label); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_get_e2label)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, device");
    {
	guestfs_h *	g;
	char *	device = (char *)SvPV_nolen(ST(1))
;
#line 3576 "lib/Sys/Guestfs.xs"
      char *r;
#line 8809 "lib/Sys/Guestfs.c"
	SV *	RETVAL;

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::get_e2label(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::get_e2label(): g is not a blessed HV reference");
    }
;
#line 3578 "lib/Sys/Guestfs.xs"
      Perl_ck_warner (aTHX_ packWARN(WARN_DEPRECATED),
        "Sys::Guestfs::get_e2label is deprecated; use Sys::Guestfs::vfs_label instead");
      r = guestfs_get_e2label (g, device);
      if (r == NULL)
        croak ("%s", guestfs_last_error (g));
      RETVAL = newSVpv (r, 0);
      free (r);
#line 8832 "lib/Sys/Guestfs.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Guestfs_get_e2uuid); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_get_e2uuid)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, device");
    {
	guestfs_h *	g;
	char *	device = (char *)SvPV_nolen(ST(1))
;
#line 3593 "lib/Sys/Guestfs.xs"
      char *r;
#line 8852 "lib/Sys/Guestfs.c"
	SV *	RETVAL;

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::get_e2uuid(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::get_e2uuid(): g is not a blessed HV reference");
    }
;
#line 3595 "lib/Sys/Guestfs.xs"
      Perl_ck_warner (aTHX_ packWARN(WARN_DEPRECATED),
        "Sys::Guestfs::get_e2uuid is deprecated; use Sys::Guestfs::vfs_uuid instead");
      r = guestfs_get_e2uuid (g, device);
      if (r == NULL)
        croak ("%s", guestfs_last_error (g));
      RETVAL = newSVpv (r, 0);
      free (r);
#line 8875 "lib/Sys/Guestfs.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Guestfs_get_hv); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_get_hv)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "g");
    {
	guestfs_h *	g;
#line 3609 "lib/Sys/Guestfs.xs"
      char *r;
#line 8893 "lib/Sys/Guestfs.c"
	SV *	RETVAL;

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::get_hv(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::get_hv(): g is not a blessed HV reference");
    }
;
#line 3611 "lib/Sys/Guestfs.xs"
      r = guestfs_get_hv (g);
      if (r == NULL)
        croak ("%s", guestfs_last_error (g));
      RETVAL = newSVpv (r, 0);
      free (r);
#line 8914 "lib/Sys/Guestfs.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Guestfs_get_identifier); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_get_identifier)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "g");
    {
	guestfs_h *	g;
#line 3623 "lib/Sys/Guestfs.xs"
      const char *r;
#line 8932 "lib/Sys/Guestfs.c"
	SV *	RETVAL;

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::get_identifier(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::get_identifier(): g is not a blessed HV reference");
    }
;
#line 3625 "lib/Sys/Guestfs.xs"
      r = guestfs_get_identifier (g);
      if (r == NULL)
        croak ("%s", guestfs_last_error (g));
      RETVAL = newSVpv (r, 0);
#line 8952 "lib/Sys/Guestfs.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Guestfs_get_libvirt_requested_credential_challenge); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_get_libvirt_requested_credential_challenge)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, index");
    {
	guestfs_h *	g;
	int	index = (int)SvIV(ST(1))
;
#line 3637 "lib/Sys/Guestfs.xs"
      char *r;
#line 8972 "lib/Sys/Guestfs.c"
	SV *	RETVAL;

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::get_libvirt_requested_credential_challenge(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::get_libvirt_requested_credential_challenge(): g is not a blessed HV reference");
    }
;
#line 3639 "lib/Sys/Guestfs.xs"
      r = guestfs_get_libvirt_requested_credential_challenge (g, index);
      if (r == NULL)
        croak ("%s", guestfs_last_error (g));
      RETVAL = newSVpv (r, 0);
      free (r);
#line 8993 "lib/Sys/Guestfs.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Guestfs_get_libvirt_requested_credential_defresult); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_get_libvirt_requested_credential_defresult)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, index");
    {
	guestfs_h *	g;
	int	index = (int)SvIV(ST(1))
;
#line 3652 "lib/Sys/Guestfs.xs"
      char *r;
#line 9013 "lib/Sys/Guestfs.c"
	SV *	RETVAL;

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::get_libvirt_requested_credential_defresult(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::get_libvirt_requested_credential_defresult(): g is not a blessed HV reference");
    }
;
#line 3654 "lib/Sys/Guestfs.xs"
      r = guestfs_get_libvirt_requested_credential_defresult (g, index);
      if (r == NULL)
        croak ("%s", guestfs_last_error (g));
      RETVAL = newSVpv (r, 0);
      free (r);
#line 9034 "lib/Sys/Guestfs.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Guestfs_get_libvirt_requested_credential_prompt); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_get_libvirt_requested_credential_prompt)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, index");
    {
	guestfs_h *	g;
	int	index = (int)SvIV(ST(1))
;
#line 3667 "lib/Sys/Guestfs.xs"
      char *r;
#line 9054 "lib/Sys/Guestfs.c"
	SV *	RETVAL;

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::get_libvirt_requested_credential_prompt(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::get_libvirt_requested_credential_prompt(): g is not a blessed HV reference");
    }
;
#line 3669 "lib/Sys/Guestfs.xs"
      r = guestfs_get_libvirt_requested_credential_prompt (g, index);
      if (r == NULL)
        croak ("%s", guestfs_last_error (g));
      RETVAL = newSVpv (r, 0);
      free (r);
#line 9075 "lib/Sys/Guestfs.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Guestfs_get_libvirt_requested_credentials); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_get_libvirt_requested_credentials)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "g");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
#line 3681 "lib/Sys/Guestfs.xs"
      char **r;
      size_t i, n;
#line 9096 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::get_libvirt_requested_credentials(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::get_libvirt_requested_credentials(): g is not a blessed HV reference");
    }
;
#line 3684 "lib/Sys/Guestfs.xs"
      r = guestfs_get_libvirt_requested_credentials (g);
      if (r == NULL)
        croak ("%s", guestfs_last_error (g));
      for (n = 0; r[n] != NULL; ++n) /**/;
      EXTEND (SP, n);
      for (i = 0; i < n; ++i) {
        PUSHs (sv_2mortal (newSVpv (r[i], 0)));
        free (r[i]);
      }
      free (r);
#line 9121 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_get_memsize); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_get_memsize)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "g");
    {
	guestfs_h *	g;
#line 3699 "lib/Sys/Guestfs.xs"
      int r;
#line 9138 "lib/Sys/Guestfs.c"
	SV *	RETVAL;

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::get_memsize(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::get_memsize(): g is not a blessed HV reference");
    }
;
#line 3701 "lib/Sys/Guestfs.xs"
      r = guestfs_get_memsize (g);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
      RETVAL = newSViv (r);
#line 9158 "lib/Sys/Guestfs.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Guestfs_get_network); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_get_network)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "g");
    {
	guestfs_h *	g;
#line 3712 "lib/Sys/Guestfs.xs"
      int r;
#line 9176 "lib/Sys/Guestfs.c"
	SV *	RETVAL;

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::get_network(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::get_network(): g is not a blessed HV reference");
    }
;
#line 3714 "lib/Sys/Guestfs.xs"
      r = guestfs_get_network (g);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
      RETVAL = newSViv (r);
#line 9196 "lib/Sys/Guestfs.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Guestfs_get_path); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_get_path)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "g");
    {
	guestfs_h *	g;
#line 3725 "lib/Sys/Guestfs.xs"
      const char *r;
#line 9214 "lib/Sys/Guestfs.c"
	SV *	RETVAL;

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::get_path(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::get_path(): g is not a blessed HV reference");
    }
;
#line 3727 "lib/Sys/Guestfs.xs"
      r = guestfs_get_path (g);
      if (r == NULL)
        croak ("%s", guestfs_last_error (g));
      RETVAL = newSVpv (r, 0);
#line 9234 "lib/Sys/Guestfs.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Guestfs_get_pgroup); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_get_pgroup)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "g");
    {
	guestfs_h *	g;
#line 3738 "lib/Sys/Guestfs.xs"
      int r;
#line 9252 "lib/Sys/Guestfs.c"
	SV *	RETVAL;

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::get_pgroup(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::get_pgroup(): g is not a blessed HV reference");
    }
;
#line 3740 "lib/Sys/Guestfs.xs"
      r = guestfs_get_pgroup (g);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
      RETVAL = newSViv (r);
#line 9272 "lib/Sys/Guestfs.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Guestfs_get_pid); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_get_pid)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "g");
    {
	guestfs_h *	g;
#line 3751 "lib/Sys/Guestfs.xs"
      int r;
#line 9290 "lib/Sys/Guestfs.c"
	SV *	RETVAL;

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::get_pid(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::get_pid(): g is not a blessed HV reference");
    }
;
#line 3753 "lib/Sys/Guestfs.xs"
      r = guestfs_get_pid (g);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
      RETVAL = newSViv (r);
#line 9310 "lib/Sys/Guestfs.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Guestfs_get_program); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_get_program)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "g");
    {
	guestfs_h *	g;
#line 3764 "lib/Sys/Guestfs.xs"
      const char *r;
#line 9328 "lib/Sys/Guestfs.c"
	SV *	RETVAL;

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::get_program(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::get_program(): g is not a blessed HV reference");
    }
;
#line 3766 "lib/Sys/Guestfs.xs"
      r = guestfs_get_program (g);
      if (r == NULL)
        croak ("%s", guestfs_last_error (g));
      RETVAL = newSVpv (r, 0);
#line 9348 "lib/Sys/Guestfs.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Guestfs_get_qemu); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_get_qemu)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "g");
    {
	guestfs_h *	g;
#line 3777 "lib/Sys/Guestfs.xs"
      const char *r;
#line 9366 "lib/Sys/Guestfs.c"
	SV *	RETVAL;

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::get_qemu(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::get_qemu(): g is not a blessed HV reference");
    }
;
#line 3779 "lib/Sys/Guestfs.xs"
      Perl_ck_warner (aTHX_ packWARN(WARN_DEPRECATED),
        "Sys::Guestfs::get_qemu is deprecated; use Sys::Guestfs::get_hv instead");
      r = guestfs_get_qemu (g);
      if (r == NULL)
        croak ("%s", guestfs_last_error (g));
      RETVAL = newSVpv (r, 0);
#line 9388 "lib/Sys/Guestfs.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Guestfs_get_recovery_proc); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_get_recovery_proc)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "g");
    {
	guestfs_h *	g;
#line 3792 "lib/Sys/Guestfs.xs"
      int r;
#line 9406 "lib/Sys/Guestfs.c"
	SV *	RETVAL;

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::get_recovery_proc(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::get_recovery_proc(): g is not a blessed HV reference");
    }
;
#line 3794 "lib/Sys/Guestfs.xs"
      r = guestfs_get_recovery_proc (g);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
      RETVAL = newSViv (r);
#line 9426 "lib/Sys/Guestfs.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Guestfs_get_selinux); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_get_selinux)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "g");
    {
	guestfs_h *	g;
#line 3805 "lib/Sys/Guestfs.xs"
      int r;
#line 9444 "lib/Sys/Guestfs.c"
	SV *	RETVAL;

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::get_selinux(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::get_selinux(): g is not a blessed HV reference");
    }
;
#line 3807 "lib/Sys/Guestfs.xs"
      Perl_ck_warner (aTHX_ packWARN(WARN_DEPRECATED),
        "Sys::Guestfs::get_selinux is deprecated; use Sys::Guestfs::selinux_relabel instead");
      r = guestfs_get_selinux (g);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
      RETVAL = newSViv (r);
#line 9466 "lib/Sys/Guestfs.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Guestfs_get_smp); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_get_smp)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "g");
    {
	guestfs_h *	g;
#line 3820 "lib/Sys/Guestfs.xs"
      int r;
#line 9484 "lib/Sys/Guestfs.c"
	SV *	RETVAL;

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::get_smp(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::get_smp(): g is not a blessed HV reference");
    }
;
#line 3822 "lib/Sys/Guestfs.xs"
      r = guestfs_get_smp (g);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
      RETVAL = newSViv (r);
#line 9504 "lib/Sys/Guestfs.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Guestfs_get_sockdir); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_get_sockdir)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "g");
    {
	guestfs_h *	g;
#line 3833 "lib/Sys/Guestfs.xs"
      char *r;
#line 9522 "lib/Sys/Guestfs.c"
	SV *	RETVAL;

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::get_sockdir(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::get_sockdir(): g is not a blessed HV reference");
    }
;
#line 3835 "lib/Sys/Guestfs.xs"
      r = guestfs_get_sockdir (g);
      if (r == NULL)
        croak ("%s", guestfs_last_error (g));
      RETVAL = newSVpv (r, 0);
      free (r);
#line 9543 "lib/Sys/Guestfs.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Guestfs_get_state); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_get_state)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "g");
    {
	guestfs_h *	g;
#line 3847 "lib/Sys/Guestfs.xs"
      int r;
#line 9561 "lib/Sys/Guestfs.c"
	SV *	RETVAL;

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::get_state(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::get_state(): g is not a blessed HV reference");
    }
;
#line 3849 "lib/Sys/Guestfs.xs"
      r = guestfs_get_state (g);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
      RETVAL = newSViv (r);
#line 9581 "lib/Sys/Guestfs.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Guestfs_get_tmpdir); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_get_tmpdir)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "g");
    {
	guestfs_h *	g;
#line 3860 "lib/Sys/Guestfs.xs"
      char *r;
#line 9599 "lib/Sys/Guestfs.c"
	SV *	RETVAL;

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::get_tmpdir(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::get_tmpdir(): g is not a blessed HV reference");
    }
;
#line 3862 "lib/Sys/Guestfs.xs"
      r = guestfs_get_tmpdir (g);
      if (r == NULL)
        croak ("%s", guestfs_last_error (g));
      RETVAL = newSVpv (r, 0);
      free (r);
#line 9620 "lib/Sys/Guestfs.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Guestfs_get_trace); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_get_trace)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "g");
    {
	guestfs_h *	g;
#line 3874 "lib/Sys/Guestfs.xs"
      int r;
#line 9638 "lib/Sys/Guestfs.c"
	SV *	RETVAL;

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::get_trace(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::get_trace(): g is not a blessed HV reference");
    }
;
#line 3876 "lib/Sys/Guestfs.xs"
      r = guestfs_get_trace (g);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
      RETVAL = newSViv (r);
#line 9658 "lib/Sys/Guestfs.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Guestfs_get_umask); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_get_umask)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "g");
    {
	guestfs_h *	g;
#line 3887 "lib/Sys/Guestfs.xs"
      int r;
#line 9676 "lib/Sys/Guestfs.c"
	SV *	RETVAL;

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::get_umask(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::get_umask(): g is not a blessed HV reference");
    }
;
#line 3889 "lib/Sys/Guestfs.xs"
      r = guestfs_get_umask (g);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
      RETVAL = newSViv (r);
#line 9696 "lib/Sys/Guestfs.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Guestfs_get_verbose); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_get_verbose)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "g");
    {
	guestfs_h *	g;
#line 3900 "lib/Sys/Guestfs.xs"
      int r;
#line 9714 "lib/Sys/Guestfs.c"
	SV *	RETVAL;

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::get_verbose(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::get_verbose(): g is not a blessed HV reference");
    }
;
#line 3902 "lib/Sys/Guestfs.xs"
      r = guestfs_get_verbose (g);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
      RETVAL = newSViv (r);
#line 9734 "lib/Sys/Guestfs.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Guestfs_getcon); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_getcon)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "g");
    {
	guestfs_h *	g;
#line 3913 "lib/Sys/Guestfs.xs"
      char *r;
#line 9752 "lib/Sys/Guestfs.c"
	SV *	RETVAL;

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::getcon(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::getcon(): g is not a blessed HV reference");
    }
;
#line 3915 "lib/Sys/Guestfs.xs"
      Perl_ck_warner (aTHX_ packWARN(WARN_DEPRECATED),
        "Sys::Guestfs::getcon is deprecated; use Sys::Guestfs::selinux_relabel instead");
      r = guestfs_getcon (g);
      if (r == NULL)
        croak ("%s", guestfs_last_error (g));
      RETVAL = newSVpv (r, 0);
      free (r);
#line 9775 "lib/Sys/Guestfs.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Guestfs_getxattr); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_getxattr)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "g, path, name");
    {
	guestfs_h *	g;
	char *	path = (char *)SvPV_nolen(ST(1))
;
	char *	name = (char *)SvPV_nolen(ST(2))
;
#line 3931 "lib/Sys/Guestfs.xs"
      char *r;
      size_t size;
#line 9798 "lib/Sys/Guestfs.c"
	SV *	RETVAL;

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::getxattr(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::getxattr(): g is not a blessed HV reference");
    }
;
#line 3934 "lib/Sys/Guestfs.xs"
      r = guestfs_getxattr (g, path, name, &size);
      if (r == NULL)
        croak ("%s", guestfs_last_error (g));
      RETVAL = newSVpvn (r, size);
      free (r);
#line 9819 "lib/Sys/Guestfs.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Guestfs_getxattrs); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_getxattrs)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, path");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	path = (char *)SvPV_nolen(ST(1))
;
#line 3947 "lib/Sys/Guestfs.xs"
      struct guestfs_xattr_list *r;
      size_t i;
      HV *hv;
#line 9843 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::getxattrs(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::getxattrs(): g is not a blessed HV reference");
    }
;
#line 3951 "lib/Sys/Guestfs.xs"
      r = guestfs_getxattrs (g, path);
      if (r == NULL)
        croak ("%s", guestfs_last_error (g));
      EXTEND (SP, r->len);
      for (i = 0; i < r->len; ++i) {
        hv = newHV ();
        (void) hv_store (hv, "attrname", 8, newSVpv (r->val[i].attrname, 0), 0);
        (void) hv_store (hv, "attrval", 7, newSVpvn (r->val[i].attrval, r->val[i].attrval_len), 0);
        PUSHs (sv_2mortal (newRV ((SV *) hv)));
      }
      guestfs_free_xattr_list (r);
#line 9869 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_glob_expand); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_glob_expand)
{
    dVAR; dXSARGS;
    if (items < 2)
       croak_xs_usage(cv,  "g, pattern, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	pattern = (char *)SvPV_nolen(ST(1))
;
#line 3968 "lib/Sys/Guestfs.xs"
      char **r;
      size_t i, n;
      struct guestfs_glob_expand_opts_argv optargs_s = { .bitmask = 0 };
      struct guestfs_glob_expand_opts_argv *optargs = &optargs_s;
      size_t items_i;
#line 9894 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::glob_expand(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::glob_expand(): g is not a blessed HV reference");
    }
;
#line 3974 "lib/Sys/Guestfs.xs"
      if (((items - 2) & 1) != 0)
        croak ("expecting an even number of extra parameters");
      for (items_i = 2; items_i < items; items_i += 2) {
        uint64_t this_mask;
        const char *this_arg;

        this_arg = SvPV_nolen (ST (items_i));
        if (STREQ (this_arg, "directoryslash")) {
          optargs_s.directoryslash = SvIV (ST (items_i+1));
          this_mask = GUESTFS_GLOB_EXPAND_OPTS_DIRECTORYSLASH_BITMASK;
        }
        else croak ("unknown optional argument '%s'", this_arg);
        if (optargs_s.bitmask & this_mask)
          croak ("optional argument '%s' given more than once",
                 this_arg);
        optargs_s.bitmask |= this_mask;
      }

      r = guestfs_glob_expand_opts_argv (g, pattern, optargs);
      if (r == NULL)
        croak ("%s", guestfs_last_error (g));
      for (n = 0; r[n] != NULL; ++n) /**/;
      EXTEND (SP, n);
      for (i = 0; i < n; ++i) {
        PUSHs (sv_2mortal (newSVpv (r[i], 0)));
        free (r[i]);
      }
      free (r);
#line 9937 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_grep); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_grep)
{
    dVAR; dXSARGS;
    if (items < 3)
       croak_xs_usage(cv,  "g, regex, path, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	regex = (char *)SvPV_nolen(ST(1))
;
	char *	path = (char *)SvPV_nolen(ST(2))
;
#line 4009 "lib/Sys/Guestfs.xs"
      char **r;
      size_t i, n;
      struct guestfs_grep_opts_argv optargs_s = { .bitmask = 0 };
      struct guestfs_grep_opts_argv *optargs = &optargs_s;
      size_t items_i;
#line 9964 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::grep(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::grep(): g is not a blessed HV reference");
    }
;
#line 4015 "lib/Sys/Guestfs.xs"
      if (((items - 3) & 1) != 0)
        croak ("expecting an even number of extra parameters");
      for (items_i = 3; items_i < items; items_i += 2) {
        uint64_t this_mask;
        const char *this_arg;

        this_arg = SvPV_nolen (ST (items_i));
        if (STREQ (this_arg, "extended")) {
          optargs_s.extended = SvIV (ST (items_i+1));
          this_mask = GUESTFS_GREP_OPTS_EXTENDED_BITMASK;
        }
        else if (STREQ (this_arg, "fixed")) {
          optargs_s.fixed = SvIV (ST (items_i+1));
          this_mask = GUESTFS_GREP_OPTS_FIXED_BITMASK;
        }
        else if (STREQ (this_arg, "insensitive")) {
          optargs_s.insensitive = SvIV (ST (items_i+1));
          this_mask = GUESTFS_GREP_OPTS_INSENSITIVE_BITMASK;
        }
        else if (STREQ (this_arg, "compressed")) {
          optargs_s.compressed = SvIV (ST (items_i+1));
          this_mask = GUESTFS_GREP_OPTS_COMPRESSED_BITMASK;
        }
        else croak ("unknown optional argument '%s'", this_arg);
        if (optargs_s.bitmask & this_mask)
          croak ("optional argument '%s' given more than once",
                 this_arg);
        optargs_s.bitmask |= this_mask;
      }

      r = guestfs_grep_opts_argv (g, regex, path, optargs);
      if (r == NULL)
        croak ("%s", guestfs_last_error (g));
      for (n = 0; r[n] != NULL; ++n) /**/;
      EXTEND (SP, n);
      for (i = 0; i < n; ++i) {
        PUSHs (sv_2mortal (newSVpv (r[i], 0)));
        free (r[i]);
      }
      free (r);
#line 10019 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_grepi); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_grepi)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "g, regex, path");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	regex = (char *)SvPV_nolen(ST(1))
;
	char *	path = (char *)SvPV_nolen(ST(2))
;
#line 4062 "lib/Sys/Guestfs.xs"
      char **r;
      size_t i, n;
#line 10043 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::grepi(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::grepi(): g is not a blessed HV reference");
    }
;
#line 4065 "lib/Sys/Guestfs.xs"
      Perl_ck_warner (aTHX_ packWARN(WARN_DEPRECATED),
        "Sys::Guestfs::grepi is deprecated; use Sys::Guestfs::grep instead");
      r = guestfs_grepi (g, regex, path);
      if (r == NULL)
        croak ("%s", guestfs_last_error (g));
      for (n = 0; r[n] != NULL; ++n) /**/;
      EXTEND (SP, n);
      for (i = 0; i < n; ++i) {
        PUSHs (sv_2mortal (newSVpv (r[i], 0)));
        free (r[i]);
      }
      free (r);
#line 10070 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_grub_install); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_grub_install)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "g, root, device");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	root = (char *)SvPV_nolen(ST(1))
;
	char *	device = (char *)SvPV_nolen(ST(2))
;
#line 4084 "lib/Sys/Guestfs.xs"
      int r;
#line 10093 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::grub_install(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::grub_install(): g is not a blessed HV reference");
    }
;
#line 4086 "lib/Sys/Guestfs.xs"
      r = guestfs_grub_install (g, root, device);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 10111 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_head); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_head)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, path");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	path = (char *)SvPV_nolen(ST(1))
;
#line 4095 "lib/Sys/Guestfs.xs"
      char **r;
      size_t i, n;
#line 10133 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::head(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::head(): g is not a blessed HV reference");
    }
;
#line 4098 "lib/Sys/Guestfs.xs"
      r = guestfs_head (g, path);
      if (r == NULL)
        croak ("%s", guestfs_last_error (g));
      for (n = 0; r[n] != NULL; ++n) /**/;
      EXTEND (SP, n);
      for (i = 0; i < n; ++i) {
        PUSHs (sv_2mortal (newSVpv (r[i], 0)));
        free (r[i]);
      }
      free (r);
#line 10158 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_head_n); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_head_n)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "g, nrlines, path");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	int	nrlines = (int)SvIV(ST(1))
;
	char *	path = (char *)SvPV_nolen(ST(2))
;
#line 4115 "lib/Sys/Guestfs.xs"
      char **r;
      size_t i, n;
#line 10182 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::head_n(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::head_n(): g is not a blessed HV reference");
    }
;
#line 4118 "lib/Sys/Guestfs.xs"
      r = guestfs_head_n (g, nrlines, path);
      if (r == NULL)
        croak ("%s", guestfs_last_error (g));
      for (n = 0; r[n] != NULL; ++n) /**/;
      EXTEND (SP, n);
      for (i = 0; i < n; ++i) {
        PUSHs (sv_2mortal (newSVpv (r[i], 0)));
        free (r[i]);
      }
      free (r);
#line 10207 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_hexdump); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_hexdump)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, path");
    {
	guestfs_h *	g;
	char *	path = (char *)SvPV_nolen(ST(1))
;
#line 4134 "lib/Sys/Guestfs.xs"
      char *r;
#line 10226 "lib/Sys/Guestfs.c"
	SV *	RETVAL;

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::hexdump(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::hexdump(): g is not a blessed HV reference");
    }
;
#line 4136 "lib/Sys/Guestfs.xs"
      r = guestfs_hexdump (g, path);
      if (r == NULL)
        croak ("%s", guestfs_last_error (g));
      RETVAL = newSVpv (r, 0);
      free (r);
#line 10247 "lib/Sys/Guestfs.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Guestfs_hivex_close); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_hivex_close)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "g");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
#line 4148 "lib/Sys/Guestfs.xs"
      int r;
#line 10267 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::hivex_close(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::hivex_close(): g is not a blessed HV reference");
    }
;
#line 4150 "lib/Sys/Guestfs.xs"
      r = guestfs_hivex_close (g);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 10285 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_hivex_commit); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_hivex_commit)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, filename");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	filename = SvOK(ST(1)) ? SvPV_nolen(ST(1)) : NULL;
#line 4159 "lib/Sys/Guestfs.xs"
      int r;
#line 10305 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::hivex_commit(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::hivex_commit(): g is not a blessed HV reference");
    }
;
#line 4161 "lib/Sys/Guestfs.xs"
      r = guestfs_hivex_commit (g, filename);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 10323 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_hivex_node_add_child); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_hivex_node_add_child)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "g, parent, name");
    {
	guestfs_h *	g;
	int64_t    parent = my_SvIV64 (ST(1))
;
	char *	name = (char *)SvPV_nolen(ST(2))
;
#line 4171 "lib/Sys/Guestfs.xs"
      int64_t r;
#line 10344 "lib/Sys/Guestfs.c"
	SV *	RETVAL;

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::hivex_node_add_child(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::hivex_node_add_child(): g is not a blessed HV reference");
    }
;
#line 4173 "lib/Sys/Guestfs.xs"
      r = guestfs_hivex_node_add_child (g, parent, name);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
      RETVAL = my_newSVll (r);
#line 10364 "lib/Sys/Guestfs.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Guestfs_hivex_node_children); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_hivex_node_children)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, nodeh");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	int64_t    nodeh = my_SvIV64 (ST(1))
;
#line 4185 "lib/Sys/Guestfs.xs"
      struct guestfs_hivex_node_list *r;
      size_t i;
      HV *hv;
#line 10388 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::hivex_node_children(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::hivex_node_children(): g is not a blessed HV reference");
    }
;
#line 4189 "lib/Sys/Guestfs.xs"
      r = guestfs_hivex_node_children (g, nodeh);
      if (r == NULL)
        croak ("%s", guestfs_last_error (g));
      EXTEND (SP, r->len);
      for (i = 0; i < r->len; ++i) {
        hv = newHV ();
        (void) hv_store (hv, "hivex_node_h", 12, my_newSVll (r->val[i].hivex_node_h), 0);
        PUSHs (sv_2mortal (newRV ((SV *) hv)));
      }
      guestfs_free_hivex_node_list (r);
#line 10413 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_hivex_node_delete_child); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_hivex_node_delete_child)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, nodeh");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	int64_t    nodeh = my_SvIV64 (ST(1))
;
#line 4205 "lib/Sys/Guestfs.xs"
      int r;
#line 10434 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::hivex_node_delete_child(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::hivex_node_delete_child(): g is not a blessed HV reference");
    }
;
#line 4207 "lib/Sys/Guestfs.xs"
      r = guestfs_hivex_node_delete_child (g, nodeh);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 10452 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_hivex_node_get_child); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_hivex_node_get_child)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "g, nodeh, name");
    {
	guestfs_h *	g;
	int64_t    nodeh = my_SvIV64 (ST(1))
;
	char *	name = (char *)SvPV_nolen(ST(2))
;
#line 4217 "lib/Sys/Guestfs.xs"
      int64_t r;
#line 10473 "lib/Sys/Guestfs.c"
	SV *	RETVAL;

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::hivex_node_get_child(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::hivex_node_get_child(): g is not a blessed HV reference");
    }
;
#line 4219 "lib/Sys/Guestfs.xs"
      r = guestfs_hivex_node_get_child (g, nodeh, name);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
      RETVAL = my_newSVll (r);
#line 10493 "lib/Sys/Guestfs.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Guestfs_hivex_node_get_value); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_hivex_node_get_value)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "g, nodeh, key");
    {
	guestfs_h *	g;
	int64_t    nodeh = my_SvIV64 (ST(1))
;
	char *	key = (char *)SvPV_nolen(ST(2))
;
#line 4232 "lib/Sys/Guestfs.xs"
      int64_t r;
#line 10515 "lib/Sys/Guestfs.c"
	SV *	RETVAL;

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::hivex_node_get_value(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::hivex_node_get_value(): g is not a blessed HV reference");
    }
;
#line 4234 "lib/Sys/Guestfs.xs"
      r = guestfs_hivex_node_get_value (g, nodeh, key);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
      RETVAL = my_newSVll (r);
#line 10535 "lib/Sys/Guestfs.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Guestfs_hivex_node_name); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_hivex_node_name)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, nodeh");
    {
	guestfs_h *	g;
	int64_t    nodeh = my_SvIV64 (ST(1))
;
#line 4246 "lib/Sys/Guestfs.xs"
      char *r;
#line 10555 "lib/Sys/Guestfs.c"
	SV *	RETVAL;

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::hivex_node_name(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::hivex_node_name(): g is not a blessed HV reference");
    }
;
#line 4248 "lib/Sys/Guestfs.xs"
      r = guestfs_hivex_node_name (g, nodeh);
      if (r == NULL)
        croak ("%s", guestfs_last_error (g));
      RETVAL = newSVpv (r, 0);
      free (r);
#line 10576 "lib/Sys/Guestfs.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Guestfs_hivex_node_parent); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_hivex_node_parent)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, nodeh");
    {
	guestfs_h *	g;
	int64_t    nodeh = my_SvIV64 (ST(1))
;
#line 4261 "lib/Sys/Guestfs.xs"
      int64_t r;
#line 10596 "lib/Sys/Guestfs.c"
	SV *	RETVAL;

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::hivex_node_parent(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::hivex_node_parent(): g is not a blessed HV reference");
    }
;
#line 4263 "lib/Sys/Guestfs.xs"
      r = guestfs_hivex_node_parent (g, nodeh);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
      RETVAL = my_newSVll (r);
#line 10616 "lib/Sys/Guestfs.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Guestfs_hivex_node_set_value); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_hivex_node_set_value)
{
    dVAR; dXSARGS;
    if (items != 5)
       croak_xs_usage(cv,  "g, nodeh, key, t, val");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	int64_t    nodeh = my_SvIV64 (ST(1))
;
	char *	key = (char *)SvPV_nolen(ST(2))
;
	int64_t    t = my_SvIV64 (ST(3))
;
	char *	val = (char *)SvPV_nolen(ST(4))
;
	size_t	val_size = SvCUR (ST(4));
#line 4279 "lib/Sys/Guestfs.xs"
      int r;
#line 10645 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::hivex_node_set_value(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::hivex_node_set_value(): g is not a blessed HV reference");
    }
;
#line 4281 "lib/Sys/Guestfs.xs"
      r = guestfs_hivex_node_set_value (g, nodeh, key, t, val, val_size);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 10663 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_hivex_node_values); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_hivex_node_values)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, nodeh");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	int64_t    nodeh = my_SvIV64 (ST(1))
;
#line 4290 "lib/Sys/Guestfs.xs"
      struct guestfs_hivex_value_list *r;
      size_t i;
      HV *hv;
#line 10686 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::hivex_node_values(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::hivex_node_values(): g is not a blessed HV reference");
    }
;
#line 4294 "lib/Sys/Guestfs.xs"
      r = guestfs_hivex_node_values (g, nodeh);
      if (r == NULL)
        croak ("%s", guestfs_last_error (g));
      EXTEND (SP, r->len);
      for (i = 0; i < r->len; ++i) {
        hv = newHV ();
        (void) hv_store (hv, "hivex_value_h", 13, my_newSVll (r->val[i].hivex_value_h), 0);
        PUSHs (sv_2mortal (newRV ((SV *) hv)));
      }
      guestfs_free_hivex_value_list (r);
#line 10711 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_hivex_open); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_hivex_open)
{
    dVAR; dXSARGS;
    if (items < 2)
       croak_xs_usage(cv,  "g, filename, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	filename = (char *)SvPV_nolen(ST(1))
;
#line 4310 "lib/Sys/Guestfs.xs"
      int r;
      struct guestfs_hivex_open_argv optargs_s = { .bitmask = 0 };
      struct guestfs_hivex_open_argv *optargs = &optargs_s;
      size_t items_i;
#line 10735 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::hivex_open(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::hivex_open(): g is not a blessed HV reference");
    }
;
#line 4315 "lib/Sys/Guestfs.xs"
      if (((items - 2) & 1) != 0)
        croak ("expecting an even number of extra parameters");
      for (items_i = 2; items_i < items; items_i += 2) {
        uint64_t this_mask;
        const char *this_arg;

        this_arg = SvPV_nolen (ST (items_i));
        if (STREQ (this_arg, "verbose")) {
          optargs_s.verbose = SvIV (ST (items_i+1));
          this_mask = GUESTFS_HIVEX_OPEN_VERBOSE_BITMASK;
        }
        else if (STREQ (this_arg, "debug")) {
          optargs_s.debug = SvIV (ST (items_i+1));
          this_mask = GUESTFS_HIVEX_OPEN_DEBUG_BITMASK;
        }
        else if (STREQ (this_arg, "write")) {
          optargs_s.write = SvIV (ST (items_i+1));
          this_mask = GUESTFS_HIVEX_OPEN_WRITE_BITMASK;
        }
        else if (STREQ (this_arg, "unsafe")) {
          optargs_s.unsafe = SvIV (ST (items_i+1));
          this_mask = GUESTFS_HIVEX_OPEN_UNSAFE_BITMASK;
        }
        else croak ("unknown optional argument '%s'", this_arg);
        if (optargs_s.bitmask & this_mask)
          croak ("optional argument '%s' given more than once",
                 this_arg);
        optargs_s.bitmask |= this_mask;
      }

      r = guestfs_hivex_open_argv (g, filename, optargs);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 10783 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_hivex_root); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_hivex_root)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "g");
    {
	guestfs_h *	g;
#line 4353 "lib/Sys/Guestfs.xs"
      int64_t r;
#line 10800 "lib/Sys/Guestfs.c"
	SV *	RETVAL;

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::hivex_root(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::hivex_root(): g is not a blessed HV reference");
    }
;
#line 4355 "lib/Sys/Guestfs.xs"
      r = guestfs_hivex_root (g);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
      RETVAL = my_newSVll (r);
#line 10820 "lib/Sys/Guestfs.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Guestfs_hivex_value_key); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_hivex_value_key)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, valueh");
    {
	guestfs_h *	g;
	int64_t    valueh = my_SvIV64 (ST(1))
;
#line 4367 "lib/Sys/Guestfs.xs"
      char *r;
#line 10840 "lib/Sys/Guestfs.c"
	SV *	RETVAL;

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::hivex_value_key(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::hivex_value_key(): g is not a blessed HV reference");
    }
;
#line 4369 "lib/Sys/Guestfs.xs"
      r = guestfs_hivex_value_key (g, valueh);
      if (r == NULL)
        croak ("%s", guestfs_last_error (g));
      RETVAL = newSVpv (r, 0);
      free (r);
#line 10861 "lib/Sys/Guestfs.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Guestfs_hivex_value_string); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_hivex_value_string)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, valueh");
    {
	guestfs_h *	g;
	int64_t    valueh = my_SvIV64 (ST(1))
;
#line 4382 "lib/Sys/Guestfs.xs"
      char *r;
#line 10881 "lib/Sys/Guestfs.c"
	SV *	RETVAL;

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::hivex_value_string(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::hivex_value_string(): g is not a blessed HV reference");
    }
;
#line 4384 "lib/Sys/Guestfs.xs"
      r = guestfs_hivex_value_string (g, valueh);
      if (r == NULL)
        croak ("%s", guestfs_last_error (g));
      RETVAL = newSVpv (r, 0);
      free (r);
#line 10902 "lib/Sys/Guestfs.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Guestfs_hivex_value_type); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_hivex_value_type)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, valueh");
    {
	guestfs_h *	g;
	int64_t    valueh = my_SvIV64 (ST(1))
;
#line 4397 "lib/Sys/Guestfs.xs"
      int64_t r;
#line 10922 "lib/Sys/Guestfs.c"
	SV *	RETVAL;

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::hivex_value_type(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::hivex_value_type(): g is not a blessed HV reference");
    }
;
#line 4399 "lib/Sys/Guestfs.xs"
      r = guestfs_hivex_value_type (g, valueh);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
      RETVAL = my_newSVll (r);
#line 10942 "lib/Sys/Guestfs.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Guestfs_hivex_value_utf8); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_hivex_value_utf8)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, valueh");
    {
	guestfs_h *	g;
	int64_t    valueh = my_SvIV64 (ST(1))
;
#line 4411 "lib/Sys/Guestfs.xs"
      char *r;
#line 10962 "lib/Sys/Guestfs.c"
	SV *	RETVAL;

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::hivex_value_utf8(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::hivex_value_utf8(): g is not a blessed HV reference");
    }
;
#line 4413 "lib/Sys/Guestfs.xs"
      Perl_ck_warner (aTHX_ packWARN(WARN_DEPRECATED),
        "Sys::Guestfs::hivex_value_utf8 is deprecated; use Sys::Guestfs::hivex_value_string instead");
      r = guestfs_hivex_value_utf8 (g, valueh);
      if (r == NULL)
        croak ("%s", guestfs_last_error (g));
      RETVAL = newSVpv (r, 0);
      free (r);
#line 10985 "lib/Sys/Guestfs.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Guestfs_hivex_value_value); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_hivex_value_value)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, valueh");
    {
	guestfs_h *	g;
	int64_t    valueh = my_SvIV64 (ST(1))
;
#line 4428 "lib/Sys/Guestfs.xs"
      char *r;
      size_t size;
#line 11006 "lib/Sys/Guestfs.c"
	SV *	RETVAL;

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::hivex_value_value(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::hivex_value_value(): g is not a blessed HV reference");
    }
;
#line 4431 "lib/Sys/Guestfs.xs"
      r = guestfs_hivex_value_value (g, valueh, &size);
      if (r == NULL)
        croak ("%s", guestfs_last_error (g));
      RETVAL = newSVpvn (r, size);
      free (r);
#line 11027 "lib/Sys/Guestfs.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Guestfs_initrd_cat); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_initrd_cat)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "g, initrdpath, filename");
    {
	guestfs_h *	g;
	char *	initrdpath = (char *)SvPV_nolen(ST(1))
;
	char *	filename = (char *)SvPV_nolen(ST(2))
;
#line 4445 "lib/Sys/Guestfs.xs"
      char *r;
      size_t size;
#line 11050 "lib/Sys/Guestfs.c"
	SV *	RETVAL;

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::initrd_cat(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::initrd_cat(): g is not a blessed HV reference");
    }
;
#line 4448 "lib/Sys/Guestfs.xs"
      r = guestfs_initrd_cat (g, initrdpath, filename, &size);
      if (r == NULL)
        croak ("%s", guestfs_last_error (g));
      RETVAL = newSVpvn (r, size);
      free (r);
#line 11071 "lib/Sys/Guestfs.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Guestfs_initrd_list); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_initrd_list)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, path");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	path = (char *)SvPV_nolen(ST(1))
;
#line 4461 "lib/Sys/Guestfs.xs"
      char **r;
      size_t i, n;
#line 11094 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::initrd_list(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::initrd_list(): g is not a blessed HV reference");
    }
;
#line 4464 "lib/Sys/Guestfs.xs"
      r = guestfs_initrd_list (g, path);
      if (r == NULL)
        croak ("%s", guestfs_last_error (g));
      for (n = 0; r[n] != NULL; ++n) /**/;
      EXTEND (SP, n);
      for (i = 0; i < n; ++i) {
        PUSHs (sv_2mortal (newSVpv (r[i], 0)));
        free (r[i]);
      }
      free (r);
#line 11119 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_inotify_add_watch); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_inotify_add_watch)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "g, path, mask");
    {
	guestfs_h *	g;
	char *	path = (char *)SvPV_nolen(ST(1))
;
	int	mask = (int)SvIV(ST(2))
;
#line 4481 "lib/Sys/Guestfs.xs"
      int64_t r;
#line 11140 "lib/Sys/Guestfs.c"
	SV *	RETVAL;

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::inotify_add_watch(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::inotify_add_watch(): g is not a blessed HV reference");
    }
;
#line 4483 "lib/Sys/Guestfs.xs"
      r = guestfs_inotify_add_watch (g, path, mask);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
      RETVAL = my_newSVll (r);
#line 11160 "lib/Sys/Guestfs.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Guestfs_inotify_close); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_inotify_close)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "g");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
#line 4494 "lib/Sys/Guestfs.xs"
      int r;
#line 11180 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::inotify_close(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::inotify_close(): g is not a blessed HV reference");
    }
;
#line 4496 "lib/Sys/Guestfs.xs"
      r = guestfs_inotify_close (g);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 11198 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_inotify_files); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_inotify_files)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "g");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
#line 4504 "lib/Sys/Guestfs.xs"
      char **r;
      size_t i, n;
#line 11218 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::inotify_files(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::inotify_files(): g is not a blessed HV reference");
    }
;
#line 4507 "lib/Sys/Guestfs.xs"
      r = guestfs_inotify_files (g);
      if (r == NULL)
        croak ("%s", guestfs_last_error (g));
      for (n = 0; r[n] != NULL; ++n) /**/;
      EXTEND (SP, n);
      for (i = 0; i < n; ++i) {
        PUSHs (sv_2mortal (newSVpv (r[i], 0)));
        free (r[i]);
      }
      free (r);
#line 11243 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_inotify_init); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_inotify_init)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, maxevents");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	int	maxevents = (int)SvIV(ST(1))
;
#line 4523 "lib/Sys/Guestfs.xs"
      int r;
#line 11264 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::inotify_init(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::inotify_init(): g is not a blessed HV reference");
    }
;
#line 4525 "lib/Sys/Guestfs.xs"
      r = guestfs_inotify_init (g, maxevents);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 11282 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_inotify_read); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_inotify_read)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "g");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
#line 4533 "lib/Sys/Guestfs.xs"
      struct guestfs_inotify_event_list *r;
      size_t i;
      HV *hv;
#line 11303 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::inotify_read(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::inotify_read(): g is not a blessed HV reference");
    }
;
#line 4537 "lib/Sys/Guestfs.xs"
      r = guestfs_inotify_read (g);
      if (r == NULL)
        croak ("%s", guestfs_last_error (g));
      EXTEND (SP, r->len);
      for (i = 0; i < r->len; ++i) {
        hv = newHV ();
        (void) hv_store (hv, "in_wd", 5, my_newSVll (r->val[i].in_wd), 0);
        (void) hv_store (hv, "in_mask", 7, newSVnv (r->val[i].in_mask), 0);
        (void) hv_store (hv, "in_cookie", 9, newSVnv (r->val[i].in_cookie), 0);
        (void) hv_store (hv, "in_name", 7, newSVpv (r->val[i].in_name, 0), 0);
        PUSHs (sv_2mortal (newRV ((SV *) hv)));
      }
      guestfs_free_inotify_event_list (r);
#line 11331 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_inotify_rm_watch); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_inotify_rm_watch)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, wd");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	int	wd = (int)SvIV(ST(1))
;
#line 4556 "lib/Sys/Guestfs.xs"
      int r;
#line 11352 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::inotify_rm_watch(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::inotify_rm_watch(): g is not a blessed HV reference");
    }
;
#line 4558 "lib/Sys/Guestfs.xs"
      r = guestfs_inotify_rm_watch (g, wd);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 11370 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_inspect_get_arch); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_inspect_get_arch)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, root");
    {
	guestfs_h *	g;
	char *	root = (char *)SvPV_nolen(ST(1))
;
#line 4567 "lib/Sys/Guestfs.xs"
      char *r;
#line 11389 "lib/Sys/Guestfs.c"
	SV *	RETVAL;

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::inspect_get_arch(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::inspect_get_arch(): g is not a blessed HV reference");
    }
;
#line 4569 "lib/Sys/Guestfs.xs"
      r = guestfs_inspect_get_arch (g, root);
      if (r == NULL)
        croak ("%s", guestfs_last_error (g));
      RETVAL = newSVpv (r, 0);
      free (r);
#line 11410 "lib/Sys/Guestfs.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Guestfs_inspect_get_build_id); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_inspect_get_build_id)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, root");
    {
	guestfs_h *	g;
	char *	root = (char *)SvPV_nolen(ST(1))
;
#line 4582 "lib/Sys/Guestfs.xs"
      char *r;
#line 11430 "lib/Sys/Guestfs.c"
	SV *	RETVAL;

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::inspect_get_build_id(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::inspect_get_build_id(): g is not a blessed HV reference");
    }
;
#line 4584 "lib/Sys/Guestfs.xs"
      r = guestfs_inspect_get_build_id (g, root);
      if (r == NULL)
        croak ("%s", guestfs_last_error (g));
      RETVAL = newSVpv (r, 0);
      free (r);
#line 11451 "lib/Sys/Guestfs.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Guestfs_inspect_get_distro); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_inspect_get_distro)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, root");
    {
	guestfs_h *	g;
	char *	root = (char *)SvPV_nolen(ST(1))
;
#line 4597 "lib/Sys/Guestfs.xs"
      char *r;
#line 11471 "lib/Sys/Guestfs.c"
	SV *	RETVAL;

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::inspect_get_distro(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::inspect_get_distro(): g is not a blessed HV reference");
    }
;
#line 4599 "lib/Sys/Guestfs.xs"
      r = guestfs_inspect_get_distro (g, root);
      if (r == NULL)
        croak ("%s", guestfs_last_error (g));
      RETVAL = newSVpv (r, 0);
      free (r);
#line 11492 "lib/Sys/Guestfs.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Guestfs_inspect_get_drive_mappings); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_inspect_get_drive_mappings)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, root");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	root = (char *)SvPV_nolen(ST(1))
;
#line 4612 "lib/Sys/Guestfs.xs"
      char **r;
      size_t i, n;
#line 11515 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::inspect_get_drive_mappings(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::inspect_get_drive_mappings(): g is not a blessed HV reference");
    }
;
#line 4615 "lib/Sys/Guestfs.xs"
      r = guestfs_inspect_get_drive_mappings (g, root);
      if (r == NULL)
        croak ("%s", guestfs_last_error (g));
      for (n = 0; r[n] != NULL; ++n) /**/;
      EXTEND (SP, n);
      for (i = 0; i < n; ++i) {
        PUSHs (sv_2mortal (newSVpv (r[i], 0)));
        free (r[i]);
      }
      free (r);
#line 11540 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_inspect_get_filesystems); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_inspect_get_filesystems)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, root");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	root = (char *)SvPV_nolen(ST(1))
;
#line 4631 "lib/Sys/Guestfs.xs"
      char **r;
      size_t i, n;
#line 11562 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::inspect_get_filesystems(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::inspect_get_filesystems(): g is not a blessed HV reference");
    }
;
#line 4634 "lib/Sys/Guestfs.xs"
      r = guestfs_inspect_get_filesystems (g, root);
      if (r == NULL)
        croak ("%s", guestfs_last_error (g));
      for (n = 0; r[n] != NULL; ++n) /**/;
      EXTEND (SP, n);
      for (i = 0; i < n; ++i) {
        PUSHs (sv_2mortal (newSVpv (r[i], 0)));
        free (r[i]);
      }
      free (r);
#line 11587 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_inspect_get_format); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_inspect_get_format)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, root");
    {
	guestfs_h *	g;
	char *	root = (char *)SvPV_nolen(ST(1))
;
#line 4650 "lib/Sys/Guestfs.xs"
      char *r;
#line 11606 "lib/Sys/Guestfs.c"
	SV *	RETVAL;

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::inspect_get_format(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::inspect_get_format(): g is not a blessed HV reference");
    }
;
#line 4652 "lib/Sys/Guestfs.xs"
      Perl_ck_warner (aTHX_ packWARN(WARN_DEPRECATED),
        "Sys::Guestfs::inspect_get_format is deprecated");
      r = guestfs_inspect_get_format (g, root);
      if (r == NULL)
        croak ("%s", guestfs_last_error (g));
      RETVAL = newSVpv (r, 0);
      free (r);
#line 11629 "lib/Sys/Guestfs.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Guestfs_inspect_get_hostname); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_inspect_get_hostname)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, root");
    {
	guestfs_h *	g;
	char *	root = (char *)SvPV_nolen(ST(1))
;
#line 4667 "lib/Sys/Guestfs.xs"
      char *r;
#line 11649 "lib/Sys/Guestfs.c"
	SV *	RETVAL;

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::inspect_get_hostname(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::inspect_get_hostname(): g is not a blessed HV reference");
    }
;
#line 4669 "lib/Sys/Guestfs.xs"
      r = guestfs_inspect_get_hostname (g, root);
      if (r == NULL)
        croak ("%s", guestfs_last_error (g));
      RETVAL = newSVpv (r, 0);
      free (r);
#line 11670 "lib/Sys/Guestfs.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Guestfs_inspect_get_icon); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_inspect_get_icon)
{
    dVAR; dXSARGS;
    if (items < 2)
       croak_xs_usage(cv,  "g, root, ...");
    {
	guestfs_h *	g;
	char *	root = (char *)SvPV_nolen(ST(1))
;
#line 4682 "lib/Sys/Guestfs.xs"
      char *r;
      size_t size;
      struct guestfs_inspect_get_icon_argv optargs_s = { .bitmask = 0 };
      struct guestfs_inspect_get_icon_argv *optargs = &optargs_s;
      size_t items_i;
#line 11694 "lib/Sys/Guestfs.c"
	SV *	RETVAL;

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::inspect_get_icon(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::inspect_get_icon(): g is not a blessed HV reference");
    }
;
#line 4688 "lib/Sys/Guestfs.xs"
      if (((items - 2) & 1) != 0)
        croak ("expecting an even number of extra parameters");
      for (items_i = 2; items_i < items; items_i += 2) {
        uint64_t this_mask;
        const char *this_arg;

        this_arg = SvPV_nolen (ST (items_i));
        if (STREQ (this_arg, "favicon")) {
          optargs_s.favicon = SvIV (ST (items_i+1));
          this_mask = GUESTFS_INSPECT_GET_ICON_FAVICON_BITMASK;
        }
        else if (STREQ (this_arg, "highquality")) {
          optargs_s.highquality = SvIV (ST (items_i+1));
          this_mask = GUESTFS_INSPECT_GET_ICON_HIGHQUALITY_BITMASK;
        }
        else croak ("unknown optional argument '%s'", this_arg);
        if (optargs_s.bitmask & this_mask)
          croak ("optional argument '%s' given more than once",
                 this_arg);
        optargs_s.bitmask |= this_mask;
      }

      r = guestfs_inspect_get_icon_argv (g, root, &size, optargs);
      if (r == NULL)
        croak ("%s", guestfs_last_error (g));
      RETVAL = newSVpvn (r, size);
      free (r);
#line 11737 "lib/Sys/Guestfs.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Guestfs_inspect_get_major_version); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_inspect_get_major_version)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, root");
    {
	guestfs_h *	g;
	char *	root = (char *)SvPV_nolen(ST(1))
;
#line 4723 "lib/Sys/Guestfs.xs"
      int r;
#line 11757 "lib/Sys/Guestfs.c"
	SV *	RETVAL;

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::inspect_get_major_version(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::inspect_get_major_version(): g is not a blessed HV reference");
    }
;
#line 4725 "lib/Sys/Guestfs.xs"
      r = guestfs_inspect_get_major_version (g, root);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
      RETVAL = newSViv (r);
#line 11777 "lib/Sys/Guestfs.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Guestfs_inspect_get_minor_version); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_inspect_get_minor_version)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, root");
    {
	guestfs_h *	g;
	char *	root = (char *)SvPV_nolen(ST(1))
;
#line 4737 "lib/Sys/Guestfs.xs"
      int r;
#line 11797 "lib/Sys/Guestfs.c"
	SV *	RETVAL;

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::inspect_get_minor_version(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::inspect_get_minor_version(): g is not a blessed HV reference");
    }
;
#line 4739 "lib/Sys/Guestfs.xs"
      r = guestfs_inspect_get_minor_version (g, root);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
      RETVAL = newSViv (r);
#line 11817 "lib/Sys/Guestfs.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Guestfs_inspect_get_mountpoints); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_inspect_get_mountpoints)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, root");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	root = (char *)SvPV_nolen(ST(1))
;
#line 4751 "lib/Sys/Guestfs.xs"
      char **r;
      size_t i, n;
#line 11840 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::inspect_get_mountpoints(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::inspect_get_mountpoints(): g is not a blessed HV reference");
    }
;
#line 4754 "lib/Sys/Guestfs.xs"
      r = guestfs_inspect_get_mountpoints (g, root);
      if (r == NULL)
        croak ("%s", guestfs_last_error (g));
      for (n = 0; r[n] != NULL; ++n) /**/;
      EXTEND (SP, n);
      for (i = 0; i < n; ++i) {
        PUSHs (sv_2mortal (newSVpv (r[i], 0)));
        free (r[i]);
      }
      free (r);
#line 11865 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_inspect_get_osinfo); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_inspect_get_osinfo)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, root");
    {
	guestfs_h *	g;
	char *	root = (char *)SvPV_nolen(ST(1))
;
#line 4770 "lib/Sys/Guestfs.xs"
      char *r;
#line 11884 "lib/Sys/Guestfs.c"
	SV *	RETVAL;

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::inspect_get_osinfo(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::inspect_get_osinfo(): g is not a blessed HV reference");
    }
;
#line 4772 "lib/Sys/Guestfs.xs"
      r = guestfs_inspect_get_osinfo (g, root);
      if (r == NULL)
        croak ("%s", guestfs_last_error (g));
      RETVAL = newSVpv (r, 0);
      free (r);
#line 11905 "lib/Sys/Guestfs.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Guestfs_inspect_get_package_format); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_inspect_get_package_format)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, root");
    {
	guestfs_h *	g;
	char *	root = (char *)SvPV_nolen(ST(1))
;
#line 4785 "lib/Sys/Guestfs.xs"
      char *r;
#line 11925 "lib/Sys/Guestfs.c"
	SV *	RETVAL;

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::inspect_get_package_format(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::inspect_get_package_format(): g is not a blessed HV reference");
    }
;
#line 4787 "lib/Sys/Guestfs.xs"
      r = guestfs_inspect_get_package_format (g, root);
      if (r == NULL)
        croak ("%s", guestfs_last_error (g));
      RETVAL = newSVpv (r, 0);
      free (r);
#line 11946 "lib/Sys/Guestfs.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Guestfs_inspect_get_package_management); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_inspect_get_package_management)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, root");
    {
	guestfs_h *	g;
	char *	root = (char *)SvPV_nolen(ST(1))
;
#line 4800 "lib/Sys/Guestfs.xs"
      char *r;
#line 11966 "lib/Sys/Guestfs.c"
	SV *	RETVAL;

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::inspect_get_package_management(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::inspect_get_package_management(): g is not a blessed HV reference");
    }
;
#line 4802 "lib/Sys/Guestfs.xs"
      r = guestfs_inspect_get_package_management (g, root);
      if (r == NULL)
        croak ("%s", guestfs_last_error (g));
      RETVAL = newSVpv (r, 0);
      free (r);
#line 11987 "lib/Sys/Guestfs.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Guestfs_inspect_get_product_name); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_inspect_get_product_name)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, root");
    {
	guestfs_h *	g;
	char *	root = (char *)SvPV_nolen(ST(1))
;
#line 4815 "lib/Sys/Guestfs.xs"
      char *r;
#line 12007 "lib/Sys/Guestfs.c"
	SV *	RETVAL;

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::inspect_get_product_name(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::inspect_get_product_name(): g is not a blessed HV reference");
    }
;
#line 4817 "lib/Sys/Guestfs.xs"
      r = guestfs_inspect_get_product_name (g, root);
      if (r == NULL)
        croak ("%s", guestfs_last_error (g));
      RETVAL = newSVpv (r, 0);
      free (r);
#line 12028 "lib/Sys/Guestfs.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Guestfs_inspect_get_product_variant); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_inspect_get_product_variant)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, root");
    {
	guestfs_h *	g;
	char *	root = (char *)SvPV_nolen(ST(1))
;
#line 4830 "lib/Sys/Guestfs.xs"
      char *r;
#line 12048 "lib/Sys/Guestfs.c"
	SV *	RETVAL;

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::inspect_get_product_variant(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::inspect_get_product_variant(): g is not a blessed HV reference");
    }
;
#line 4832 "lib/Sys/Guestfs.xs"
      r = guestfs_inspect_get_product_variant (g, root);
      if (r == NULL)
        croak ("%s", guestfs_last_error (g));
      RETVAL = newSVpv (r, 0);
      free (r);
#line 12069 "lib/Sys/Guestfs.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Guestfs_inspect_get_roots); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_inspect_get_roots)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "g");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
#line 4844 "lib/Sys/Guestfs.xs"
      char **r;
      size_t i, n;
#line 12090 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::inspect_get_roots(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::inspect_get_roots(): g is not a blessed HV reference");
    }
;
#line 4847 "lib/Sys/Guestfs.xs"
      r = guestfs_inspect_get_roots (g);
      if (r == NULL)
        croak ("%s", guestfs_last_error (g));
      for (n = 0; r[n] != NULL; ++n) /**/;
      EXTEND (SP, n);
      for (i = 0; i < n; ++i) {
        PUSHs (sv_2mortal (newSVpv (r[i], 0)));
        free (r[i]);
      }
      free (r);
#line 12115 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_inspect_get_type); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_inspect_get_type)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, root");
    {
	guestfs_h *	g;
	char *	root = (char *)SvPV_nolen(ST(1))
;
#line 4863 "lib/Sys/Guestfs.xs"
      char *r;
#line 12134 "lib/Sys/Guestfs.c"
	SV *	RETVAL;

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::inspect_get_type(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::inspect_get_type(): g is not a blessed HV reference");
    }
;
#line 4865 "lib/Sys/Guestfs.xs"
      r = guestfs_inspect_get_type (g, root);
      if (r == NULL)
        croak ("%s", guestfs_last_error (g));
      RETVAL = newSVpv (r, 0);
      free (r);
#line 12155 "lib/Sys/Guestfs.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Guestfs_inspect_get_windows_current_control_set); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_inspect_get_windows_current_control_set)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, root");
    {
	guestfs_h *	g;
	char *	root = (char *)SvPV_nolen(ST(1))
;
#line 4878 "lib/Sys/Guestfs.xs"
      char *r;
#line 12175 "lib/Sys/Guestfs.c"
	SV *	RETVAL;

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::inspect_get_windows_current_control_set(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::inspect_get_windows_current_control_set(): g is not a blessed HV reference");
    }
;
#line 4880 "lib/Sys/Guestfs.xs"
      r = guestfs_inspect_get_windows_current_control_set (g, root);
      if (r == NULL)
        croak ("%s", guestfs_last_error (g));
      RETVAL = newSVpv (r, 0);
      free (r);
#line 12196 "lib/Sys/Guestfs.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Guestfs_inspect_get_windows_software_hive); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_inspect_get_windows_software_hive)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, root");
    {
	guestfs_h *	g;
	char *	root = (char *)SvPV_nolen(ST(1))
;
#line 4893 "lib/Sys/Guestfs.xs"
      char *r;
#line 12216 "lib/Sys/Guestfs.c"
	SV *	RETVAL;

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::inspect_get_windows_software_hive(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::inspect_get_windows_software_hive(): g is not a blessed HV reference");
    }
;
#line 4895 "lib/Sys/Guestfs.xs"
      r = guestfs_inspect_get_windows_software_hive (g, root);
      if (r == NULL)
        croak ("%s", guestfs_last_error (g));
      RETVAL = newSVpv (r, 0);
      free (r);
#line 12237 "lib/Sys/Guestfs.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Guestfs_inspect_get_windows_system_hive); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_inspect_get_windows_system_hive)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, root");
    {
	guestfs_h *	g;
	char *	root = (char *)SvPV_nolen(ST(1))
;
#line 4908 "lib/Sys/Guestfs.xs"
      char *r;
#line 12257 "lib/Sys/Guestfs.c"
	SV *	RETVAL;

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::inspect_get_windows_system_hive(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::inspect_get_windows_system_hive(): g is not a blessed HV reference");
    }
;
#line 4910 "lib/Sys/Guestfs.xs"
      r = guestfs_inspect_get_windows_system_hive (g, root);
      if (r == NULL)
        croak ("%s", guestfs_last_error (g));
      RETVAL = newSVpv (r, 0);
      free (r);
#line 12278 "lib/Sys/Guestfs.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Guestfs_inspect_get_windows_systemroot); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_inspect_get_windows_systemroot)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, root");
    {
	guestfs_h *	g;
	char *	root = (char *)SvPV_nolen(ST(1))
;
#line 4923 "lib/Sys/Guestfs.xs"
      char *r;
#line 12298 "lib/Sys/Guestfs.c"
	SV *	RETVAL;

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::inspect_get_windows_systemroot(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::inspect_get_windows_systemroot(): g is not a blessed HV reference");
    }
;
#line 4925 "lib/Sys/Guestfs.xs"
      r = guestfs_inspect_get_windows_systemroot (g, root);
      if (r == NULL)
        croak ("%s", guestfs_last_error (g));
      RETVAL = newSVpv (r, 0);
      free (r);
#line 12319 "lib/Sys/Guestfs.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Guestfs_inspect_is_live); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_inspect_is_live)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, root");
    {
	guestfs_h *	g;
	char *	root = (char *)SvPV_nolen(ST(1))
;
#line 4938 "lib/Sys/Guestfs.xs"
      int r;
#line 12339 "lib/Sys/Guestfs.c"
	SV *	RETVAL;

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::inspect_is_live(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::inspect_is_live(): g is not a blessed HV reference");
    }
;
#line 4940 "lib/Sys/Guestfs.xs"
      Perl_ck_warner (aTHX_ packWARN(WARN_DEPRECATED),
        "Sys::Guestfs::inspect_is_live is deprecated");
      r = guestfs_inspect_is_live (g, root);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
      RETVAL = newSViv (r);
#line 12361 "lib/Sys/Guestfs.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Guestfs_inspect_is_multipart); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_inspect_is_multipart)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, root");
    {
	guestfs_h *	g;
	char *	root = (char *)SvPV_nolen(ST(1))
;
#line 4954 "lib/Sys/Guestfs.xs"
      int r;
#line 12381 "lib/Sys/Guestfs.c"
	SV *	RETVAL;

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::inspect_is_multipart(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::inspect_is_multipart(): g is not a blessed HV reference");
    }
;
#line 4956 "lib/Sys/Guestfs.xs"
      Perl_ck_warner (aTHX_ packWARN(WARN_DEPRECATED),
        "Sys::Guestfs::inspect_is_multipart is deprecated");
      r = guestfs_inspect_is_multipart (g, root);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
      RETVAL = newSViv (r);
#line 12403 "lib/Sys/Guestfs.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Guestfs_inspect_is_netinst); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_inspect_is_netinst)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, root");
    {
	guestfs_h *	g;
	char *	root = (char *)SvPV_nolen(ST(1))
;
#line 4970 "lib/Sys/Guestfs.xs"
      int r;
#line 12423 "lib/Sys/Guestfs.c"
	SV *	RETVAL;

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::inspect_is_netinst(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::inspect_is_netinst(): g is not a blessed HV reference");
    }
;
#line 4972 "lib/Sys/Guestfs.xs"
      Perl_ck_warner (aTHX_ packWARN(WARN_DEPRECATED),
        "Sys::Guestfs::inspect_is_netinst is deprecated");
      r = guestfs_inspect_is_netinst (g, root);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
      RETVAL = newSViv (r);
#line 12445 "lib/Sys/Guestfs.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Guestfs_inspect_list_applications); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_inspect_list_applications)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, root");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	root = (char *)SvPV_nolen(ST(1))
;
#line 4986 "lib/Sys/Guestfs.xs"
      struct guestfs_application_list *r;
      size_t i;
      HV *hv;
#line 12469 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::inspect_list_applications(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::inspect_list_applications(): g is not a blessed HV reference");
    }
;
#line 4990 "lib/Sys/Guestfs.xs"
      Perl_ck_warner (aTHX_ packWARN(WARN_DEPRECATED),
        "Sys::Guestfs::inspect_list_applications is deprecated; use Sys::Guestfs::inspect_list_applications2 instead");
      r = guestfs_inspect_list_applications (g, root);
      if (r == NULL)
        croak ("%s", guestfs_last_error (g));
      EXTEND (SP, r->len);
      for (i = 0; i < r->len; ++i) {
        hv = newHV ();
        (void) hv_store (hv, "app_name", 8, newSVpv (r->val[i].app_name, 0), 0);
        (void) hv_store (hv, "app_display_name", 16, newSVpv (r->val[i].app_display_name, 0), 0);
        (void) hv_store (hv, "app_epoch", 9, newSVnv (r->val[i].app_epoch), 0);
        (void) hv_store (hv, "app_version", 11, newSVpv (r->val[i].app_version, 0), 0);
        (void) hv_store (hv, "app_release", 11, newSVpv (r->val[i].app_release, 0), 0);
        (void) hv_store (hv, "app_install_path", 16, newSVpv (r->val[i].app_install_path, 0), 0);
        (void) hv_store (hv, "app_trans_path", 14, newSVpv (r->val[i].app_trans_path, 0), 0);
        (void) hv_store (hv, "app_publisher", 13, newSVpv (r->val[i].app_publisher, 0), 0);
        (void) hv_store (hv, "app_url", 7, newSVpv (r->val[i].app_url, 0), 0);
        (void) hv_store (hv, "app_source_package", 18, newSVpv (r->val[i].app_source_package, 0), 0);
        (void) hv_store (hv, "app_summary", 11, newSVpv (r->val[i].app_summary, 0), 0);
        (void) hv_store (hv, "app_description", 15, newSVpv (r->val[i].app_description, 0), 0);
        PUSHs (sv_2mortal (newRV ((SV *) hv)));
      }
      guestfs_free_application_list (r);
#line 12507 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_inspect_list_applications2); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_inspect_list_applications2)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, root");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	root = (char *)SvPV_nolen(ST(1))
;
#line 5019 "lib/Sys/Guestfs.xs"
      struct guestfs_application2_list *r;
      size_t i;
      HV *hv;
#line 12530 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::inspect_list_applications2(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::inspect_list_applications2(): g is not a blessed HV reference");
    }
;
#line 5023 "lib/Sys/Guestfs.xs"
      r = guestfs_inspect_list_applications2 (g, root);
      if (r == NULL)
        croak ("%s", guestfs_last_error (g));
      EXTEND (SP, r->len);
      for (i = 0; i < r->len; ++i) {
        hv = newHV ();
        (void) hv_store (hv, "app2_name", 9, newSVpv (r->val[i].app2_name, 0), 0);
        (void) hv_store (hv, "app2_display_name", 17, newSVpv (r->val[i].app2_display_name, 0), 0);
        (void) hv_store (hv, "app2_epoch", 10, newSVnv (r->val[i].app2_epoch), 0);
        (void) hv_store (hv, "app2_version", 12, newSVpv (r->val[i].app2_version, 0), 0);
        (void) hv_store (hv, "app2_release", 12, newSVpv (r->val[i].app2_release, 0), 0);
        (void) hv_store (hv, "app2_arch", 9, newSVpv (r->val[i].app2_arch, 0), 0);
        (void) hv_store (hv, "app2_install_path", 17, newSVpv (r->val[i].app2_install_path, 0), 0);
        (void) hv_store (hv, "app2_trans_path", 15, newSVpv (r->val[i].app2_trans_path, 0), 0);
        (void) hv_store (hv, "app2_publisher", 14, newSVpv (r->val[i].app2_publisher, 0), 0);
        (void) hv_store (hv, "app2_url", 8, newSVpv (r->val[i].app2_url, 0), 0);
        (void) hv_store (hv, "app2_source_package", 19, newSVpv (r->val[i].app2_source_package, 0), 0);
        (void) hv_store (hv, "app2_summary", 12, newSVpv (r->val[i].app2_summary, 0), 0);
        (void) hv_store (hv, "app2_description", 16, newSVpv (r->val[i].app2_description, 0), 0);
        (void) hv_store (hv, "app2_spare1", 11, newSVpv (r->val[i].app2_spare1, 0), 0);
        (void) hv_store (hv, "app2_spare2", 11, newSVpv (r->val[i].app2_spare2, 0), 0);
        (void) hv_store (hv, "app2_spare3", 11, newSVpv (r->val[i].app2_spare3, 0), 0);
        (void) hv_store (hv, "app2_spare4", 11, newSVpv (r->val[i].app2_spare4, 0), 0);
        PUSHs (sv_2mortal (newRV ((SV *) hv)));
      }
      guestfs_free_application2_list (r);
#line 12571 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_inspect_os); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_inspect_os)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "g");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
#line 5054 "lib/Sys/Guestfs.xs"
      char **r;
      size_t i, n;
#line 12591 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::inspect_os(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::inspect_os(): g is not a blessed HV reference");
    }
;
#line 5057 "lib/Sys/Guestfs.xs"
      r = guestfs_inspect_os (g);
      if (r == NULL)
        croak ("%s", guestfs_last_error (g));
      for (n = 0; r[n] != NULL; ++n) /**/;
      EXTEND (SP, n);
      for (i = 0; i < n; ++i) {
        PUSHs (sv_2mortal (newSVpv (r[i], 0)));
        free (r[i]);
      }
      free (r);
#line 12616 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_internal_exit); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_internal_exit)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "g");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
#line 5072 "lib/Sys/Guestfs.xs"
      int r;
#line 12635 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::internal_exit(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::internal_exit(): g is not a blessed HV reference");
    }
;
#line 5074 "lib/Sys/Guestfs.xs"
      r = guestfs_internal_exit (g);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 12653 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_internal_test); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_internal_test)
{
    dVAR; dXSARGS;
    if (items < 10)
       croak_xs_usage(cv,  "g, str, optstr, strlist, b, integer, integer64, filein, fileout, bufferin, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	str = (char *)SvPV_nolen(ST(1))
;
	char *	optstr = SvOK(ST(2)) ? SvPV_nolen(ST(2)) : NULL;
	char **	strlist = XS_unpack_charPtrPtr(ST(3))
;
	int	b = (int)SvIV(ST(4))
;
	int	integer = (int)SvIV(ST(5))
;
	int64_t    integer64 = my_SvIV64 (ST(6))
;
	char *	filein = (char *)SvPV_nolen(ST(7))
;
	char *	fileout = (char *)SvPV_nolen(ST(8))
;
	char *	bufferin = (char *)SvPV_nolen(ST(9))
;
	size_t	bufferin_size = SvCUR (ST(9));
#line 5092 "lib/Sys/Guestfs.xs"
      int r;
      struct guestfs_internal_test_argv optargs_s = { .bitmask = 0 };
      struct guestfs_internal_test_argv *optargs = &optargs_s;
      size_t items_i;
#line 12693 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::internal_test(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::internal_test(): g is not a blessed HV reference");
    }
;
#line 5097 "lib/Sys/Guestfs.xs"
      if (((items - 10) & 1) != 0)
        croak ("expecting an even number of extra parameters");
      for (items_i = 10; items_i < items; items_i += 2) {
        uint64_t this_mask;
        const char *this_arg;

        this_arg = SvPV_nolen (ST (items_i));
        if (STREQ (this_arg, "obool")) {
          optargs_s.obool = SvIV (ST (items_i+1));
          this_mask = GUESTFS_INTERNAL_TEST_OBOOL_BITMASK;
        }
        else if (STREQ (this_arg, "oint")) {
          optargs_s.oint = SvIV (ST (items_i+1));
          this_mask = GUESTFS_INTERNAL_TEST_OINT_BITMASK;
        }
        else if (STREQ (this_arg, "oint64")) {
          optargs_s.oint64 = my_SvIV64 (ST (items_i+1));
          this_mask = GUESTFS_INTERNAL_TEST_OINT64_BITMASK;
        }
        else if (STREQ (this_arg, "ostring")) {
          optargs_s.ostring = SvPV_nolen (ST (items_i+1));
          this_mask = GUESTFS_INTERNAL_TEST_OSTRING_BITMASK;
        }
        else if (STREQ (this_arg, "ostringlist")) {
          size_t i, len;
          char **r;
          SV *arg;
          AV *av;
          SV **svp;

          arg = ST (items_i+1);
          if (!SvROK (arg) || SvTYPE (SvRV (arg)) != SVt_PVAV)
            croak ("array reference expected for '%s' argument", "ostringlist");
          av = (AV *) SvRV (ST (items_i+1));

          /* Note av_len returns index of final element. */
          len = av_len (av) + 1;

          r = malloc ((len+1) * sizeof (char *));
          if (r == NULL) croak ("malloc: %m");
          for (i = 0; i < len; ++i) {
            svp = av_fetch (av, i, 0);
            r[i] = SvPV_nolen (*svp);
          }
          r[i] = NULL;
          optargs_s.ostringlist = r;
          this_mask = GUESTFS_INTERNAL_TEST_OSTRINGLIST_BITMASK;
        }
        else croak ("unknown optional argument '%s'", this_arg);
        if (optargs_s.bitmask & this_mask)
          croak ("optional argument '%s' given more than once",
                 this_arg);
        optargs_s.bitmask |= this_mask;
      }

      r = guestfs_internal_test_argv (g, str, optstr, strlist, b, integer, integer64, filein, fileout, bufferin, bufferin_size, optargs);
      free (strlist);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 12767 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_internal_test_63_optargs); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_internal_test_63_optargs)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "g, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
#line 5161 "lib/Sys/Guestfs.xs"
      int r;
      struct guestfs_internal_test_63_optargs_argv optargs_s = { .bitmask = 0 };
      struct guestfs_internal_test_63_optargs_argv *optargs = &optargs_s;
      size_t items_i;
#line 12789 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::internal_test_63_optargs(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::internal_test_63_optargs(): g is not a blessed HV reference");
    }
;
#line 5166 "lib/Sys/Guestfs.xs"
      if (((items - 1) & 1) != 0)
        croak ("expecting an even number of extra parameters");
      for (items_i = 1; items_i < items; items_i += 2) {
        uint64_t this_mask;
        const char *this_arg;

        this_arg = SvPV_nolen (ST (items_i));
        if (STREQ (this_arg, "opt1")) {
          optargs_s.opt1 = SvIV (ST (items_i+1));
          this_mask = GUESTFS_INTERNAL_TEST_63_OPTARGS_OPT1_BITMASK;
        }
        else if (STREQ (this_arg, "opt2")) {
          optargs_s.opt2 = SvIV (ST (items_i+1));
          this_mask = GUESTFS_INTERNAL_TEST_63_OPTARGS_OPT2_BITMASK;
        }
        else if (STREQ (this_arg, "opt3")) {
          optargs_s.opt3 = SvIV (ST (items_i+1));
          this_mask = GUESTFS_INTERNAL_TEST_63_OPTARGS_OPT3_BITMASK;
        }
        else if (STREQ (this_arg, "opt4")) {
          optargs_s.opt4 = SvIV (ST (items_i+1));
          this_mask = GUESTFS_INTERNAL_TEST_63_OPTARGS_OPT4_BITMASK;
        }
        else if (STREQ (this_arg, "opt5")) {
          optargs_s.opt5 = SvIV (ST (items_i+1));
          this_mask = GUESTFS_INTERNAL_TEST_63_OPTARGS_OPT5_BITMASK;
        }
        else if (STREQ (this_arg, "opt6")) {
          optargs_s.opt6 = SvIV (ST (items_i+1));
          this_mask = GUESTFS_INTERNAL_TEST_63_OPTARGS_OPT6_BITMASK;
        }
        else if (STREQ (this_arg, "opt7")) {
          optargs_s.opt7 = SvIV (ST (items_i+1));
          this_mask = GUESTFS_INTERNAL_TEST_63_OPTARGS_OPT7_BITMASK;
        }
        else if (STREQ (this_arg, "opt8")) {
          optargs_s.opt8 = SvIV (ST (items_i+1));
          this_mask = GUESTFS_INTERNAL_TEST_63_OPTARGS_OPT8_BITMASK;
        }
        else if (STREQ (this_arg, "opt9")) {
          optargs_s.opt9 = SvIV (ST (items_i+1));
          this_mask = GUESTFS_INTERNAL_TEST_63_OPTARGS_OPT9_BITMASK;
        }
        else if (STREQ (this_arg, "opt10")) {
          optargs_s.opt10 = SvIV (ST (items_i+1));
          this_mask = GUESTFS_INTERNAL_TEST_63_OPTARGS_OPT10_BITMASK;
        }
        else if (STREQ (this_arg, "opt11")) {
          optargs_s.opt11 = SvIV (ST (items_i+1));
          this_mask = GUESTFS_INTERNAL_TEST_63_OPTARGS_OPT11_BITMASK;
        }
        else if (STREQ (this_arg, "opt12")) {
          optargs_s.opt12 = SvIV (ST (items_i+1));
          this_mask = GUESTFS_INTERNAL_TEST_63_OPTARGS_OPT12_BITMASK;
        }
        else if (STREQ (this_arg, "opt13")) {
          optargs_s.opt13 = SvIV (ST (items_i+1));
          this_mask = GUESTFS_INTERNAL_TEST_63_OPTARGS_OPT13_BITMASK;
        }
        else if (STREQ (this_arg, "opt14")) {
          optargs_s.opt14 = SvIV (ST (items_i+1));
          this_mask = GUESTFS_INTERNAL_TEST_63_OPTARGS_OPT14_BITMASK;
        }
        else if (STREQ (this_arg, "opt15")) {
          optargs_s.opt15 = SvIV (ST (items_i+1));
          this_mask = GUESTFS_INTERNAL_TEST_63_OPTARGS_OPT15_BITMASK;
        }
        else if (STREQ (this_arg, "opt16")) {
          optargs_s.opt16 = SvIV (ST (items_i+1));
          this_mask = GUESTFS_INTERNAL_TEST_63_OPTARGS_OPT16_BITMASK;
        }
        else if (STREQ (this_arg, "opt17")) {
          optargs_s.opt17 = SvIV (ST (items_i+1));
          this_mask = GUESTFS_INTERNAL_TEST_63_OPTARGS_OPT17_BITMASK;
        }
        else if (STREQ (this_arg, "opt18")) {
          optargs_s.opt18 = SvIV (ST (items_i+1));
          this_mask = GUESTFS_INTERNAL_TEST_63_OPTARGS_OPT18_BITMASK;
        }
        else if (STREQ (this_arg, "opt19")) {
          optargs_s.opt19 = SvIV (ST (items_i+1));
          this_mask = GUESTFS_INTERNAL_TEST_63_OPTARGS_OPT19_BITMASK;
        }
        else if (STREQ (this_arg, "opt20")) {
          optargs_s.opt20 = SvIV (ST (items_i+1));
          this_mask = GUESTFS_INTERNAL_TEST_63_OPTARGS_OPT20_BITMASK;
        }
        else if (STREQ (this_arg, "opt21")) {
          optargs_s.opt21 = SvIV (ST (items_i+1));
          this_mask = GUESTFS_INTERNAL_TEST_63_OPTARGS_OPT21_BITMASK;
        }
        else if (STREQ (this_arg, "opt22")) {
          optargs_s.opt22 = SvIV (ST (items_i+1));
          this_mask = GUESTFS_INTERNAL_TEST_63_OPTARGS_OPT22_BITMASK;
        }
        else if (STREQ (this_arg, "opt23")) {
          optargs_s.opt23 = SvIV (ST (items_i+1));
          this_mask = GUESTFS_INTERNAL_TEST_63_OPTARGS_OPT23_BITMASK;
        }
        else if (STREQ (this_arg, "opt24")) {
          optargs_s.opt24 = SvIV (ST (items_i+1));
          this_mask = GUESTFS_INTERNAL_TEST_63_OPTARGS_OPT24_BITMASK;
        }
        else if (STREQ (this_arg, "opt25")) {
          optargs_s.opt25 = SvIV (ST (items_i+1));
          this_mask = GUESTFS_INTERNAL_TEST_63_OPTARGS_OPT25_BITMASK;
        }
        else if (STREQ (this_arg, "opt26")) {
          optargs_s.opt26 = SvIV (ST (items_i+1));
          this_mask = GUESTFS_INTERNAL_TEST_63_OPTARGS_OPT26_BITMASK;
        }
        else if (STREQ (this_arg, "opt27")) {
          optargs_s.opt27 = SvIV (ST (items_i+1));
          this_mask = GUESTFS_INTERNAL_TEST_63_OPTARGS_OPT27_BITMASK;
        }
        else if (STREQ (this_arg, "opt28")) {
          optargs_s.opt28 = SvIV (ST (items_i+1));
          this_mask = GUESTFS_INTERNAL_TEST_63_OPTARGS_OPT28_BITMASK;
        }
        else if (STREQ (this_arg, "opt29")) {
          optargs_s.opt29 = SvIV (ST (items_i+1));
          this_mask = GUESTFS_INTERNAL_TEST_63_OPTARGS_OPT29_BITMASK;
        }
        else if (STREQ (this_arg, "opt30")) {
          optargs_s.opt30 = SvIV (ST (items_i+1));
          this_mask = GUESTFS_INTERNAL_TEST_63_OPTARGS_OPT30_BITMASK;
        }
        else if (STREQ (this_arg, "opt31")) {
          optargs_s.opt31 = SvIV (ST (items_i+1));
          this_mask = GUESTFS_INTERNAL_TEST_63_OPTARGS_OPT31_BITMASK;
        }
        else if (STREQ (this_arg, "opt32")) {
          optargs_s.opt32 = SvIV (ST (items_i+1));
          this_mask = GUESTFS_INTERNAL_TEST_63_OPTARGS_OPT32_BITMASK;
        }
        else if (STREQ (this_arg, "opt33")) {
          optargs_s.opt33 = SvIV (ST (items_i+1));
          this_mask = GUESTFS_INTERNAL_TEST_63_OPTARGS_OPT33_BITMASK;
        }
        else if (STREQ (this_arg, "opt34")) {
          optargs_s.opt34 = SvIV (ST (items_i+1));
          this_mask = GUESTFS_INTERNAL_TEST_63_OPTARGS_OPT34_BITMASK;
        }
        else if (STREQ (this_arg, "opt35")) {
          optargs_s.opt35 = SvIV (ST (items_i+1));
          this_mask = GUESTFS_INTERNAL_TEST_63_OPTARGS_OPT35_BITMASK;
        }
        else if (STREQ (this_arg, "opt36")) {
          optargs_s.opt36 = SvIV (ST (items_i+1));
          this_mask = GUESTFS_INTERNAL_TEST_63_OPTARGS_OPT36_BITMASK;
        }
        else if (STREQ (this_arg, "opt37")) {
          optargs_s.opt37 = SvIV (ST (items_i+1));
          this_mask = GUESTFS_INTERNAL_TEST_63_OPTARGS_OPT37_BITMASK;
        }
        else if (STREQ (this_arg, "opt38")) {
          optargs_s.opt38 = SvIV (ST (items_i+1));
          this_mask = GUESTFS_INTERNAL_TEST_63_OPTARGS_OPT38_BITMASK;
        }
        else if (STREQ (this_arg, "opt39")) {
          optargs_s.opt39 = SvIV (ST (items_i+1));
          this_mask = GUESTFS_INTERNAL_TEST_63_OPTARGS_OPT39_BITMASK;
        }
        else if (STREQ (this_arg, "opt40")) {
          optargs_s.opt40 = SvIV (ST (items_i+1));
          this_mask = GUESTFS_INTERNAL_TEST_63_OPTARGS_OPT40_BITMASK;
        }
        else if (STREQ (this_arg, "opt41")) {
          optargs_s.opt41 = SvIV (ST (items_i+1));
          this_mask = GUESTFS_INTERNAL_TEST_63_OPTARGS_OPT41_BITMASK;
        }
        else if (STREQ (this_arg, "opt42")) {
          optargs_s.opt42 = SvIV (ST (items_i+1));
          this_mask = GUESTFS_INTERNAL_TEST_63_OPTARGS_OPT42_BITMASK;
        }
        else if (STREQ (this_arg, "opt43")) {
          optargs_s.opt43 = SvIV (ST (items_i+1));
          this_mask = GUESTFS_INTERNAL_TEST_63_OPTARGS_OPT43_BITMASK;
        }
        else if (STREQ (this_arg, "opt44")) {
          optargs_s.opt44 = SvIV (ST (items_i+1));
          this_mask = GUESTFS_INTERNAL_TEST_63_OPTARGS_OPT44_BITMASK;
        }
        else if (STREQ (this_arg, "opt45")) {
          optargs_s.opt45 = SvIV (ST (items_i+1));
          this_mask = GUESTFS_INTERNAL_TEST_63_OPTARGS_OPT45_BITMASK;
        }
        else if (STREQ (this_arg, "opt46")) {
          optargs_s.opt46 = SvIV (ST (items_i+1));
          this_mask = GUESTFS_INTERNAL_TEST_63_OPTARGS_OPT46_BITMASK;
        }
        else if (STREQ (this_arg, "opt47")) {
          optargs_s.opt47 = SvIV (ST (items_i+1));
          this_mask = GUESTFS_INTERNAL_TEST_63_OPTARGS_OPT47_BITMASK;
        }
        else if (STREQ (this_arg, "opt48")) {
          optargs_s.opt48 = SvIV (ST (items_i+1));
          this_mask = GUESTFS_INTERNAL_TEST_63_OPTARGS_OPT48_BITMASK;
        }
        else if (STREQ (this_arg, "opt49")) {
          optargs_s.opt49 = SvIV (ST (items_i+1));
          this_mask = GUESTFS_INTERNAL_TEST_63_OPTARGS_OPT49_BITMASK;
        }
        else if (STREQ (this_arg, "opt50")) {
          optargs_s.opt50 = SvIV (ST (items_i+1));
          this_mask = GUESTFS_INTERNAL_TEST_63_OPTARGS_OPT50_BITMASK;
        }
        else if (STREQ (this_arg, "opt51")) {
          optargs_s.opt51 = SvIV (ST (items_i+1));
          this_mask = GUESTFS_INTERNAL_TEST_63_OPTARGS_OPT51_BITMASK;
        }
        else if (STREQ (this_arg, "opt52")) {
          optargs_s.opt52 = SvIV (ST (items_i+1));
          this_mask = GUESTFS_INTERNAL_TEST_63_OPTARGS_OPT52_BITMASK;
        }
        else if (STREQ (this_arg, "opt53")) {
          optargs_s.opt53 = SvIV (ST (items_i+1));
          this_mask = GUESTFS_INTERNAL_TEST_63_OPTARGS_OPT53_BITMASK;
        }
        else if (STREQ (this_arg, "opt54")) {
          optargs_s.opt54 = SvIV (ST (items_i+1));
          this_mask = GUESTFS_INTERNAL_TEST_63_OPTARGS_OPT54_BITMASK;
        }
        else if (STREQ (this_arg, "opt55")) {
          optargs_s.opt55 = SvIV (ST (items_i+1));
          this_mask = GUESTFS_INTERNAL_TEST_63_OPTARGS_OPT55_BITMASK;
        }
        else if (STREQ (this_arg, "opt56")) {
          optargs_s.opt56 = SvIV (ST (items_i+1));
          this_mask = GUESTFS_INTERNAL_TEST_63_OPTARGS_OPT56_BITMASK;
        }
        else if (STREQ (this_arg, "opt57")) {
          optargs_s.opt57 = SvIV (ST (items_i+1));
          this_mask = GUESTFS_INTERNAL_TEST_63_OPTARGS_OPT57_BITMASK;
        }
        else if (STREQ (this_arg, "opt58")) {
          optargs_s.opt58 = SvIV (ST (items_i+1));
          this_mask = GUESTFS_INTERNAL_TEST_63_OPTARGS_OPT58_BITMASK;
        }
        else if (STREQ (this_arg, "opt59")) {
          optargs_s.opt59 = SvIV (ST (items_i+1));
          this_mask = GUESTFS_INTERNAL_TEST_63_OPTARGS_OPT59_BITMASK;
        }
        else if (STREQ (this_arg, "opt60")) {
          optargs_s.opt60 = SvIV (ST (items_i+1));
          this_mask = GUESTFS_INTERNAL_TEST_63_OPTARGS_OPT60_BITMASK;
        }
        else if (STREQ (this_arg, "opt61")) {
          optargs_s.opt61 = SvIV (ST (items_i+1));
          this_mask = GUESTFS_INTERNAL_TEST_63_OPTARGS_OPT61_BITMASK;
        }
        else if (STREQ (this_arg, "opt62")) {
          optargs_s.opt62 = SvIV (ST (items_i+1));
          this_mask = GUESTFS_INTERNAL_TEST_63_OPTARGS_OPT62_BITMASK;
        }
        else if (STREQ (this_arg, "opt63")) {
          optargs_s.opt63 = SvIV (ST (items_i+1));
          this_mask = GUESTFS_INTERNAL_TEST_63_OPTARGS_OPT63_BITMASK;
        }
        else croak ("unknown optional argument '%s'", this_arg);
        if (optargs_s.bitmask & this_mask)
          croak ("optional argument '%s' given more than once",
                 this_arg);
        optargs_s.bitmask |= this_mask;
      }

      r = guestfs_internal_test_63_optargs_argv (g, optargs);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 13073 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_internal_test_close_output); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_internal_test_close_output)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "g");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
#line 5440 "lib/Sys/Guestfs.xs"
      int r;
#line 13092 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::internal_test_close_output(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::internal_test_close_output(): g is not a blessed HV reference");
    }
;
#line 5442 "lib/Sys/Guestfs.xs"
      r = guestfs_internal_test_close_output (g);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 13110 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_internal_test_only_optargs); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_internal_test_only_optargs)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "g, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
#line 5450 "lib/Sys/Guestfs.xs"
      int r;
      struct guestfs_internal_test_only_optargs_argv optargs_s = { .bitmask = 0 };
      struct guestfs_internal_test_only_optargs_argv *optargs = &optargs_s;
      size_t items_i;
#line 13132 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::internal_test_only_optargs(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::internal_test_only_optargs(): g is not a blessed HV reference");
    }
;
#line 5455 "lib/Sys/Guestfs.xs"
      if (((items - 1) & 1) != 0)
        croak ("expecting an even number of extra parameters");
      for (items_i = 1; items_i < items; items_i += 2) {
        uint64_t this_mask;
        const char *this_arg;

        this_arg = SvPV_nolen (ST (items_i));
        if (STREQ (this_arg, "test")) {
          optargs_s.test = SvIV (ST (items_i+1));
          this_mask = GUESTFS_INTERNAL_TEST_ONLY_OPTARGS_TEST_BITMASK;
        }
        else croak ("unknown optional argument '%s'", this_arg);
        if (optargs_s.bitmask & this_mask)
          croak ("optional argument '%s' given more than once",
                 this_arg);
        optargs_s.bitmask |= this_mask;
      }

      r = guestfs_internal_test_only_optargs_argv (g, optargs);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 13168 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_internal_test_rbool); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_internal_test_rbool)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, val");
    {
	guestfs_h *	g;
	char *	val = (char *)SvPV_nolen(ST(1))
;
#line 5482 "lib/Sys/Guestfs.xs"
      int r;
#line 13187 "lib/Sys/Guestfs.c"
	SV *	RETVAL;

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::internal_test_rbool(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::internal_test_rbool(): g is not a blessed HV reference");
    }
;
#line 5484 "lib/Sys/Guestfs.xs"
      r = guestfs_internal_test_rbool (g, val);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
      RETVAL = newSViv (r);
#line 13207 "lib/Sys/Guestfs.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Guestfs_internal_test_rboolerr); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_internal_test_rboolerr)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "g");
    {
	guestfs_h *	g;
#line 5495 "lib/Sys/Guestfs.xs"
      int r;
#line 13225 "lib/Sys/Guestfs.c"
	SV *	RETVAL;

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::internal_test_rboolerr(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::internal_test_rboolerr(): g is not a blessed HV reference");
    }
;
#line 5497 "lib/Sys/Guestfs.xs"
      r = guestfs_internal_test_rboolerr (g);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
      RETVAL = newSViv (r);
#line 13245 "lib/Sys/Guestfs.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Guestfs_internal_test_rbufferout); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_internal_test_rbufferout)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, val");
    {
	guestfs_h *	g;
	char *	val = (char *)SvPV_nolen(ST(1))
;
#line 5509 "lib/Sys/Guestfs.xs"
      char *r;
      size_t size;
#line 13266 "lib/Sys/Guestfs.c"
	SV *	RETVAL;

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::internal_test_rbufferout(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::internal_test_rbufferout(): g is not a blessed HV reference");
    }
;
#line 5512 "lib/Sys/Guestfs.xs"
      r = guestfs_internal_test_rbufferout (g, val, &size);
      if (r == NULL)
        croak ("%s", guestfs_last_error (g));
      RETVAL = newSVpvn (r, size);
      free (r);
#line 13287 "lib/Sys/Guestfs.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Guestfs_internal_test_rbufferouterr); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_internal_test_rbufferouterr)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "g");
    {
	guestfs_h *	g;
#line 5524 "lib/Sys/Guestfs.xs"
      char *r;
      size_t size;
#line 13306 "lib/Sys/Guestfs.c"
	SV *	RETVAL;

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::internal_test_rbufferouterr(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::internal_test_rbufferouterr(): g is not a blessed HV reference");
    }
;
#line 5527 "lib/Sys/Guestfs.xs"
      r = guestfs_internal_test_rbufferouterr (g, &size);
      if (r == NULL)
        croak ("%s", guestfs_last_error (g));
      RETVAL = newSVpvn (r, size);
      free (r);
#line 13327 "lib/Sys/Guestfs.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Guestfs_internal_test_rconstoptstring); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_internal_test_rconstoptstring)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, val");
    {
	guestfs_h *	g;
	char *	val = (char *)SvPV_nolen(ST(1))
;
#line 5540 "lib/Sys/Guestfs.xs"
      const char *r;
#line 13347 "lib/Sys/Guestfs.c"
	SV *	RETVAL;

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::internal_test_rconstoptstring(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::internal_test_rconstoptstring(): g is not a blessed HV reference");
    }
;
#line 5542 "lib/Sys/Guestfs.xs"
      r = guestfs_internal_test_rconstoptstring (g, val);
      if (r == NULL)
        RETVAL = &PL_sv_undef;
      else
        RETVAL = newSVpv (r, 0);
#line 13368 "lib/Sys/Guestfs.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Guestfs_internal_test_rconstoptstringerr); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_internal_test_rconstoptstringerr)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "g");
    {
	guestfs_h *	g;
#line 5554 "lib/Sys/Guestfs.xs"
      const char *r;
#line 13386 "lib/Sys/Guestfs.c"
	SV *	RETVAL;

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::internal_test_rconstoptstringerr(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::internal_test_rconstoptstringerr(): g is not a blessed HV reference");
    }
;
#line 5556 "lib/Sys/Guestfs.xs"
      r = guestfs_internal_test_rconstoptstringerr (g);
      if (r == NULL)
        RETVAL = &PL_sv_undef;
      else
        RETVAL = newSVpv (r, 0);
#line 13407 "lib/Sys/Guestfs.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Guestfs_internal_test_rconststring); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_internal_test_rconststring)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, val");
    {
	guestfs_h *	g;
	char *	val = (char *)SvPV_nolen(ST(1))
;
#line 5569 "lib/Sys/Guestfs.xs"
      const char *r;
#line 13427 "lib/Sys/Guestfs.c"
	SV *	RETVAL;

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::internal_test_rconststring(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::internal_test_rconststring(): g is not a blessed HV reference");
    }
;
#line 5571 "lib/Sys/Guestfs.xs"
      r = guestfs_internal_test_rconststring (g, val);
      if (r == NULL)
        croak ("%s", guestfs_last_error (g));
      RETVAL = newSVpv (r, 0);
#line 13447 "lib/Sys/Guestfs.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Guestfs_internal_test_rconststringerr); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_internal_test_rconststringerr)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "g");
    {
	guestfs_h *	g;
#line 5582 "lib/Sys/Guestfs.xs"
      const char *r;
#line 13465 "lib/Sys/Guestfs.c"
	SV *	RETVAL;

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::internal_test_rconststringerr(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::internal_test_rconststringerr(): g is not a blessed HV reference");
    }
;
#line 5584 "lib/Sys/Guestfs.xs"
      r = guestfs_internal_test_rconststringerr (g);
      if (r == NULL)
        croak ("%s", guestfs_last_error (g));
      RETVAL = newSVpv (r, 0);
#line 13485 "lib/Sys/Guestfs.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Guestfs_internal_test_rhashtable); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_internal_test_rhashtable)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, val");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	val = (char *)SvPV_nolen(ST(1))
;
#line 5596 "lib/Sys/Guestfs.xs"
      char **r;
      size_t i, n;
#line 13508 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::internal_test_rhashtable(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::internal_test_rhashtable(): g is not a blessed HV reference");
    }
;
#line 5599 "lib/Sys/Guestfs.xs"
      r = guestfs_internal_test_rhashtable (g, val);
      if (r == NULL)
        croak ("%s", guestfs_last_error (g));
      for (n = 0; r[n] != NULL; ++n) /**/;
      EXTEND (SP, n);
      for (i = 0; i < n; ++i) {
        PUSHs (sv_2mortal (newSVpv (r[i], 0)));
        free (r[i]);
      }
      free (r);
#line 13533 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_internal_test_rhashtableerr); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_internal_test_rhashtableerr)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "g");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
#line 5614 "lib/Sys/Guestfs.xs"
      char **r;
      size_t i, n;
#line 13553 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::internal_test_rhashtableerr(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::internal_test_rhashtableerr(): g is not a blessed HV reference");
    }
;
#line 5617 "lib/Sys/Guestfs.xs"
      r = guestfs_internal_test_rhashtableerr (g);
      if (r == NULL)
        croak ("%s", guestfs_last_error (g));
      for (n = 0; r[n] != NULL; ++n) /**/;
      EXTEND (SP, n);
      for (i = 0; i < n; ++i) {
        PUSHs (sv_2mortal (newSVpv (r[i], 0)));
        free (r[i]);
      }
      free (r);
#line 13578 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_internal_test_rint); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_internal_test_rint)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, val");
    {
	guestfs_h *	g;
	char *	val = (char *)SvPV_nolen(ST(1))
;
#line 5633 "lib/Sys/Guestfs.xs"
      int r;
#line 13597 "lib/Sys/Guestfs.c"
	SV *	RETVAL;

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::internal_test_rint(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::internal_test_rint(): g is not a blessed HV reference");
    }
;
#line 5635 "lib/Sys/Guestfs.xs"
      r = guestfs_internal_test_rint (g, val);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
      RETVAL = newSViv (r);
#line 13617 "lib/Sys/Guestfs.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Guestfs_internal_test_rint64); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_internal_test_rint64)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, val");
    {
	guestfs_h *	g;
	char *	val = (char *)SvPV_nolen(ST(1))
;
#line 5647 "lib/Sys/Guestfs.xs"
      int64_t r;
#line 13637 "lib/Sys/Guestfs.c"
	SV *	RETVAL;

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::internal_test_rint64(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::internal_test_rint64(): g is not a blessed HV reference");
    }
;
#line 5649 "lib/Sys/Guestfs.xs"
      r = guestfs_internal_test_rint64 (g, val);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
      RETVAL = my_newSVll (r);
#line 13657 "lib/Sys/Guestfs.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Guestfs_internal_test_rint64err); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_internal_test_rint64err)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "g");
    {
	guestfs_h *	g;
#line 5660 "lib/Sys/Guestfs.xs"
      int64_t r;
#line 13675 "lib/Sys/Guestfs.c"
	SV *	RETVAL;

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::internal_test_rint64err(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::internal_test_rint64err(): g is not a blessed HV reference");
    }
;
#line 5662 "lib/Sys/Guestfs.xs"
      r = guestfs_internal_test_rint64err (g);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
      RETVAL = my_newSVll (r);
#line 13695 "lib/Sys/Guestfs.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Guestfs_internal_test_rinterr); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_internal_test_rinterr)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "g");
    {
	guestfs_h *	g;
#line 5673 "lib/Sys/Guestfs.xs"
      int r;
#line 13713 "lib/Sys/Guestfs.c"
	SV *	RETVAL;

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::internal_test_rinterr(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::internal_test_rinterr(): g is not a blessed HV reference");
    }
;
#line 5675 "lib/Sys/Guestfs.xs"
      r = guestfs_internal_test_rinterr (g);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
      RETVAL = newSViv (r);
#line 13733 "lib/Sys/Guestfs.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Guestfs_internal_test_rstring); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_internal_test_rstring)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, val");
    {
	guestfs_h *	g;
	char *	val = (char *)SvPV_nolen(ST(1))
;
#line 5687 "lib/Sys/Guestfs.xs"
      char *r;
#line 13753 "lib/Sys/Guestfs.c"
	SV *	RETVAL;

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::internal_test_rstring(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::internal_test_rstring(): g is not a blessed HV reference");
    }
;
#line 5689 "lib/Sys/Guestfs.xs"
      r = guestfs_internal_test_rstring (g, val);
      if (r == NULL)
        croak ("%s", guestfs_last_error (g));
      RETVAL = newSVpv (r, 0);
      free (r);
#line 13774 "lib/Sys/Guestfs.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Guestfs_internal_test_rstringerr); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_internal_test_rstringerr)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "g");
    {
	guestfs_h *	g;
#line 5701 "lib/Sys/Guestfs.xs"
      char *r;
#line 13792 "lib/Sys/Guestfs.c"
	SV *	RETVAL;

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::internal_test_rstringerr(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::internal_test_rstringerr(): g is not a blessed HV reference");
    }
;
#line 5703 "lib/Sys/Guestfs.xs"
      r = guestfs_internal_test_rstringerr (g);
      if (r == NULL)
        croak ("%s", guestfs_last_error (g));
      RETVAL = newSVpv (r, 0);
      free (r);
#line 13813 "lib/Sys/Guestfs.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Guestfs_internal_test_rstringlist); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_internal_test_rstringlist)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, val");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	val = (char *)SvPV_nolen(ST(1))
;
#line 5716 "lib/Sys/Guestfs.xs"
      char **r;
      size_t i, n;
#line 13836 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::internal_test_rstringlist(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::internal_test_rstringlist(): g is not a blessed HV reference");
    }
;
#line 5719 "lib/Sys/Guestfs.xs"
      r = guestfs_internal_test_rstringlist (g, val);
      if (r == NULL)
        croak ("%s", guestfs_last_error (g));
      for (n = 0; r[n] != NULL; ++n) /**/;
      EXTEND (SP, n);
      for (i = 0; i < n; ++i) {
        PUSHs (sv_2mortal (newSVpv (r[i], 0)));
        free (r[i]);
      }
      free (r);
#line 13861 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_internal_test_rstringlisterr); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_internal_test_rstringlisterr)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "g");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
#line 5734 "lib/Sys/Guestfs.xs"
      char **r;
      size_t i, n;
#line 13881 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::internal_test_rstringlisterr(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::internal_test_rstringlisterr(): g is not a blessed HV reference");
    }
;
#line 5737 "lib/Sys/Guestfs.xs"
      r = guestfs_internal_test_rstringlisterr (g);
      if (r == NULL)
        croak ("%s", guestfs_last_error (g));
      for (n = 0; r[n] != NULL; ++n) /**/;
      EXTEND (SP, n);
      for (i = 0; i < n; ++i) {
        PUSHs (sv_2mortal (newSVpv (r[i], 0)));
        free (r[i]);
      }
      free (r);
#line 13906 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_internal_test_rstruct); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_internal_test_rstruct)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, val");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	val = (char *)SvPV_nolen(ST(1))
;
#line 5753 "lib/Sys/Guestfs.xs"
      struct guestfs_lvm_pv *r;
#line 13927 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::internal_test_rstruct(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::internal_test_rstruct(): g is not a blessed HV reference");
    }
;
#line 5755 "lib/Sys/Guestfs.xs"
      r = guestfs_internal_test_rstruct (g, val);
      if (r == NULL)
        croak ("%s", guestfs_last_error (g));
      EXTEND (SP, 2 * 14);
      PUSHs (sv_2mortal (newSVpv ("pv_name", 0)));
      PUSHs (sv_2mortal (newSVpv (r->pv_name, 0)));
      PUSHs (sv_2mortal (newSVpv ("pv_uuid", 0)));
      PUSHs (sv_2mortal (newSVpv (r->pv_uuid, 32)));
      PUSHs (sv_2mortal (newSVpv ("pv_fmt", 0)));
      PUSHs (sv_2mortal (newSVpv (r->pv_fmt, 0)));
      PUSHs (sv_2mortal (newSVpv ("pv_size", 0)));
      PUSHs (sv_2mortal (my_newSVull (r->pv_size)));
      PUSHs (sv_2mortal (newSVpv ("dev_size", 0)));
      PUSHs (sv_2mortal (my_newSVull (r->dev_size)));
      PUSHs (sv_2mortal (newSVpv ("pv_free", 0)));
      PUSHs (sv_2mortal (my_newSVull (r->pv_free)));
      PUSHs (sv_2mortal (newSVpv ("pv_used", 0)));
      PUSHs (sv_2mortal (my_newSVull (r->pv_used)));
      PUSHs (sv_2mortal (newSVpv ("pv_attr", 0)));
      PUSHs (sv_2mortal (newSVpv (r->pv_attr, 0)));
      PUSHs (sv_2mortal (newSVpv ("pv_pe_count", 0)));
      PUSHs (sv_2mortal (my_newSVll (r->pv_pe_count)));
      PUSHs (sv_2mortal (newSVpv ("pv_pe_alloc_count", 0)));
      PUSHs (sv_2mortal (my_newSVll (r->pv_pe_alloc_count)));
      PUSHs (sv_2mortal (newSVpv ("pv_tags", 0)));
      PUSHs (sv_2mortal (newSVpv (r->pv_tags, 0)));
      PUSHs (sv_2mortal (newSVpv ("pe_start", 0)));
      PUSHs (sv_2mortal (my_newSVull (r->pe_start)));
      PUSHs (sv_2mortal (newSVpv ("pv_mda_count", 0)));
      PUSHs (sv_2mortal (my_newSVll (r->pv_mda_count)));
      PUSHs (sv_2mortal (newSVpv ("pv_mda_free", 0)));
      PUSHs (sv_2mortal (my_newSVull (r->pv_mda_free)));
      guestfs_free_lvm_pv (r);
#line 13975 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_internal_test_rstructerr); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_internal_test_rstructerr)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "g");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
#line 5793 "lib/Sys/Guestfs.xs"
      struct guestfs_lvm_pv *r;
#line 13994 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::internal_test_rstructerr(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::internal_test_rstructerr(): g is not a blessed HV reference");
    }
;
#line 5795 "lib/Sys/Guestfs.xs"
      r = guestfs_internal_test_rstructerr (g);
      if (r == NULL)
        croak ("%s", guestfs_last_error (g));
      EXTEND (SP, 2 * 14);
      PUSHs (sv_2mortal (newSVpv ("pv_name", 0)));
      PUSHs (sv_2mortal (newSVpv (r->pv_name, 0)));
      PUSHs (sv_2mortal (newSVpv ("pv_uuid", 0)));
      PUSHs (sv_2mortal (newSVpv (r->pv_uuid, 32)));
      PUSHs (sv_2mortal (newSVpv ("pv_fmt", 0)));
      PUSHs (sv_2mortal (newSVpv (r->pv_fmt, 0)));
      PUSHs (sv_2mortal (newSVpv ("pv_size", 0)));
      PUSHs (sv_2mortal (my_newSVull (r->pv_size)));
      PUSHs (sv_2mortal (newSVpv ("dev_size", 0)));
      PUSHs (sv_2mortal (my_newSVull (r->dev_size)));
      PUSHs (sv_2mortal (newSVpv ("pv_free", 0)));
      PUSHs (sv_2mortal (my_newSVull (r->pv_free)));
      PUSHs (sv_2mortal (newSVpv ("pv_used", 0)));
      PUSHs (sv_2mortal (my_newSVull (r->pv_used)));
      PUSHs (sv_2mortal (newSVpv ("pv_attr", 0)));
      PUSHs (sv_2mortal (newSVpv (r->pv_attr, 0)));
      PUSHs (sv_2mortal (newSVpv ("pv_pe_count", 0)));
      PUSHs (sv_2mortal (my_newSVll (r->pv_pe_count)));
      PUSHs (sv_2mortal (newSVpv ("pv_pe_alloc_count", 0)));
      PUSHs (sv_2mortal (my_newSVll (r->pv_pe_alloc_count)));
      PUSHs (sv_2mortal (newSVpv ("pv_tags", 0)));
      PUSHs (sv_2mortal (newSVpv (r->pv_tags, 0)));
      PUSHs (sv_2mortal (newSVpv ("pe_start", 0)));
      PUSHs (sv_2mortal (my_newSVull (r->pe_start)));
      PUSHs (sv_2mortal (newSVpv ("pv_mda_count", 0)));
      PUSHs (sv_2mortal (my_newSVll (r->pv_mda_count)));
      PUSHs (sv_2mortal (newSVpv ("pv_mda_free", 0)));
      PUSHs (sv_2mortal (my_newSVull (r->pv_mda_free)));
      guestfs_free_lvm_pv (r);
#line 14042 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_internal_test_rstructlist); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_internal_test_rstructlist)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, val");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	val = (char *)SvPV_nolen(ST(1))
;
#line 5834 "lib/Sys/Guestfs.xs"
      struct guestfs_lvm_pv_list *r;
      size_t i;
      HV *hv;
#line 14065 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::internal_test_rstructlist(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::internal_test_rstructlist(): g is not a blessed HV reference");
    }
;
#line 5838 "lib/Sys/Guestfs.xs"
      r = guestfs_internal_test_rstructlist (g, val);
      if (r == NULL)
        croak ("%s", guestfs_last_error (g));
      EXTEND (SP, r->len);
      for (i = 0; i < r->len; ++i) {
        hv = newHV ();
        (void) hv_store (hv, "pv_name", 7, newSVpv (r->val[i].pv_name, 0), 0);
        (void) hv_store (hv, "pv_uuid", 7, newSVpv (r->val[i].pv_uuid, 32), 0);
        (void) hv_store (hv, "pv_fmt", 6, newSVpv (r->val[i].pv_fmt, 0), 0);
        (void) hv_store (hv, "pv_size", 7, my_newSVull (r->val[i].pv_size), 0);
        (void) hv_store (hv, "dev_size", 8, my_newSVull (r->val[i].dev_size), 0);
        (void) hv_store (hv, "pv_free", 7, my_newSVull (r->val[i].pv_free), 0);
        (void) hv_store (hv, "pv_used", 7, my_newSVull (r->val[i].pv_used), 0);
        (void) hv_store (hv, "pv_attr", 7, newSVpv (r->val[i].pv_attr, 0), 0);
        (void) hv_store (hv, "pv_pe_count", 11, my_newSVll (r->val[i].pv_pe_count), 0);
        (void) hv_store (hv, "pv_pe_alloc_count", 17, my_newSVll (r->val[i].pv_pe_alloc_count), 0);
        (void) hv_store (hv, "pv_tags", 7, newSVpv (r->val[i].pv_tags, 0), 0);
        (void) hv_store (hv, "pe_start", 8, my_newSVull (r->val[i].pe_start), 0);
        (void) hv_store (hv, "pv_mda_count", 12, my_newSVll (r->val[i].pv_mda_count), 0);
        (void) hv_store (hv, "pv_mda_free", 11, my_newSVull (r->val[i].pv_mda_free), 0);
        PUSHs (sv_2mortal (newRV ((SV *) hv)));
      }
      guestfs_free_lvm_pv_list (r);
#line 14103 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_internal_test_rstructlisterr); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_internal_test_rstructlisterr)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "g");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
#line 5866 "lib/Sys/Guestfs.xs"
      struct guestfs_lvm_pv_list *r;
      size_t i;
      HV *hv;
#line 14124 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::internal_test_rstructlisterr(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::internal_test_rstructlisterr(): g is not a blessed HV reference");
    }
;
#line 5870 "lib/Sys/Guestfs.xs"
      r = guestfs_internal_test_rstructlisterr (g);
      if (r == NULL)
        croak ("%s", guestfs_last_error (g));
      EXTEND (SP, r->len);
      for (i = 0; i < r->len; ++i) {
        hv = newHV ();
        (void) hv_store (hv, "pv_name", 7, newSVpv (r->val[i].pv_name, 0), 0);
        (void) hv_store (hv, "pv_uuid", 7, newSVpv (r->val[i].pv_uuid, 32), 0);
        (void) hv_store (hv, "pv_fmt", 6, newSVpv (r->val[i].pv_fmt, 0), 0);
        (void) hv_store (hv, "pv_size", 7, my_newSVull (r->val[i].pv_size), 0);
        (void) hv_store (hv, "dev_size", 8, my_newSVull (r->val[i].dev_size), 0);
        (void) hv_store (hv, "pv_free", 7, my_newSVull (r->val[i].pv_free), 0);
        (void) hv_store (hv, "pv_used", 7, my_newSVull (r->val[i].pv_used), 0);
        (void) hv_store (hv, "pv_attr", 7, newSVpv (r->val[i].pv_attr, 0), 0);
        (void) hv_store (hv, "pv_pe_count", 11, my_newSVll (r->val[i].pv_pe_count), 0);
        (void) hv_store (hv, "pv_pe_alloc_count", 17, my_newSVll (r->val[i].pv_pe_alloc_count), 0);
        (void) hv_store (hv, "pv_tags", 7, newSVpv (r->val[i].pv_tags, 0), 0);
        (void) hv_store (hv, "pe_start", 8, my_newSVull (r->val[i].pe_start), 0);
        (void) hv_store (hv, "pv_mda_count", 12, my_newSVll (r->val[i].pv_mda_count), 0);
        (void) hv_store (hv, "pv_mda_free", 11, my_newSVull (r->val[i].pv_mda_free), 0);
        PUSHs (sv_2mortal (newRV ((SV *) hv)));
      }
      guestfs_free_lvm_pv_list (r);
#line 14162 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_internal_test_set_output); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_internal_test_set_output)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, filename");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	filename = (char *)SvPV_nolen(ST(1))
;
#line 5899 "lib/Sys/Guestfs.xs"
      int r;
#line 14183 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::internal_test_set_output(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::internal_test_set_output(): g is not a blessed HV reference");
    }
;
#line 5901 "lib/Sys/Guestfs.xs"
      r = guestfs_internal_test_set_output (g, filename);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 14201 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_is_blockdev); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_is_blockdev)
{
    dVAR; dXSARGS;
    if (items < 2)
       croak_xs_usage(cv,  "g, path, ...");
    {
	guestfs_h *	g;
	char *	path = (char *)SvPV_nolen(ST(1))
;
#line 5910 "lib/Sys/Guestfs.xs"
      int r;
      struct guestfs_is_blockdev_opts_argv optargs_s = { .bitmask = 0 };
      struct guestfs_is_blockdev_opts_argv *optargs = &optargs_s;
      size_t items_i;
#line 14223 "lib/Sys/Guestfs.c"
	SV *	RETVAL;

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::is_blockdev(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::is_blockdev(): g is not a blessed HV reference");
    }
;
#line 5915 "lib/Sys/Guestfs.xs"
      if (((items - 2) & 1) != 0)
        croak ("expecting an even number of extra parameters");
      for (items_i = 2; items_i < items; items_i += 2) {
        uint64_t this_mask;
        const char *this_arg;

        this_arg = SvPV_nolen (ST (items_i));
        if (STREQ (this_arg, "followsymlinks")) {
          optargs_s.followsymlinks = SvIV (ST (items_i+1));
          this_mask = GUESTFS_IS_BLOCKDEV_OPTS_FOLLOWSYMLINKS_BITMASK;
        }
        else croak ("unknown optional argument '%s'", this_arg);
        if (optargs_s.bitmask & this_mask)
          croak ("optional argument '%s' given more than once",
                 this_arg);
        optargs_s.bitmask |= this_mask;
      }

      r = guestfs_is_blockdev_opts_argv (g, path, optargs);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
      RETVAL = newSViv (r);
#line 14261 "lib/Sys/Guestfs.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Guestfs_is_busy); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_is_busy)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "g");
    {
	guestfs_h *	g;
#line 5944 "lib/Sys/Guestfs.xs"
      int r;
#line 14279 "lib/Sys/Guestfs.c"
	SV *	RETVAL;

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::is_busy(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::is_busy(): g is not a blessed HV reference");
    }
;
#line 5946 "lib/Sys/Guestfs.xs"
      r = guestfs_is_busy (g);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
      RETVAL = newSViv (r);
#line 14299 "lib/Sys/Guestfs.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Guestfs_is_chardev); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_is_chardev)
{
    dVAR; dXSARGS;
    if (items < 2)
       croak_xs_usage(cv,  "g, path, ...");
    {
	guestfs_h *	g;
	char *	path = (char *)SvPV_nolen(ST(1))
;
#line 5958 "lib/Sys/Guestfs.xs"
      int r;
      struct guestfs_is_chardev_opts_argv optargs_s = { .bitmask = 0 };
      struct guestfs_is_chardev_opts_argv *optargs = &optargs_s;
      size_t items_i;
#line 14322 "lib/Sys/Guestfs.c"
	SV *	RETVAL;

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::is_chardev(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::is_chardev(): g is not a blessed HV reference");
    }
;
#line 5963 "lib/Sys/Guestfs.xs"
      if (((items - 2) & 1) != 0)
        croak ("expecting an even number of extra parameters");
      for (items_i = 2; items_i < items; items_i += 2) {
        uint64_t this_mask;
        const char *this_arg;

        this_arg = SvPV_nolen (ST (items_i));
        if (STREQ (this_arg, "followsymlinks")) {
          optargs_s.followsymlinks = SvIV (ST (items_i+1));
          this_mask = GUESTFS_IS_CHARDEV_OPTS_FOLLOWSYMLINKS_BITMASK;
        }
        else croak ("unknown optional argument '%s'", this_arg);
        if (optargs_s.bitmask & this_mask)
          croak ("optional argument '%s' given more than once",
                 this_arg);
        optargs_s.bitmask |= this_mask;
      }

      r = guestfs_is_chardev_opts_argv (g, path, optargs);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
      RETVAL = newSViv (r);
#line 14360 "lib/Sys/Guestfs.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Guestfs_is_config); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_is_config)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "g");
    {
	guestfs_h *	g;
#line 5992 "lib/Sys/Guestfs.xs"
      int r;
#line 14378 "lib/Sys/Guestfs.c"
	SV *	RETVAL;

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::is_config(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::is_config(): g is not a blessed HV reference");
    }
;
#line 5994 "lib/Sys/Guestfs.xs"
      r = guestfs_is_config (g);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
      RETVAL = newSViv (r);
#line 14398 "lib/Sys/Guestfs.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Guestfs_is_dir); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_is_dir)
{
    dVAR; dXSARGS;
    if (items < 2)
       croak_xs_usage(cv,  "g, path, ...");
    {
	guestfs_h *	g;
	char *	path = (char *)SvPV_nolen(ST(1))
;
#line 6006 "lib/Sys/Guestfs.xs"
      int r;
      struct guestfs_is_dir_opts_argv optargs_s = { .bitmask = 0 };
      struct guestfs_is_dir_opts_argv *optargs = &optargs_s;
      size_t items_i;
#line 14421 "lib/Sys/Guestfs.c"
	SV *	RETVAL;

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::is_dir(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::is_dir(): g is not a blessed HV reference");
    }
;
#line 6011 "lib/Sys/Guestfs.xs"
      if (((items - 2) & 1) != 0)
        croak ("expecting an even number of extra parameters");
      for (items_i = 2; items_i < items; items_i += 2) {
        uint64_t this_mask;
        const char *this_arg;

        this_arg = SvPV_nolen (ST (items_i));
        if (STREQ (this_arg, "followsymlinks")) {
          optargs_s.followsymlinks = SvIV (ST (items_i+1));
          this_mask = GUESTFS_IS_DIR_OPTS_FOLLOWSYMLINKS_BITMASK;
        }
        else croak ("unknown optional argument '%s'", this_arg);
        if (optargs_s.bitmask & this_mask)
          croak ("optional argument '%s' given more than once",
                 this_arg);
        optargs_s.bitmask |= this_mask;
      }

      r = guestfs_is_dir_opts_argv (g, path, optargs);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
      RETVAL = newSViv (r);
#line 14459 "lib/Sys/Guestfs.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Guestfs_is_fifo); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_is_fifo)
{
    dVAR; dXSARGS;
    if (items < 2)
       croak_xs_usage(cv,  "g, path, ...");
    {
	guestfs_h *	g;
	char *	path = (char *)SvPV_nolen(ST(1))
;
#line 6041 "lib/Sys/Guestfs.xs"
      int r;
      struct guestfs_is_fifo_opts_argv optargs_s = { .bitmask = 0 };
      struct guestfs_is_fifo_opts_argv *optargs = &optargs_s;
      size_t items_i;
#line 14482 "lib/Sys/Guestfs.c"
	SV *	RETVAL;

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::is_fifo(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::is_fifo(): g is not a blessed HV reference");
    }
;
#line 6046 "lib/Sys/Guestfs.xs"
      if (((items - 2) & 1) != 0)
        croak ("expecting an even number of extra parameters");
      for (items_i = 2; items_i < items; items_i += 2) {
        uint64_t this_mask;
        const char *this_arg;

        this_arg = SvPV_nolen (ST (items_i));
        if (STREQ (this_arg, "followsymlinks")) {
          optargs_s.followsymlinks = SvIV (ST (items_i+1));
          this_mask = GUESTFS_IS_FIFO_OPTS_FOLLOWSYMLINKS_BITMASK;
        }
        else croak ("unknown optional argument '%s'", this_arg);
        if (optargs_s.bitmask & this_mask)
          croak ("optional argument '%s' given more than once",
                 this_arg);
        optargs_s.bitmask |= this_mask;
      }

      r = guestfs_is_fifo_opts_argv (g, path, optargs);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
      RETVAL = newSViv (r);
#line 14520 "lib/Sys/Guestfs.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Guestfs_is_file); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_is_file)
{
    dVAR; dXSARGS;
    if (items < 2)
       croak_xs_usage(cv,  "g, path, ...");
    {
	guestfs_h *	g;
	char *	path = (char *)SvPV_nolen(ST(1))
;
#line 6076 "lib/Sys/Guestfs.xs"
      int r;
      struct guestfs_is_file_opts_argv optargs_s = { .bitmask = 0 };
      struct guestfs_is_file_opts_argv *optargs = &optargs_s;
      size_t items_i;
#line 14543 "lib/Sys/Guestfs.c"
	SV *	RETVAL;

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::is_file(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::is_file(): g is not a blessed HV reference");
    }
;
#line 6081 "lib/Sys/Guestfs.xs"
      if (((items - 2) & 1) != 0)
        croak ("expecting an even number of extra parameters");
      for (items_i = 2; items_i < items; items_i += 2) {
        uint64_t this_mask;
        const char *this_arg;

        this_arg = SvPV_nolen (ST (items_i));
        if (STREQ (this_arg, "followsymlinks")) {
          optargs_s.followsymlinks = SvIV (ST (items_i+1));
          this_mask = GUESTFS_IS_FILE_OPTS_FOLLOWSYMLINKS_BITMASK;
        }
        else croak ("unknown optional argument '%s'", this_arg);
        if (optargs_s.bitmask & this_mask)
          croak ("optional argument '%s' given more than once",
                 this_arg);
        optargs_s.bitmask |= this_mask;
      }

      r = guestfs_is_file_opts_argv (g, path, optargs);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
      RETVAL = newSViv (r);
#line 14581 "lib/Sys/Guestfs.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Guestfs_is_launching); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_is_launching)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "g");
    {
	guestfs_h *	g;
#line 6110 "lib/Sys/Guestfs.xs"
      int r;
#line 14599 "lib/Sys/Guestfs.c"
	SV *	RETVAL;

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::is_launching(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::is_launching(): g is not a blessed HV reference");
    }
;
#line 6112 "lib/Sys/Guestfs.xs"
      r = guestfs_is_launching (g);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
      RETVAL = newSViv (r);
#line 14619 "lib/Sys/Guestfs.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Guestfs_is_lv); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_is_lv)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, mountable");
    {
	guestfs_h *	g;
	char *	mountable = (char *)SvPV_nolen(ST(1))
;
#line 6124 "lib/Sys/Guestfs.xs"
      int r;
#line 14639 "lib/Sys/Guestfs.c"
	SV *	RETVAL;

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::is_lv(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::is_lv(): g is not a blessed HV reference");
    }
;
#line 6126 "lib/Sys/Guestfs.xs"
      r = guestfs_is_lv (g, mountable);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
      RETVAL = newSViv (r);
#line 14659 "lib/Sys/Guestfs.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Guestfs_is_ready); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_is_ready)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "g");
    {
	guestfs_h *	g;
#line 6137 "lib/Sys/Guestfs.xs"
      int r;
#line 14677 "lib/Sys/Guestfs.c"
	SV *	RETVAL;

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::is_ready(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::is_ready(): g is not a blessed HV reference");
    }
;
#line 6139 "lib/Sys/Guestfs.xs"
      r = guestfs_is_ready (g);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
      RETVAL = newSViv (r);
#line 14697 "lib/Sys/Guestfs.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Guestfs_is_socket); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_is_socket)
{
    dVAR; dXSARGS;
    if (items < 2)
       croak_xs_usage(cv,  "g, path, ...");
    {
	guestfs_h *	g;
	char *	path = (char *)SvPV_nolen(ST(1))
;
#line 6151 "lib/Sys/Guestfs.xs"
      int r;
      struct guestfs_is_socket_opts_argv optargs_s = { .bitmask = 0 };
      struct guestfs_is_socket_opts_argv *optargs = &optargs_s;
      size_t items_i;
#line 14720 "lib/Sys/Guestfs.c"
	SV *	RETVAL;

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::is_socket(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::is_socket(): g is not a blessed HV reference");
    }
;
#line 6156 "lib/Sys/Guestfs.xs"
      if (((items - 2) & 1) != 0)
        croak ("expecting an even number of extra parameters");
      for (items_i = 2; items_i < items; items_i += 2) {
        uint64_t this_mask;
        const char *this_arg;

        this_arg = SvPV_nolen (ST (items_i));
        if (STREQ (this_arg, "followsymlinks")) {
          optargs_s.followsymlinks = SvIV (ST (items_i+1));
          this_mask = GUESTFS_IS_SOCKET_OPTS_FOLLOWSYMLINKS_BITMASK;
        }
        else croak ("unknown optional argument '%s'", this_arg);
        if (optargs_s.bitmask & this_mask)
          croak ("optional argument '%s' given more than once",
                 this_arg);
        optargs_s.bitmask |= this_mask;
      }

      r = guestfs_is_socket_opts_argv (g, path, optargs);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
      RETVAL = newSViv (r);
#line 14758 "lib/Sys/Guestfs.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Guestfs_is_symlink); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_is_symlink)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, path");
    {
	guestfs_h *	g;
	char *	path = (char *)SvPV_nolen(ST(1))
;
#line 6186 "lib/Sys/Guestfs.xs"
      int r;
#line 14778 "lib/Sys/Guestfs.c"
	SV *	RETVAL;

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::is_symlink(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::is_symlink(): g is not a blessed HV reference");
    }
;
#line 6188 "lib/Sys/Guestfs.xs"
      r = guestfs_is_symlink (g, path);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
      RETVAL = newSViv (r);
#line 14798 "lib/Sys/Guestfs.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Guestfs_is_whole_device); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_is_whole_device)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, device");
    {
	guestfs_h *	g;
	char *	device = (char *)SvPV_nolen(ST(1))
;
#line 6200 "lib/Sys/Guestfs.xs"
      int r;
#line 14818 "lib/Sys/Guestfs.c"
	SV *	RETVAL;

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::is_whole_device(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::is_whole_device(): g is not a blessed HV reference");
    }
;
#line 6202 "lib/Sys/Guestfs.xs"
      r = guestfs_is_whole_device (g, device);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
      RETVAL = newSViv (r);
#line 14838 "lib/Sys/Guestfs.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Guestfs_is_zero); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_is_zero)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, path");
    {
	guestfs_h *	g;
	char *	path = (char *)SvPV_nolen(ST(1))
;
#line 6214 "lib/Sys/Guestfs.xs"
      int r;
#line 14858 "lib/Sys/Guestfs.c"
	SV *	RETVAL;

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::is_zero(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::is_zero(): g is not a blessed HV reference");
    }
;
#line 6216 "lib/Sys/Guestfs.xs"
      r = guestfs_is_zero (g, path);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
      RETVAL = newSViv (r);
#line 14878 "lib/Sys/Guestfs.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Guestfs_is_zero_device); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_is_zero_device)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, device");
    {
	guestfs_h *	g;
	char *	device = (char *)SvPV_nolen(ST(1))
;
#line 6228 "lib/Sys/Guestfs.xs"
      int r;
#line 14898 "lib/Sys/Guestfs.c"
	SV *	RETVAL;

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::is_zero_device(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::is_zero_device(): g is not a blessed HV reference");
    }
;
#line 6230 "lib/Sys/Guestfs.xs"
      r = guestfs_is_zero_device (g, device);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
      RETVAL = newSViv (r);
#line 14918 "lib/Sys/Guestfs.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Guestfs_isoinfo); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_isoinfo)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, isofile");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	isofile = (char *)SvPV_nolen(ST(1))
;
#line 6242 "lib/Sys/Guestfs.xs"
      struct guestfs_isoinfo *r;
#line 14940 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::isoinfo(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::isoinfo(): g is not a blessed HV reference");
    }
;
#line 6244 "lib/Sys/Guestfs.xs"
      r = guestfs_isoinfo (g, isofile);
      if (r == NULL)
        croak ("%s", guestfs_last_error (g));
      EXTEND (SP, 2 * 17);
      PUSHs (sv_2mortal (newSVpv ("iso_system_id", 0)));
      PUSHs (sv_2mortal (newSVpv (r->iso_system_id, 0)));
      PUSHs (sv_2mortal (newSVpv ("iso_volume_id", 0)));
      PUSHs (sv_2mortal (newSVpv (r->iso_volume_id, 0)));
      PUSHs (sv_2mortal (newSVpv ("iso_volume_space_size", 0)));
      PUSHs (sv_2mortal (newSVnv (r->iso_volume_space_size)));
      PUSHs (sv_2mortal (newSVpv ("iso_volume_set_size", 0)));
      PUSHs (sv_2mortal (newSVnv (r->iso_volume_set_size)));
      PUSHs (sv_2mortal (newSVpv ("iso_volume_sequence_number", 0)));
      PUSHs (sv_2mortal (newSVnv (r->iso_volume_sequence_number)));
      PUSHs (sv_2mortal (newSVpv ("iso_logical_block_size", 0)));
      PUSHs (sv_2mortal (newSVnv (r->iso_logical_block_size)));
      PUSHs (sv_2mortal (newSVpv ("iso_volume_set_id", 0)));
      PUSHs (sv_2mortal (newSVpv (r->iso_volume_set_id, 0)));
      PUSHs (sv_2mortal (newSVpv ("iso_publisher_id", 0)));
      PUSHs (sv_2mortal (newSVpv (r->iso_publisher_id, 0)));
      PUSHs (sv_2mortal (newSVpv ("iso_data_preparer_id", 0)));
      PUSHs (sv_2mortal (newSVpv (r->iso_data_preparer_id, 0)));
      PUSHs (sv_2mortal (newSVpv ("iso_application_id", 0)));
      PUSHs (sv_2mortal (newSVpv (r->iso_application_id, 0)));
      PUSHs (sv_2mortal (newSVpv ("iso_copyright_file_id", 0)));
      PUSHs (sv_2mortal (newSVpv (r->iso_copyright_file_id, 0)));
      PUSHs (sv_2mortal (newSVpv ("iso_abstract_file_id", 0)));
      PUSHs (sv_2mortal (newSVpv (r->iso_abstract_file_id, 0)));
      PUSHs (sv_2mortal (newSVpv ("iso_bibliographic_file_id", 0)));
      PUSHs (sv_2mortal (newSVpv (r->iso_bibliographic_file_id, 0)));
      PUSHs (sv_2mortal (newSVpv ("iso_volume_creation_t", 0)));
      PUSHs (sv_2mortal (my_newSVll (r->iso_volume_creation_t)));
      PUSHs (sv_2mortal (newSVpv ("iso_volume_modification_t", 0)));
      PUSHs (sv_2mortal (my_newSVll (r->iso_volume_modification_t)));
      PUSHs (sv_2mortal (newSVpv ("iso_volume_expiration_t", 0)));
      PUSHs (sv_2mortal (my_newSVll (r->iso_volume_expiration_t)));
      PUSHs (sv_2mortal (newSVpv ("iso_volume_effective_t", 0)));
      PUSHs (sv_2mortal (my_newSVll (r->iso_volume_effective_t)));
      guestfs_free_isoinfo (r);
#line 14994 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_isoinfo_device); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_isoinfo_device)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, device");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	device = (char *)SvPV_nolen(ST(1))
;
#line 6289 "lib/Sys/Guestfs.xs"
      struct guestfs_isoinfo *r;
#line 15015 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::isoinfo_device(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::isoinfo_device(): g is not a blessed HV reference");
    }
;
#line 6291 "lib/Sys/Guestfs.xs"
      r = guestfs_isoinfo_device (g, device);
      if (r == NULL)
        croak ("%s", guestfs_last_error (g));
      EXTEND (SP, 2 * 17);
      PUSHs (sv_2mortal (newSVpv ("iso_system_id", 0)));
      PUSHs (sv_2mortal (newSVpv (r->iso_system_id, 0)));
      PUSHs (sv_2mortal (newSVpv ("iso_volume_id", 0)));
      PUSHs (sv_2mortal (newSVpv (r->iso_volume_id, 0)));
      PUSHs (sv_2mortal (newSVpv ("iso_volume_space_size", 0)));
      PUSHs (sv_2mortal (newSVnv (r->iso_volume_space_size)));
      PUSHs (sv_2mortal (newSVpv ("iso_volume_set_size", 0)));
      PUSHs (sv_2mortal (newSVnv (r->iso_volume_set_size)));
      PUSHs (sv_2mortal (newSVpv ("iso_volume_sequence_number", 0)));
      PUSHs (sv_2mortal (newSVnv (r->iso_volume_sequence_number)));
      PUSHs (sv_2mortal (newSVpv ("iso_logical_block_size", 0)));
      PUSHs (sv_2mortal (newSVnv (r->iso_logical_block_size)));
      PUSHs (sv_2mortal (newSVpv ("iso_volume_set_id", 0)));
      PUSHs (sv_2mortal (newSVpv (r->iso_volume_set_id, 0)));
      PUSHs (sv_2mortal (newSVpv ("iso_publisher_id", 0)));
      PUSHs (sv_2mortal (newSVpv (r->iso_publisher_id, 0)));
      PUSHs (sv_2mortal (newSVpv ("iso_data_preparer_id", 0)));
      PUSHs (sv_2mortal (newSVpv (r->iso_data_preparer_id, 0)));
      PUSHs (sv_2mortal (newSVpv ("iso_application_id", 0)));
      PUSHs (sv_2mortal (newSVpv (r->iso_application_id, 0)));
      PUSHs (sv_2mortal (newSVpv ("iso_copyright_file_id", 0)));
      PUSHs (sv_2mortal (newSVpv (r->iso_copyright_file_id, 0)));
      PUSHs (sv_2mortal (newSVpv ("iso_abstract_file_id", 0)));
      PUSHs (sv_2mortal (newSVpv (r->iso_abstract_file_id, 0)));
      PUSHs (sv_2mortal (newSVpv ("iso_bibliographic_file_id", 0)));
      PUSHs (sv_2mortal (newSVpv (r->iso_bibliographic_file_id, 0)));
      PUSHs (sv_2mortal (newSVpv ("iso_volume_creation_t", 0)));
      PUSHs (sv_2mortal (my_newSVll (r->iso_volume_creation_t)));
      PUSHs (sv_2mortal (newSVpv ("iso_volume_modification_t", 0)));
      PUSHs (sv_2mortal (my_newSVll (r->iso_volume_modification_t)));
      PUSHs (sv_2mortal (newSVpv ("iso_volume_expiration_t", 0)));
      PUSHs (sv_2mortal (my_newSVll (r->iso_volume_expiration_t)));
      PUSHs (sv_2mortal (newSVpv ("iso_volume_effective_t", 0)));
      PUSHs (sv_2mortal (my_newSVll (r->iso_volume_effective_t)));
      guestfs_free_isoinfo (r);
#line 15069 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_journal_close); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_journal_close)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "g");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
#line 6335 "lib/Sys/Guestfs.xs"
      int r;
#line 15088 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::journal_close(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::journal_close(): g is not a blessed HV reference");
    }
;
#line 6337 "lib/Sys/Guestfs.xs"
      r = guestfs_journal_close (g);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 15106 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_journal_get); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_journal_get)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "g");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
#line 6345 "lib/Sys/Guestfs.xs"
      struct guestfs_xattr_list *r;
      size_t i;
      HV *hv;
#line 15127 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::journal_get(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::journal_get(): g is not a blessed HV reference");
    }
;
#line 6349 "lib/Sys/Guestfs.xs"
      r = guestfs_journal_get (g);
      if (r == NULL)
        croak ("%s", guestfs_last_error (g));
      EXTEND (SP, r->len);
      for (i = 0; i < r->len; ++i) {
        hv = newHV ();
        (void) hv_store (hv, "attrname", 8, newSVpv (r->val[i].attrname, 0), 0);
        (void) hv_store (hv, "attrval", 7, newSVpvn (r->val[i].attrval, r->val[i].attrval_len), 0);
        PUSHs (sv_2mortal (newRV ((SV *) hv)));
      }
      guestfs_free_xattr_list (r);
#line 15153 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_journal_get_data_threshold); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_journal_get_data_threshold)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "g");
    {
	guestfs_h *	g;
#line 6365 "lib/Sys/Guestfs.xs"
      int64_t r;
#line 15170 "lib/Sys/Guestfs.c"
	SV *	RETVAL;

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::journal_get_data_threshold(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::journal_get_data_threshold(): g is not a blessed HV reference");
    }
;
#line 6367 "lib/Sys/Guestfs.xs"
      r = guestfs_journal_get_data_threshold (g);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
      RETVAL = my_newSVll (r);
#line 15190 "lib/Sys/Guestfs.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Guestfs_journal_get_realtime_usec); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_journal_get_realtime_usec)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "g");
    {
	guestfs_h *	g;
#line 6378 "lib/Sys/Guestfs.xs"
      int64_t r;
#line 15208 "lib/Sys/Guestfs.c"
	SV *	RETVAL;

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::journal_get_realtime_usec(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::journal_get_realtime_usec(): g is not a blessed HV reference");
    }
;
#line 6380 "lib/Sys/Guestfs.xs"
      r = guestfs_journal_get_realtime_usec (g);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
      RETVAL = my_newSVll (r);
#line 15228 "lib/Sys/Guestfs.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Guestfs_journal_next); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_journal_next)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "g");
    {
	guestfs_h *	g;
#line 6391 "lib/Sys/Guestfs.xs"
      int r;
#line 15246 "lib/Sys/Guestfs.c"
	SV *	RETVAL;

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::journal_next(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::journal_next(): g is not a blessed HV reference");
    }
;
#line 6393 "lib/Sys/Guestfs.xs"
      r = guestfs_journal_next (g);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
      RETVAL = newSViv (r);
#line 15266 "lib/Sys/Guestfs.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Guestfs_journal_open); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_journal_open)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, directory");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	directory = (char *)SvPV_nolen(ST(1))
;
#line 6405 "lib/Sys/Guestfs.xs"
      int r;
#line 15288 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::journal_open(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::journal_open(): g is not a blessed HV reference");
    }
;
#line 6407 "lib/Sys/Guestfs.xs"
      r = guestfs_journal_open (g, directory);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 15306 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_journal_set_data_threshold); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_journal_set_data_threshold)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, threshold");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	int64_t    threshold = my_SvIV64 (ST(1))
;
#line 6416 "lib/Sys/Guestfs.xs"
      int r;
#line 15327 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::journal_set_data_threshold(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::journal_set_data_threshold(): g is not a blessed HV reference");
    }
;
#line 6418 "lib/Sys/Guestfs.xs"
      r = guestfs_journal_set_data_threshold (g, threshold);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 15345 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_journal_skip); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_journal_skip)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, skip");
    {
	guestfs_h *	g;
	int64_t    skip = my_SvIV64 (ST(1))
;
#line 6427 "lib/Sys/Guestfs.xs"
      int64_t r;
#line 15364 "lib/Sys/Guestfs.c"
	SV *	RETVAL;

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::journal_skip(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::journal_skip(): g is not a blessed HV reference");
    }
;
#line 6429 "lib/Sys/Guestfs.xs"
      r = guestfs_journal_skip (g, skip);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
      RETVAL = my_newSVll (r);
#line 15384 "lib/Sys/Guestfs.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Guestfs_kill_subprocess); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_kill_subprocess)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "g");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
#line 6440 "lib/Sys/Guestfs.xs"
      int r;
#line 15404 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::kill_subprocess(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::kill_subprocess(): g is not a blessed HV reference");
    }
;
#line 6442 "lib/Sys/Guestfs.xs"
      Perl_ck_warner (aTHX_ packWARN(WARN_DEPRECATED),
        "Sys::Guestfs::kill_subprocess is deprecated; use Sys::Guestfs::shutdown instead");
      r = guestfs_kill_subprocess (g);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 15424 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_launch); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_launch)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "g");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
#line 6452 "lib/Sys/Guestfs.xs"
      int r;
#line 15443 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::launch(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::launch(): g is not a blessed HV reference");
    }
;
#line 6454 "lib/Sys/Guestfs.xs"
      r = guestfs_launch (g);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 15461 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_lchown); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_lchown)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "g, owner, group, path");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	int	owner = (int)SvIV(ST(1))
;
	int	group = (int)SvIV(ST(2))
;
	char *	path = (char *)SvPV_nolen(ST(3))
;
#line 6465 "lib/Sys/Guestfs.xs"
      int r;
#line 15486 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::lchown(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::lchown(): g is not a blessed HV reference");
    }
;
#line 6467 "lib/Sys/Guestfs.xs"
      r = guestfs_lchown (g, owner, group, path);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 15504 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_ldmtool_create_all); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_ldmtool_create_all)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "g");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
#line 6475 "lib/Sys/Guestfs.xs"
      int r;
#line 15523 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::ldmtool_create_all(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::ldmtool_create_all(): g is not a blessed HV reference");
    }
;
#line 6477 "lib/Sys/Guestfs.xs"
      r = guestfs_ldmtool_create_all (g);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 15541 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_ldmtool_diskgroup_disks); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_ldmtool_diskgroup_disks)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, diskgroup");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	diskgroup = (char *)SvPV_nolen(ST(1))
;
#line 6486 "lib/Sys/Guestfs.xs"
      char **r;
      size_t i, n;
#line 15563 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::ldmtool_diskgroup_disks(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::ldmtool_diskgroup_disks(): g is not a blessed HV reference");
    }
;
#line 6489 "lib/Sys/Guestfs.xs"
      r = guestfs_ldmtool_diskgroup_disks (g, diskgroup);
      if (r == NULL)
        croak ("%s", guestfs_last_error (g));
      for (n = 0; r[n] != NULL; ++n) /**/;
      EXTEND (SP, n);
      for (i = 0; i < n; ++i) {
        PUSHs (sv_2mortal (newSVpv (r[i], 0)));
        free (r[i]);
      }
      free (r);
#line 15588 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_ldmtool_diskgroup_name); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_ldmtool_diskgroup_name)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, diskgroup");
    {
	guestfs_h *	g;
	char *	diskgroup = (char *)SvPV_nolen(ST(1))
;
#line 6505 "lib/Sys/Guestfs.xs"
      char *r;
#line 15607 "lib/Sys/Guestfs.c"
	SV *	RETVAL;

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::ldmtool_diskgroup_name(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::ldmtool_diskgroup_name(): g is not a blessed HV reference");
    }
;
#line 6507 "lib/Sys/Guestfs.xs"
      r = guestfs_ldmtool_diskgroup_name (g, diskgroup);
      if (r == NULL)
        croak ("%s", guestfs_last_error (g));
      RETVAL = newSVpv (r, 0);
      free (r);
#line 15628 "lib/Sys/Guestfs.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Guestfs_ldmtool_diskgroup_volumes); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_ldmtool_diskgroup_volumes)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, diskgroup");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	diskgroup = (char *)SvPV_nolen(ST(1))
;
#line 6520 "lib/Sys/Guestfs.xs"
      char **r;
      size_t i, n;
#line 15651 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::ldmtool_diskgroup_volumes(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::ldmtool_diskgroup_volumes(): g is not a blessed HV reference");
    }
;
#line 6523 "lib/Sys/Guestfs.xs"
      r = guestfs_ldmtool_diskgroup_volumes (g, diskgroup);
      if (r == NULL)
        croak ("%s", guestfs_last_error (g));
      for (n = 0; r[n] != NULL; ++n) /**/;
      EXTEND (SP, n);
      for (i = 0; i < n; ++i) {
        PUSHs (sv_2mortal (newSVpv (r[i], 0)));
        free (r[i]);
      }
      free (r);
#line 15676 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_ldmtool_remove_all); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_ldmtool_remove_all)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "g");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
#line 6538 "lib/Sys/Guestfs.xs"
      int r;
#line 15695 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::ldmtool_remove_all(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::ldmtool_remove_all(): g is not a blessed HV reference");
    }
;
#line 6540 "lib/Sys/Guestfs.xs"
      r = guestfs_ldmtool_remove_all (g);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 15713 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_ldmtool_scan); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_ldmtool_scan)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "g");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
#line 6548 "lib/Sys/Guestfs.xs"
      char **r;
      size_t i, n;
#line 15733 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::ldmtool_scan(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::ldmtool_scan(): g is not a blessed HV reference");
    }
;
#line 6551 "lib/Sys/Guestfs.xs"
      r = guestfs_ldmtool_scan (g);
      if (r == NULL)
        croak ("%s", guestfs_last_error (g));
      for (n = 0; r[n] != NULL; ++n) /**/;
      EXTEND (SP, n);
      for (i = 0; i < n; ++i) {
        PUSHs (sv_2mortal (newSVpv (r[i], 0)));
        free (r[i]);
      }
      free (r);
#line 15758 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_ldmtool_scan_devices); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_ldmtool_scan_devices)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, devices");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char **	devices = XS_unpack_charPtrPtr(ST(1))
;
#line 6567 "lib/Sys/Guestfs.xs"
      char **r;
      size_t i, n;
#line 15780 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::ldmtool_scan_devices(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::ldmtool_scan_devices(): g is not a blessed HV reference");
    }
;
#line 6570 "lib/Sys/Guestfs.xs"
      r = guestfs_ldmtool_scan_devices (g, devices);
      free (devices);
      if (r == NULL)
        croak ("%s", guestfs_last_error (g));
      for (n = 0; r[n] != NULL; ++n) /**/;
      EXTEND (SP, n);
      for (i = 0; i < n; ++i) {
        PUSHs (sv_2mortal (newSVpv (r[i], 0)));
        free (r[i]);
      }
      free (r);
#line 15806 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_ldmtool_volume_hint); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_ldmtool_volume_hint)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "g, diskgroup, volume");
    {
	guestfs_h *	g;
	char *	diskgroup = (char *)SvPV_nolen(ST(1))
;
	char *	volume = (char *)SvPV_nolen(ST(2))
;
#line 6588 "lib/Sys/Guestfs.xs"
      char *r;
#line 15827 "lib/Sys/Guestfs.c"
	SV *	RETVAL;

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::ldmtool_volume_hint(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::ldmtool_volume_hint(): g is not a blessed HV reference");
    }
;
#line 6590 "lib/Sys/Guestfs.xs"
      r = guestfs_ldmtool_volume_hint (g, diskgroup, volume);
      if (r == NULL)
        croak ("%s", guestfs_last_error (g));
      RETVAL = newSVpv (r, 0);
      free (r);
#line 15848 "lib/Sys/Guestfs.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Guestfs_ldmtool_volume_partitions); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_ldmtool_volume_partitions)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "g, diskgroup, volume");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	diskgroup = (char *)SvPV_nolen(ST(1))
;
	char *	volume = (char *)SvPV_nolen(ST(2))
;
#line 6604 "lib/Sys/Guestfs.xs"
      char **r;
      size_t i, n;
#line 15873 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::ldmtool_volume_partitions(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::ldmtool_volume_partitions(): g is not a blessed HV reference");
    }
;
#line 6607 "lib/Sys/Guestfs.xs"
      r = guestfs_ldmtool_volume_partitions (g, diskgroup, volume);
      if (r == NULL)
        croak ("%s", guestfs_last_error (g));
      for (n = 0; r[n] != NULL; ++n) /**/;
      EXTEND (SP, n);
      for (i = 0; i < n; ++i) {
        PUSHs (sv_2mortal (newSVpv (r[i], 0)));
        free (r[i]);
      }
      free (r);
#line 15898 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_ldmtool_volume_type); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_ldmtool_volume_type)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "g, diskgroup, volume");
    {
	guestfs_h *	g;
	char *	diskgroup = (char *)SvPV_nolen(ST(1))
;
	char *	volume = (char *)SvPV_nolen(ST(2))
;
#line 6624 "lib/Sys/Guestfs.xs"
      char *r;
#line 15919 "lib/Sys/Guestfs.c"
	SV *	RETVAL;

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::ldmtool_volume_type(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::ldmtool_volume_type(): g is not a blessed HV reference");
    }
;
#line 6626 "lib/Sys/Guestfs.xs"
      r = guestfs_ldmtool_volume_type (g, diskgroup, volume);
      if (r == NULL)
        croak ("%s", guestfs_last_error (g));
      RETVAL = newSVpv (r, 0);
      free (r);
#line 15940 "lib/Sys/Guestfs.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Guestfs_lgetxattr); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_lgetxattr)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "g, path, name");
    {
	guestfs_h *	g;
	char *	path = (char *)SvPV_nolen(ST(1))
;
	char *	name = (char *)SvPV_nolen(ST(2))
;
#line 6640 "lib/Sys/Guestfs.xs"
      char *r;
      size_t size;
#line 15963 "lib/Sys/Guestfs.c"
	SV *	RETVAL;

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::lgetxattr(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::lgetxattr(): g is not a blessed HV reference");
    }
;
#line 6643 "lib/Sys/Guestfs.xs"
      r = guestfs_lgetxattr (g, path, name, &size);
      if (r == NULL)
        croak ("%s", guestfs_last_error (g));
      RETVAL = newSVpvn (r, size);
      free (r);
#line 15984 "lib/Sys/Guestfs.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Guestfs_lgetxattrs); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_lgetxattrs)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, path");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	path = (char *)SvPV_nolen(ST(1))
;
#line 6656 "lib/Sys/Guestfs.xs"
      struct guestfs_xattr_list *r;
      size_t i;
      HV *hv;
#line 16008 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::lgetxattrs(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::lgetxattrs(): g is not a blessed HV reference");
    }
;
#line 6660 "lib/Sys/Guestfs.xs"
      r = guestfs_lgetxattrs (g, path);
      if (r == NULL)
        croak ("%s", guestfs_last_error (g));
      EXTEND (SP, r->len);
      for (i = 0; i < r->len; ++i) {
        hv = newHV ();
        (void) hv_store (hv, "attrname", 8, newSVpv (r->val[i].attrname, 0), 0);
        (void) hv_store (hv, "attrval", 7, newSVpvn (r->val[i].attrval, r->val[i].attrval_len), 0);
        PUSHs (sv_2mortal (newRV ((SV *) hv)));
      }
      guestfs_free_xattr_list (r);
#line 16034 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_list_9p); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_list_9p)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "g");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
#line 6676 "lib/Sys/Guestfs.xs"
      char **r;
      size_t i, n;
#line 16054 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::list_9p(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::list_9p(): g is not a blessed HV reference");
    }
;
#line 6679 "lib/Sys/Guestfs.xs"
      Perl_ck_warner (aTHX_ packWARN(WARN_DEPRECATED),
        "Sys::Guestfs::list_9p is deprecated");
      r = guestfs_list_9p (g);
      if (r == NULL)
        croak ("%s", guestfs_last_error (g));
      for (n = 0; r[n] != NULL; ++n) /**/;
      EXTEND (SP, n);
      for (i = 0; i < n; ++i) {
        PUSHs (sv_2mortal (newSVpv (r[i], 0)));
        free (r[i]);
      }
      free (r);
#line 16081 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_list_devices); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_list_devices)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "g");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
#line 6696 "lib/Sys/Guestfs.xs"
      char **r;
      size_t i, n;
#line 16101 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::list_devices(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::list_devices(): g is not a blessed HV reference");
    }
;
#line 6699 "lib/Sys/Guestfs.xs"
      r = guestfs_list_devices (g);
      if (r == NULL)
        croak ("%s", guestfs_last_error (g));
      for (n = 0; r[n] != NULL; ++n) /**/;
      EXTEND (SP, n);
      for (i = 0; i < n; ++i) {
        PUSHs (sv_2mortal (newSVpv (r[i], 0)));
        free (r[i]);
      }
      free (r);
#line 16126 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_list_disk_labels); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_list_disk_labels)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "g");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
#line 6714 "lib/Sys/Guestfs.xs"
      char **r;
      size_t i, n;
#line 16146 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::list_disk_labels(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::list_disk_labels(): g is not a blessed HV reference");
    }
;
#line 6717 "lib/Sys/Guestfs.xs"
      r = guestfs_list_disk_labels (g);
      if (r == NULL)
        croak ("%s", guestfs_last_error (g));
      for (n = 0; r[n] != NULL; ++n) /**/;
      EXTEND (SP, n);
      for (i = 0; i < n; ++i) {
        PUSHs (sv_2mortal (newSVpv (r[i], 0)));
        free (r[i]);
      }
      free (r);
#line 16171 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_list_dm_devices); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_list_dm_devices)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "g");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
#line 6732 "lib/Sys/Guestfs.xs"
      char **r;
      size_t i, n;
#line 16191 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::list_dm_devices(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::list_dm_devices(): g is not a blessed HV reference");
    }
;
#line 6735 "lib/Sys/Guestfs.xs"
      r = guestfs_list_dm_devices (g);
      if (r == NULL)
        croak ("%s", guestfs_last_error (g));
      for (n = 0; r[n] != NULL; ++n) /**/;
      EXTEND (SP, n);
      for (i = 0; i < n; ++i) {
        PUSHs (sv_2mortal (newSVpv (r[i], 0)));
        free (r[i]);
      }
      free (r);
#line 16216 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_list_filesystems); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_list_filesystems)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "g");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
#line 6750 "lib/Sys/Guestfs.xs"
      char **r;
      size_t i, n;
#line 16236 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::list_filesystems(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::list_filesystems(): g is not a blessed HV reference");
    }
;
#line 6753 "lib/Sys/Guestfs.xs"
      r = guestfs_list_filesystems (g);
      if (r == NULL)
        croak ("%s", guestfs_last_error (g));
      for (n = 0; r[n] != NULL; ++n) /**/;
      EXTEND (SP, n);
      for (i = 0; i < n; ++i) {
        PUSHs (sv_2mortal (newSVpv (r[i], 0)));
        free (r[i]);
      }
      free (r);
#line 16261 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_list_ldm_partitions); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_list_ldm_partitions)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "g");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
#line 6768 "lib/Sys/Guestfs.xs"
      char **r;
      size_t i, n;
#line 16281 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::list_ldm_partitions(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::list_ldm_partitions(): g is not a blessed HV reference");
    }
;
#line 6771 "lib/Sys/Guestfs.xs"
      r = guestfs_list_ldm_partitions (g);
      if (r == NULL)
        croak ("%s", guestfs_last_error (g));
      for (n = 0; r[n] != NULL; ++n) /**/;
      EXTEND (SP, n);
      for (i = 0; i < n; ++i) {
        PUSHs (sv_2mortal (newSVpv (r[i], 0)));
        free (r[i]);
      }
      free (r);
#line 16306 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_list_ldm_volumes); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_list_ldm_volumes)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "g");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
#line 6786 "lib/Sys/Guestfs.xs"
      char **r;
      size_t i, n;
#line 16326 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::list_ldm_volumes(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::list_ldm_volumes(): g is not a blessed HV reference");
    }
;
#line 6789 "lib/Sys/Guestfs.xs"
      r = guestfs_list_ldm_volumes (g);
      if (r == NULL)
        croak ("%s", guestfs_last_error (g));
      for (n = 0; r[n] != NULL; ++n) /**/;
      EXTEND (SP, n);
      for (i = 0; i < n; ++i) {
        PUSHs (sv_2mortal (newSVpv (r[i], 0)));
        free (r[i]);
      }
      free (r);
#line 16351 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_list_md_devices); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_list_md_devices)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "g");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
#line 6804 "lib/Sys/Guestfs.xs"
      char **r;
      size_t i, n;
#line 16371 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::list_md_devices(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::list_md_devices(): g is not a blessed HV reference");
    }
;
#line 6807 "lib/Sys/Guestfs.xs"
      r = guestfs_list_md_devices (g);
      if (r == NULL)
        croak ("%s", guestfs_last_error (g));
      for (n = 0; r[n] != NULL; ++n) /**/;
      EXTEND (SP, n);
      for (i = 0; i < n; ++i) {
        PUSHs (sv_2mortal (newSVpv (r[i], 0)));
        free (r[i]);
      }
      free (r);
#line 16396 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_list_partitions); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_list_partitions)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "g");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
#line 6822 "lib/Sys/Guestfs.xs"
      char **r;
      size_t i, n;
#line 16416 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::list_partitions(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::list_partitions(): g is not a blessed HV reference");
    }
;
#line 6825 "lib/Sys/Guestfs.xs"
      r = guestfs_list_partitions (g);
      if (r == NULL)
        croak ("%s", guestfs_last_error (g));
      for (n = 0; r[n] != NULL; ++n) /**/;
      EXTEND (SP, n);
      for (i = 0; i < n; ++i) {
        PUSHs (sv_2mortal (newSVpv (r[i], 0)));
        free (r[i]);
      }
      free (r);
#line 16441 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_ll); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_ll)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, directory");
    {
	guestfs_h *	g;
	char *	directory = (char *)SvPV_nolen(ST(1))
;
#line 6841 "lib/Sys/Guestfs.xs"
      char *r;
#line 16460 "lib/Sys/Guestfs.c"
	SV *	RETVAL;

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::ll(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::ll(): g is not a blessed HV reference");
    }
;
#line 6843 "lib/Sys/Guestfs.xs"
      r = guestfs_ll (g, directory);
      if (r == NULL)
        croak ("%s", guestfs_last_error (g));
      RETVAL = newSVpv (r, 0);
      free (r);
#line 16481 "lib/Sys/Guestfs.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Guestfs_llz); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_llz)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, directory");
    {
	guestfs_h *	g;
	char *	directory = (char *)SvPV_nolen(ST(1))
;
#line 6856 "lib/Sys/Guestfs.xs"
      char *r;
#line 16501 "lib/Sys/Guestfs.c"
	SV *	RETVAL;

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::llz(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::llz(): g is not a blessed HV reference");
    }
;
#line 6858 "lib/Sys/Guestfs.xs"
      Perl_ck_warner (aTHX_ packWARN(WARN_DEPRECATED),
        "Sys::Guestfs::llz is deprecated; use Sys::Guestfs::lgetxattrs instead");
      r = guestfs_llz (g, directory);
      if (r == NULL)
        croak ("%s", guestfs_last_error (g));
      RETVAL = newSVpv (r, 0);
      free (r);
#line 16524 "lib/Sys/Guestfs.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Guestfs_ln); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_ln)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "g, target, linkname");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	target = (char *)SvPV_nolen(ST(1))
;
	char *	linkname = (char *)SvPV_nolen(ST(2))
;
#line 6874 "lib/Sys/Guestfs.xs"
      int r;
#line 16548 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::ln(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::ln(): g is not a blessed HV reference");
    }
;
#line 6876 "lib/Sys/Guestfs.xs"
      r = guestfs_ln (g, target, linkname);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 16566 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_ln_f); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_ln_f)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "g, target, linkname");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	target = (char *)SvPV_nolen(ST(1))
;
	char *	linkname = (char *)SvPV_nolen(ST(2))
;
#line 6886 "lib/Sys/Guestfs.xs"
      int r;
#line 16589 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::ln_f(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::ln_f(): g is not a blessed HV reference");
    }
;
#line 6888 "lib/Sys/Guestfs.xs"
      r = guestfs_ln_f (g, target, linkname);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 16607 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_ln_s); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_ln_s)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "g, target, linkname");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	target = (char *)SvPV_nolen(ST(1))
;
	char *	linkname = (char *)SvPV_nolen(ST(2))
;
#line 6898 "lib/Sys/Guestfs.xs"
      int r;
#line 16630 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::ln_s(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::ln_s(): g is not a blessed HV reference");
    }
;
#line 6900 "lib/Sys/Guestfs.xs"
      r = guestfs_ln_s (g, target, linkname);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 16648 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_ln_sf); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_ln_sf)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "g, target, linkname");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	target = (char *)SvPV_nolen(ST(1))
;
	char *	linkname = (char *)SvPV_nolen(ST(2))
;
#line 6910 "lib/Sys/Guestfs.xs"
      int r;
#line 16671 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::ln_sf(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::ln_sf(): g is not a blessed HV reference");
    }
;
#line 6912 "lib/Sys/Guestfs.xs"
      r = guestfs_ln_sf (g, target, linkname);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 16689 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_lremovexattr); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_lremovexattr)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "g, xattr, path");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	xattr = (char *)SvPV_nolen(ST(1))
;
	char *	path = (char *)SvPV_nolen(ST(2))
;
#line 6922 "lib/Sys/Guestfs.xs"
      int r;
#line 16712 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::lremovexattr(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::lremovexattr(): g is not a blessed HV reference");
    }
;
#line 6924 "lib/Sys/Guestfs.xs"
      r = guestfs_lremovexattr (g, xattr, path);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 16730 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_ls); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_ls)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, directory");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	directory = (char *)SvPV_nolen(ST(1))
;
#line 6933 "lib/Sys/Guestfs.xs"
      char **r;
      size_t i, n;
#line 16752 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::ls(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::ls(): g is not a blessed HV reference");
    }
;
#line 6936 "lib/Sys/Guestfs.xs"
      r = guestfs_ls (g, directory);
      if (r == NULL)
        croak ("%s", guestfs_last_error (g));
      for (n = 0; r[n] != NULL; ++n) /**/;
      EXTEND (SP, n);
      for (i = 0; i < n; ++i) {
        PUSHs (sv_2mortal (newSVpv (r[i], 0)));
        free (r[i]);
      }
      free (r);
#line 16777 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_ls0); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_ls0)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "g, dir, filenames");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	dir = (char *)SvPV_nolen(ST(1))
;
	char *	filenames = (char *)SvPV_nolen(ST(2))
;
#line 6953 "lib/Sys/Guestfs.xs"
      int r;
#line 16800 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::ls0(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::ls0(): g is not a blessed HV reference");
    }
;
#line 6955 "lib/Sys/Guestfs.xs"
      r = guestfs_ls0 (g, dir, filenames);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 16818 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_lsetxattr); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_lsetxattr)
{
    dVAR; dXSARGS;
    if (items != 5)
       croak_xs_usage(cv,  "g, xattr, val, vallen, path");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	xattr = (char *)SvPV_nolen(ST(1))
;
	char *	val = (char *)SvPV_nolen(ST(2))
;
	int	vallen = (int)SvIV(ST(3))
;
	char *	path = (char *)SvPV_nolen(ST(4))
;
#line 6967 "lib/Sys/Guestfs.xs"
      int r;
#line 16845 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::lsetxattr(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::lsetxattr(): g is not a blessed HV reference");
    }
;
#line 6969 "lib/Sys/Guestfs.xs"
      r = guestfs_lsetxattr (g, xattr, val, vallen, path);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 16863 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_lstat); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_lstat)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, path");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	path = (char *)SvPV_nolen(ST(1))
;
#line 6978 "lib/Sys/Guestfs.xs"
      struct guestfs_stat *r;
#line 16884 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::lstat(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::lstat(): g is not a blessed HV reference");
    }
;
#line 6980 "lib/Sys/Guestfs.xs"
      Perl_ck_warner (aTHX_ packWARN(WARN_DEPRECATED),
        "Sys::Guestfs::lstat is deprecated; use Sys::Guestfs::lstatns instead");
      r = guestfs_lstat (g, path);
      if (r == NULL)
        croak ("%s", guestfs_last_error (g));
      EXTEND (SP, 2 * 13);
      PUSHs (sv_2mortal (newSVpv ("dev", 0)));
      PUSHs (sv_2mortal (my_newSVll (r->dev)));
      PUSHs (sv_2mortal (newSVpv ("ino", 0)));
      PUSHs (sv_2mortal (my_newSVll (r->ino)));
      PUSHs (sv_2mortal (newSVpv ("mode", 0)));
      PUSHs (sv_2mortal (my_newSVll (r->mode)));
      PUSHs (sv_2mortal (newSVpv ("nlink", 0)));
      PUSHs (sv_2mortal (my_newSVll (r->nlink)));
      PUSHs (sv_2mortal (newSVpv ("uid", 0)));
      PUSHs (sv_2mortal (my_newSVll (r->uid)));
      PUSHs (sv_2mortal (newSVpv ("gid", 0)));
      PUSHs (sv_2mortal (my_newSVll (r->gid)));
      PUSHs (sv_2mortal (newSVpv ("rdev", 0)));
      PUSHs (sv_2mortal (my_newSVll (r->rdev)));
      PUSHs (sv_2mortal (newSVpv ("size", 0)));
      PUSHs (sv_2mortal (my_newSVll (r->size)));
      PUSHs (sv_2mortal (newSVpv ("blksize", 0)));
      PUSHs (sv_2mortal (my_newSVll (r->blksize)));
      PUSHs (sv_2mortal (newSVpv ("blocks", 0)));
      PUSHs (sv_2mortal (my_newSVll (r->blocks)));
      PUSHs (sv_2mortal (newSVpv ("atime", 0)));
      PUSHs (sv_2mortal (my_newSVll (r->atime)));
      PUSHs (sv_2mortal (newSVpv ("mtime", 0)));
      PUSHs (sv_2mortal (my_newSVll (r->mtime)));
      PUSHs (sv_2mortal (newSVpv ("ctime", 0)));
      PUSHs (sv_2mortal (my_newSVll (r->ctime)));
      guestfs_free_stat (r);
#line 16932 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_lstatlist); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_lstatlist)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "g, path, names");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	path = (char *)SvPV_nolen(ST(1))
;
	char **	names = XS_unpack_charPtrPtr(ST(2))
;
#line 7020 "lib/Sys/Guestfs.xs"
      struct guestfs_stat_list *r;
      size_t i;
      HV *hv;
#line 16957 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::lstatlist(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::lstatlist(): g is not a blessed HV reference");
    }
;
#line 7024 "lib/Sys/Guestfs.xs"
      Perl_ck_warner (aTHX_ packWARN(WARN_DEPRECATED),
        "Sys::Guestfs::lstatlist is deprecated; use Sys::Guestfs::lstatnslist instead");
      r = guestfs_lstatlist (g, path, names);
      free (names);
      if (r == NULL)
        croak ("%s", guestfs_last_error (g));
      EXTEND (SP, r->len);
      for (i = 0; i < r->len; ++i) {
        hv = newHV ();
        (void) hv_store (hv, "dev", 3, my_newSVll (r->val[i].dev), 0);
        (void) hv_store (hv, "ino", 3, my_newSVll (r->val[i].ino), 0);
        (void) hv_store (hv, "mode", 4, my_newSVll (r->val[i].mode), 0);
        (void) hv_store (hv, "nlink", 5, my_newSVll (r->val[i].nlink), 0);
        (void) hv_store (hv, "uid", 3, my_newSVll (r->val[i].uid), 0);
        (void) hv_store (hv, "gid", 3, my_newSVll (r->val[i].gid), 0);
        (void) hv_store (hv, "rdev", 4, my_newSVll (r->val[i].rdev), 0);
        (void) hv_store (hv, "size", 4, my_newSVll (r->val[i].size), 0);
        (void) hv_store (hv, "blksize", 7, my_newSVll (r->val[i].blksize), 0);
        (void) hv_store (hv, "blocks", 6, my_newSVll (r->val[i].blocks), 0);
        (void) hv_store (hv, "atime", 5, my_newSVll (r->val[i].atime), 0);
        (void) hv_store (hv, "mtime", 5, my_newSVll (r->val[i].mtime), 0);
        (void) hv_store (hv, "ctime", 5, my_newSVll (r->val[i].ctime), 0);
        PUSHs (sv_2mortal (newRV ((SV *) hv)));
      }
      guestfs_free_stat_list (r);
#line 16997 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_lstatns); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_lstatns)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, path");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	path = (char *)SvPV_nolen(ST(1))
;
#line 7055 "lib/Sys/Guestfs.xs"
      struct guestfs_statns *r;
#line 17018 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::lstatns(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::lstatns(): g is not a blessed HV reference");
    }
;
#line 7057 "lib/Sys/Guestfs.xs"
      r = guestfs_lstatns (g, path);
      if (r == NULL)
        croak ("%s", guestfs_last_error (g));
      EXTEND (SP, 2 * 22);
      PUSHs (sv_2mortal (newSVpv ("st_dev", 0)));
      PUSHs (sv_2mortal (my_newSVll (r->st_dev)));
      PUSHs (sv_2mortal (newSVpv ("st_ino", 0)));
      PUSHs (sv_2mortal (my_newSVll (r->st_ino)));
      PUSHs (sv_2mortal (newSVpv ("st_mode", 0)));
      PUSHs (sv_2mortal (my_newSVll (r->st_mode)));
      PUSHs (sv_2mortal (newSVpv ("st_nlink", 0)));
      PUSHs (sv_2mortal (my_newSVll (r->st_nlink)));
      PUSHs (sv_2mortal (newSVpv ("st_uid", 0)));
      PUSHs (sv_2mortal (my_newSVll (r->st_uid)));
      PUSHs (sv_2mortal (newSVpv ("st_gid", 0)));
      PUSHs (sv_2mortal (my_newSVll (r->st_gid)));
      PUSHs (sv_2mortal (newSVpv ("st_rdev", 0)));
      PUSHs (sv_2mortal (my_newSVll (r->st_rdev)));
      PUSHs (sv_2mortal (newSVpv ("st_size", 0)));
      PUSHs (sv_2mortal (my_newSVll (r->st_size)));
      PUSHs (sv_2mortal (newSVpv ("st_blksize", 0)));
      PUSHs (sv_2mortal (my_newSVll (r->st_blksize)));
      PUSHs (sv_2mortal (newSVpv ("st_blocks", 0)));
      PUSHs (sv_2mortal (my_newSVll (r->st_blocks)));
      PUSHs (sv_2mortal (newSVpv ("st_atime_sec", 0)));
      PUSHs (sv_2mortal (my_newSVll (r->st_atime_sec)));
      PUSHs (sv_2mortal (newSVpv ("st_atime_nsec", 0)));
      PUSHs (sv_2mortal (my_newSVll (r->st_atime_nsec)));
      PUSHs (sv_2mortal (newSVpv ("st_mtime_sec", 0)));
      PUSHs (sv_2mortal (my_newSVll (r->st_mtime_sec)));
      PUSHs (sv_2mortal (newSVpv ("st_mtime_nsec", 0)));
      PUSHs (sv_2mortal (my_newSVll (r->st_mtime_nsec)));
      PUSHs (sv_2mortal (newSVpv ("st_ctime_sec", 0)));
      PUSHs (sv_2mortal (my_newSVll (r->st_ctime_sec)));
      PUSHs (sv_2mortal (newSVpv ("st_ctime_nsec", 0)));
      PUSHs (sv_2mortal (my_newSVll (r->st_ctime_nsec)));
      PUSHs (sv_2mortal (newSVpv ("st_spare1", 0)));
      PUSHs (sv_2mortal (my_newSVll (r->st_spare1)));
      PUSHs (sv_2mortal (newSVpv ("st_spare2", 0)));
      PUSHs (sv_2mortal (my_newSVll (r->st_spare2)));
      PUSHs (sv_2mortal (newSVpv ("st_spare3", 0)));
      PUSHs (sv_2mortal (my_newSVll (r->st_spare3)));
      PUSHs (sv_2mortal (newSVpv ("st_spare4", 0)));
      PUSHs (sv_2mortal (my_newSVll (r->st_spare4)));
      PUSHs (sv_2mortal (newSVpv ("st_spare5", 0)));
      PUSHs (sv_2mortal (my_newSVll (r->st_spare5)));
      PUSHs (sv_2mortal (newSVpv ("st_spare6", 0)));
      PUSHs (sv_2mortal (my_newSVll (r->st_spare6)));
      guestfs_free_statns (r);
#line 17082 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_lstatnslist); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_lstatnslist)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "g, path, names");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	path = (char *)SvPV_nolen(ST(1))
;
	char **	names = XS_unpack_charPtrPtr(ST(2))
;
#line 7113 "lib/Sys/Guestfs.xs"
      struct guestfs_statns_list *r;
      size_t i;
      HV *hv;
#line 17107 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::lstatnslist(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::lstatnslist(): g is not a blessed HV reference");
    }
;
#line 7117 "lib/Sys/Guestfs.xs"
      r = guestfs_lstatnslist (g, path, names);
      free (names);
      if (r == NULL)
        croak ("%s", guestfs_last_error (g));
      EXTEND (SP, r->len);
      for (i = 0; i < r->len; ++i) {
        hv = newHV ();
        (void) hv_store (hv, "st_dev", 6, my_newSVll (r->val[i].st_dev), 0);
        (void) hv_store (hv, "st_ino", 6, my_newSVll (r->val[i].st_ino), 0);
        (void) hv_store (hv, "st_mode", 7, my_newSVll (r->val[i].st_mode), 0);
        (void) hv_store (hv, "st_nlink", 8, my_newSVll (r->val[i].st_nlink), 0);
        (void) hv_store (hv, "st_uid", 6, my_newSVll (r->val[i].st_uid), 0);
        (void) hv_store (hv, "st_gid", 6, my_newSVll (r->val[i].st_gid), 0);
        (void) hv_store (hv, "st_rdev", 7, my_newSVll (r->val[i].st_rdev), 0);
        (void) hv_store (hv, "st_size", 7, my_newSVll (r->val[i].st_size), 0);
        (void) hv_store (hv, "st_blksize", 10, my_newSVll (r->val[i].st_blksize), 0);
        (void) hv_store (hv, "st_blocks", 9, my_newSVll (r->val[i].st_blocks), 0);
        (void) hv_store (hv, "st_atime_sec", 12, my_newSVll (r->val[i].st_atime_sec), 0);
        (void) hv_store (hv, "st_atime_nsec", 13, my_newSVll (r->val[i].st_atime_nsec), 0);
        (void) hv_store (hv, "st_mtime_sec", 12, my_newSVll (r->val[i].st_mtime_sec), 0);
        (void) hv_store (hv, "st_mtime_nsec", 13, my_newSVll (r->val[i].st_mtime_nsec), 0);
        (void) hv_store (hv, "st_ctime_sec", 12, my_newSVll (r->val[i].st_ctime_sec), 0);
        (void) hv_store (hv, "st_ctime_nsec", 13, my_newSVll (r->val[i].st_ctime_nsec), 0);
        (void) hv_store (hv, "st_spare1", 9, my_newSVll (r->val[i].st_spare1), 0);
        (void) hv_store (hv, "st_spare2", 9, my_newSVll (r->val[i].st_spare2), 0);
        (void) hv_store (hv, "st_spare3", 9, my_newSVll (r->val[i].st_spare3), 0);
        (void) hv_store (hv, "st_spare4", 9, my_newSVll (r->val[i].st_spare4), 0);
        (void) hv_store (hv, "st_spare5", 9, my_newSVll (r->val[i].st_spare5), 0);
        (void) hv_store (hv, "st_spare6", 9, my_newSVll (r->val[i].st_spare6), 0);
        PUSHs (sv_2mortal (newRV ((SV *) hv)));
      }
      guestfs_free_statns_list (r);
#line 17154 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_luks_add_key); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_luks_add_key)
{
    dVAR; dXSARGS;
    if (items != 5)
       croak_xs_usage(cv,  "g, device, key, newkey, keyslot");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	device = (char *)SvPV_nolen(ST(1))
;
	char *	key = (char *)SvPV_nolen(ST(2))
;
	char *	newkey = (char *)SvPV_nolen(ST(3))
;
	int	keyslot = (int)SvIV(ST(4))
;
#line 7158 "lib/Sys/Guestfs.xs"
      int r;
#line 17181 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::luks_add_key(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::luks_add_key(): g is not a blessed HV reference");
    }
;
#line 7160 "lib/Sys/Guestfs.xs"
      r = guestfs_luks_add_key (g, device, key, newkey, keyslot);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 17199 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_luks_close); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_luks_close)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, device");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	device = (char *)SvPV_nolen(ST(1))
;
#line 7169 "lib/Sys/Guestfs.xs"
      int r;
#line 17220 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::luks_close(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::luks_close(): g is not a blessed HV reference");
    }
;
#line 7171 "lib/Sys/Guestfs.xs"
      Perl_ck_warner (aTHX_ packWARN(WARN_DEPRECATED),
        "Sys::Guestfs::luks_close is deprecated; use Sys::Guestfs::cryptsetup_close instead");
      r = guestfs_luks_close (g, device);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 17240 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_luks_format); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_luks_format)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "g, device, key, keyslot");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	device = (char *)SvPV_nolen(ST(1))
;
	char *	key = (char *)SvPV_nolen(ST(2))
;
	int	keyslot = (int)SvIV(ST(3))
;
#line 7184 "lib/Sys/Guestfs.xs"
      int r;
#line 17265 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::luks_format(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::luks_format(): g is not a blessed HV reference");
    }
;
#line 7186 "lib/Sys/Guestfs.xs"
      r = guestfs_luks_format (g, device, key, keyslot);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 17283 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_luks_format_cipher); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_luks_format_cipher)
{
    dVAR; dXSARGS;
    if (items != 5)
       croak_xs_usage(cv,  "g, device, key, keyslot, cipher");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	device = (char *)SvPV_nolen(ST(1))
;
	char *	key = (char *)SvPV_nolen(ST(2))
;
	int	keyslot = (int)SvIV(ST(3))
;
	char *	cipher = (char *)SvPV_nolen(ST(4))
;
#line 7198 "lib/Sys/Guestfs.xs"
      int r;
#line 17310 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::luks_format_cipher(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::luks_format_cipher(): g is not a blessed HV reference");
    }
;
#line 7200 "lib/Sys/Guestfs.xs"
      r = guestfs_luks_format_cipher (g, device, key, keyslot, cipher);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 17328 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_luks_kill_slot); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_luks_kill_slot)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "g, device, key, keyslot");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	device = (char *)SvPV_nolen(ST(1))
;
	char *	key = (char *)SvPV_nolen(ST(2))
;
	int	keyslot = (int)SvIV(ST(3))
;
#line 7211 "lib/Sys/Guestfs.xs"
      int r;
#line 17353 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::luks_kill_slot(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::luks_kill_slot(): g is not a blessed HV reference");
    }
;
#line 7213 "lib/Sys/Guestfs.xs"
      r = guestfs_luks_kill_slot (g, device, key, keyslot);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 17371 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_luks_open); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_luks_open)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "g, device, key, mapname");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	device = (char *)SvPV_nolen(ST(1))
;
	char *	key = (char *)SvPV_nolen(ST(2))
;
	char *	mapname = (char *)SvPV_nolen(ST(3))
;
#line 7224 "lib/Sys/Guestfs.xs"
      int r;
#line 17396 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::luks_open(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::luks_open(): g is not a blessed HV reference");
    }
;
#line 7226 "lib/Sys/Guestfs.xs"
      Perl_ck_warner (aTHX_ packWARN(WARN_DEPRECATED),
        "Sys::Guestfs::luks_open is deprecated; use Sys::Guestfs::cryptsetup_open instead");
      r = guestfs_luks_open (g, device, key, mapname);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 17416 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_luks_open_ro); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_luks_open_ro)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "g, device, key, mapname");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	device = (char *)SvPV_nolen(ST(1))
;
	char *	key = (char *)SvPV_nolen(ST(2))
;
	char *	mapname = (char *)SvPV_nolen(ST(3))
;
#line 7239 "lib/Sys/Guestfs.xs"
      int r;
#line 17441 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::luks_open_ro(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::luks_open_ro(): g is not a blessed HV reference");
    }
;
#line 7241 "lib/Sys/Guestfs.xs"
      Perl_ck_warner (aTHX_ packWARN(WARN_DEPRECATED),
        "Sys::Guestfs::luks_open_ro is deprecated; use Sys::Guestfs::cryptsetup_open instead");
      r = guestfs_luks_open_ro (g, device, key, mapname);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 17461 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_luks_uuid); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_luks_uuid)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, device");
    {
	guestfs_h *	g;
	char *	device = (char *)SvPV_nolen(ST(1))
;
#line 7252 "lib/Sys/Guestfs.xs"
      char *r;
#line 17480 "lib/Sys/Guestfs.c"
	SV *	RETVAL;

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::luks_uuid(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::luks_uuid(): g is not a blessed HV reference");
    }
;
#line 7254 "lib/Sys/Guestfs.xs"
      r = guestfs_luks_uuid (g, device);
      if (r == NULL)
        croak ("%s", guestfs_last_error (g));
      RETVAL = newSVpv (r, 0);
      free (r);
#line 17501 "lib/Sys/Guestfs.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Guestfs_lvcreate); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_lvcreate)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "g, logvol, volgroup, mbytes");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	logvol = (char *)SvPV_nolen(ST(1))
;
	char *	volgroup = (char *)SvPV_nolen(ST(2))
;
	int	mbytes = (int)SvIV(ST(3))
;
#line 7269 "lib/Sys/Guestfs.xs"
      int r;
#line 17527 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::lvcreate(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::lvcreate(): g is not a blessed HV reference");
    }
;
#line 7271 "lib/Sys/Guestfs.xs"
      r = guestfs_lvcreate (g, logvol, volgroup, mbytes);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 17545 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_lvcreate_free); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_lvcreate_free)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "g, logvol, volgroup, percent");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	logvol = (char *)SvPV_nolen(ST(1))
;
	char *	volgroup = (char *)SvPV_nolen(ST(2))
;
	int	percent = (int)SvIV(ST(3))
;
#line 7282 "lib/Sys/Guestfs.xs"
      int r;
#line 17570 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::lvcreate_free(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::lvcreate_free(): g is not a blessed HV reference");
    }
;
#line 7284 "lib/Sys/Guestfs.xs"
      r = guestfs_lvcreate_free (g, logvol, volgroup, percent);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 17588 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_lvm_canonical_lv_name); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_lvm_canonical_lv_name)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, lvname");
    {
	guestfs_h *	g;
	char *	lvname = (char *)SvPV_nolen(ST(1))
;
#line 7293 "lib/Sys/Guestfs.xs"
      char *r;
#line 17607 "lib/Sys/Guestfs.c"
	SV *	RETVAL;

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::lvm_canonical_lv_name(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::lvm_canonical_lv_name(): g is not a blessed HV reference");
    }
;
#line 7295 "lib/Sys/Guestfs.xs"
      r = guestfs_lvm_canonical_lv_name (g, lvname);
      if (r == NULL)
        croak ("%s", guestfs_last_error (g));
      RETVAL = newSVpv (r, 0);
      free (r);
#line 17628 "lib/Sys/Guestfs.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Guestfs_lvm_clear_filter); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_lvm_clear_filter)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "g");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
#line 7307 "lib/Sys/Guestfs.xs"
      int r;
#line 17648 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::lvm_clear_filter(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::lvm_clear_filter(): g is not a blessed HV reference");
    }
;
#line 7309 "lib/Sys/Guestfs.xs"
      r = guestfs_lvm_clear_filter (g);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 17666 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_lvm_remove_all); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_lvm_remove_all)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "g");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
#line 7317 "lib/Sys/Guestfs.xs"
      int r;
#line 17685 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::lvm_remove_all(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::lvm_remove_all(): g is not a blessed HV reference");
    }
;
#line 7319 "lib/Sys/Guestfs.xs"
      r = guestfs_lvm_remove_all (g);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 17703 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_lvm_scan); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_lvm_scan)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, activate");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	int	activate = (int)SvIV(ST(1))
;
#line 7328 "lib/Sys/Guestfs.xs"
      int r;
#line 17724 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::lvm_scan(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::lvm_scan(): g is not a blessed HV reference");
    }
;
#line 7330 "lib/Sys/Guestfs.xs"
      r = guestfs_lvm_scan (g, activate);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 17742 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_lvm_set_filter); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_lvm_set_filter)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, devices");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char **	devices = XS_unpack_charPtrPtr(ST(1))
;
#line 7339 "lib/Sys/Guestfs.xs"
      int r;
#line 17763 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::lvm_set_filter(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::lvm_set_filter(): g is not a blessed HV reference");
    }
;
#line 7341 "lib/Sys/Guestfs.xs"
      r = guestfs_lvm_set_filter (g, devices);
      free (devices);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 17782 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_lvremove); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_lvremove)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, device");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	device = (char *)SvPV_nolen(ST(1))
;
#line 7351 "lib/Sys/Guestfs.xs"
      int r;
#line 17803 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::lvremove(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::lvremove(): g is not a blessed HV reference");
    }
;
#line 7353 "lib/Sys/Guestfs.xs"
      r = guestfs_lvremove (g, device);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 17821 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_lvrename); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_lvrename)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "g, logvol, newlogvol");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	logvol = (char *)SvPV_nolen(ST(1))
;
	char *	newlogvol = (char *)SvPV_nolen(ST(2))
;
#line 7363 "lib/Sys/Guestfs.xs"
      int r;
#line 17844 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::lvrename(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::lvrename(): g is not a blessed HV reference");
    }
;
#line 7365 "lib/Sys/Guestfs.xs"
      r = guestfs_lvrename (g, logvol, newlogvol);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 17862 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_lvresize); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_lvresize)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "g, device, mbytes");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	device = (char *)SvPV_nolen(ST(1))
;
	int	mbytes = (int)SvIV(ST(2))
;
#line 7375 "lib/Sys/Guestfs.xs"
      int r;
#line 17885 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::lvresize(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::lvresize(): g is not a blessed HV reference");
    }
;
#line 7377 "lib/Sys/Guestfs.xs"
      r = guestfs_lvresize (g, device, mbytes);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 17903 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_lvresize_free); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_lvresize_free)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "g, lv, percent");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	lv = (char *)SvPV_nolen(ST(1))
;
	int	percent = (int)SvIV(ST(2))
;
#line 7387 "lib/Sys/Guestfs.xs"
      int r;
#line 17926 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::lvresize_free(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::lvresize_free(): g is not a blessed HV reference");
    }
;
#line 7389 "lib/Sys/Guestfs.xs"
      r = guestfs_lvresize_free (g, lv, percent);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 17944 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_lvs); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_lvs)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "g");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
#line 7397 "lib/Sys/Guestfs.xs"
      char **r;
      size_t i, n;
#line 17964 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::lvs(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::lvs(): g is not a blessed HV reference");
    }
;
#line 7400 "lib/Sys/Guestfs.xs"
      r = guestfs_lvs (g);
      if (r == NULL)
        croak ("%s", guestfs_last_error (g));
      for (n = 0; r[n] != NULL; ++n) /**/;
      EXTEND (SP, n);
      for (i = 0; i < n; ++i) {
        PUSHs (sv_2mortal (newSVpv (r[i], 0)));
        free (r[i]);
      }
      free (r);
#line 17989 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_lvs_full); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_lvs_full)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "g");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
#line 7415 "lib/Sys/Guestfs.xs"
      struct guestfs_lvm_lv_list *r;
      size_t i;
      HV *hv;
#line 18010 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::lvs_full(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::lvs_full(): g is not a blessed HV reference");
    }
;
#line 7419 "lib/Sys/Guestfs.xs"
      r = guestfs_lvs_full (g);
      if (r == NULL)
        croak ("%s", guestfs_last_error (g));
      EXTEND (SP, r->len);
      for (i = 0; i < r->len; ++i) {
        hv = newHV ();
        (void) hv_store (hv, "lv_name", 7, newSVpv (r->val[i].lv_name, 0), 0);
        (void) hv_store (hv, "lv_uuid", 7, newSVpv (r->val[i].lv_uuid, 32), 0);
        (void) hv_store (hv, "lv_attr", 7, newSVpv (r->val[i].lv_attr, 0), 0);
        (void) hv_store (hv, "lv_major", 8, my_newSVll (r->val[i].lv_major), 0);
        (void) hv_store (hv, "lv_minor", 8, my_newSVll (r->val[i].lv_minor), 0);
        (void) hv_store (hv, "lv_kernel_major", 15, my_newSVll (r->val[i].lv_kernel_major), 0);
        (void) hv_store (hv, "lv_kernel_minor", 15, my_newSVll (r->val[i].lv_kernel_minor), 0);
        (void) hv_store (hv, "lv_size", 7, my_newSVull (r->val[i].lv_size), 0);
        (void) hv_store (hv, "seg_count", 9, my_newSVll (r->val[i].seg_count), 0);
        (void) hv_store (hv, "origin", 6, newSVpv (r->val[i].origin, 0), 0);
        (void) hv_store (hv, "snap_percent", 12, newSVnv (r->val[i].snap_percent), 0);
        (void) hv_store (hv, "copy_percent", 12, newSVnv (r->val[i].copy_percent), 0);
        (void) hv_store (hv, "move_pv", 7, newSVpv (r->val[i].move_pv, 0), 0);
        (void) hv_store (hv, "lv_tags", 7, newSVpv (r->val[i].lv_tags, 0), 0);
        (void) hv_store (hv, "mirror_log", 10, newSVpv (r->val[i].mirror_log, 0), 0);
        (void) hv_store (hv, "modules", 7, newSVpv (r->val[i].modules, 0), 0);
        PUSHs (sv_2mortal (newRV ((SV *) hv)));
      }
      guestfs_free_lvm_lv_list (r);
#line 18050 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_lvuuid); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_lvuuid)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, device");
    {
	guestfs_h *	g;
	char *	device = (char *)SvPV_nolen(ST(1))
;
#line 7450 "lib/Sys/Guestfs.xs"
      char *r;
#line 18069 "lib/Sys/Guestfs.c"
	SV *	RETVAL;

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::lvuuid(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::lvuuid(): g is not a blessed HV reference");
    }
;
#line 7452 "lib/Sys/Guestfs.xs"
      r = guestfs_lvuuid (g, device);
      if (r == NULL)
        croak ("%s", guestfs_last_error (g));
      RETVAL = newSVpv (r, 0);
      free (r);
#line 18090 "lib/Sys/Guestfs.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Guestfs_lxattrlist); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_lxattrlist)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "g, path, names");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	path = (char *)SvPV_nolen(ST(1))
;
	char **	names = XS_unpack_charPtrPtr(ST(2))
;
#line 7466 "lib/Sys/Guestfs.xs"
      struct guestfs_xattr_list *r;
      size_t i;
      HV *hv;
#line 18116 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::lxattrlist(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::lxattrlist(): g is not a blessed HV reference");
    }
;
#line 7470 "lib/Sys/Guestfs.xs"
      r = guestfs_lxattrlist (g, path, names);
      free (names);
      if (r == NULL)
        croak ("%s", guestfs_last_error (g));
      EXTEND (SP, r->len);
      for (i = 0; i < r->len; ++i) {
        hv = newHV ();
        (void) hv_store (hv, "attrname", 8, newSVpv (r->val[i].attrname, 0), 0);
        (void) hv_store (hv, "attrval", 7, newSVpvn (r->val[i].attrval, r->val[i].attrval_len), 0);
        PUSHs (sv_2mortal (newRV ((SV *) hv)));
      }
      guestfs_free_xattr_list (r);
#line 18143 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_max_disks); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_max_disks)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "g");
    {
	guestfs_h *	g;
#line 7487 "lib/Sys/Guestfs.xs"
      int r;
#line 18160 "lib/Sys/Guestfs.c"
	SV *	RETVAL;

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::max_disks(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::max_disks(): g is not a blessed HV reference");
    }
;
#line 7489 "lib/Sys/Guestfs.xs"
      r = guestfs_max_disks (g);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
      RETVAL = newSViv (r);
#line 18180 "lib/Sys/Guestfs.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Guestfs_md_create); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_md_create)
{
    dVAR; dXSARGS;
    if (items < 3)
       croak_xs_usage(cv,  "g, name, devices, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	name = (char *)SvPV_nolen(ST(1))
;
	char **	devices = XS_unpack_charPtrPtr(ST(2))
;
#line 7502 "lib/Sys/Guestfs.xs"
      int r;
      struct guestfs_md_create_argv optargs_s = { .bitmask = 0 };
      struct guestfs_md_create_argv *optargs = &optargs_s;
      size_t items_i;
#line 18207 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::md_create(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::md_create(): g is not a blessed HV reference");
    }
;
#line 7507 "lib/Sys/Guestfs.xs"
      if (((items - 3) & 1) != 0)
        croak ("expecting an even number of extra parameters");
      for (items_i = 3; items_i < items; items_i += 2) {
        uint64_t this_mask;
        const char *this_arg;

        this_arg = SvPV_nolen (ST (items_i));
        if (STREQ (this_arg, "missingbitmap")) {
          optargs_s.missingbitmap = my_SvIV64 (ST (items_i+1));
          this_mask = GUESTFS_MD_CREATE_MISSINGBITMAP_BITMASK;
        }
        else if (STREQ (this_arg, "nrdevices")) {
          optargs_s.nrdevices = SvIV (ST (items_i+1));
          this_mask = GUESTFS_MD_CREATE_NRDEVICES_BITMASK;
        }
        else if (STREQ (this_arg, "spare")) {
          optargs_s.spare = SvIV (ST (items_i+1));
          this_mask = GUESTFS_MD_CREATE_SPARE_BITMASK;
        }
        else if (STREQ (this_arg, "chunk")) {
          optargs_s.chunk = my_SvIV64 (ST (items_i+1));
          this_mask = GUESTFS_MD_CREATE_CHUNK_BITMASK;
        }
        else if (STREQ (this_arg, "level")) {
          optargs_s.level = SvPV_nolen (ST (items_i+1));
          this_mask = GUESTFS_MD_CREATE_LEVEL_BITMASK;
        }
        else croak ("unknown optional argument '%s'", this_arg);
        if (optargs_s.bitmask & this_mask)
          croak ("optional argument '%s' given more than once",
                 this_arg);
        optargs_s.bitmask |= this_mask;
      }

      r = guestfs_md_create_argv (g, name, devices, optargs);
      free (devices);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 18260 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_md_detail); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_md_detail)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, md");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	md = (char *)SvPV_nolen(ST(1))
;
#line 7551 "lib/Sys/Guestfs.xs"
      char **r;
      size_t i, n;
#line 18282 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::md_detail(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::md_detail(): g is not a blessed HV reference");
    }
;
#line 7554 "lib/Sys/Guestfs.xs"
      r = guestfs_md_detail (g, md);
      if (r == NULL)
        croak ("%s", guestfs_last_error (g));
      for (n = 0; r[n] != NULL; ++n) /**/;
      EXTEND (SP, n);
      for (i = 0; i < n; ++i) {
        PUSHs (sv_2mortal (newSVpv (r[i], 0)));
        free (r[i]);
      }
      free (r);
#line 18307 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_md_stat); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_md_stat)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, md");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	md = (char *)SvPV_nolen(ST(1))
;
#line 7570 "lib/Sys/Guestfs.xs"
      struct guestfs_mdstat_list *r;
      size_t i;
      HV *hv;
#line 18330 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::md_stat(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::md_stat(): g is not a blessed HV reference");
    }
;
#line 7574 "lib/Sys/Guestfs.xs"
      r = guestfs_md_stat (g, md);
      if (r == NULL)
        croak ("%s", guestfs_last_error (g));
      EXTEND (SP, r->len);
      for (i = 0; i < r->len; ++i) {
        hv = newHV ();
        (void) hv_store (hv, "mdstat_device", 13, newSVpv (r->val[i].mdstat_device, 0), 0);
        (void) hv_store (hv, "mdstat_index", 12, newSVnv (r->val[i].mdstat_index), 0);
        (void) hv_store (hv, "mdstat_flags", 12, newSVpv (r->val[i].mdstat_flags, 0), 0);
        PUSHs (sv_2mortal (newRV ((SV *) hv)));
      }
      guestfs_free_mdstat_list (r);
#line 18357 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_md_stop); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_md_stop)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, md");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	md = (char *)SvPV_nolen(ST(1))
;
#line 7592 "lib/Sys/Guestfs.xs"
      int r;
#line 18378 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::md_stop(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::md_stop(): g is not a blessed HV reference");
    }
;
#line 7594 "lib/Sys/Guestfs.xs"
      r = guestfs_md_stop (g, md);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 18396 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_mkdir); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_mkdir)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, path");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	path = (char *)SvPV_nolen(ST(1))
;
#line 7603 "lib/Sys/Guestfs.xs"
      int r;
#line 18417 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::mkdir(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::mkdir(): g is not a blessed HV reference");
    }
;
#line 7605 "lib/Sys/Guestfs.xs"
      r = guestfs_mkdir (g, path);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 18435 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_mkdir_mode); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_mkdir_mode)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "g, path, mode");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	path = (char *)SvPV_nolen(ST(1))
;
	int	mode = (int)SvIV(ST(2))
;
#line 7615 "lib/Sys/Guestfs.xs"
      int r;
#line 18458 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::mkdir_mode(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::mkdir_mode(): g is not a blessed HV reference");
    }
;
#line 7617 "lib/Sys/Guestfs.xs"
      r = guestfs_mkdir_mode (g, path, mode);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 18476 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_mkdir_p); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_mkdir_p)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, path");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	path = (char *)SvPV_nolen(ST(1))
;
#line 7626 "lib/Sys/Guestfs.xs"
      int r;
#line 18497 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::mkdir_p(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::mkdir_p(): g is not a blessed HV reference");
    }
;
#line 7628 "lib/Sys/Guestfs.xs"
      r = guestfs_mkdir_p (g, path);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 18515 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_mkdtemp); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_mkdtemp)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, tmpl");
    {
	guestfs_h *	g;
	char *	tmpl = (char *)SvPV_nolen(ST(1))
;
#line 7637 "lib/Sys/Guestfs.xs"
      char *r;
#line 18534 "lib/Sys/Guestfs.c"
	SV *	RETVAL;

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::mkdtemp(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::mkdtemp(): g is not a blessed HV reference");
    }
;
#line 7639 "lib/Sys/Guestfs.xs"
      r = guestfs_mkdtemp (g, tmpl);
      if (r == NULL)
        croak ("%s", guestfs_last_error (g));
      RETVAL = newSVpv (r, 0);
      free (r);
#line 18555 "lib/Sys/Guestfs.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Guestfs_mke2fs); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_mke2fs)
{
    dVAR; dXSARGS;
    if (items < 2)
       croak_xs_usage(cv,  "g, device, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	device = (char *)SvPV_nolen(ST(1))
;
#line 7652 "lib/Sys/Guestfs.xs"
      int r;
      struct guestfs_mke2fs_argv optargs_s = { .bitmask = 0 };
      struct guestfs_mke2fs_argv *optargs = &optargs_s;
      size_t items_i;
#line 18580 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::mke2fs(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::mke2fs(): g is not a blessed HV reference");
    }
;
#line 7657 "lib/Sys/Guestfs.xs"
      if (((items - 2) & 1) != 0)
        croak ("expecting an even number of extra parameters");
      for (items_i = 2; items_i < items; items_i += 2) {
        uint64_t this_mask;
        const char *this_arg;

        this_arg = SvPV_nolen (ST (items_i));
        if (STREQ (this_arg, "blockscount")) {
          optargs_s.blockscount = my_SvIV64 (ST (items_i+1));
          this_mask = GUESTFS_MKE2FS_BLOCKSCOUNT_BITMASK;
        }
        else if (STREQ (this_arg, "blocksize")) {
          optargs_s.blocksize = my_SvIV64 (ST (items_i+1));
          this_mask = GUESTFS_MKE2FS_BLOCKSIZE_BITMASK;
        }
        else if (STREQ (this_arg, "fragsize")) {
          optargs_s.fragsize = my_SvIV64 (ST (items_i+1));
          this_mask = GUESTFS_MKE2FS_FRAGSIZE_BITMASK;
        }
        else if (STREQ (this_arg, "blockspergroup")) {
          optargs_s.blockspergroup = my_SvIV64 (ST (items_i+1));
          this_mask = GUESTFS_MKE2FS_BLOCKSPERGROUP_BITMASK;
        }
        else if (STREQ (this_arg, "numberofgroups")) {
          optargs_s.numberofgroups = my_SvIV64 (ST (items_i+1));
          this_mask = GUESTFS_MKE2FS_NUMBEROFGROUPS_BITMASK;
        }
        else if (STREQ (this_arg, "bytesperinode")) {
          optargs_s.bytesperinode = my_SvIV64 (ST (items_i+1));
          this_mask = GUESTFS_MKE2FS_BYTESPERINODE_BITMASK;
        }
        else if (STREQ (this_arg, "inodesize")) {
          optargs_s.inodesize = my_SvIV64 (ST (items_i+1));
          this_mask = GUESTFS_MKE2FS_INODESIZE_BITMASK;
        }
        else if (STREQ (this_arg, "journalsize")) {
          optargs_s.journalsize = my_SvIV64 (ST (items_i+1));
          this_mask = GUESTFS_MKE2FS_JOURNALSIZE_BITMASK;
        }
        else if (STREQ (this_arg, "numberofinodes")) {
          optargs_s.numberofinodes = my_SvIV64 (ST (items_i+1));
          this_mask = GUESTFS_MKE2FS_NUMBEROFINODES_BITMASK;
        }
        else if (STREQ (this_arg, "stridesize")) {
          optargs_s.stridesize = my_SvIV64 (ST (items_i+1));
          this_mask = GUESTFS_MKE2FS_STRIDESIZE_BITMASK;
        }
        else if (STREQ (this_arg, "stripewidth")) {
          optargs_s.stripewidth = my_SvIV64 (ST (items_i+1));
          this_mask = GUESTFS_MKE2FS_STRIPEWIDTH_BITMASK;
        }
        else if (STREQ (this_arg, "maxonlineresize")) {
          optargs_s.maxonlineresize = my_SvIV64 (ST (items_i+1));
          this_mask = GUESTFS_MKE2FS_MAXONLINERESIZE_BITMASK;
        }
        else if (STREQ (this_arg, "reservedblockspercentage")) {
          optargs_s.reservedblockspercentage = SvIV (ST (items_i+1));
          this_mask = GUESTFS_MKE2FS_RESERVEDBLOCKSPERCENTAGE_BITMASK;
        }
        else if (STREQ (this_arg, "mmpupdateinterval")) {
          optargs_s.mmpupdateinterval = SvIV (ST (items_i+1));
          this_mask = GUESTFS_MKE2FS_MMPUPDATEINTERVAL_BITMASK;
        }
        else if (STREQ (this_arg, "journaldevice")) {
          optargs_s.journaldevice = SvPV_nolen (ST (items_i+1));
          this_mask = GUESTFS_MKE2FS_JOURNALDEVICE_BITMASK;
        }
        else if (STREQ (this_arg, "label")) {
          optargs_s.label = SvPV_nolen (ST (items_i+1));
          this_mask = GUESTFS_MKE2FS_LABEL_BITMASK;
        }
        else if (STREQ (this_arg, "lastmounteddir")) {
          optargs_s.lastmounteddir = SvPV_nolen (ST (items_i+1));
          this_mask = GUESTFS_MKE2FS_LASTMOUNTEDDIR_BITMASK;
        }
        else if (STREQ (this_arg, "creatoros")) {
          optargs_s.creatoros = SvPV_nolen (ST (items_i+1));
          this_mask = GUESTFS_MKE2FS_CREATOROS_BITMASK;
        }
        else if (STREQ (this_arg, "fstype")) {
          optargs_s.fstype = SvPV_nolen (ST (items_i+1));
          this_mask = GUESTFS_MKE2FS_FSTYPE_BITMASK;
        }
        else if (STREQ (this_arg, "usagetype")) {
          optargs_s.usagetype = SvPV_nolen (ST (items_i+1));
          this_mask = GUESTFS_MKE2FS_USAGETYPE_BITMASK;
        }
        else if (STREQ (this_arg, "uuid")) {
          optargs_s.uuid = SvPV_nolen (ST (items_i+1));
          this_mask = GUESTFS_MKE2FS_UUID_BITMASK;
        }
        else if (STREQ (this_arg, "forcecreate")) {
          optargs_s.forcecreate = SvIV (ST (items_i+1));
          this_mask = GUESTFS_MKE2FS_FORCECREATE_BITMASK;
        }
        else if (STREQ (this_arg, "writesbandgrouponly")) {
          optargs_s.writesbandgrouponly = SvIV (ST (items_i+1));
          this_mask = GUESTFS_MKE2FS_WRITESBANDGROUPONLY_BITMASK;
        }
        else if (STREQ (this_arg, "lazyitableinit")) {
          optargs_s.lazyitableinit = SvIV (ST (items_i+1));
          this_mask = GUESTFS_MKE2FS_LAZYITABLEINIT_BITMASK;
        }
        else if (STREQ (this_arg, "lazyjournalinit")) {
          optargs_s.lazyjournalinit = SvIV (ST (items_i+1));
          this_mask = GUESTFS_MKE2FS_LAZYJOURNALINIT_BITMASK;
        }
        else if (STREQ (this_arg, "testfs")) {
          optargs_s.testfs = SvIV (ST (items_i+1));
          this_mask = GUESTFS_MKE2FS_TESTFS_BITMASK;
        }
        else if (STREQ (this_arg, "discard")) {
          optargs_s.discard = SvIV (ST (items_i+1));
          this_mask = GUESTFS_MKE2FS_DISCARD_BITMASK;
        }
        else if (STREQ (this_arg, "quotatype")) {
          optargs_s.quotatype = SvIV (ST (items_i+1));
          this_mask = GUESTFS_MKE2FS_QUOTATYPE_BITMASK;
        }
        else if (STREQ (this_arg, "extent")) {
          optargs_s.extent = SvIV (ST (items_i+1));
          this_mask = GUESTFS_MKE2FS_EXTENT_BITMASK;
        }
        else if (STREQ (this_arg, "filetype")) {
          optargs_s.filetype = SvIV (ST (items_i+1));
          this_mask = GUESTFS_MKE2FS_FILETYPE_BITMASK;
        }
        else if (STREQ (this_arg, "flexbg")) {
          optargs_s.flexbg = SvIV (ST (items_i+1));
          this_mask = GUESTFS_MKE2FS_FLEXBG_BITMASK;
        }
        else if (STREQ (this_arg, "hasjournal")) {
          optargs_s.hasjournal = SvIV (ST (items_i+1));
          this_mask = GUESTFS_MKE2FS_HASJOURNAL_BITMASK;
        }
        else if (STREQ (this_arg, "journaldev")) {
          optargs_s.journaldev = SvIV (ST (items_i+1));
          this_mask = GUESTFS_MKE2FS_JOURNALDEV_BITMASK;
        }
        else if (STREQ (this_arg, "largefile")) {
          optargs_s.largefile = SvIV (ST (items_i+1));
          this_mask = GUESTFS_MKE2FS_LARGEFILE_BITMASK;
        }
        else if (STREQ (this_arg, "quota")) {
          optargs_s.quota = SvIV (ST (items_i+1));
          this_mask = GUESTFS_MKE2FS_QUOTA_BITMASK;
        }
        else if (STREQ (this_arg, "resizeinode")) {
          optargs_s.resizeinode = SvIV (ST (items_i+1));
          this_mask = GUESTFS_MKE2FS_RESIZEINODE_BITMASK;
        }
        else if (STREQ (this_arg, "sparsesuper")) {
          optargs_s.sparsesuper = SvIV (ST (items_i+1));
          this_mask = GUESTFS_MKE2FS_SPARSESUPER_BITMASK;
        }
        else if (STREQ (this_arg, "uninitbg")) {
          optargs_s.uninitbg = SvIV (ST (items_i+1));
          this_mask = GUESTFS_MKE2FS_UNINITBG_BITMASK;
        }
        else croak ("unknown optional argument '%s'", this_arg);
        if (optargs_s.bitmask & this_mask)
          croak ("optional argument '%s' given more than once",
                 this_arg);
        optargs_s.bitmask |= this_mask;
      }

      r = guestfs_mke2fs_argv (g, device, optargs);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 18764 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_mke2fs_J); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_mke2fs_J)
{
    dVAR; dXSARGS;
    if (items != 5)
       croak_xs_usage(cv,  "g, fstype, blocksize, device, journal");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	fstype = (char *)SvPV_nolen(ST(1))
;
	int	blocksize = (int)SvIV(ST(2))
;
	char *	device = (char *)SvPV_nolen(ST(3))
;
	char *	journal = (char *)SvPV_nolen(ST(4))
;
#line 7835 "lib/Sys/Guestfs.xs"
      int r;
#line 18791 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::mke2fs_J(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::mke2fs_J(): g is not a blessed HV reference");
    }
;
#line 7837 "lib/Sys/Guestfs.xs"
      Perl_ck_warner (aTHX_ packWARN(WARN_DEPRECATED),
        "Sys::Guestfs::mke2fs_J is deprecated; use Sys::Guestfs::mke2fs instead");
      r = guestfs_mke2fs_J (g, fstype, blocksize, device, journal);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 18811 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_mke2fs_JL); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_mke2fs_JL)
{
    dVAR; dXSARGS;
    if (items != 5)
       croak_xs_usage(cv,  "g, fstype, blocksize, device, label");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	fstype = (char *)SvPV_nolen(ST(1))
;
	int	blocksize = (int)SvIV(ST(2))
;
	char *	device = (char *)SvPV_nolen(ST(3))
;
	char *	label = (char *)SvPV_nolen(ST(4))
;
#line 7851 "lib/Sys/Guestfs.xs"
      int r;
#line 18838 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::mke2fs_JL(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::mke2fs_JL(): g is not a blessed HV reference");
    }
;
#line 7853 "lib/Sys/Guestfs.xs"
      Perl_ck_warner (aTHX_ packWARN(WARN_DEPRECATED),
        "Sys::Guestfs::mke2fs_JL is deprecated; use Sys::Guestfs::mke2fs instead");
      r = guestfs_mke2fs_JL (g, fstype, blocksize, device, label);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 18858 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_mke2fs_JU); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_mke2fs_JU)
{
    dVAR; dXSARGS;
    if (items != 5)
       croak_xs_usage(cv,  "g, fstype, blocksize, device, uuid");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	fstype = (char *)SvPV_nolen(ST(1))
;
	int	blocksize = (int)SvIV(ST(2))
;
	char *	device = (char *)SvPV_nolen(ST(3))
;
	char *	uuid = (char *)SvPV_nolen(ST(4))
;
#line 7867 "lib/Sys/Guestfs.xs"
      int r;
#line 18885 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::mke2fs_JU(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::mke2fs_JU(): g is not a blessed HV reference");
    }
;
#line 7869 "lib/Sys/Guestfs.xs"
      Perl_ck_warner (aTHX_ packWARN(WARN_DEPRECATED),
        "Sys::Guestfs::mke2fs_JU is deprecated; use Sys::Guestfs::mke2fs instead");
      r = guestfs_mke2fs_JU (g, fstype, blocksize, device, uuid);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 18905 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_mke2journal); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_mke2journal)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "g, blocksize, device");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	int	blocksize = (int)SvIV(ST(1))
;
	char *	device = (char *)SvPV_nolen(ST(2))
;
#line 7881 "lib/Sys/Guestfs.xs"
      int r;
#line 18928 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::mke2journal(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::mke2journal(): g is not a blessed HV reference");
    }
;
#line 7883 "lib/Sys/Guestfs.xs"
      Perl_ck_warner (aTHX_ packWARN(WARN_DEPRECATED),
        "Sys::Guestfs::mke2journal is deprecated; use Sys::Guestfs::mke2fs instead");
      r = guestfs_mke2journal (g, blocksize, device);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 18948 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_mke2journal_L); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_mke2journal_L)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "g, blocksize, label, device");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	int	blocksize = (int)SvIV(ST(1))
;
	char *	label = (char *)SvPV_nolen(ST(2))
;
	char *	device = (char *)SvPV_nolen(ST(3))
;
#line 7896 "lib/Sys/Guestfs.xs"
      int r;
#line 18973 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::mke2journal_L(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::mke2journal_L(): g is not a blessed HV reference");
    }
;
#line 7898 "lib/Sys/Guestfs.xs"
      Perl_ck_warner (aTHX_ packWARN(WARN_DEPRECATED),
        "Sys::Guestfs::mke2journal_L is deprecated; use Sys::Guestfs::mke2fs instead");
      r = guestfs_mke2journal_L (g, blocksize, label, device);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 18993 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_mke2journal_U); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_mke2journal_U)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "g, blocksize, uuid, device");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	int	blocksize = (int)SvIV(ST(1))
;
	char *	uuid = (char *)SvPV_nolen(ST(2))
;
	char *	device = (char *)SvPV_nolen(ST(3))
;
#line 7911 "lib/Sys/Guestfs.xs"
      int r;
#line 19018 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::mke2journal_U(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::mke2journal_U(): g is not a blessed HV reference");
    }
;
#line 7913 "lib/Sys/Guestfs.xs"
      Perl_ck_warner (aTHX_ packWARN(WARN_DEPRECATED),
        "Sys::Guestfs::mke2journal_U is deprecated; use Sys::Guestfs::mke2fs instead");
      r = guestfs_mke2journal_U (g, blocksize, uuid, device);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 19038 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_mkfifo); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_mkfifo)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "g, mode, path");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	int	mode = (int)SvIV(ST(1))
;
	char *	path = (char *)SvPV_nolen(ST(2))
;
#line 7925 "lib/Sys/Guestfs.xs"
      int r;
#line 19061 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::mkfifo(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::mkfifo(): g is not a blessed HV reference");
    }
;
#line 7927 "lib/Sys/Guestfs.xs"
      r = guestfs_mkfifo (g, mode, path);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 19079 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_mkfs); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_mkfs)
{
    dVAR; dXSARGS;
    if (items < 3)
       croak_xs_usage(cv,  "g, fstype, device, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	fstype = (char *)SvPV_nolen(ST(1))
;
	char *	device = (char *)SvPV_nolen(ST(2))
;
#line 7937 "lib/Sys/Guestfs.xs"
      int r;
      struct guestfs_mkfs_opts_argv optargs_s = { .bitmask = 0 };
      struct guestfs_mkfs_opts_argv *optargs = &optargs_s;
      size_t items_i;
#line 19105 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::mkfs(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::mkfs(): g is not a blessed HV reference");
    }
;
#line 7942 "lib/Sys/Guestfs.xs"
      if (((items - 3) & 1) != 0)
        croak ("expecting an even number of extra parameters");
      for (items_i = 3; items_i < items; items_i += 2) {
        uint64_t this_mask;
        const char *this_arg;

        this_arg = SvPV_nolen (ST (items_i));
        if (STREQ (this_arg, "blocksize")) {
          optargs_s.blocksize = SvIV (ST (items_i+1));
          this_mask = GUESTFS_MKFS_OPTS_BLOCKSIZE_BITMASK;
        }
        else if (STREQ (this_arg, "features")) {
          optargs_s.features = SvPV_nolen (ST (items_i+1));
          this_mask = GUESTFS_MKFS_OPTS_FEATURES_BITMASK;
        }
        else if (STREQ (this_arg, "inode")) {
          optargs_s.inode = SvIV (ST (items_i+1));
          this_mask = GUESTFS_MKFS_OPTS_INODE_BITMASK;
        }
        else if (STREQ (this_arg, "sectorsize")) {
          optargs_s.sectorsize = SvIV (ST (items_i+1));
          this_mask = GUESTFS_MKFS_OPTS_SECTORSIZE_BITMASK;
        }
        else if (STREQ (this_arg, "label")) {
          optargs_s.label = SvPV_nolen (ST (items_i+1));
          this_mask = GUESTFS_MKFS_OPTS_LABEL_BITMASK;
        }
        else croak ("unknown optional argument '%s'", this_arg);
        if (optargs_s.bitmask & this_mask)
          croak ("optional argument '%s' given more than once",
                 this_arg);
        optargs_s.bitmask |= this_mask;
      }

      r = guestfs_mkfs_opts_argv (g, fstype, device, optargs);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 19157 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_mkfs_b); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_mkfs_b)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "g, fstype, blocksize, device");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	fstype = (char *)SvPV_nolen(ST(1))
;
	int	blocksize = (int)SvIV(ST(2))
;
	char *	device = (char *)SvPV_nolen(ST(3))
;
#line 7987 "lib/Sys/Guestfs.xs"
      int r;
#line 19182 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::mkfs_b(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::mkfs_b(): g is not a blessed HV reference");
    }
;
#line 7989 "lib/Sys/Guestfs.xs"
      Perl_ck_warner (aTHX_ packWARN(WARN_DEPRECATED),
        "Sys::Guestfs::mkfs_b is deprecated; use Sys::Guestfs::mkfs instead");
      r = guestfs_mkfs_b (g, fstype, blocksize, device);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 19202 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_mkfs_btrfs); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_mkfs_btrfs)
{
    dVAR; dXSARGS;
    if (items < 2)
       croak_xs_usage(cv,  "g, devices, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char **	devices = XS_unpack_charPtrPtr(ST(1))
;
#line 8000 "lib/Sys/Guestfs.xs"
      int r;
      struct guestfs_mkfs_btrfs_argv optargs_s = { .bitmask = 0 };
      struct guestfs_mkfs_btrfs_argv *optargs = &optargs_s;
      size_t items_i;
#line 19226 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::mkfs_btrfs(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::mkfs_btrfs(): g is not a blessed HV reference");
    }
;
#line 8005 "lib/Sys/Guestfs.xs"
      if (((items - 2) & 1) != 0)
        croak ("expecting an even number of extra parameters");
      for (items_i = 2; items_i < items; items_i += 2) {
        uint64_t this_mask;
        const char *this_arg;

        this_arg = SvPV_nolen (ST (items_i));
        if (STREQ (this_arg, "allocstart")) {
          optargs_s.allocstart = my_SvIV64 (ST (items_i+1));
          this_mask = GUESTFS_MKFS_BTRFS_ALLOCSTART_BITMASK;
        }
        else if (STREQ (this_arg, "bytecount")) {
          optargs_s.bytecount = my_SvIV64 (ST (items_i+1));
          this_mask = GUESTFS_MKFS_BTRFS_BYTECOUNT_BITMASK;
        }
        else if (STREQ (this_arg, "datatype")) {
          optargs_s.datatype = SvPV_nolen (ST (items_i+1));
          this_mask = GUESTFS_MKFS_BTRFS_DATATYPE_BITMASK;
        }
        else if (STREQ (this_arg, "leafsize")) {
          optargs_s.leafsize = SvIV (ST (items_i+1));
          this_mask = GUESTFS_MKFS_BTRFS_LEAFSIZE_BITMASK;
        }
        else if (STREQ (this_arg, "label")) {
          optargs_s.label = SvPV_nolen (ST (items_i+1));
          this_mask = GUESTFS_MKFS_BTRFS_LABEL_BITMASK;
        }
        else if (STREQ (this_arg, "metadata")) {
          optargs_s.metadata = SvPV_nolen (ST (items_i+1));
          this_mask = GUESTFS_MKFS_BTRFS_METADATA_BITMASK;
        }
        else if (STREQ (this_arg, "nodesize")) {
          optargs_s.nodesize = SvIV (ST (items_i+1));
          this_mask = GUESTFS_MKFS_BTRFS_NODESIZE_BITMASK;
        }
        else if (STREQ (this_arg, "sectorsize")) {
          optargs_s.sectorsize = SvIV (ST (items_i+1));
          this_mask = GUESTFS_MKFS_BTRFS_SECTORSIZE_BITMASK;
        }
        else croak ("unknown optional argument '%s'", this_arg);
        if (optargs_s.bitmask & this_mask)
          croak ("optional argument '%s' given more than once",
                 this_arg);
        optargs_s.bitmask |= this_mask;
      }

      r = guestfs_mkfs_btrfs_argv (g, devices, optargs);
      free (devices);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 19291 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_mklost_and_found); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_mklost_and_found)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, mountpoint");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	mountpoint = (char *)SvPV_nolen(ST(1))
;
#line 8061 "lib/Sys/Guestfs.xs"
      int r;
#line 19312 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::mklost_and_found(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::mklost_and_found(): g is not a blessed HV reference");
    }
;
#line 8063 "lib/Sys/Guestfs.xs"
      r = guestfs_mklost_and_found (g, mountpoint);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 19330 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_mkmountpoint); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_mkmountpoint)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, exemptpath");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	exemptpath = (char *)SvPV_nolen(ST(1))
;
#line 8072 "lib/Sys/Guestfs.xs"
      int r;
#line 19351 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::mkmountpoint(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::mkmountpoint(): g is not a blessed HV reference");
    }
;
#line 8074 "lib/Sys/Guestfs.xs"
      r = guestfs_mkmountpoint (g, exemptpath);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 19369 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_mknod); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_mknod)
{
    dVAR; dXSARGS;
    if (items != 5)
       croak_xs_usage(cv,  "g, mode, devmajor, devminor, path");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	int	mode = (int)SvIV(ST(1))
;
	int	devmajor = (int)SvIV(ST(2))
;
	int	devminor = (int)SvIV(ST(3))
;
	char *	path = (char *)SvPV_nolen(ST(4))
;
#line 8086 "lib/Sys/Guestfs.xs"
      int r;
#line 19396 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::mknod(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::mknod(): g is not a blessed HV reference");
    }
;
#line 8088 "lib/Sys/Guestfs.xs"
      r = guestfs_mknod (g, mode, devmajor, devminor, path);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 19414 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_mknod_b); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_mknod_b)
{
    dVAR; dXSARGS;
    if (items != 5)
       croak_xs_usage(cv,  "g, mode, devmajor, devminor, path");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	int	mode = (int)SvIV(ST(1))
;
	int	devmajor = (int)SvIV(ST(2))
;
	int	devminor = (int)SvIV(ST(3))
;
	char *	path = (char *)SvPV_nolen(ST(4))
;
#line 8100 "lib/Sys/Guestfs.xs"
      int r;
#line 19441 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::mknod_b(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::mknod_b(): g is not a blessed HV reference");
    }
;
#line 8102 "lib/Sys/Guestfs.xs"
      r = guestfs_mknod_b (g, mode, devmajor, devminor, path);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 19459 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_mknod_c); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_mknod_c)
{
    dVAR; dXSARGS;
    if (items != 5)
       croak_xs_usage(cv,  "g, mode, devmajor, devminor, path");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	int	mode = (int)SvIV(ST(1))
;
	int	devmajor = (int)SvIV(ST(2))
;
	int	devminor = (int)SvIV(ST(3))
;
	char *	path = (char *)SvPV_nolen(ST(4))
;
#line 8114 "lib/Sys/Guestfs.xs"
      int r;
#line 19486 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::mknod_c(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::mknod_c(): g is not a blessed HV reference");
    }
;
#line 8116 "lib/Sys/Guestfs.xs"
      r = guestfs_mknod_c (g, mode, devmajor, devminor, path);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 19504 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_mksquashfs); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_mksquashfs)
{
    dVAR; dXSARGS;
    if (items < 3)
       croak_xs_usage(cv,  "g, path, filename, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	path = (char *)SvPV_nolen(ST(1))
;
	char *	filename = (char *)SvPV_nolen(ST(2))
;
#line 8126 "lib/Sys/Guestfs.xs"
      int r;
      struct guestfs_mksquashfs_argv optargs_s = { .bitmask = 0 };
      struct guestfs_mksquashfs_argv *optargs = &optargs_s;
      size_t items_i;
#line 19530 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::mksquashfs(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::mksquashfs(): g is not a blessed HV reference");
    }
;
#line 8131 "lib/Sys/Guestfs.xs"
      if (((items - 3) & 1) != 0)
        croak ("expecting an even number of extra parameters");
      for (items_i = 3; items_i < items; items_i += 2) {
        uint64_t this_mask;
        const char *this_arg;

        this_arg = SvPV_nolen (ST (items_i));
        if (STREQ (this_arg, "compress")) {
          optargs_s.compress = SvPV_nolen (ST (items_i+1));
          this_mask = GUESTFS_MKSQUASHFS_COMPRESS_BITMASK;
        }
        else if (STREQ (this_arg, "excludes")) {
          size_t i, len;
          char **r;
          SV *arg;
          AV *av;
          SV **svp;

          arg = ST (items_i+1);
          if (!SvROK (arg) || SvTYPE (SvRV (arg)) != SVt_PVAV)
            croak ("array reference expected for '%s' argument", "excludes");
          av = (AV *) SvRV (ST (items_i+1));

          /* Note av_len returns index of final element. */
          len = av_len (av) + 1;

          r = malloc ((len+1) * sizeof (char *));
          if (r == NULL) croak ("malloc: %m");
          for (i = 0; i < len; ++i) {
            svp = av_fetch (av, i, 0);
            r[i] = SvPV_nolen (*svp);
          }
          r[i] = NULL;
          optargs_s.excludes = r;
          this_mask = GUESTFS_MKSQUASHFS_EXCLUDES_BITMASK;
        }
        else croak ("unknown optional argument '%s'", this_arg);
        if (optargs_s.bitmask & this_mask)
          croak ("optional argument '%s' given more than once",
                 this_arg);
        optargs_s.bitmask |= this_mask;
      }

      r = guestfs_mksquashfs_argv (g, path, filename, optargs);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 19591 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_mkswap); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_mkswap)
{
    dVAR; dXSARGS;
    if (items < 2)
       croak_xs_usage(cv,  "g, device, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	device = (char *)SvPV_nolen(ST(1))
;
#line 8183 "lib/Sys/Guestfs.xs"
      int r;
      struct guestfs_mkswap_opts_argv optargs_s = { .bitmask = 0 };
      struct guestfs_mkswap_opts_argv *optargs = &optargs_s;
      size_t items_i;
#line 19615 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::mkswap(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::mkswap(): g is not a blessed HV reference");
    }
;
#line 8188 "lib/Sys/Guestfs.xs"
      if (((items - 2) & 1) != 0)
        croak ("expecting an even number of extra parameters");
      for (items_i = 2; items_i < items; items_i += 2) {
        uint64_t this_mask;
        const char *this_arg;

        this_arg = SvPV_nolen (ST (items_i));
        if (STREQ (this_arg, "label")) {
          optargs_s.label = SvPV_nolen (ST (items_i+1));
          this_mask = GUESTFS_MKSWAP_OPTS_LABEL_BITMASK;
        }
        else if (STREQ (this_arg, "uuid")) {
          optargs_s.uuid = SvPV_nolen (ST (items_i+1));
          this_mask = GUESTFS_MKSWAP_OPTS_UUID_BITMASK;
        }
        else croak ("unknown optional argument '%s'", this_arg);
        if (optargs_s.bitmask & this_mask)
          croak ("optional argument '%s' given more than once",
                 this_arg);
        optargs_s.bitmask |= this_mask;
      }

      r = guestfs_mkswap_opts_argv (g, device, optargs);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 19655 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_mkswap_L); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_mkswap_L)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "g, label, device");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	label = (char *)SvPV_nolen(ST(1))
;
	char *	device = (char *)SvPV_nolen(ST(2))
;
#line 8220 "lib/Sys/Guestfs.xs"
      int r;
#line 19678 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::mkswap_L(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::mkswap_L(): g is not a blessed HV reference");
    }
;
#line 8222 "lib/Sys/Guestfs.xs"
      Perl_ck_warner (aTHX_ packWARN(WARN_DEPRECATED),
        "Sys::Guestfs::mkswap_L is deprecated; use Sys::Guestfs::mkswap instead");
      r = guestfs_mkswap_L (g, label, device);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 19698 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_mkswap_U); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_mkswap_U)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "g, uuid, device");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	uuid = (char *)SvPV_nolen(ST(1))
;
	char *	device = (char *)SvPV_nolen(ST(2))
;
#line 8234 "lib/Sys/Guestfs.xs"
      int r;
#line 19721 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::mkswap_U(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::mkswap_U(): g is not a blessed HV reference");
    }
;
#line 8236 "lib/Sys/Guestfs.xs"
      Perl_ck_warner (aTHX_ packWARN(WARN_DEPRECATED),
        "Sys::Guestfs::mkswap_U is deprecated; use Sys::Guestfs::mkswap instead");
      r = guestfs_mkswap_U (g, uuid, device);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 19741 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_mkswap_file); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_mkswap_file)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, path");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	path = (char *)SvPV_nolen(ST(1))
;
#line 8247 "lib/Sys/Guestfs.xs"
      int r;
#line 19762 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::mkswap_file(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::mkswap_file(): g is not a blessed HV reference");
    }
;
#line 8249 "lib/Sys/Guestfs.xs"
      r = guestfs_mkswap_file (g, path);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 19780 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_mktemp); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_mktemp)
{
    dVAR; dXSARGS;
    if (items < 2)
       croak_xs_usage(cv,  "g, tmpl, ...");
    {
	guestfs_h *	g;
	char *	tmpl = (char *)SvPV_nolen(ST(1))
;
#line 8258 "lib/Sys/Guestfs.xs"
      char *r;
      struct guestfs_mktemp_argv optargs_s = { .bitmask = 0 };
      struct guestfs_mktemp_argv *optargs = &optargs_s;
      size_t items_i;
#line 19802 "lib/Sys/Guestfs.c"
	SV *	RETVAL;

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::mktemp(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::mktemp(): g is not a blessed HV reference");
    }
;
#line 8263 "lib/Sys/Guestfs.xs"
      if (((items - 2) & 1) != 0)
        croak ("expecting an even number of extra parameters");
      for (items_i = 2; items_i < items; items_i += 2) {
        uint64_t this_mask;
        const char *this_arg;

        this_arg = SvPV_nolen (ST (items_i));
        if (STREQ (this_arg, "suffix")) {
          optargs_s.suffix = SvPV_nolen (ST (items_i+1));
          this_mask = GUESTFS_MKTEMP_SUFFIX_BITMASK;
        }
        else croak ("unknown optional argument '%s'", this_arg);
        if (optargs_s.bitmask & this_mask)
          croak ("optional argument '%s' given more than once",
                 this_arg);
        optargs_s.bitmask |= this_mask;
      }

      r = guestfs_mktemp_argv (g, tmpl, optargs);
      if (r == NULL)
        croak ("%s", guestfs_last_error (g));
      RETVAL = newSVpv (r, 0);
      free (r);
#line 19841 "lib/Sys/Guestfs.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Guestfs_modprobe); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_modprobe)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, modulename");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	modulename = (char *)SvPV_nolen(ST(1))
;
#line 8294 "lib/Sys/Guestfs.xs"
      int r;
#line 19863 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::modprobe(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::modprobe(): g is not a blessed HV reference");
    }
;
#line 8296 "lib/Sys/Guestfs.xs"
      r = guestfs_modprobe (g, modulename);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 19881 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_mount); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_mount)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "g, mountable, mountpoint");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	mountable = (char *)SvPV_nolen(ST(1))
;
	char *	mountpoint = (char *)SvPV_nolen(ST(2))
;
#line 8306 "lib/Sys/Guestfs.xs"
      int r;
#line 19904 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::mount(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::mount(): g is not a blessed HV reference");
    }
;
#line 8308 "lib/Sys/Guestfs.xs"
      r = guestfs_mount (g, mountable, mountpoint);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 19922 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_mount_9p); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_mount_9p)
{
    dVAR; dXSARGS;
    if (items < 3)
       croak_xs_usage(cv,  "g, mounttag, mountpoint, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	mounttag = (char *)SvPV_nolen(ST(1))
;
	char *	mountpoint = (char *)SvPV_nolen(ST(2))
;
#line 8318 "lib/Sys/Guestfs.xs"
      int r;
      struct guestfs_mount_9p_argv optargs_s = { .bitmask = 0 };
      struct guestfs_mount_9p_argv *optargs = &optargs_s;
      size_t items_i;
#line 19948 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::mount_9p(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::mount_9p(): g is not a blessed HV reference");
    }
;
#line 8323 "lib/Sys/Guestfs.xs"
      Perl_ck_warner (aTHX_ packWARN(WARN_DEPRECATED),
        "Sys::Guestfs::mount_9p is deprecated");
      if (((items - 3) & 1) != 0)
        croak ("expecting an even number of extra parameters");
      for (items_i = 3; items_i < items; items_i += 2) {
        uint64_t this_mask;
        const char *this_arg;

        this_arg = SvPV_nolen (ST (items_i));
        if (STREQ (this_arg, "options")) {
          optargs_s.options = SvPV_nolen (ST (items_i+1));
          this_mask = GUESTFS_MOUNT_9P_OPTIONS_BITMASK;
        }
        else croak ("unknown optional argument '%s'", this_arg);
        if (optargs_s.bitmask & this_mask)
          croak ("optional argument '%s' given more than once",
                 this_arg);
        optargs_s.bitmask |= this_mask;
      }

      r = guestfs_mount_9p_argv (g, mounttag, mountpoint, optargs);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 19986 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_mount_local); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_mount_local)
{
    dVAR; dXSARGS;
    if (items < 2)
       croak_xs_usage(cv,  "g, localmountpoint, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	localmountpoint = (char *)SvPV_nolen(ST(1))
;
#line 8352 "lib/Sys/Guestfs.xs"
      int r;
      struct guestfs_mount_local_argv optargs_s = { .bitmask = 0 };
      struct guestfs_mount_local_argv *optargs = &optargs_s;
      size_t items_i;
#line 20010 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::mount_local(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::mount_local(): g is not a blessed HV reference");
    }
;
#line 8357 "lib/Sys/Guestfs.xs"
      if (((items - 2) & 1) != 0)
        croak ("expecting an even number of extra parameters");
      for (items_i = 2; items_i < items; items_i += 2) {
        uint64_t this_mask;
        const char *this_arg;

        this_arg = SvPV_nolen (ST (items_i));
        if (STREQ (this_arg, "readonly")) {
          optargs_s.readonly = SvIV (ST (items_i+1));
          this_mask = GUESTFS_MOUNT_LOCAL_READONLY_BITMASK;
        }
        else if (STREQ (this_arg, "options")) {
          optargs_s.options = SvPV_nolen (ST (items_i+1));
          this_mask = GUESTFS_MOUNT_LOCAL_OPTIONS_BITMASK;
        }
        else if (STREQ (this_arg, "cachetimeout")) {
          optargs_s.cachetimeout = SvIV (ST (items_i+1));
          this_mask = GUESTFS_MOUNT_LOCAL_CACHETIMEOUT_BITMASK;
        }
        else if (STREQ (this_arg, "debugcalls")) {
          optargs_s.debugcalls = SvIV (ST (items_i+1));
          this_mask = GUESTFS_MOUNT_LOCAL_DEBUGCALLS_BITMASK;
        }
        else croak ("unknown optional argument '%s'", this_arg);
        if (optargs_s.bitmask & this_mask)
          croak ("optional argument '%s' given more than once",
                 this_arg);
        optargs_s.bitmask |= this_mask;
      }

      r = guestfs_mount_local_argv (g, localmountpoint, optargs);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 20058 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_mount_local_run); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_mount_local_run)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "g");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
#line 8395 "lib/Sys/Guestfs.xs"
      int r;
#line 20077 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::mount_local_run(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::mount_local_run(): g is not a blessed HV reference");
    }
;
#line 8397 "lib/Sys/Guestfs.xs"
      r = guestfs_mount_local_run (g);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 20095 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_mount_loop); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_mount_loop)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "g, file, mountpoint");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	file = (char *)SvPV_nolen(ST(1))
;
	char *	mountpoint = (char *)SvPV_nolen(ST(2))
;
#line 8407 "lib/Sys/Guestfs.xs"
      int r;
#line 20118 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::mount_loop(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::mount_loop(): g is not a blessed HV reference");
    }
;
#line 8409 "lib/Sys/Guestfs.xs"
      r = guestfs_mount_loop (g, file, mountpoint);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 20136 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_mount_options); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_mount_options)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "g, options, mountable, mountpoint");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	options = (char *)SvPV_nolen(ST(1))
;
	char *	mountable = (char *)SvPV_nolen(ST(2))
;
	char *	mountpoint = (char *)SvPV_nolen(ST(3))
;
#line 8420 "lib/Sys/Guestfs.xs"
      int r;
#line 20161 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::mount_options(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::mount_options(): g is not a blessed HV reference");
    }
;
#line 8422 "lib/Sys/Guestfs.xs"
      r = guestfs_mount_options (g, options, mountable, mountpoint);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 20179 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_mount_ro); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_mount_ro)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "g, mountable, mountpoint");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	mountable = (char *)SvPV_nolen(ST(1))
;
	char *	mountpoint = (char *)SvPV_nolen(ST(2))
;
#line 8432 "lib/Sys/Guestfs.xs"
      int r;
#line 20202 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::mount_ro(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::mount_ro(): g is not a blessed HV reference");
    }
;
#line 8434 "lib/Sys/Guestfs.xs"
      r = guestfs_mount_ro (g, mountable, mountpoint);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 20220 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_mount_vfs); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_mount_vfs)
{
    dVAR; dXSARGS;
    if (items != 5)
       croak_xs_usage(cv,  "g, options, vfstype, mountable, mountpoint");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	options = (char *)SvPV_nolen(ST(1))
;
	char *	vfstype = (char *)SvPV_nolen(ST(2))
;
	char *	mountable = (char *)SvPV_nolen(ST(3))
;
	char *	mountpoint = (char *)SvPV_nolen(ST(4))
;
#line 8446 "lib/Sys/Guestfs.xs"
      int r;
#line 20247 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::mount_vfs(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::mount_vfs(): g is not a blessed HV reference");
    }
;
#line 8448 "lib/Sys/Guestfs.xs"
      r = guestfs_mount_vfs (g, options, vfstype, mountable, mountpoint);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 20265 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_mountable_device); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_mountable_device)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, mountable");
    {
	guestfs_h *	g;
	char *	mountable = (char *)SvPV_nolen(ST(1))
;
#line 8457 "lib/Sys/Guestfs.xs"
      char *r;
#line 20284 "lib/Sys/Guestfs.c"
	SV *	RETVAL;

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::mountable_device(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::mountable_device(): g is not a blessed HV reference");
    }
;
#line 8459 "lib/Sys/Guestfs.xs"
      r = guestfs_mountable_device (g, mountable);
      if (r == NULL)
        croak ("%s", guestfs_last_error (g));
      RETVAL = newSVpv (r, 0);
      free (r);
#line 20305 "lib/Sys/Guestfs.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Guestfs_mountable_subvolume); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_mountable_subvolume)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, mountable");
    {
	guestfs_h *	g;
	char *	mountable = (char *)SvPV_nolen(ST(1))
;
#line 8472 "lib/Sys/Guestfs.xs"
      char *r;
#line 20325 "lib/Sys/Guestfs.c"
	SV *	RETVAL;

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::mountable_subvolume(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::mountable_subvolume(): g is not a blessed HV reference");
    }
;
#line 8474 "lib/Sys/Guestfs.xs"
      r = guestfs_mountable_subvolume (g, mountable);
      if (r == NULL)
        croak ("%s", guestfs_last_error (g));
      RETVAL = newSVpv (r, 0);
      free (r);
#line 20346 "lib/Sys/Guestfs.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Guestfs_mountpoints); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_mountpoints)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "g");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
#line 8486 "lib/Sys/Guestfs.xs"
      char **r;
      size_t i, n;
#line 20367 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::mountpoints(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::mountpoints(): g is not a blessed HV reference");
    }
;
#line 8489 "lib/Sys/Guestfs.xs"
      r = guestfs_mountpoints (g);
      if (r == NULL)
        croak ("%s", guestfs_last_error (g));
      for (n = 0; r[n] != NULL; ++n) /**/;
      EXTEND (SP, n);
      for (i = 0; i < n; ++i) {
        PUSHs (sv_2mortal (newSVpv (r[i], 0)));
        free (r[i]);
      }
      free (r);
#line 20392 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_mounts); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_mounts)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "g");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
#line 8504 "lib/Sys/Guestfs.xs"
      char **r;
      size_t i, n;
#line 20412 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::mounts(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::mounts(): g is not a blessed HV reference");
    }
;
#line 8507 "lib/Sys/Guestfs.xs"
      r = guestfs_mounts (g);
      if (r == NULL)
        croak ("%s", guestfs_last_error (g));
      for (n = 0; r[n] != NULL; ++n) /**/;
      EXTEND (SP, n);
      for (i = 0; i < n; ++i) {
        PUSHs (sv_2mortal (newSVpv (r[i], 0)));
        free (r[i]);
      }
      free (r);
#line 20437 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_mv); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_mv)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "g, src, dest");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	src = (char *)SvPV_nolen(ST(1))
;
	char *	dest = (char *)SvPV_nolen(ST(2))
;
#line 8524 "lib/Sys/Guestfs.xs"
      int r;
#line 20460 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::mv(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::mv(): g is not a blessed HV reference");
    }
;
#line 8526 "lib/Sys/Guestfs.xs"
      r = guestfs_mv (g, src, dest);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 20478 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_nr_devices); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_nr_devices)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "g");
    {
	guestfs_h *	g;
#line 8534 "lib/Sys/Guestfs.xs"
      int r;
#line 20495 "lib/Sys/Guestfs.c"
	SV *	RETVAL;

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::nr_devices(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::nr_devices(): g is not a blessed HV reference");
    }
;
#line 8536 "lib/Sys/Guestfs.xs"
      r = guestfs_nr_devices (g);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
      RETVAL = newSViv (r);
#line 20515 "lib/Sys/Guestfs.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Guestfs_ntfs_3g_probe); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_ntfs_3g_probe)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "g, rw, device");
    {
	guestfs_h *	g;
	int	rw = (int)SvIV(ST(1))
;
	char *	device = (char *)SvPV_nolen(ST(2))
;
#line 8549 "lib/Sys/Guestfs.xs"
      int r;
#line 20537 "lib/Sys/Guestfs.c"
	SV *	RETVAL;

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::ntfs_3g_probe(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::ntfs_3g_probe(): g is not a blessed HV reference");
    }
;
#line 8551 "lib/Sys/Guestfs.xs"
      r = guestfs_ntfs_3g_probe (g, rw, device);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
      RETVAL = newSViv (r);
#line 20557 "lib/Sys/Guestfs.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Guestfs_ntfscat_i); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_ntfscat_i)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "g, device, inode, filename");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	device = (char *)SvPV_nolen(ST(1))
;
	int64_t    inode = my_SvIV64 (ST(2))
;
	char *	filename = (char *)SvPV_nolen(ST(3))
;
#line 8565 "lib/Sys/Guestfs.xs"
      int r;
#line 20583 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::ntfscat_i(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::ntfscat_i(): g is not a blessed HV reference");
    }
;
#line 8567 "lib/Sys/Guestfs.xs"
      r = guestfs_ntfscat_i (g, device, inode, filename);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 20601 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_ntfsclone_in); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_ntfsclone_in)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "g, backupfile, device");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	backupfile = (char *)SvPV_nolen(ST(1))
;
	char *	device = (char *)SvPV_nolen(ST(2))
;
#line 8577 "lib/Sys/Guestfs.xs"
      int r;
#line 20624 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::ntfsclone_in(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::ntfsclone_in(): g is not a blessed HV reference");
    }
;
#line 8579 "lib/Sys/Guestfs.xs"
      r = guestfs_ntfsclone_in (g, backupfile, device);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 20642 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_ntfsclone_out); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_ntfsclone_out)
{
    dVAR; dXSARGS;
    if (items < 3)
       croak_xs_usage(cv,  "g, device, backupfile, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	device = (char *)SvPV_nolen(ST(1))
;
	char *	backupfile = (char *)SvPV_nolen(ST(2))
;
#line 8589 "lib/Sys/Guestfs.xs"
      int r;
      struct guestfs_ntfsclone_out_argv optargs_s = { .bitmask = 0 };
      struct guestfs_ntfsclone_out_argv *optargs = &optargs_s;
      size_t items_i;
#line 20668 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::ntfsclone_out(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::ntfsclone_out(): g is not a blessed HV reference");
    }
;
#line 8594 "lib/Sys/Guestfs.xs"
      if (((items - 3) & 1) != 0)
        croak ("expecting an even number of extra parameters");
      for (items_i = 3; items_i < items; items_i += 2) {
        uint64_t this_mask;
        const char *this_arg;

        this_arg = SvPV_nolen (ST (items_i));
        if (STREQ (this_arg, "metadataonly")) {
          optargs_s.metadataonly = SvIV (ST (items_i+1));
          this_mask = GUESTFS_NTFSCLONE_OUT_METADATAONLY_BITMASK;
        }
        else if (STREQ (this_arg, "rescue")) {
          optargs_s.rescue = SvIV (ST (items_i+1));
          this_mask = GUESTFS_NTFSCLONE_OUT_RESCUE_BITMASK;
        }
        else if (STREQ (this_arg, "ignorefscheck")) {
          optargs_s.ignorefscheck = SvIV (ST (items_i+1));
          this_mask = GUESTFS_NTFSCLONE_OUT_IGNOREFSCHECK_BITMASK;
        }
        else if (STREQ (this_arg, "preservetimestamps")) {
          optargs_s.preservetimestamps = SvIV (ST (items_i+1));
          this_mask = GUESTFS_NTFSCLONE_OUT_PRESERVETIMESTAMPS_BITMASK;
        }
        else if (STREQ (this_arg, "force")) {
          optargs_s.force = SvIV (ST (items_i+1));
          this_mask = GUESTFS_NTFSCLONE_OUT_FORCE_BITMASK;
        }
        else croak ("unknown optional argument '%s'", this_arg);
        if (optargs_s.bitmask & this_mask)
          croak ("optional argument '%s' given more than once",
                 this_arg);
        optargs_s.bitmask |= this_mask;
      }

      r = guestfs_ntfsclone_out_argv (g, device, backupfile, optargs);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 20720 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_ntfsfix); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_ntfsfix)
{
    dVAR; dXSARGS;
    if (items < 2)
       croak_xs_usage(cv,  "g, device, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	device = (char *)SvPV_nolen(ST(1))
;
#line 8637 "lib/Sys/Guestfs.xs"
      int r;
      struct guestfs_ntfsfix_argv optargs_s = { .bitmask = 0 };
      struct guestfs_ntfsfix_argv *optargs = &optargs_s;
      size_t items_i;
#line 20744 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::ntfsfix(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::ntfsfix(): g is not a blessed HV reference");
    }
;
#line 8642 "lib/Sys/Guestfs.xs"
      if (((items - 2) & 1) != 0)
        croak ("expecting an even number of extra parameters");
      for (items_i = 2; items_i < items; items_i += 2) {
        uint64_t this_mask;
        const char *this_arg;

        this_arg = SvPV_nolen (ST (items_i));
        if (STREQ (this_arg, "clearbadsectors")) {
          optargs_s.clearbadsectors = SvIV (ST (items_i+1));
          this_mask = GUESTFS_NTFSFIX_CLEARBADSECTORS_BITMASK;
        }
        else croak ("unknown optional argument '%s'", this_arg);
        if (optargs_s.bitmask & this_mask)
          croak ("optional argument '%s' given more than once",
                 this_arg);
        optargs_s.bitmask |= this_mask;
      }

      r = guestfs_ntfsfix_argv (g, device, optargs);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 20780 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_ntfsresize); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_ntfsresize)
{
    dVAR; dXSARGS;
    if (items < 2)
       croak_xs_usage(cv,  "g, device, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	device = (char *)SvPV_nolen(ST(1))
;
#line 8669 "lib/Sys/Guestfs.xs"
      int r;
      struct guestfs_ntfsresize_opts_argv optargs_s = { .bitmask = 0 };
      struct guestfs_ntfsresize_opts_argv *optargs = &optargs_s;
      size_t items_i;
#line 20804 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::ntfsresize(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::ntfsresize(): g is not a blessed HV reference");
    }
;
#line 8674 "lib/Sys/Guestfs.xs"
      if (((items - 2) & 1) != 0)
        croak ("expecting an even number of extra parameters");
      for (items_i = 2; items_i < items; items_i += 2) {
        uint64_t this_mask;
        const char *this_arg;

        this_arg = SvPV_nolen (ST (items_i));
        if (STREQ (this_arg, "size")) {
          optargs_s.size = my_SvIV64 (ST (items_i+1));
          this_mask = GUESTFS_NTFSRESIZE_OPTS_SIZE_BITMASK;
        }
        else if (STREQ (this_arg, "force")) {
          optargs_s.force = SvIV (ST (items_i+1));
          this_mask = GUESTFS_NTFSRESIZE_OPTS_FORCE_BITMASK;
        }
        else croak ("unknown optional argument '%s'", this_arg);
        if (optargs_s.bitmask & this_mask)
          croak ("optional argument '%s' given more than once",
                 this_arg);
        optargs_s.bitmask |= this_mask;
      }

      r = guestfs_ntfsresize_opts_argv (g, device, optargs);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 20844 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_ntfsresize_size); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_ntfsresize_size)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "g, device, size");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	device = (char *)SvPV_nolen(ST(1))
;
	int64_t    size = my_SvIV64 (ST(2))
;
#line 8706 "lib/Sys/Guestfs.xs"
      int r;
#line 20867 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::ntfsresize_size(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::ntfsresize_size(): g is not a blessed HV reference");
    }
;
#line 8708 "lib/Sys/Guestfs.xs"
      Perl_ck_warner (aTHX_ packWARN(WARN_DEPRECATED),
        "Sys::Guestfs::ntfsresize_size is deprecated; use Sys::Guestfs::ntfsresize instead");
      r = guestfs_ntfsresize_size (g, device, size);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 20887 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_parse_environment); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_parse_environment)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "g");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
#line 8718 "lib/Sys/Guestfs.xs"
      int r;
#line 20906 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::parse_environment(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::parse_environment(): g is not a blessed HV reference");
    }
;
#line 8720 "lib/Sys/Guestfs.xs"
      r = guestfs_parse_environment (g);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 20924 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_parse_environment_list); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_parse_environment_list)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, environment");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char **	environment = XS_unpack_charPtrPtr(ST(1))
;
#line 8729 "lib/Sys/Guestfs.xs"
      int r;
#line 20945 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::parse_environment_list(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::parse_environment_list(): g is not a blessed HV reference");
    }
;
#line 8731 "lib/Sys/Guestfs.xs"
      r = guestfs_parse_environment_list (g, environment);
      free (environment);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 20964 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_part_add); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_part_add)
{
    dVAR; dXSARGS;
    if (items != 5)
       croak_xs_usage(cv,  "g, device, prlogex, startsect, endsect");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	device = (char *)SvPV_nolen(ST(1))
;
	char *	prlogex = (char *)SvPV_nolen(ST(2))
;
	int64_t    startsect = my_SvIV64 (ST(3))
;
	int64_t    endsect = my_SvIV64 (ST(4))
;
#line 8744 "lib/Sys/Guestfs.xs"
      int r;
#line 20991 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::part_add(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::part_add(): g is not a blessed HV reference");
    }
;
#line 8746 "lib/Sys/Guestfs.xs"
      r = guestfs_part_add (g, device, prlogex, startsect, endsect);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 21009 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_part_del); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_part_del)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "g, device, partnum");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	device = (char *)SvPV_nolen(ST(1))
;
	int	partnum = (int)SvIV(ST(2))
;
#line 8756 "lib/Sys/Guestfs.xs"
      int r;
#line 21032 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::part_del(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::part_del(): g is not a blessed HV reference");
    }
;
#line 8758 "lib/Sys/Guestfs.xs"
      r = guestfs_part_del (g, device, partnum);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 21050 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_part_disk); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_part_disk)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "g, device, parttype");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	device = (char *)SvPV_nolen(ST(1))
;
	char *	parttype = (char *)SvPV_nolen(ST(2))
;
#line 8768 "lib/Sys/Guestfs.xs"
      int r;
#line 21073 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::part_disk(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::part_disk(): g is not a blessed HV reference");
    }
;
#line 8770 "lib/Sys/Guestfs.xs"
      r = guestfs_part_disk (g, device, parttype);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 21091 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_part_expand_gpt); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_part_expand_gpt)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, device");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	device = (char *)SvPV_nolen(ST(1))
;
#line 8779 "lib/Sys/Guestfs.xs"
      int r;
#line 21112 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::part_expand_gpt(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::part_expand_gpt(): g is not a blessed HV reference");
    }
;
#line 8781 "lib/Sys/Guestfs.xs"
      r = guestfs_part_expand_gpt (g, device);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 21130 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_part_get_bootable); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_part_get_bootable)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "g, device, partnum");
    {
	guestfs_h *	g;
	char *	device = (char *)SvPV_nolen(ST(1))
;
	int	partnum = (int)SvIV(ST(2))
;
#line 8791 "lib/Sys/Guestfs.xs"
      int r;
#line 21151 "lib/Sys/Guestfs.c"
	SV *	RETVAL;

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::part_get_bootable(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::part_get_bootable(): g is not a blessed HV reference");
    }
;
#line 8793 "lib/Sys/Guestfs.xs"
      r = guestfs_part_get_bootable (g, device, partnum);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
      RETVAL = newSViv (r);
#line 21171 "lib/Sys/Guestfs.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Guestfs_part_get_disk_guid); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_part_get_disk_guid)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, device");
    {
	guestfs_h *	g;
	char *	device = (char *)SvPV_nolen(ST(1))
;
#line 8805 "lib/Sys/Guestfs.xs"
      char *r;
#line 21191 "lib/Sys/Guestfs.c"
	SV *	RETVAL;

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::part_get_disk_guid(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::part_get_disk_guid(): g is not a blessed HV reference");
    }
;
#line 8807 "lib/Sys/Guestfs.xs"
      r = guestfs_part_get_disk_guid (g, device);
      if (r == NULL)
        croak ("%s", guestfs_last_error (g));
      RETVAL = newSVpv (r, 0);
      free (r);
#line 21212 "lib/Sys/Guestfs.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Guestfs_part_get_gpt_attributes); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_part_get_gpt_attributes)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "g, device, partnum");
    {
	guestfs_h *	g;
	char *	device = (char *)SvPV_nolen(ST(1))
;
	int	partnum = (int)SvIV(ST(2))
;
#line 8821 "lib/Sys/Guestfs.xs"
      int64_t r;
#line 21234 "lib/Sys/Guestfs.c"
	SV *	RETVAL;

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::part_get_gpt_attributes(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::part_get_gpt_attributes(): g is not a blessed HV reference");
    }
;
#line 8823 "lib/Sys/Guestfs.xs"
      r = guestfs_part_get_gpt_attributes (g, device, partnum);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
      RETVAL = my_newSVll (r);
#line 21254 "lib/Sys/Guestfs.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Guestfs_part_get_gpt_guid); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_part_get_gpt_guid)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "g, device, partnum");
    {
	guestfs_h *	g;
	char *	device = (char *)SvPV_nolen(ST(1))
;
	int	partnum = (int)SvIV(ST(2))
;
#line 8836 "lib/Sys/Guestfs.xs"
      char *r;
#line 21276 "lib/Sys/Guestfs.c"
	SV *	RETVAL;

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::part_get_gpt_guid(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::part_get_gpt_guid(): g is not a blessed HV reference");
    }
;
#line 8838 "lib/Sys/Guestfs.xs"
      r = guestfs_part_get_gpt_guid (g, device, partnum);
      if (r == NULL)
        croak ("%s", guestfs_last_error (g));
      RETVAL = newSVpv (r, 0);
      free (r);
#line 21297 "lib/Sys/Guestfs.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Guestfs_part_get_gpt_type); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_part_get_gpt_type)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "g, device, partnum");
    {
	guestfs_h *	g;
	char *	device = (char *)SvPV_nolen(ST(1))
;
	int	partnum = (int)SvIV(ST(2))
;
#line 8852 "lib/Sys/Guestfs.xs"
      char *r;
#line 21319 "lib/Sys/Guestfs.c"
	SV *	RETVAL;

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::part_get_gpt_type(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::part_get_gpt_type(): g is not a blessed HV reference");
    }
;
#line 8854 "lib/Sys/Guestfs.xs"
      r = guestfs_part_get_gpt_type (g, device, partnum);
      if (r == NULL)
        croak ("%s", guestfs_last_error (g));
      RETVAL = newSVpv (r, 0);
      free (r);
#line 21340 "lib/Sys/Guestfs.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Guestfs_part_get_mbr_id); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_part_get_mbr_id)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "g, device, partnum");
    {
	guestfs_h *	g;
	char *	device = (char *)SvPV_nolen(ST(1))
;
	int	partnum = (int)SvIV(ST(2))
;
#line 8868 "lib/Sys/Guestfs.xs"
      int r;
#line 21362 "lib/Sys/Guestfs.c"
	SV *	RETVAL;

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::part_get_mbr_id(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::part_get_mbr_id(): g is not a blessed HV reference");
    }
;
#line 8870 "lib/Sys/Guestfs.xs"
      r = guestfs_part_get_mbr_id (g, device, partnum);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
      RETVAL = newSViv (r);
#line 21382 "lib/Sys/Guestfs.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Guestfs_part_get_mbr_part_type); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_part_get_mbr_part_type)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "g, device, partnum");
    {
	guestfs_h *	g;
	char *	device = (char *)SvPV_nolen(ST(1))
;
	int	partnum = (int)SvIV(ST(2))
;
#line 8883 "lib/Sys/Guestfs.xs"
      char *r;
#line 21404 "lib/Sys/Guestfs.c"
	SV *	RETVAL;

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::part_get_mbr_part_type(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::part_get_mbr_part_type(): g is not a blessed HV reference");
    }
;
#line 8885 "lib/Sys/Guestfs.xs"
      r = guestfs_part_get_mbr_part_type (g, device, partnum);
      if (r == NULL)
        croak ("%s", guestfs_last_error (g));
      RETVAL = newSVpv (r, 0);
      free (r);
#line 21425 "lib/Sys/Guestfs.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Guestfs_part_get_name); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_part_get_name)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "g, device, partnum");
    {
	guestfs_h *	g;
	char *	device = (char *)SvPV_nolen(ST(1))
;
	int	partnum = (int)SvIV(ST(2))
;
#line 8899 "lib/Sys/Guestfs.xs"
      char *r;
#line 21447 "lib/Sys/Guestfs.c"
	SV *	RETVAL;

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::part_get_name(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::part_get_name(): g is not a blessed HV reference");
    }
;
#line 8901 "lib/Sys/Guestfs.xs"
      r = guestfs_part_get_name (g, device, partnum);
      if (r == NULL)
        croak ("%s", guestfs_last_error (g));
      RETVAL = newSVpv (r, 0);
      free (r);
#line 21468 "lib/Sys/Guestfs.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Guestfs_part_get_parttype); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_part_get_parttype)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, device");
    {
	guestfs_h *	g;
	char *	device = (char *)SvPV_nolen(ST(1))
;
#line 8914 "lib/Sys/Guestfs.xs"
      char *r;
#line 21488 "lib/Sys/Guestfs.c"
	SV *	RETVAL;

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::part_get_parttype(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::part_get_parttype(): g is not a blessed HV reference");
    }
;
#line 8916 "lib/Sys/Guestfs.xs"
      r = guestfs_part_get_parttype (g, device);
      if (r == NULL)
        croak ("%s", guestfs_last_error (g));
      RETVAL = newSVpv (r, 0);
      free (r);
#line 21509 "lib/Sys/Guestfs.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Guestfs_part_init); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_part_init)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "g, device, parttype");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	device = (char *)SvPV_nolen(ST(1))
;
	char *	parttype = (char *)SvPV_nolen(ST(2))
;
#line 8930 "lib/Sys/Guestfs.xs"
      int r;
#line 21533 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::part_init(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::part_init(): g is not a blessed HV reference");
    }
;
#line 8932 "lib/Sys/Guestfs.xs"
      r = guestfs_part_init (g, device, parttype);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 21551 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_part_list); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_part_list)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, device");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	device = (char *)SvPV_nolen(ST(1))
;
#line 8941 "lib/Sys/Guestfs.xs"
      struct guestfs_partition_list *r;
      size_t i;
      HV *hv;
#line 21574 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::part_list(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::part_list(): g is not a blessed HV reference");
    }
;
#line 8945 "lib/Sys/Guestfs.xs"
      r = guestfs_part_list (g, device);
      if (r == NULL)
        croak ("%s", guestfs_last_error (g));
      EXTEND (SP, r->len);
      for (i = 0; i < r->len; ++i) {
        hv = newHV ();
        (void) hv_store (hv, "part_num", 8, newSVnv (r->val[i].part_num), 0);
        (void) hv_store (hv, "part_start", 10, my_newSVull (r->val[i].part_start), 0);
        (void) hv_store (hv, "part_end", 8, my_newSVull (r->val[i].part_end), 0);
        (void) hv_store (hv, "part_size", 9, my_newSVull (r->val[i].part_size), 0);
        PUSHs (sv_2mortal (newRV ((SV *) hv)));
      }
      guestfs_free_partition_list (r);
#line 21602 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_part_resize); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_part_resize)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "g, device, partnum, endsect");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	device = (char *)SvPV_nolen(ST(1))
;
	int	partnum = (int)SvIV(ST(2))
;
	int64_t    endsect = my_SvIV64 (ST(3))
;
#line 8966 "lib/Sys/Guestfs.xs"
      int r;
#line 21627 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::part_resize(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::part_resize(): g is not a blessed HV reference");
    }
;
#line 8968 "lib/Sys/Guestfs.xs"
      r = guestfs_part_resize (g, device, partnum, endsect);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 21645 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_part_set_bootable); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_part_set_bootable)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "g, device, partnum, bootable");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	device = (char *)SvPV_nolen(ST(1))
;
	int	partnum = (int)SvIV(ST(2))
;
	int	bootable = (int)SvIV(ST(3))
;
#line 8979 "lib/Sys/Guestfs.xs"
      int r;
#line 21670 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::part_set_bootable(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::part_set_bootable(): g is not a blessed HV reference");
    }
;
#line 8981 "lib/Sys/Guestfs.xs"
      r = guestfs_part_set_bootable (g, device, partnum, bootable);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 21688 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_part_set_disk_guid); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_part_set_disk_guid)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "g, device, guid");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	device = (char *)SvPV_nolen(ST(1))
;
	char *	guid = (char *)SvPV_nolen(ST(2))
;
#line 8991 "lib/Sys/Guestfs.xs"
      int r;
#line 21711 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::part_set_disk_guid(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::part_set_disk_guid(): g is not a blessed HV reference");
    }
;
#line 8993 "lib/Sys/Guestfs.xs"
      r = guestfs_part_set_disk_guid (g, device, guid);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 21729 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_part_set_disk_guid_random); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_part_set_disk_guid_random)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, device");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	device = (char *)SvPV_nolen(ST(1))
;
#line 9002 "lib/Sys/Guestfs.xs"
      int r;
#line 21750 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::part_set_disk_guid_random(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::part_set_disk_guid_random(): g is not a blessed HV reference");
    }
;
#line 9004 "lib/Sys/Guestfs.xs"
      r = guestfs_part_set_disk_guid_random (g, device);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 21768 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_part_set_gpt_attributes); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_part_set_gpt_attributes)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "g, device, partnum, attributes");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	device = (char *)SvPV_nolen(ST(1))
;
	int	partnum = (int)SvIV(ST(2))
;
	int64_t    attributes = my_SvIV64 (ST(3))
;
#line 9015 "lib/Sys/Guestfs.xs"
      int r;
#line 21793 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::part_set_gpt_attributes(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::part_set_gpt_attributes(): g is not a blessed HV reference");
    }
;
#line 9017 "lib/Sys/Guestfs.xs"
      r = guestfs_part_set_gpt_attributes (g, device, partnum, attributes);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 21811 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_part_set_gpt_guid); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_part_set_gpt_guid)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "g, device, partnum, guid");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	device = (char *)SvPV_nolen(ST(1))
;
	int	partnum = (int)SvIV(ST(2))
;
	char *	guid = (char *)SvPV_nolen(ST(3))
;
#line 9028 "lib/Sys/Guestfs.xs"
      int r;
#line 21836 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::part_set_gpt_guid(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::part_set_gpt_guid(): g is not a blessed HV reference");
    }
;
#line 9030 "lib/Sys/Guestfs.xs"
      r = guestfs_part_set_gpt_guid (g, device, partnum, guid);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 21854 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_part_set_gpt_type); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_part_set_gpt_type)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "g, device, partnum, guid");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	device = (char *)SvPV_nolen(ST(1))
;
	int	partnum = (int)SvIV(ST(2))
;
	char *	guid = (char *)SvPV_nolen(ST(3))
;
#line 9041 "lib/Sys/Guestfs.xs"
      int r;
#line 21879 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::part_set_gpt_type(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::part_set_gpt_type(): g is not a blessed HV reference");
    }
;
#line 9043 "lib/Sys/Guestfs.xs"
      r = guestfs_part_set_gpt_type (g, device, partnum, guid);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 21897 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_part_set_mbr_id); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_part_set_mbr_id)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "g, device, partnum, idbyte");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	device = (char *)SvPV_nolen(ST(1))
;
	int	partnum = (int)SvIV(ST(2))
;
	int	idbyte = (int)SvIV(ST(3))
;
#line 9054 "lib/Sys/Guestfs.xs"
      int r;
#line 21922 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::part_set_mbr_id(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::part_set_mbr_id(): g is not a blessed HV reference");
    }
;
#line 9056 "lib/Sys/Guestfs.xs"
      r = guestfs_part_set_mbr_id (g, device, partnum, idbyte);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 21940 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_part_set_name); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_part_set_name)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "g, device, partnum, name");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	device = (char *)SvPV_nolen(ST(1))
;
	int	partnum = (int)SvIV(ST(2))
;
	char *	name = (char *)SvPV_nolen(ST(3))
;
#line 9067 "lib/Sys/Guestfs.xs"
      int r;
#line 21965 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::part_set_name(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::part_set_name(): g is not a blessed HV reference");
    }
;
#line 9069 "lib/Sys/Guestfs.xs"
      r = guestfs_part_set_name (g, device, partnum, name);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 21983 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_part_to_dev); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_part_to_dev)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, partition");
    {
	guestfs_h *	g;
	char *	partition = (char *)SvPV_nolen(ST(1))
;
#line 9078 "lib/Sys/Guestfs.xs"
      char *r;
#line 22002 "lib/Sys/Guestfs.c"
	SV *	RETVAL;

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::part_to_dev(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::part_to_dev(): g is not a blessed HV reference");
    }
;
#line 9080 "lib/Sys/Guestfs.xs"
      r = guestfs_part_to_dev (g, partition);
      if (r == NULL)
        croak ("%s", guestfs_last_error (g));
      RETVAL = newSVpv (r, 0);
      free (r);
#line 22023 "lib/Sys/Guestfs.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Guestfs_part_to_partnum); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_part_to_partnum)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, partition");
    {
	guestfs_h *	g;
	char *	partition = (char *)SvPV_nolen(ST(1))
;
#line 9093 "lib/Sys/Guestfs.xs"
      int r;
#line 22043 "lib/Sys/Guestfs.c"
	SV *	RETVAL;

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::part_to_partnum(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::part_to_partnum(): g is not a blessed HV reference");
    }
;
#line 9095 "lib/Sys/Guestfs.xs"
      r = guestfs_part_to_partnum (g, partition);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
      RETVAL = newSViv (r);
#line 22063 "lib/Sys/Guestfs.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Guestfs_ping_daemon); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_ping_daemon)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "g");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
#line 9106 "lib/Sys/Guestfs.xs"
      int r;
#line 22083 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::ping_daemon(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::ping_daemon(): g is not a blessed HV reference");
    }
;
#line 9108 "lib/Sys/Guestfs.xs"
      r = guestfs_ping_daemon (g);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 22101 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_pread); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_pread)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "g, path, count, offset");
    {
	guestfs_h *	g;
	char *	path = (char *)SvPV_nolen(ST(1))
;
	int	count = (int)SvIV(ST(2))
;
	int64_t    offset = my_SvIV64 (ST(3))
;
#line 9119 "lib/Sys/Guestfs.xs"
      char *r;
      size_t size;
#line 22125 "lib/Sys/Guestfs.c"
	SV *	RETVAL;

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::pread(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::pread(): g is not a blessed HV reference");
    }
;
#line 9122 "lib/Sys/Guestfs.xs"
      r = guestfs_pread (g, path, count, offset, &size);
      if (r == NULL)
        croak ("%s", guestfs_last_error (g));
      RETVAL = newSVpvn (r, size);
      free (r);
#line 22146 "lib/Sys/Guestfs.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Guestfs_pread_device); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_pread_device)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "g, device, count, offset");
    {
	guestfs_h *	g;
	char *	device = (char *)SvPV_nolen(ST(1))
;
	int	count = (int)SvIV(ST(2))
;
	int64_t    offset = my_SvIV64 (ST(3))
;
#line 9137 "lib/Sys/Guestfs.xs"
      char *r;
      size_t size;
#line 22171 "lib/Sys/Guestfs.c"
	SV *	RETVAL;

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::pread_device(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::pread_device(): g is not a blessed HV reference");
    }
;
#line 9140 "lib/Sys/Guestfs.xs"
      r = guestfs_pread_device (g, device, count, offset, &size);
      if (r == NULL)
        croak ("%s", guestfs_last_error (g));
      RETVAL = newSVpvn (r, size);
      free (r);
#line 22192 "lib/Sys/Guestfs.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Guestfs_pvchange_uuid); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_pvchange_uuid)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, device");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	device = (char *)SvPV_nolen(ST(1))
;
#line 9153 "lib/Sys/Guestfs.xs"
      int r;
#line 22214 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::pvchange_uuid(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::pvchange_uuid(): g is not a blessed HV reference");
    }
;
#line 9155 "lib/Sys/Guestfs.xs"
      r = guestfs_pvchange_uuid (g, device);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 22232 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_pvchange_uuid_all); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_pvchange_uuid_all)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "g");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
#line 9163 "lib/Sys/Guestfs.xs"
      int r;
#line 22251 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::pvchange_uuid_all(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::pvchange_uuid_all(): g is not a blessed HV reference");
    }
;
#line 9165 "lib/Sys/Guestfs.xs"
      r = guestfs_pvchange_uuid_all (g);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 22269 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_pvcreate); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_pvcreate)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, device");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	device = (char *)SvPV_nolen(ST(1))
;
#line 9174 "lib/Sys/Guestfs.xs"
      int r;
#line 22290 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::pvcreate(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::pvcreate(): g is not a blessed HV reference");
    }
;
#line 9176 "lib/Sys/Guestfs.xs"
      r = guestfs_pvcreate (g, device);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 22308 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_pvremove); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_pvremove)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, device");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	device = (char *)SvPV_nolen(ST(1))
;
#line 9185 "lib/Sys/Guestfs.xs"
      int r;
#line 22329 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::pvremove(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::pvremove(): g is not a blessed HV reference");
    }
;
#line 9187 "lib/Sys/Guestfs.xs"
      r = guestfs_pvremove (g, device);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 22347 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_pvresize); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_pvresize)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, device");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	device = (char *)SvPV_nolen(ST(1))
;
#line 9196 "lib/Sys/Guestfs.xs"
      int r;
#line 22368 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::pvresize(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::pvresize(): g is not a blessed HV reference");
    }
;
#line 9198 "lib/Sys/Guestfs.xs"
      r = guestfs_pvresize (g, device);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 22386 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_pvresize_size); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_pvresize_size)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "g, device, size");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	device = (char *)SvPV_nolen(ST(1))
;
	int64_t    size = my_SvIV64 (ST(2))
;
#line 9208 "lib/Sys/Guestfs.xs"
      int r;
#line 22409 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::pvresize_size(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::pvresize_size(): g is not a blessed HV reference");
    }
;
#line 9210 "lib/Sys/Guestfs.xs"
      r = guestfs_pvresize_size (g, device, size);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 22427 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_pvs); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_pvs)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "g");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
#line 9218 "lib/Sys/Guestfs.xs"
      char **r;
      size_t i, n;
#line 22447 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::pvs(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::pvs(): g is not a blessed HV reference");
    }
;
#line 9221 "lib/Sys/Guestfs.xs"
      r = guestfs_pvs (g);
      if (r == NULL)
        croak ("%s", guestfs_last_error (g));
      for (n = 0; r[n] != NULL; ++n) /**/;
      EXTEND (SP, n);
      for (i = 0; i < n; ++i) {
        PUSHs (sv_2mortal (newSVpv (r[i], 0)));
        free (r[i]);
      }
      free (r);
#line 22472 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_pvs_full); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_pvs_full)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "g");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
#line 9236 "lib/Sys/Guestfs.xs"
      struct guestfs_lvm_pv_list *r;
      size_t i;
      HV *hv;
#line 22493 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::pvs_full(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::pvs_full(): g is not a blessed HV reference");
    }
;
#line 9240 "lib/Sys/Guestfs.xs"
      r = guestfs_pvs_full (g);
      if (r == NULL)
        croak ("%s", guestfs_last_error (g));
      EXTEND (SP, r->len);
      for (i = 0; i < r->len; ++i) {
        hv = newHV ();
        (void) hv_store (hv, "pv_name", 7, newSVpv (r->val[i].pv_name, 0), 0);
        (void) hv_store (hv, "pv_uuid", 7, newSVpv (r->val[i].pv_uuid, 32), 0);
        (void) hv_store (hv, "pv_fmt", 6, newSVpv (r->val[i].pv_fmt, 0), 0);
        (void) hv_store (hv, "pv_size", 7, my_newSVull (r->val[i].pv_size), 0);
        (void) hv_store (hv, "dev_size", 8, my_newSVull (r->val[i].dev_size), 0);
        (void) hv_store (hv, "pv_free", 7, my_newSVull (r->val[i].pv_free), 0);
        (void) hv_store (hv, "pv_used", 7, my_newSVull (r->val[i].pv_used), 0);
        (void) hv_store (hv, "pv_attr", 7, newSVpv (r->val[i].pv_attr, 0), 0);
        (void) hv_store (hv, "pv_pe_count", 11, my_newSVll (r->val[i].pv_pe_count), 0);
        (void) hv_store (hv, "pv_pe_alloc_count", 17, my_newSVll (r->val[i].pv_pe_alloc_count), 0);
        (void) hv_store (hv, "pv_tags", 7, newSVpv (r->val[i].pv_tags, 0), 0);
        (void) hv_store (hv, "pe_start", 8, my_newSVull (r->val[i].pe_start), 0);
        (void) hv_store (hv, "pv_mda_count", 12, my_newSVll (r->val[i].pv_mda_count), 0);
        (void) hv_store (hv, "pv_mda_free", 11, my_newSVull (r->val[i].pv_mda_free), 0);
        PUSHs (sv_2mortal (newRV ((SV *) hv)));
      }
      guestfs_free_lvm_pv_list (r);
#line 22531 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_pvuuid); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_pvuuid)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, device");
    {
	guestfs_h *	g;
	char *	device = (char *)SvPV_nolen(ST(1))
;
#line 9269 "lib/Sys/Guestfs.xs"
      char *r;
#line 22550 "lib/Sys/Guestfs.c"
	SV *	RETVAL;

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::pvuuid(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::pvuuid(): g is not a blessed HV reference");
    }
;
#line 9271 "lib/Sys/Guestfs.xs"
      r = guestfs_pvuuid (g, device);
      if (r == NULL)
        croak ("%s", guestfs_last_error (g));
      RETVAL = newSVpv (r, 0);
      free (r);
#line 22571 "lib/Sys/Guestfs.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Guestfs_pwrite); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_pwrite)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "g, path, content, offset");
    {
	guestfs_h *	g;
	char *	path = (char *)SvPV_nolen(ST(1))
;
	char *	content = (char *)SvPV_nolen(ST(2))
;
	size_t	content_size = SvCUR (ST(2));
	int64_t    offset = my_SvIV64 (ST(3))
;
#line 9287 "lib/Sys/Guestfs.xs"
      int r;
#line 22596 "lib/Sys/Guestfs.c"
	SV *	RETVAL;

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::pwrite(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::pwrite(): g is not a blessed HV reference");
    }
;
#line 9289 "lib/Sys/Guestfs.xs"
      r = guestfs_pwrite (g, path, content, content_size, offset);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
      RETVAL = newSViv (r);
#line 22616 "lib/Sys/Guestfs.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Guestfs_pwrite_device); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_pwrite_device)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "g, device, content, offset");
    {
	guestfs_h *	g;
	char *	device = (char *)SvPV_nolen(ST(1))
;
	char *	content = (char *)SvPV_nolen(ST(2))
;
	size_t	content_size = SvCUR (ST(2));
	int64_t    offset = my_SvIV64 (ST(3))
;
#line 9304 "lib/Sys/Guestfs.xs"
      int r;
#line 22641 "lib/Sys/Guestfs.c"
	SV *	RETVAL;

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::pwrite_device(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::pwrite_device(): g is not a blessed HV reference");
    }
;
#line 9306 "lib/Sys/Guestfs.xs"
      r = guestfs_pwrite_device (g, device, content, content_size, offset);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
      RETVAL = newSViv (r);
#line 22661 "lib/Sys/Guestfs.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Guestfs_read_file); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_read_file)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, path");
    {
	guestfs_h *	g;
	char *	path = (char *)SvPV_nolen(ST(1))
;
#line 9318 "lib/Sys/Guestfs.xs"
      char *r;
      size_t size;
#line 22682 "lib/Sys/Guestfs.c"
	SV *	RETVAL;

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::read_file(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::read_file(): g is not a blessed HV reference");
    }
;
#line 9321 "lib/Sys/Guestfs.xs"
      r = guestfs_read_file (g, path, &size);
      if (r == NULL)
        croak ("%s", guestfs_last_error (g));
      RETVAL = newSVpvn (r, size);
      free (r);
#line 22703 "lib/Sys/Guestfs.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Guestfs_read_lines); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_read_lines)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, path");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	path = (char *)SvPV_nolen(ST(1))
;
#line 9334 "lib/Sys/Guestfs.xs"
      char **r;
      size_t i, n;
#line 22726 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::read_lines(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::read_lines(): g is not a blessed HV reference");
    }
;
#line 9337 "lib/Sys/Guestfs.xs"
      r = guestfs_read_lines (g, path);
      if (r == NULL)
        croak ("%s", guestfs_last_error (g));
      for (n = 0; r[n] != NULL; ++n) /**/;
      EXTEND (SP, n);
      for (i = 0; i < n; ++i) {
        PUSHs (sv_2mortal (newSVpv (r[i], 0)));
        free (r[i]);
      }
      free (r);
#line 22751 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_readdir); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_readdir)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, dir");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	dir = (char *)SvPV_nolen(ST(1))
;
#line 9353 "lib/Sys/Guestfs.xs"
      struct guestfs_dirent_list *r;
      size_t i;
      HV *hv;
#line 22774 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::readdir(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::readdir(): g is not a blessed HV reference");
    }
;
#line 9357 "lib/Sys/Guestfs.xs"
      r = guestfs_readdir (g, dir);
      if (r == NULL)
        croak ("%s", guestfs_last_error (g));
      EXTEND (SP, r->len);
      for (i = 0; i < r->len; ++i) {
        hv = newHV ();
        (void) hv_store (hv, "ino", 3, my_newSVll (r->val[i].ino), 0);
        (void) hv_store (hv, "ftyp", 4, newSVpv (&r->val[i].ftyp, 1), 0);
        (void) hv_store (hv, "name", 4, newSVpv (r->val[i].name, 0), 0);
        PUSHs (sv_2mortal (newRV ((SV *) hv)));
      }
      guestfs_free_dirent_list (r);
#line 22801 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_readlink); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_readlink)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, path");
    {
	guestfs_h *	g;
	char *	path = (char *)SvPV_nolen(ST(1))
;
#line 9375 "lib/Sys/Guestfs.xs"
      char *r;
#line 22820 "lib/Sys/Guestfs.c"
	SV *	RETVAL;

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::readlink(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::readlink(): g is not a blessed HV reference");
    }
;
#line 9377 "lib/Sys/Guestfs.xs"
      r = guestfs_readlink (g, path);
      if (r == NULL)
        croak ("%s", guestfs_last_error (g));
      RETVAL = newSVpv (r, 0);
      free (r);
#line 22841 "lib/Sys/Guestfs.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Guestfs_readlinklist); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_readlinklist)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "g, path, names");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	path = (char *)SvPV_nolen(ST(1))
;
	char **	names = XS_unpack_charPtrPtr(ST(2))
;
#line 9391 "lib/Sys/Guestfs.xs"
      char **r;
      size_t i, n;
#line 22866 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::readlinklist(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::readlinklist(): g is not a blessed HV reference");
    }
;
#line 9394 "lib/Sys/Guestfs.xs"
      r = guestfs_readlinklist (g, path, names);
      free (names);
      if (r == NULL)
        croak ("%s", guestfs_last_error (g));
      for (n = 0; r[n] != NULL; ++n) /**/;
      EXTEND (SP, n);
      for (i = 0; i < n; ++i) {
        PUSHs (sv_2mortal (newSVpv (r[i], 0)));
        free (r[i]);
      }
      free (r);
#line 22892 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_realpath); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_realpath)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, path");
    {
	guestfs_h *	g;
	char *	path = (char *)SvPV_nolen(ST(1))
;
#line 9411 "lib/Sys/Guestfs.xs"
      char *r;
#line 22911 "lib/Sys/Guestfs.c"
	SV *	RETVAL;

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::realpath(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::realpath(): g is not a blessed HV reference");
    }
;
#line 9413 "lib/Sys/Guestfs.xs"
      r = guestfs_realpath (g, path);
      if (r == NULL)
        croak ("%s", guestfs_last_error (g));
      RETVAL = newSVpv (r, 0);
      free (r);
#line 22932 "lib/Sys/Guestfs.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Guestfs_remount); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_remount)
{
    dVAR; dXSARGS;
    if (items < 2)
       croak_xs_usage(cv,  "g, mountpoint, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	mountpoint = (char *)SvPV_nolen(ST(1))
;
#line 9426 "lib/Sys/Guestfs.xs"
      int r;
      struct guestfs_remount_argv optargs_s = { .bitmask = 0 };
      struct guestfs_remount_argv *optargs = &optargs_s;
      size_t items_i;
#line 22957 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::remount(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::remount(): g is not a blessed HV reference");
    }
;
#line 9431 "lib/Sys/Guestfs.xs"
      if (((items - 2) & 1) != 0)
        croak ("expecting an even number of extra parameters");
      for (items_i = 2; items_i < items; items_i += 2) {
        uint64_t this_mask;
        const char *this_arg;

        this_arg = SvPV_nolen (ST (items_i));
        if (STREQ (this_arg, "rw")) {
          optargs_s.rw = SvIV (ST (items_i+1));
          this_mask = GUESTFS_REMOUNT_RW_BITMASK;
        }
        else croak ("unknown optional argument '%s'", this_arg);
        if (optargs_s.bitmask & this_mask)
          croak ("optional argument '%s' given more than once",
                 this_arg);
        optargs_s.bitmask |= this_mask;
      }

      r = guestfs_remount_argv (g, mountpoint, optargs);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 22993 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_remove_drive); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_remove_drive)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, label");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	label = (char *)SvPV_nolen(ST(1))
;
#line 9458 "lib/Sys/Guestfs.xs"
      int r;
#line 23014 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::remove_drive(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::remove_drive(): g is not a blessed HV reference");
    }
;
#line 9460 "lib/Sys/Guestfs.xs"
      Perl_ck_warner (aTHX_ packWARN(WARN_DEPRECATED),
        "Sys::Guestfs::remove_drive is deprecated");
      r = guestfs_remove_drive (g, label);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 23034 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_removexattr); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_removexattr)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "g, xattr, path");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	xattr = (char *)SvPV_nolen(ST(1))
;
	char *	path = (char *)SvPV_nolen(ST(2))
;
#line 9472 "lib/Sys/Guestfs.xs"
      int r;
#line 23057 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::removexattr(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::removexattr(): g is not a blessed HV reference");
    }
;
#line 9474 "lib/Sys/Guestfs.xs"
      r = guestfs_removexattr (g, xattr, path);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 23075 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_rename); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_rename)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "g, oldpath, newpath");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	oldpath = (char *)SvPV_nolen(ST(1))
;
	char *	newpath = (char *)SvPV_nolen(ST(2))
;
#line 9484 "lib/Sys/Guestfs.xs"
      int r;
#line 23098 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::rename(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::rename(): g is not a blessed HV reference");
    }
;
#line 9486 "lib/Sys/Guestfs.xs"
      r = guestfs_rename (g, oldpath, newpath);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 23116 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_resize2fs); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_resize2fs)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, device");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	device = (char *)SvPV_nolen(ST(1))
;
#line 9495 "lib/Sys/Guestfs.xs"
      int r;
#line 23137 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::resize2fs(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::resize2fs(): g is not a blessed HV reference");
    }
;
#line 9497 "lib/Sys/Guestfs.xs"
      r = guestfs_resize2fs (g, device);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 23155 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_resize2fs_M); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_resize2fs_M)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, device");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	device = (char *)SvPV_nolen(ST(1))
;
#line 9506 "lib/Sys/Guestfs.xs"
      int r;
#line 23176 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::resize2fs_M(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::resize2fs_M(): g is not a blessed HV reference");
    }
;
#line 9508 "lib/Sys/Guestfs.xs"
      r = guestfs_resize2fs_M (g, device);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 23194 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_resize2fs_size); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_resize2fs_size)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "g, device, size");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	device = (char *)SvPV_nolen(ST(1))
;
	int64_t    size = my_SvIV64 (ST(2))
;
#line 9518 "lib/Sys/Guestfs.xs"
      int r;
#line 23217 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::resize2fs_size(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::resize2fs_size(): g is not a blessed HV reference");
    }
;
#line 9520 "lib/Sys/Guestfs.xs"
      r = guestfs_resize2fs_size (g, device, size);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 23235 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_rm); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_rm)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, path");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	path = (char *)SvPV_nolen(ST(1))
;
#line 9529 "lib/Sys/Guestfs.xs"
      int r;
#line 23256 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::rm(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::rm(): g is not a blessed HV reference");
    }
;
#line 9531 "lib/Sys/Guestfs.xs"
      r = guestfs_rm (g, path);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 23274 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_rm_f); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_rm_f)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, path");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	path = (char *)SvPV_nolen(ST(1))
;
#line 9540 "lib/Sys/Guestfs.xs"
      int r;
#line 23295 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::rm_f(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::rm_f(): g is not a blessed HV reference");
    }
;
#line 9542 "lib/Sys/Guestfs.xs"
      r = guestfs_rm_f (g, path);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 23313 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_rm_rf); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_rm_rf)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, path");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	path = (char *)SvPV_nolen(ST(1))
;
#line 9551 "lib/Sys/Guestfs.xs"
      int r;
#line 23334 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::rm_rf(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::rm_rf(): g is not a blessed HV reference");
    }
;
#line 9553 "lib/Sys/Guestfs.xs"
      r = guestfs_rm_rf (g, path);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 23352 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_rmdir); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_rmdir)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, path");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	path = (char *)SvPV_nolen(ST(1))
;
#line 9562 "lib/Sys/Guestfs.xs"
      int r;
#line 23373 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::rmdir(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::rmdir(): g is not a blessed HV reference");
    }
;
#line 9564 "lib/Sys/Guestfs.xs"
      r = guestfs_rmdir (g, path);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 23391 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_rmmountpoint); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_rmmountpoint)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, exemptpath");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	exemptpath = (char *)SvPV_nolen(ST(1))
;
#line 9573 "lib/Sys/Guestfs.xs"
      int r;
#line 23412 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::rmmountpoint(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::rmmountpoint(): g is not a blessed HV reference");
    }
;
#line 9575 "lib/Sys/Guestfs.xs"
      r = guestfs_rmmountpoint (g, exemptpath);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 23430 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_rsync); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_rsync)
{
    dVAR; dXSARGS;
    if (items < 3)
       croak_xs_usage(cv,  "g, src, dest, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	src = (char *)SvPV_nolen(ST(1))
;
	char *	dest = (char *)SvPV_nolen(ST(2))
;
#line 9585 "lib/Sys/Guestfs.xs"
      int r;
      struct guestfs_rsync_argv optargs_s = { .bitmask = 0 };
      struct guestfs_rsync_argv *optargs = &optargs_s;
      size_t items_i;
#line 23456 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::rsync(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::rsync(): g is not a blessed HV reference");
    }
;
#line 9590 "lib/Sys/Guestfs.xs"
      if (((items - 3) & 1) != 0)
        croak ("expecting an even number of extra parameters");
      for (items_i = 3; items_i < items; items_i += 2) {
        uint64_t this_mask;
        const char *this_arg;

        this_arg = SvPV_nolen (ST (items_i));
        if (STREQ (this_arg, "archive")) {
          optargs_s.archive = SvIV (ST (items_i+1));
          this_mask = GUESTFS_RSYNC_ARCHIVE_BITMASK;
        }
        else if (STREQ (this_arg, "deletedest")) {
          optargs_s.deletedest = SvIV (ST (items_i+1));
          this_mask = GUESTFS_RSYNC_DELETEDEST_BITMASK;
        }
        else croak ("unknown optional argument '%s'", this_arg);
        if (optargs_s.bitmask & this_mask)
          croak ("optional argument '%s' given more than once",
                 this_arg);
        optargs_s.bitmask |= this_mask;
      }

      r = guestfs_rsync_argv (g, src, dest, optargs);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 23496 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_rsync_in); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_rsync_in)
{
    dVAR; dXSARGS;
    if (items < 3)
       croak_xs_usage(cv,  "g, remote, dest, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	remote = (char *)SvPV_nolen(ST(1))
;
	char *	dest = (char *)SvPV_nolen(ST(2))
;
#line 9622 "lib/Sys/Guestfs.xs"
      int r;
      struct guestfs_rsync_in_argv optargs_s = { .bitmask = 0 };
      struct guestfs_rsync_in_argv *optargs = &optargs_s;
      size_t items_i;
#line 23522 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::rsync_in(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::rsync_in(): g is not a blessed HV reference");
    }
;
#line 9627 "lib/Sys/Guestfs.xs"
      if (((items - 3) & 1) != 0)
        croak ("expecting an even number of extra parameters");
      for (items_i = 3; items_i < items; items_i += 2) {
        uint64_t this_mask;
        const char *this_arg;

        this_arg = SvPV_nolen (ST (items_i));
        if (STREQ (this_arg, "archive")) {
          optargs_s.archive = SvIV (ST (items_i+1));
          this_mask = GUESTFS_RSYNC_IN_ARCHIVE_BITMASK;
        }
        else if (STREQ (this_arg, "deletedest")) {
          optargs_s.deletedest = SvIV (ST (items_i+1));
          this_mask = GUESTFS_RSYNC_IN_DELETEDEST_BITMASK;
        }
        else croak ("unknown optional argument '%s'", this_arg);
        if (optargs_s.bitmask & this_mask)
          croak ("optional argument '%s' given more than once",
                 this_arg);
        optargs_s.bitmask |= this_mask;
      }

      r = guestfs_rsync_in_argv (g, remote, dest, optargs);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 23562 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_rsync_out); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_rsync_out)
{
    dVAR; dXSARGS;
    if (items < 3)
       croak_xs_usage(cv,  "g, src, remote, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	src = (char *)SvPV_nolen(ST(1))
;
	char *	remote = (char *)SvPV_nolen(ST(2))
;
#line 9659 "lib/Sys/Guestfs.xs"
      int r;
      struct guestfs_rsync_out_argv optargs_s = { .bitmask = 0 };
      struct guestfs_rsync_out_argv *optargs = &optargs_s;
      size_t items_i;
#line 23588 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::rsync_out(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::rsync_out(): g is not a blessed HV reference");
    }
;
#line 9664 "lib/Sys/Guestfs.xs"
      if (((items - 3) & 1) != 0)
        croak ("expecting an even number of extra parameters");
      for (items_i = 3; items_i < items; items_i += 2) {
        uint64_t this_mask;
        const char *this_arg;

        this_arg = SvPV_nolen (ST (items_i));
        if (STREQ (this_arg, "archive")) {
          optargs_s.archive = SvIV (ST (items_i+1));
          this_mask = GUESTFS_RSYNC_OUT_ARCHIVE_BITMASK;
        }
        else if (STREQ (this_arg, "deletedest")) {
          optargs_s.deletedest = SvIV (ST (items_i+1));
          this_mask = GUESTFS_RSYNC_OUT_DELETEDEST_BITMASK;
        }
        else croak ("unknown optional argument '%s'", this_arg);
        if (optargs_s.bitmask & this_mask)
          croak ("optional argument '%s' given more than once",
                 this_arg);
        optargs_s.bitmask |= this_mask;
      }

      r = guestfs_rsync_out_argv (g, src, remote, optargs);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 23628 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_scrub_device); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_scrub_device)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, device");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	device = (char *)SvPV_nolen(ST(1))
;
#line 9695 "lib/Sys/Guestfs.xs"
      int r;
#line 23649 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::scrub_device(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::scrub_device(): g is not a blessed HV reference");
    }
;
#line 9697 "lib/Sys/Guestfs.xs"
      r = guestfs_scrub_device (g, device);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 23667 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_scrub_file); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_scrub_file)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, file");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	file = (char *)SvPV_nolen(ST(1))
;
#line 9706 "lib/Sys/Guestfs.xs"
      int r;
#line 23688 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::scrub_file(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::scrub_file(): g is not a blessed HV reference");
    }
;
#line 9708 "lib/Sys/Guestfs.xs"
      r = guestfs_scrub_file (g, file);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 23706 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_scrub_freespace); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_scrub_freespace)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, dir");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	dir = (char *)SvPV_nolen(ST(1))
;
#line 9717 "lib/Sys/Guestfs.xs"
      int r;
#line 23727 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::scrub_freespace(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::scrub_freespace(): g is not a blessed HV reference");
    }
;
#line 9719 "lib/Sys/Guestfs.xs"
      r = guestfs_scrub_freespace (g, dir);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 23745 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_selinux_relabel); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_selinux_relabel)
{
    dVAR; dXSARGS;
    if (items < 3)
       croak_xs_usage(cv,  "g, specfile, path, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	specfile = (char *)SvPV_nolen(ST(1))
;
	char *	path = (char *)SvPV_nolen(ST(2))
;
#line 9729 "lib/Sys/Guestfs.xs"
      int r;
      struct guestfs_selinux_relabel_argv optargs_s = { .bitmask = 0 };
      struct guestfs_selinux_relabel_argv *optargs = &optargs_s;
      size_t items_i;
#line 23771 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::selinux_relabel(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::selinux_relabel(): g is not a blessed HV reference");
    }
;
#line 9734 "lib/Sys/Guestfs.xs"
      if (((items - 3) & 1) != 0)
        croak ("expecting an even number of extra parameters");
      for (items_i = 3; items_i < items; items_i += 2) {
        uint64_t this_mask;
        const char *this_arg;

        this_arg = SvPV_nolen (ST (items_i));
        if (STREQ (this_arg, "force")) {
          optargs_s.force = SvIV (ST (items_i+1));
          this_mask = GUESTFS_SELINUX_RELABEL_FORCE_BITMASK;
        }
        else croak ("unknown optional argument '%s'", this_arg);
        if (optargs_s.bitmask & this_mask)
          croak ("optional argument '%s' given more than once",
                 this_arg);
        optargs_s.bitmask |= this_mask;
      }

      r = guestfs_selinux_relabel_argv (g, specfile, path, optargs);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 23807 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_set_append); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_set_append)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, append");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	append = SvOK(ST(1)) ? SvPV_nolen(ST(1)) : NULL;
#line 9761 "lib/Sys/Guestfs.xs"
      int r;
#line 23827 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::set_append(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::set_append(): g is not a blessed HV reference");
    }
;
#line 9763 "lib/Sys/Guestfs.xs"
      r = guestfs_set_append (g, append);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 23845 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_set_attach_method); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_set_attach_method)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, backend");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	backend = (char *)SvPV_nolen(ST(1))
;
#line 9772 "lib/Sys/Guestfs.xs"
      int r;
#line 23866 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::set_attach_method(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::set_attach_method(): g is not a blessed HV reference");
    }
;
#line 9774 "lib/Sys/Guestfs.xs"
      Perl_ck_warner (aTHX_ packWARN(WARN_DEPRECATED),
        "Sys::Guestfs::set_attach_method is deprecated; use Sys::Guestfs::set_backend instead");
      r = guestfs_set_attach_method (g, backend);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 23886 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_set_autosync); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_set_autosync)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, autosync");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	int	autosync = (int)SvIV(ST(1))
;
#line 9785 "lib/Sys/Guestfs.xs"
      int r;
#line 23907 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::set_autosync(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::set_autosync(): g is not a blessed HV reference");
    }
;
#line 9787 "lib/Sys/Guestfs.xs"
      r = guestfs_set_autosync (g, autosync);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 23925 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_set_backend); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_set_backend)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, backend");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	backend = (char *)SvPV_nolen(ST(1))
;
#line 9796 "lib/Sys/Guestfs.xs"
      int r;
#line 23946 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::set_backend(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::set_backend(): g is not a blessed HV reference");
    }
;
#line 9798 "lib/Sys/Guestfs.xs"
      r = guestfs_set_backend (g, backend);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 23964 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_set_backend_setting); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_set_backend_setting)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "g, name, val");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	name = (char *)SvPV_nolen(ST(1))
;
	char *	val = (char *)SvPV_nolen(ST(2))
;
#line 9808 "lib/Sys/Guestfs.xs"
      int r;
#line 23987 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::set_backend_setting(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::set_backend_setting(): g is not a blessed HV reference");
    }
;
#line 9810 "lib/Sys/Guestfs.xs"
      r = guestfs_set_backend_setting (g, name, val);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 24005 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_set_backend_settings); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_set_backend_settings)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, settings");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char **	settings = XS_unpack_charPtrPtr(ST(1))
;
#line 9819 "lib/Sys/Guestfs.xs"
      int r;
#line 24026 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::set_backend_settings(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::set_backend_settings(): g is not a blessed HV reference");
    }
;
#line 9821 "lib/Sys/Guestfs.xs"
      r = guestfs_set_backend_settings (g, settings);
      free (settings);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 24045 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_set_cachedir); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_set_cachedir)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, cachedir");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	cachedir = SvOK(ST(1)) ? SvPV_nolen(ST(1)) : NULL;
#line 9831 "lib/Sys/Guestfs.xs"
      int r;
#line 24065 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::set_cachedir(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::set_cachedir(): g is not a blessed HV reference");
    }
;
#line 9833 "lib/Sys/Guestfs.xs"
      r = guestfs_set_cachedir (g, cachedir);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 24083 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_set_direct); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_set_direct)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, direct");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	int	direct = (int)SvIV(ST(1))
;
#line 9842 "lib/Sys/Guestfs.xs"
      int r;
#line 24104 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::set_direct(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::set_direct(): g is not a blessed HV reference");
    }
;
#line 9844 "lib/Sys/Guestfs.xs"
      Perl_ck_warner (aTHX_ packWARN(WARN_DEPRECATED),
        "Sys::Guestfs::set_direct is deprecated; use Sys::Guestfs::internal_get_console_socket instead");
      r = guestfs_set_direct (g, direct);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 24124 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_set_e2attrs); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_set_e2attrs)
{
    dVAR; dXSARGS;
    if (items < 3)
       croak_xs_usage(cv,  "g, file, attrs, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	file = (char *)SvPV_nolen(ST(1))
;
	char *	attrs = (char *)SvPV_nolen(ST(2))
;
#line 9856 "lib/Sys/Guestfs.xs"
      int r;
      struct guestfs_set_e2attrs_argv optargs_s = { .bitmask = 0 };
      struct guestfs_set_e2attrs_argv *optargs = &optargs_s;
      size_t items_i;
#line 24150 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::set_e2attrs(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::set_e2attrs(): g is not a blessed HV reference");
    }
;
#line 9861 "lib/Sys/Guestfs.xs"
      if (((items - 3) & 1) != 0)
        croak ("expecting an even number of extra parameters");
      for (items_i = 3; items_i < items; items_i += 2) {
        uint64_t this_mask;
        const char *this_arg;

        this_arg = SvPV_nolen (ST (items_i));
        if (STREQ (this_arg, "clear")) {
          optargs_s.clear = SvIV (ST (items_i+1));
          this_mask = GUESTFS_SET_E2ATTRS_CLEAR_BITMASK;
        }
        else croak ("unknown optional argument '%s'", this_arg);
        if (optargs_s.bitmask & this_mask)
          croak ("optional argument '%s' given more than once",
                 this_arg);
        optargs_s.bitmask |= this_mask;
      }

      r = guestfs_set_e2attrs_argv (g, file, attrs, optargs);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 24186 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_set_e2generation); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_set_e2generation)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "g, file, generation");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	file = (char *)SvPV_nolen(ST(1))
;
	int64_t    generation = my_SvIV64 (ST(2))
;
#line 9889 "lib/Sys/Guestfs.xs"
      int r;
#line 24209 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::set_e2generation(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::set_e2generation(): g is not a blessed HV reference");
    }
;
#line 9891 "lib/Sys/Guestfs.xs"
      r = guestfs_set_e2generation (g, file, generation);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 24227 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_set_e2label); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_set_e2label)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "g, device, label");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	device = (char *)SvPV_nolen(ST(1))
;
	char *	label = (char *)SvPV_nolen(ST(2))
;
#line 9901 "lib/Sys/Guestfs.xs"
      int r;
#line 24250 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::set_e2label(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::set_e2label(): g is not a blessed HV reference");
    }
;
#line 9903 "lib/Sys/Guestfs.xs"
      Perl_ck_warner (aTHX_ packWARN(WARN_DEPRECATED),
        "Sys::Guestfs::set_e2label is deprecated; use Sys::Guestfs::set_label instead");
      r = guestfs_set_e2label (g, device, label);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 24270 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_set_e2uuid); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_set_e2uuid)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "g, device, uuid");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	device = (char *)SvPV_nolen(ST(1))
;
	char *	uuid = (char *)SvPV_nolen(ST(2))
;
#line 9915 "lib/Sys/Guestfs.xs"
      int r;
#line 24293 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::set_e2uuid(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::set_e2uuid(): g is not a blessed HV reference");
    }
;
#line 9917 "lib/Sys/Guestfs.xs"
      Perl_ck_warner (aTHX_ packWARN(WARN_DEPRECATED),
        "Sys::Guestfs::set_e2uuid is deprecated; use Sys::Guestfs::set_uuid instead");
      r = guestfs_set_e2uuid (g, device, uuid);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 24313 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_set_hv); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_set_hv)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, hv");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	hv = (char *)SvPV_nolen(ST(1))
;
#line 9928 "lib/Sys/Guestfs.xs"
      int r;
#line 24334 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::set_hv(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::set_hv(): g is not a blessed HV reference");
    }
;
#line 9930 "lib/Sys/Guestfs.xs"
      r = guestfs_set_hv (g, hv);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 24352 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_set_identifier); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_set_identifier)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, identifier");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	identifier = (char *)SvPV_nolen(ST(1))
;
#line 9939 "lib/Sys/Guestfs.xs"
      int r;
#line 24373 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::set_identifier(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::set_identifier(): g is not a blessed HV reference");
    }
;
#line 9941 "lib/Sys/Guestfs.xs"
      r = guestfs_set_identifier (g, identifier);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 24391 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_set_label); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_set_label)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "g, mountable, label");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	mountable = (char *)SvPV_nolen(ST(1))
;
	char *	label = (char *)SvPV_nolen(ST(2))
;
#line 9951 "lib/Sys/Guestfs.xs"
      int r;
#line 24414 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::set_label(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::set_label(): g is not a blessed HV reference");
    }
;
#line 9953 "lib/Sys/Guestfs.xs"
      r = guestfs_set_label (g, mountable, label);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 24432 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_set_libvirt_requested_credential); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_set_libvirt_requested_credential)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "g, index, cred");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	int	index = (int)SvIV(ST(1))
;
	char *	cred = (char *)SvPV_nolen(ST(2))
;
	size_t	cred_size = SvCUR (ST(2));
#line 9964 "lib/Sys/Guestfs.xs"
      int r;
#line 24456 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::set_libvirt_requested_credential(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::set_libvirt_requested_credential(): g is not a blessed HV reference");
    }
;
#line 9966 "lib/Sys/Guestfs.xs"
      r = guestfs_set_libvirt_requested_credential (g, index, cred, cred_size);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 24474 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_set_libvirt_supported_credentials); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_set_libvirt_supported_credentials)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, creds");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char **	creds = XS_unpack_charPtrPtr(ST(1))
;
#line 9975 "lib/Sys/Guestfs.xs"
      int r;
#line 24495 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::set_libvirt_supported_credentials(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::set_libvirt_supported_credentials(): g is not a blessed HV reference");
    }
;
#line 9977 "lib/Sys/Guestfs.xs"
      r = guestfs_set_libvirt_supported_credentials (g, creds);
      free (creds);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 24514 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_set_memsize); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_set_memsize)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, memsize");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	int	memsize = (int)SvIV(ST(1))
;
#line 9987 "lib/Sys/Guestfs.xs"
      int r;
#line 24535 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::set_memsize(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::set_memsize(): g is not a blessed HV reference");
    }
;
#line 9989 "lib/Sys/Guestfs.xs"
      r = guestfs_set_memsize (g, memsize);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 24553 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_set_network); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_set_network)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, network");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	int	network = (int)SvIV(ST(1))
;
#line 9998 "lib/Sys/Guestfs.xs"
      int r;
#line 24574 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::set_network(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::set_network(): g is not a blessed HV reference");
    }
;
#line 10000 "lib/Sys/Guestfs.xs"
      r = guestfs_set_network (g, network);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 24592 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_set_path); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_set_path)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, searchpath");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	searchpath = SvOK(ST(1)) ? SvPV_nolen(ST(1)) : NULL;
#line 10009 "lib/Sys/Guestfs.xs"
      int r;
#line 24612 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::set_path(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::set_path(): g is not a blessed HV reference");
    }
;
#line 10011 "lib/Sys/Guestfs.xs"
      r = guestfs_set_path (g, searchpath);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 24630 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_set_pgroup); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_set_pgroup)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, pgroup");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	int	pgroup = (int)SvIV(ST(1))
;
#line 10020 "lib/Sys/Guestfs.xs"
      int r;
#line 24651 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::set_pgroup(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::set_pgroup(): g is not a blessed HV reference");
    }
;
#line 10022 "lib/Sys/Guestfs.xs"
      r = guestfs_set_pgroup (g, pgroup);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 24669 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_set_program); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_set_program)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, program");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	program = (char *)SvPV_nolen(ST(1))
;
#line 10031 "lib/Sys/Guestfs.xs"
      int r;
#line 24690 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::set_program(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::set_program(): g is not a blessed HV reference");
    }
;
#line 10033 "lib/Sys/Guestfs.xs"
      r = guestfs_set_program (g, program);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 24708 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_set_qemu); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_set_qemu)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, hv");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	hv = SvOK(ST(1)) ? SvPV_nolen(ST(1)) : NULL;
#line 10042 "lib/Sys/Guestfs.xs"
      int r;
#line 24728 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::set_qemu(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::set_qemu(): g is not a blessed HV reference");
    }
;
#line 10044 "lib/Sys/Guestfs.xs"
      Perl_ck_warner (aTHX_ packWARN(WARN_DEPRECATED),
        "Sys::Guestfs::set_qemu is deprecated; use Sys::Guestfs::set_hv instead");
      r = guestfs_set_qemu (g, hv);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 24748 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_set_recovery_proc); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_set_recovery_proc)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, recoveryproc");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	int	recoveryproc = (int)SvIV(ST(1))
;
#line 10055 "lib/Sys/Guestfs.xs"
      int r;
#line 24769 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::set_recovery_proc(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::set_recovery_proc(): g is not a blessed HV reference");
    }
;
#line 10057 "lib/Sys/Guestfs.xs"
      r = guestfs_set_recovery_proc (g, recoveryproc);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 24787 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_set_selinux); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_set_selinux)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, selinux");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	int	selinux = (int)SvIV(ST(1))
;
#line 10066 "lib/Sys/Guestfs.xs"
      int r;
#line 24808 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::set_selinux(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::set_selinux(): g is not a blessed HV reference");
    }
;
#line 10068 "lib/Sys/Guestfs.xs"
      Perl_ck_warner (aTHX_ packWARN(WARN_DEPRECATED),
        "Sys::Guestfs::set_selinux is deprecated; use Sys::Guestfs::selinux_relabel instead");
      r = guestfs_set_selinux (g, selinux);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 24828 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_set_smp); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_set_smp)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, smp");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	int	smp = (int)SvIV(ST(1))
;
#line 10079 "lib/Sys/Guestfs.xs"
      int r;
#line 24849 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::set_smp(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::set_smp(): g is not a blessed HV reference");
    }
;
#line 10081 "lib/Sys/Guestfs.xs"
      r = guestfs_set_smp (g, smp);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 24867 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_set_tmpdir); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_set_tmpdir)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, tmpdir");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	tmpdir = SvOK(ST(1)) ? SvPV_nolen(ST(1)) : NULL;
#line 10090 "lib/Sys/Guestfs.xs"
      int r;
#line 24887 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::set_tmpdir(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::set_tmpdir(): g is not a blessed HV reference");
    }
;
#line 10092 "lib/Sys/Guestfs.xs"
      r = guestfs_set_tmpdir (g, tmpdir);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 24905 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_set_trace); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_set_trace)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, trace");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	int	trace = (int)SvIV(ST(1))
;
#line 10101 "lib/Sys/Guestfs.xs"
      int r;
#line 24926 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::set_trace(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::set_trace(): g is not a blessed HV reference");
    }
;
#line 10103 "lib/Sys/Guestfs.xs"
      r = guestfs_set_trace (g, trace);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 24944 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_set_uuid); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_set_uuid)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "g, device, uuid");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	device = (char *)SvPV_nolen(ST(1))
;
	char *	uuid = (char *)SvPV_nolen(ST(2))
;
#line 10113 "lib/Sys/Guestfs.xs"
      int r;
#line 24967 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::set_uuid(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::set_uuid(): g is not a blessed HV reference");
    }
;
#line 10115 "lib/Sys/Guestfs.xs"
      r = guestfs_set_uuid (g, device, uuid);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 24985 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_set_uuid_random); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_set_uuid_random)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, device");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	device = (char *)SvPV_nolen(ST(1))
;
#line 10124 "lib/Sys/Guestfs.xs"
      int r;
#line 25006 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::set_uuid_random(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::set_uuid_random(): g is not a blessed HV reference");
    }
;
#line 10126 "lib/Sys/Guestfs.xs"
      r = guestfs_set_uuid_random (g, device);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 25024 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_set_verbose); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_set_verbose)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, verbose");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	int	verbose = (int)SvIV(ST(1))
;
#line 10135 "lib/Sys/Guestfs.xs"
      int r;
#line 25045 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::set_verbose(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::set_verbose(): g is not a blessed HV reference");
    }
;
#line 10137 "lib/Sys/Guestfs.xs"
      r = guestfs_set_verbose (g, verbose);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 25063 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_setcon); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_setcon)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, context");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	context = (char *)SvPV_nolen(ST(1))
;
#line 10146 "lib/Sys/Guestfs.xs"
      int r;
#line 25084 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::setcon(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::setcon(): g is not a blessed HV reference");
    }
;
#line 10148 "lib/Sys/Guestfs.xs"
      Perl_ck_warner (aTHX_ packWARN(WARN_DEPRECATED),
        "Sys::Guestfs::setcon is deprecated; use Sys::Guestfs::selinux_relabel instead");
      r = guestfs_setcon (g, context);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 25104 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_setxattr); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_setxattr)
{
    dVAR; dXSARGS;
    if (items != 5)
       croak_xs_usage(cv,  "g, xattr, val, vallen, path");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	xattr = (char *)SvPV_nolen(ST(1))
;
	char *	val = (char *)SvPV_nolen(ST(2))
;
	int	vallen = (int)SvIV(ST(3))
;
	char *	path = (char *)SvPV_nolen(ST(4))
;
#line 10162 "lib/Sys/Guestfs.xs"
      int r;
#line 25131 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::setxattr(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::setxattr(): g is not a blessed HV reference");
    }
;
#line 10164 "lib/Sys/Guestfs.xs"
      r = guestfs_setxattr (g, xattr, val, vallen, path);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 25149 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_sfdisk); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_sfdisk)
{
    dVAR; dXSARGS;
    if (items != 6)
       croak_xs_usage(cv,  "g, device, cyls, heads, sectors, lines");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	device = (char *)SvPV_nolen(ST(1))
;
	int	cyls = (int)SvIV(ST(2))
;
	int	heads = (int)SvIV(ST(3))
;
	int	sectors = (int)SvIV(ST(4))
;
	char **	lines = XS_unpack_charPtrPtr(ST(5))
;
#line 10177 "lib/Sys/Guestfs.xs"
      int r;
#line 25178 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::sfdisk(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::sfdisk(): g is not a blessed HV reference");
    }
;
#line 10179 "lib/Sys/Guestfs.xs"
      Perl_ck_warner (aTHX_ packWARN(WARN_DEPRECATED),
        "Sys::Guestfs::sfdisk is deprecated; use Sys::Guestfs::part_add instead");
      r = guestfs_sfdisk (g, device, cyls, heads, sectors, lines);
      free (lines);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 25199 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_sfdiskM); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_sfdiskM)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "g, device, lines");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	device = (char *)SvPV_nolen(ST(1))
;
	char **	lines = XS_unpack_charPtrPtr(ST(2))
;
#line 10192 "lib/Sys/Guestfs.xs"
      int r;
#line 25222 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::sfdiskM(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::sfdiskM(): g is not a blessed HV reference");
    }
;
#line 10194 "lib/Sys/Guestfs.xs"
      Perl_ck_warner (aTHX_ packWARN(WARN_DEPRECATED),
        "Sys::Guestfs::sfdiskM is deprecated; use Sys::Guestfs::part_add instead");
      r = guestfs_sfdiskM (g, device, lines);
      free (lines);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 25243 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_sfdisk_N); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_sfdisk_N)
{
    dVAR; dXSARGS;
    if (items != 7)
       croak_xs_usage(cv,  "g, device, partnum, cyls, heads, sectors, line");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	device = (char *)SvPV_nolen(ST(1))
;
	int	partnum = (int)SvIV(ST(2))
;
	int	cyls = (int)SvIV(ST(3))
;
	int	heads = (int)SvIV(ST(4))
;
	int	sectors = (int)SvIV(ST(5))
;
	char *	line = (char *)SvPV_nolen(ST(6))
;
#line 10211 "lib/Sys/Guestfs.xs"
      int r;
#line 25274 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::sfdisk_N(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::sfdisk_N(): g is not a blessed HV reference");
    }
;
#line 10213 "lib/Sys/Guestfs.xs"
      Perl_ck_warner (aTHX_ packWARN(WARN_DEPRECATED),
        "Sys::Guestfs::sfdisk_N is deprecated; use Sys::Guestfs::part_add instead");
      r = guestfs_sfdisk_N (g, device, partnum, cyls, heads, sectors, line);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 25294 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_sfdisk_disk_geometry); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_sfdisk_disk_geometry)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, device");
    {
	guestfs_h *	g;
	char *	device = (char *)SvPV_nolen(ST(1))
;
#line 10224 "lib/Sys/Guestfs.xs"
      char *r;
#line 25313 "lib/Sys/Guestfs.c"
	SV *	RETVAL;

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::sfdisk_disk_geometry(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::sfdisk_disk_geometry(): g is not a blessed HV reference");
    }
;
#line 10226 "lib/Sys/Guestfs.xs"
      r = guestfs_sfdisk_disk_geometry (g, device);
      if (r == NULL)
        croak ("%s", guestfs_last_error (g));
      RETVAL = newSVpv (r, 0);
      free (r);
#line 25334 "lib/Sys/Guestfs.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Guestfs_sfdisk_kernel_geometry); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_sfdisk_kernel_geometry)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, device");
    {
	guestfs_h *	g;
	char *	device = (char *)SvPV_nolen(ST(1))
;
#line 10239 "lib/Sys/Guestfs.xs"
      char *r;
#line 25354 "lib/Sys/Guestfs.c"
	SV *	RETVAL;

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::sfdisk_kernel_geometry(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::sfdisk_kernel_geometry(): g is not a blessed HV reference");
    }
;
#line 10241 "lib/Sys/Guestfs.xs"
      r = guestfs_sfdisk_kernel_geometry (g, device);
      if (r == NULL)
        croak ("%s", guestfs_last_error (g));
      RETVAL = newSVpv (r, 0);
      free (r);
#line 25375 "lib/Sys/Guestfs.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Guestfs_sfdisk_l); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_sfdisk_l)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, device");
    {
	guestfs_h *	g;
	char *	device = (char *)SvPV_nolen(ST(1))
;
#line 10254 "lib/Sys/Guestfs.xs"
      char *r;
#line 25395 "lib/Sys/Guestfs.c"
	SV *	RETVAL;

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::sfdisk_l(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::sfdisk_l(): g is not a blessed HV reference");
    }
;
#line 10256 "lib/Sys/Guestfs.xs"
      Perl_ck_warner (aTHX_ packWARN(WARN_DEPRECATED),
        "Sys::Guestfs::sfdisk_l is deprecated; use Sys::Guestfs::part_list instead");
      r = guestfs_sfdisk_l (g, device);
      if (r == NULL)
        croak ("%s", guestfs_last_error (g));
      RETVAL = newSVpv (r, 0);
      free (r);
#line 25418 "lib/Sys/Guestfs.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Guestfs_sh); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_sh)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, command");
    {
	guestfs_h *	g;
	char *	command = (char *)SvPV_nolen(ST(1))
;
#line 10271 "lib/Sys/Guestfs.xs"
      char *r;
#line 25438 "lib/Sys/Guestfs.c"
	SV *	RETVAL;

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::sh(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::sh(): g is not a blessed HV reference");
    }
;
#line 10273 "lib/Sys/Guestfs.xs"
      r = guestfs_sh (g, command);
      if (r == NULL)
        croak ("%s", guestfs_last_error (g));
      RETVAL = newSVpv (r, 0);
      free (r);
#line 25459 "lib/Sys/Guestfs.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Guestfs_sh_lines); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_sh_lines)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, command");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	command = (char *)SvPV_nolen(ST(1))
;
#line 10286 "lib/Sys/Guestfs.xs"
      char **r;
      size_t i, n;
#line 25482 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::sh_lines(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::sh_lines(): g is not a blessed HV reference");
    }
;
#line 10289 "lib/Sys/Guestfs.xs"
      r = guestfs_sh_lines (g, command);
      if (r == NULL)
        croak ("%s", guestfs_last_error (g));
      for (n = 0; r[n] != NULL; ++n) /**/;
      EXTEND (SP, n);
      for (i = 0; i < n; ++i) {
        PUSHs (sv_2mortal (newSVpv (r[i], 0)));
        free (r[i]);
      }
      free (r);
#line 25507 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_shutdown); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_shutdown)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "g");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
#line 10304 "lib/Sys/Guestfs.xs"
      int r;
#line 25526 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::shutdown(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::shutdown(): g is not a blessed HV reference");
    }
;
#line 10306 "lib/Sys/Guestfs.xs"
      r = guestfs_shutdown (g);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 25544 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_sleep); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_sleep)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, secs");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	int	secs = (int)SvIV(ST(1))
;
#line 10315 "lib/Sys/Guestfs.xs"
      int r;
#line 25565 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::sleep(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::sleep(): g is not a blessed HV reference");
    }
;
#line 10317 "lib/Sys/Guestfs.xs"
      r = guestfs_sleep (g, secs);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 25583 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_stat); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_stat)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, path");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	path = (char *)SvPV_nolen(ST(1))
;
#line 10326 "lib/Sys/Guestfs.xs"
      struct guestfs_stat *r;
#line 25604 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::stat(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::stat(): g is not a blessed HV reference");
    }
;
#line 10328 "lib/Sys/Guestfs.xs"
      Perl_ck_warner (aTHX_ packWARN(WARN_DEPRECATED),
        "Sys::Guestfs::stat is deprecated; use Sys::Guestfs::statns instead");
      r = guestfs_stat (g, path);
      if (r == NULL)
        croak ("%s", guestfs_last_error (g));
      EXTEND (SP, 2 * 13);
      PUSHs (sv_2mortal (newSVpv ("dev", 0)));
      PUSHs (sv_2mortal (my_newSVll (r->dev)));
      PUSHs (sv_2mortal (newSVpv ("ino", 0)));
      PUSHs (sv_2mortal (my_newSVll (r->ino)));
      PUSHs (sv_2mortal (newSVpv ("mode", 0)));
      PUSHs (sv_2mortal (my_newSVll (r->mode)));
      PUSHs (sv_2mortal (newSVpv ("nlink", 0)));
      PUSHs (sv_2mortal (my_newSVll (r->nlink)));
      PUSHs (sv_2mortal (newSVpv ("uid", 0)));
      PUSHs (sv_2mortal (my_newSVll (r->uid)));
      PUSHs (sv_2mortal (newSVpv ("gid", 0)));
      PUSHs (sv_2mortal (my_newSVll (r->gid)));
      PUSHs (sv_2mortal (newSVpv ("rdev", 0)));
      PUSHs (sv_2mortal (my_newSVll (r->rdev)));
      PUSHs (sv_2mortal (newSVpv ("size", 0)));
      PUSHs (sv_2mortal (my_newSVll (r->size)));
      PUSHs (sv_2mortal (newSVpv ("blksize", 0)));
      PUSHs (sv_2mortal (my_newSVll (r->blksize)));
      PUSHs (sv_2mortal (newSVpv ("blocks", 0)));
      PUSHs (sv_2mortal (my_newSVll (r->blocks)));
      PUSHs (sv_2mortal (newSVpv ("atime", 0)));
      PUSHs (sv_2mortal (my_newSVll (r->atime)));
      PUSHs (sv_2mortal (newSVpv ("mtime", 0)));
      PUSHs (sv_2mortal (my_newSVll (r->mtime)));
      PUSHs (sv_2mortal (newSVpv ("ctime", 0)));
      PUSHs (sv_2mortal (my_newSVll (r->ctime)));
      guestfs_free_stat (r);
#line 25652 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_statns); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_statns)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, path");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	path = (char *)SvPV_nolen(ST(1))
;
#line 10367 "lib/Sys/Guestfs.xs"
      struct guestfs_statns *r;
#line 25673 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::statns(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::statns(): g is not a blessed HV reference");
    }
;
#line 10369 "lib/Sys/Guestfs.xs"
      r = guestfs_statns (g, path);
      if (r == NULL)
        croak ("%s", guestfs_last_error (g));
      EXTEND (SP, 2 * 22);
      PUSHs (sv_2mortal (newSVpv ("st_dev", 0)));
      PUSHs (sv_2mortal (my_newSVll (r->st_dev)));
      PUSHs (sv_2mortal (newSVpv ("st_ino", 0)));
      PUSHs (sv_2mortal (my_newSVll (r->st_ino)));
      PUSHs (sv_2mortal (newSVpv ("st_mode", 0)));
      PUSHs (sv_2mortal (my_newSVll (r->st_mode)));
      PUSHs (sv_2mortal (newSVpv ("st_nlink", 0)));
      PUSHs (sv_2mortal (my_newSVll (r->st_nlink)));
      PUSHs (sv_2mortal (newSVpv ("st_uid", 0)));
      PUSHs (sv_2mortal (my_newSVll (r->st_uid)));
      PUSHs (sv_2mortal (newSVpv ("st_gid", 0)));
      PUSHs (sv_2mortal (my_newSVll (r->st_gid)));
      PUSHs (sv_2mortal (newSVpv ("st_rdev", 0)));
      PUSHs (sv_2mortal (my_newSVll (r->st_rdev)));
      PUSHs (sv_2mortal (newSVpv ("st_size", 0)));
      PUSHs (sv_2mortal (my_newSVll (r->st_size)));
      PUSHs (sv_2mortal (newSVpv ("st_blksize", 0)));
      PUSHs (sv_2mortal (my_newSVll (r->st_blksize)));
      PUSHs (sv_2mortal (newSVpv ("st_blocks", 0)));
      PUSHs (sv_2mortal (my_newSVll (r->st_blocks)));
      PUSHs (sv_2mortal (newSVpv ("st_atime_sec", 0)));
      PUSHs (sv_2mortal (my_newSVll (r->st_atime_sec)));
      PUSHs (sv_2mortal (newSVpv ("st_atime_nsec", 0)));
      PUSHs (sv_2mortal (my_newSVll (r->st_atime_nsec)));
      PUSHs (sv_2mortal (newSVpv ("st_mtime_sec", 0)));
      PUSHs (sv_2mortal (my_newSVll (r->st_mtime_sec)));
      PUSHs (sv_2mortal (newSVpv ("st_mtime_nsec", 0)));
      PUSHs (sv_2mortal (my_newSVll (r->st_mtime_nsec)));
      PUSHs (sv_2mortal (newSVpv ("st_ctime_sec", 0)));
      PUSHs (sv_2mortal (my_newSVll (r->st_ctime_sec)));
      PUSHs (sv_2mortal (newSVpv ("st_ctime_nsec", 0)));
      PUSHs (sv_2mortal (my_newSVll (r->st_ctime_nsec)));
      PUSHs (sv_2mortal (newSVpv ("st_spare1", 0)));
      PUSHs (sv_2mortal (my_newSVll (r->st_spare1)));
      PUSHs (sv_2mortal (newSVpv ("st_spare2", 0)));
      PUSHs (sv_2mortal (my_newSVll (r->st_spare2)));
      PUSHs (sv_2mortal (newSVpv ("st_spare3", 0)));
      PUSHs (sv_2mortal (my_newSVll (r->st_spare3)));
      PUSHs (sv_2mortal (newSVpv ("st_spare4", 0)));
      PUSHs (sv_2mortal (my_newSVll (r->st_spare4)));
      PUSHs (sv_2mortal (newSVpv ("st_spare5", 0)));
      PUSHs (sv_2mortal (my_newSVll (r->st_spare5)));
      PUSHs (sv_2mortal (newSVpv ("st_spare6", 0)));
      PUSHs (sv_2mortal (my_newSVll (r->st_spare6)));
      guestfs_free_statns (r);
#line 25737 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_statvfs); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_statvfs)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, path");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	path = (char *)SvPV_nolen(ST(1))
;
#line 10424 "lib/Sys/Guestfs.xs"
      struct guestfs_statvfs *r;
#line 25758 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::statvfs(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::statvfs(): g is not a blessed HV reference");
    }
;
#line 10426 "lib/Sys/Guestfs.xs"
      r = guestfs_statvfs (g, path);
      if (r == NULL)
        croak ("%s", guestfs_last_error (g));
      EXTEND (SP, 2 * 11);
      PUSHs (sv_2mortal (newSVpv ("bsize", 0)));
      PUSHs (sv_2mortal (my_newSVll (r->bsize)));
      PUSHs (sv_2mortal (newSVpv ("frsize", 0)));
      PUSHs (sv_2mortal (my_newSVll (r->frsize)));
      PUSHs (sv_2mortal (newSVpv ("blocks", 0)));
      PUSHs (sv_2mortal (my_newSVll (r->blocks)));
      PUSHs (sv_2mortal (newSVpv ("bfree", 0)));
      PUSHs (sv_2mortal (my_newSVll (r->bfree)));
      PUSHs (sv_2mortal (newSVpv ("bavail", 0)));
      PUSHs (sv_2mortal (my_newSVll (r->bavail)));
      PUSHs (sv_2mortal (newSVpv ("files", 0)));
      PUSHs (sv_2mortal (my_newSVll (r->files)));
      PUSHs (sv_2mortal (newSVpv ("ffree", 0)));
      PUSHs (sv_2mortal (my_newSVll (r->ffree)));
      PUSHs (sv_2mortal (newSVpv ("favail", 0)));
      PUSHs (sv_2mortal (my_newSVll (r->favail)));
      PUSHs (sv_2mortal (newSVpv ("fsid", 0)));
      PUSHs (sv_2mortal (my_newSVll (r->fsid)));
      PUSHs (sv_2mortal (newSVpv ("flag", 0)));
      PUSHs (sv_2mortal (my_newSVll (r->flag)));
      PUSHs (sv_2mortal (newSVpv ("namemax", 0)));
      PUSHs (sv_2mortal (my_newSVll (r->namemax)));
      guestfs_free_statvfs (r);
#line 25800 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_strings); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_strings)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, path");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	path = (char *)SvPV_nolen(ST(1))
;
#line 10459 "lib/Sys/Guestfs.xs"
      char **r;
      size_t i, n;
#line 25822 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::strings(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::strings(): g is not a blessed HV reference");
    }
;
#line 10462 "lib/Sys/Guestfs.xs"
      r = guestfs_strings (g, path);
      if (r == NULL)
        croak ("%s", guestfs_last_error (g));
      for (n = 0; r[n] != NULL; ++n) /**/;
      EXTEND (SP, n);
      for (i = 0; i < n; ++i) {
        PUSHs (sv_2mortal (newSVpv (r[i], 0)));
        free (r[i]);
      }
      free (r);
#line 25847 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_strings_e); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_strings_e)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "g, encoding, path");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	encoding = (char *)SvPV_nolen(ST(1))
;
	char *	path = (char *)SvPV_nolen(ST(2))
;
#line 10479 "lib/Sys/Guestfs.xs"
      char **r;
      size_t i, n;
#line 25871 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::strings_e(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::strings_e(): g is not a blessed HV reference");
    }
;
#line 10482 "lib/Sys/Guestfs.xs"
      r = guestfs_strings_e (g, encoding, path);
      if (r == NULL)
        croak ("%s", guestfs_last_error (g));
      for (n = 0; r[n] != NULL; ++n) /**/;
      EXTEND (SP, n);
      for (i = 0; i < n; ++i) {
        PUSHs (sv_2mortal (newSVpv (r[i], 0)));
        free (r[i]);
      }
      free (r);
#line 25896 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_swapoff_device); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_swapoff_device)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, device");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	device = (char *)SvPV_nolen(ST(1))
;
#line 10498 "lib/Sys/Guestfs.xs"
      int r;
#line 25917 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::swapoff_device(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::swapoff_device(): g is not a blessed HV reference");
    }
;
#line 10500 "lib/Sys/Guestfs.xs"
      r = guestfs_swapoff_device (g, device);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 25935 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_swapoff_file); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_swapoff_file)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, file");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	file = (char *)SvPV_nolen(ST(1))
;
#line 10509 "lib/Sys/Guestfs.xs"
      int r;
#line 25956 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::swapoff_file(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::swapoff_file(): g is not a blessed HV reference");
    }
;
#line 10511 "lib/Sys/Guestfs.xs"
      r = guestfs_swapoff_file (g, file);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 25974 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_swapoff_label); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_swapoff_label)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, label");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	label = (char *)SvPV_nolen(ST(1))
;
#line 10520 "lib/Sys/Guestfs.xs"
      int r;
#line 25995 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::swapoff_label(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::swapoff_label(): g is not a blessed HV reference");
    }
;
#line 10522 "lib/Sys/Guestfs.xs"
      r = guestfs_swapoff_label (g, label);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 26013 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_swapoff_uuid); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_swapoff_uuid)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, uuid");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	uuid = (char *)SvPV_nolen(ST(1))
;
#line 10531 "lib/Sys/Guestfs.xs"
      int r;
#line 26034 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::swapoff_uuid(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::swapoff_uuid(): g is not a blessed HV reference");
    }
;
#line 10533 "lib/Sys/Guestfs.xs"
      r = guestfs_swapoff_uuid (g, uuid);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 26052 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_swapon_device); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_swapon_device)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, device");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	device = (char *)SvPV_nolen(ST(1))
;
#line 10542 "lib/Sys/Guestfs.xs"
      int r;
#line 26073 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::swapon_device(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::swapon_device(): g is not a blessed HV reference");
    }
;
#line 10544 "lib/Sys/Guestfs.xs"
      r = guestfs_swapon_device (g, device);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 26091 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_swapon_file); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_swapon_file)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, file");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	file = (char *)SvPV_nolen(ST(1))
;
#line 10553 "lib/Sys/Guestfs.xs"
      int r;
#line 26112 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::swapon_file(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::swapon_file(): g is not a blessed HV reference");
    }
;
#line 10555 "lib/Sys/Guestfs.xs"
      r = guestfs_swapon_file (g, file);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 26130 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_swapon_label); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_swapon_label)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, label");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	label = (char *)SvPV_nolen(ST(1))
;
#line 10564 "lib/Sys/Guestfs.xs"
      int r;
#line 26151 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::swapon_label(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::swapon_label(): g is not a blessed HV reference");
    }
;
#line 10566 "lib/Sys/Guestfs.xs"
      r = guestfs_swapon_label (g, label);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 26169 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_swapon_uuid); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_swapon_uuid)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, uuid");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	uuid = (char *)SvPV_nolen(ST(1))
;
#line 10575 "lib/Sys/Guestfs.xs"
      int r;
#line 26190 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::swapon_uuid(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::swapon_uuid(): g is not a blessed HV reference");
    }
;
#line 10577 "lib/Sys/Guestfs.xs"
      r = guestfs_swapon_uuid (g, uuid);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 26208 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_sync); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_sync)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "g");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
#line 10585 "lib/Sys/Guestfs.xs"
      int r;
#line 26227 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::sync(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::sync(): g is not a blessed HV reference");
    }
;
#line 10587 "lib/Sys/Guestfs.xs"
      r = guestfs_sync (g);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 26245 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_syslinux); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_syslinux)
{
    dVAR; dXSARGS;
    if (items < 2)
       croak_xs_usage(cv,  "g, device, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	device = (char *)SvPV_nolen(ST(1))
;
#line 10596 "lib/Sys/Guestfs.xs"
      int r;
      struct guestfs_syslinux_argv optargs_s = { .bitmask = 0 };
      struct guestfs_syslinux_argv *optargs = &optargs_s;
      size_t items_i;
#line 26269 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::syslinux(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::syslinux(): g is not a blessed HV reference");
    }
;
#line 10601 "lib/Sys/Guestfs.xs"
      if (((items - 2) & 1) != 0)
        croak ("expecting an even number of extra parameters");
      for (items_i = 2; items_i < items; items_i += 2) {
        uint64_t this_mask;
        const char *this_arg;

        this_arg = SvPV_nolen (ST (items_i));
        if (STREQ (this_arg, "directory")) {
          optargs_s.directory = SvPV_nolen (ST (items_i+1));
          this_mask = GUESTFS_SYSLINUX_DIRECTORY_BITMASK;
        }
        else croak ("unknown optional argument '%s'", this_arg);
        if (optargs_s.bitmask & this_mask)
          croak ("optional argument '%s' given more than once",
                 this_arg);
        optargs_s.bitmask |= this_mask;
      }

      r = guestfs_syslinux_argv (g, device, optargs);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 26305 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_tail); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_tail)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, path");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	path = (char *)SvPV_nolen(ST(1))
;
#line 10628 "lib/Sys/Guestfs.xs"
      char **r;
      size_t i, n;
#line 26327 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::tail(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::tail(): g is not a blessed HV reference");
    }
;
#line 10631 "lib/Sys/Guestfs.xs"
      r = guestfs_tail (g, path);
      if (r == NULL)
        croak ("%s", guestfs_last_error (g));
      for (n = 0; r[n] != NULL; ++n) /**/;
      EXTEND (SP, n);
      for (i = 0; i < n; ++i) {
        PUSHs (sv_2mortal (newSVpv (r[i], 0)));
        free (r[i]);
      }
      free (r);
#line 26352 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_tail_n); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_tail_n)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "g, nrlines, path");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	int	nrlines = (int)SvIV(ST(1))
;
	char *	path = (char *)SvPV_nolen(ST(2))
;
#line 10648 "lib/Sys/Guestfs.xs"
      char **r;
      size_t i, n;
#line 26376 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::tail_n(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::tail_n(): g is not a blessed HV reference");
    }
;
#line 10651 "lib/Sys/Guestfs.xs"
      r = guestfs_tail_n (g, nrlines, path);
      if (r == NULL)
        croak ("%s", guestfs_last_error (g));
      for (n = 0; r[n] != NULL; ++n) /**/;
      EXTEND (SP, n);
      for (i = 0; i < n; ++i) {
        PUSHs (sv_2mortal (newSVpv (r[i], 0)));
        free (r[i]);
      }
      free (r);
#line 26401 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_tar_in); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_tar_in)
{
    dVAR; dXSARGS;
    if (items < 3)
       croak_xs_usage(cv,  "g, tarfile, directory, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	tarfile = (char *)SvPV_nolen(ST(1))
;
	char *	directory = (char *)SvPV_nolen(ST(2))
;
#line 10668 "lib/Sys/Guestfs.xs"
      int r;
      struct guestfs_tar_in_opts_argv optargs_s = { .bitmask = 0 };
      struct guestfs_tar_in_opts_argv *optargs = &optargs_s;
      size_t items_i;
#line 26427 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::tar_in(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::tar_in(): g is not a blessed HV reference");
    }
;
#line 10673 "lib/Sys/Guestfs.xs"
      if (((items - 3) & 1) != 0)
        croak ("expecting an even number of extra parameters");
      for (items_i = 3; items_i < items; items_i += 2) {
        uint64_t this_mask;
        const char *this_arg;

        this_arg = SvPV_nolen (ST (items_i));
        if (STREQ (this_arg, "compress")) {
          optargs_s.compress = SvPV_nolen (ST (items_i+1));
          this_mask = GUESTFS_TAR_IN_OPTS_COMPRESS_BITMASK;
        }
        else if (STREQ (this_arg, "xattrs")) {
          optargs_s.xattrs = SvIV (ST (items_i+1));
          this_mask = GUESTFS_TAR_IN_OPTS_XATTRS_BITMASK;
        }
        else if (STREQ (this_arg, "selinux")) {
          optargs_s.selinux = SvIV (ST (items_i+1));
          this_mask = GUESTFS_TAR_IN_OPTS_SELINUX_BITMASK;
        }
        else if (STREQ (this_arg, "acls")) {
          optargs_s.acls = SvIV (ST (items_i+1));
          this_mask = GUESTFS_TAR_IN_OPTS_ACLS_BITMASK;
        }
        else croak ("unknown optional argument '%s'", this_arg);
        if (optargs_s.bitmask & this_mask)
          croak ("optional argument '%s' given more than once",
                 this_arg);
        optargs_s.bitmask |= this_mask;
      }

      r = guestfs_tar_in_opts_argv (g, tarfile, directory, optargs);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 26475 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_tar_out); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_tar_out)
{
    dVAR; dXSARGS;
    if (items < 3)
       croak_xs_usage(cv,  "g, directory, tarfile, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	directory = (char *)SvPV_nolen(ST(1))
;
	char *	tarfile = (char *)SvPV_nolen(ST(2))
;
#line 10713 "lib/Sys/Guestfs.xs"
      int r;
      struct guestfs_tar_out_opts_argv optargs_s = { .bitmask = 0 };
      struct guestfs_tar_out_opts_argv *optargs = &optargs_s;
      size_t items_i;
#line 26501 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::tar_out(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::tar_out(): g is not a blessed HV reference");
    }
;
#line 10718 "lib/Sys/Guestfs.xs"
      if (((items - 3) & 1) != 0)
        croak ("expecting an even number of extra parameters");
      for (items_i = 3; items_i < items; items_i += 2) {
        uint64_t this_mask;
        const char *this_arg;

        this_arg = SvPV_nolen (ST (items_i));
        if (STREQ (this_arg, "compress")) {
          optargs_s.compress = SvPV_nolen (ST (items_i+1));
          this_mask = GUESTFS_TAR_OUT_OPTS_COMPRESS_BITMASK;
        }
        else if (STREQ (this_arg, "numericowner")) {
          optargs_s.numericowner = SvIV (ST (items_i+1));
          this_mask = GUESTFS_TAR_OUT_OPTS_NUMERICOWNER_BITMASK;
        }
        else if (STREQ (this_arg, "excludes")) {
          size_t i, len;
          char **r;
          SV *arg;
          AV *av;
          SV **svp;

          arg = ST (items_i+1);
          if (!SvROK (arg) || SvTYPE (SvRV (arg)) != SVt_PVAV)
            croak ("array reference expected for '%s' argument", "excludes");
          av = (AV *) SvRV (ST (items_i+1));

          /* Note av_len returns index of final element. */
          len = av_len (av) + 1;

          r = malloc ((len+1) * sizeof (char *));
          if (r == NULL) croak ("malloc: %m");
          for (i = 0; i < len; ++i) {
            svp = av_fetch (av, i, 0);
            r[i] = SvPV_nolen (*svp);
          }
          r[i] = NULL;
          optargs_s.excludes = r;
          this_mask = GUESTFS_TAR_OUT_OPTS_EXCLUDES_BITMASK;
        }
        else if (STREQ (this_arg, "xattrs")) {
          optargs_s.xattrs = SvIV (ST (items_i+1));
          this_mask = GUESTFS_TAR_OUT_OPTS_XATTRS_BITMASK;
        }
        else if (STREQ (this_arg, "selinux")) {
          optargs_s.selinux = SvIV (ST (items_i+1));
          this_mask = GUESTFS_TAR_OUT_OPTS_SELINUX_BITMASK;
        }
        else if (STREQ (this_arg, "acls")) {
          optargs_s.acls = SvIV (ST (items_i+1));
          this_mask = GUESTFS_TAR_OUT_OPTS_ACLS_BITMASK;
        }
        else croak ("unknown optional argument '%s'", this_arg);
        if (optargs_s.bitmask & this_mask)
          croak ("optional argument '%s' given more than once",
                 this_arg);
        optargs_s.bitmask |= this_mask;
      }

      r = guestfs_tar_out_opts_argv (g, directory, tarfile, optargs);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 26578 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_tgz_in); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_tgz_in)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "g, tarball, directory");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	tarball = (char *)SvPV_nolen(ST(1))
;
	char *	directory = (char *)SvPV_nolen(ST(2))
;
#line 10787 "lib/Sys/Guestfs.xs"
      int r;
#line 26601 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::tgz_in(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::tgz_in(): g is not a blessed HV reference");
    }
;
#line 10789 "lib/Sys/Guestfs.xs"
      Perl_ck_warner (aTHX_ packWARN(WARN_DEPRECATED),
        "Sys::Guestfs::tgz_in is deprecated; use Sys::Guestfs::tar_in instead");
      r = guestfs_tgz_in (g, tarball, directory);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 26621 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_tgz_out); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_tgz_out)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "g, directory, tarball");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	directory = (char *)SvPV_nolen(ST(1))
;
	char *	tarball = (char *)SvPV_nolen(ST(2))
;
#line 10801 "lib/Sys/Guestfs.xs"
      int r;
#line 26644 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::tgz_out(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::tgz_out(): g is not a blessed HV reference");
    }
;
#line 10803 "lib/Sys/Guestfs.xs"
      Perl_ck_warner (aTHX_ packWARN(WARN_DEPRECATED),
        "Sys::Guestfs::tgz_out is deprecated; use Sys::Guestfs::tar_out instead");
      r = guestfs_tgz_out (g, directory, tarball);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 26664 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_touch); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_touch)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, path");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	path = (char *)SvPV_nolen(ST(1))
;
#line 10814 "lib/Sys/Guestfs.xs"
      int r;
#line 26685 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::touch(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::touch(): g is not a blessed HV reference");
    }
;
#line 10816 "lib/Sys/Guestfs.xs"
      r = guestfs_touch (g, path);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 26703 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_truncate); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_truncate)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, path");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	path = (char *)SvPV_nolen(ST(1))
;
#line 10825 "lib/Sys/Guestfs.xs"
      int r;
#line 26724 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::truncate(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::truncate(): g is not a blessed HV reference");
    }
;
#line 10827 "lib/Sys/Guestfs.xs"
      r = guestfs_truncate (g, path);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 26742 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_truncate_size); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_truncate_size)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "g, path, size");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	path = (char *)SvPV_nolen(ST(1))
;
	int64_t    size = my_SvIV64 (ST(2))
;
#line 10837 "lib/Sys/Guestfs.xs"
      int r;
#line 26765 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::truncate_size(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::truncate_size(): g is not a blessed HV reference");
    }
;
#line 10839 "lib/Sys/Guestfs.xs"
      r = guestfs_truncate_size (g, path, size);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 26783 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_tune2fs); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_tune2fs)
{
    dVAR; dXSARGS;
    if (items < 2)
       croak_xs_usage(cv,  "g, device, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	device = (char *)SvPV_nolen(ST(1))
;
#line 10848 "lib/Sys/Guestfs.xs"
      int r;
      struct guestfs_tune2fs_argv optargs_s = { .bitmask = 0 };
      struct guestfs_tune2fs_argv *optargs = &optargs_s;
      size_t items_i;
#line 26807 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::tune2fs(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::tune2fs(): g is not a blessed HV reference");
    }
;
#line 10853 "lib/Sys/Guestfs.xs"
      if (((items - 2) & 1) != 0)
        croak ("expecting an even number of extra parameters");
      for (items_i = 2; items_i < items; items_i += 2) {
        uint64_t this_mask;
        const char *this_arg;

        this_arg = SvPV_nolen (ST (items_i));
        if (STREQ (this_arg, "force")) {
          optargs_s.force = SvIV (ST (items_i+1));
          this_mask = GUESTFS_TUNE2FS_FORCE_BITMASK;
        }
        else if (STREQ (this_arg, "maxmountcount")) {
          optargs_s.maxmountcount = SvIV (ST (items_i+1));
          this_mask = GUESTFS_TUNE2FS_MAXMOUNTCOUNT_BITMASK;
        }
        else if (STREQ (this_arg, "mountcount")) {
          optargs_s.mountcount = SvIV (ST (items_i+1));
          this_mask = GUESTFS_TUNE2FS_MOUNTCOUNT_BITMASK;
        }
        else if (STREQ (this_arg, "errorbehavior")) {
          optargs_s.errorbehavior = SvPV_nolen (ST (items_i+1));
          this_mask = GUESTFS_TUNE2FS_ERRORBEHAVIOR_BITMASK;
        }
        else if (STREQ (this_arg, "group")) {
          optargs_s.group = my_SvIV64 (ST (items_i+1));
          this_mask = GUESTFS_TUNE2FS_GROUP_BITMASK;
        }
        else if (STREQ (this_arg, "intervalbetweenchecks")) {
          optargs_s.intervalbetweenchecks = SvIV (ST (items_i+1));
          this_mask = GUESTFS_TUNE2FS_INTERVALBETWEENCHECKS_BITMASK;
        }
        else if (STREQ (this_arg, "reservedblockspercentage")) {
          optargs_s.reservedblockspercentage = SvIV (ST (items_i+1));
          this_mask = GUESTFS_TUNE2FS_RESERVEDBLOCKSPERCENTAGE_BITMASK;
        }
        else if (STREQ (this_arg, "lastmounteddirectory")) {
          optargs_s.lastmounteddirectory = SvPV_nolen (ST (items_i+1));
          this_mask = GUESTFS_TUNE2FS_LASTMOUNTEDDIRECTORY_BITMASK;
        }
        else if (STREQ (this_arg, "reservedblockscount")) {
          optargs_s.reservedblockscount = my_SvIV64 (ST (items_i+1));
          this_mask = GUESTFS_TUNE2FS_RESERVEDBLOCKSCOUNT_BITMASK;
        }
        else if (STREQ (this_arg, "user")) {
          optargs_s.user = my_SvIV64 (ST (items_i+1));
          this_mask = GUESTFS_TUNE2FS_USER_BITMASK;
        }
        else croak ("unknown optional argument '%s'", this_arg);
        if (optargs_s.bitmask & this_mask)
          croak ("optional argument '%s' given more than once",
                 this_arg);
        optargs_s.bitmask |= this_mask;
      }

      r = guestfs_tune2fs_argv (g, device, optargs);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 26879 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_tune2fs_l); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_tune2fs_l)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, device");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	device = (char *)SvPV_nolen(ST(1))
;
#line 10916 "lib/Sys/Guestfs.xs"
      char **r;
      size_t i, n;
#line 26901 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::tune2fs_l(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::tune2fs_l(): g is not a blessed HV reference");
    }
;
#line 10919 "lib/Sys/Guestfs.xs"
      r = guestfs_tune2fs_l (g, device);
      if (r == NULL)
        croak ("%s", guestfs_last_error (g));
      for (n = 0; r[n] != NULL; ++n) /**/;
      EXTEND (SP, n);
      for (i = 0; i < n; ++i) {
        PUSHs (sv_2mortal (newSVpv (r[i], 0)));
        free (r[i]);
      }
      free (r);
#line 26926 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_txz_in); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_txz_in)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "g, tarball, directory");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	tarball = (char *)SvPV_nolen(ST(1))
;
	char *	directory = (char *)SvPV_nolen(ST(2))
;
#line 10936 "lib/Sys/Guestfs.xs"
      int r;
#line 26949 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::txz_in(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::txz_in(): g is not a blessed HV reference");
    }
;
#line 10938 "lib/Sys/Guestfs.xs"
      Perl_ck_warner (aTHX_ packWARN(WARN_DEPRECATED),
        "Sys::Guestfs::txz_in is deprecated; use Sys::Guestfs::tar_in instead");
      r = guestfs_txz_in (g, tarball, directory);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 26969 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_txz_out); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_txz_out)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "g, directory, tarball");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	directory = (char *)SvPV_nolen(ST(1))
;
	char *	tarball = (char *)SvPV_nolen(ST(2))
;
#line 10950 "lib/Sys/Guestfs.xs"
      int r;
#line 26992 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::txz_out(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::txz_out(): g is not a blessed HV reference");
    }
;
#line 10952 "lib/Sys/Guestfs.xs"
      Perl_ck_warner (aTHX_ packWARN(WARN_DEPRECATED),
        "Sys::Guestfs::txz_out is deprecated; use Sys::Guestfs::tar_out instead");
      r = guestfs_txz_out (g, directory, tarball);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 27012 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_umask); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_umask)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, mask");
    {
	guestfs_h *	g;
	int	mask = (int)SvIV(ST(1))
;
#line 10963 "lib/Sys/Guestfs.xs"
      int r;
#line 27031 "lib/Sys/Guestfs.c"
	SV *	RETVAL;

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::umask(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::umask(): g is not a blessed HV reference");
    }
;
#line 10965 "lib/Sys/Guestfs.xs"
      r = guestfs_umask (g, mask);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
      RETVAL = newSViv (r);
#line 27051 "lib/Sys/Guestfs.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Guestfs_umount); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_umount)
{
    dVAR; dXSARGS;
    if (items < 2)
       croak_xs_usage(cv,  "g, pathordevice, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	pathordevice = (char *)SvPV_nolen(ST(1))
;
#line 10977 "lib/Sys/Guestfs.xs"
      int r;
      struct guestfs_umount_opts_argv optargs_s = { .bitmask = 0 };
      struct guestfs_umount_opts_argv *optargs = &optargs_s;
      size_t items_i;
#line 27076 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::umount(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::umount(): g is not a blessed HV reference");
    }
;
#line 10982 "lib/Sys/Guestfs.xs"
      if (((items - 2) & 1) != 0)
        croak ("expecting an even number of extra parameters");
      for (items_i = 2; items_i < items; items_i += 2) {
        uint64_t this_mask;
        const char *this_arg;

        this_arg = SvPV_nolen (ST (items_i));
        if (STREQ (this_arg, "force")) {
          optargs_s.force = SvIV (ST (items_i+1));
          this_mask = GUESTFS_UMOUNT_OPTS_FORCE_BITMASK;
        }
        else if (STREQ (this_arg, "lazyunmount")) {
          optargs_s.lazyunmount = SvIV (ST (items_i+1));
          this_mask = GUESTFS_UMOUNT_OPTS_LAZYUNMOUNT_BITMASK;
        }
        else croak ("unknown optional argument '%s'", this_arg);
        if (optargs_s.bitmask & this_mask)
          croak ("optional argument '%s' given more than once",
                 this_arg);
        optargs_s.bitmask |= this_mask;
      }

      r = guestfs_umount_opts_argv (g, pathordevice, optargs);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 27116 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_umount_all); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_umount_all)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "g");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
#line 11012 "lib/Sys/Guestfs.xs"
      int r;
#line 27135 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::umount_all(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::umount_all(): g is not a blessed HV reference");
    }
;
#line 11014 "lib/Sys/Guestfs.xs"
      r = guestfs_umount_all (g);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 27153 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_umount_local); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_umount_local)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "g, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
#line 11022 "lib/Sys/Guestfs.xs"
      int r;
      struct guestfs_umount_local_argv optargs_s = { .bitmask = 0 };
      struct guestfs_umount_local_argv *optargs = &optargs_s;
      size_t items_i;
#line 27175 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::umount_local(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::umount_local(): g is not a blessed HV reference");
    }
;
#line 11027 "lib/Sys/Guestfs.xs"
      if (((items - 1) & 1) != 0)
        croak ("expecting an even number of extra parameters");
      for (items_i = 1; items_i < items; items_i += 2) {
        uint64_t this_mask;
        const char *this_arg;

        this_arg = SvPV_nolen (ST (items_i));
        if (STREQ (this_arg, "retry")) {
          optargs_s.retry = SvIV (ST (items_i+1));
          this_mask = GUESTFS_UMOUNT_LOCAL_RETRY_BITMASK;
        }
        else croak ("unknown optional argument '%s'", this_arg);
        if (optargs_s.bitmask & this_mask)
          croak ("optional argument '%s' given more than once",
                 this_arg);
        optargs_s.bitmask |= this_mask;
      }

      r = guestfs_umount_local_argv (g, optargs);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 27211 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_upload); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_upload)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "g, filename, remotefilename");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	filename = (char *)SvPV_nolen(ST(1))
;
	char *	remotefilename = (char *)SvPV_nolen(ST(2))
;
#line 11055 "lib/Sys/Guestfs.xs"
      int r;
#line 27234 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::upload(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::upload(): g is not a blessed HV reference");
    }
;
#line 11057 "lib/Sys/Guestfs.xs"
      r = guestfs_upload (g, filename, remotefilename);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 27252 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_upload_offset); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_upload_offset)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "g, filename, remotefilename, offset");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	filename = (char *)SvPV_nolen(ST(1))
;
	char *	remotefilename = (char *)SvPV_nolen(ST(2))
;
	int64_t    offset = my_SvIV64 (ST(3))
;
#line 11068 "lib/Sys/Guestfs.xs"
      int r;
#line 27277 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::upload_offset(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::upload_offset(): g is not a blessed HV reference");
    }
;
#line 11070 "lib/Sys/Guestfs.xs"
      r = guestfs_upload_offset (g, filename, remotefilename, offset);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 27295 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_user_cancel); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_user_cancel)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "g");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
#line 11078 "lib/Sys/Guestfs.xs"
      int r;
#line 27314 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::user_cancel(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::user_cancel(): g is not a blessed HV reference");
    }
;
#line 11080 "lib/Sys/Guestfs.xs"
      r = guestfs_user_cancel (g);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 27332 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_utimens); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_utimens)
{
    dVAR; dXSARGS;
    if (items != 6)
       croak_xs_usage(cv,  "g, path, atsecs, atnsecs, mtsecs, mtnsecs");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	path = (char *)SvPV_nolen(ST(1))
;
	int64_t    atsecs = my_SvIV64 (ST(2))
;
	int64_t    atnsecs = my_SvIV64 (ST(3))
;
	int64_t    mtsecs = my_SvIV64 (ST(4))
;
	int64_t    mtnsecs = my_SvIV64 (ST(5))
;
#line 11093 "lib/Sys/Guestfs.xs"
      int r;
#line 27361 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::utimens(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::utimens(): g is not a blessed HV reference");
    }
;
#line 11095 "lib/Sys/Guestfs.xs"
      r = guestfs_utimens (g, path, atsecs, atnsecs, mtsecs, mtnsecs);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 27379 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_utsname); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_utsname)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "g");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
#line 11103 "lib/Sys/Guestfs.xs"
      struct guestfs_utsname *r;
#line 27398 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::utsname(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::utsname(): g is not a blessed HV reference");
    }
;
#line 11105 "lib/Sys/Guestfs.xs"
      r = guestfs_utsname (g);
      if (r == NULL)
        croak ("%s", guestfs_last_error (g));
      EXTEND (SP, 2 * 4);
      PUSHs (sv_2mortal (newSVpv ("uts_sysname", 0)));
      PUSHs (sv_2mortal (newSVpv (r->uts_sysname, 0)));
      PUSHs (sv_2mortal (newSVpv ("uts_release", 0)));
      PUSHs (sv_2mortal (newSVpv (r->uts_release, 0)));
      PUSHs (sv_2mortal (newSVpv ("uts_version", 0)));
      PUSHs (sv_2mortal (newSVpv (r->uts_version, 0)));
      PUSHs (sv_2mortal (newSVpv ("uts_machine", 0)));
      PUSHs (sv_2mortal (newSVpv (r->uts_machine, 0)));
      guestfs_free_utsname (r);
#line 27426 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_version); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_version)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "g");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
#line 11123 "lib/Sys/Guestfs.xs"
      struct guestfs_version *r;
#line 27445 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::version(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::version(): g is not a blessed HV reference");
    }
;
#line 11125 "lib/Sys/Guestfs.xs"
      r = guestfs_version (g);
      if (r == NULL)
        croak ("%s", guestfs_last_error (g));
      EXTEND (SP, 2 * 4);
      PUSHs (sv_2mortal (newSVpv ("major", 0)));
      PUSHs (sv_2mortal (my_newSVll (r->major)));
      PUSHs (sv_2mortal (newSVpv ("minor", 0)));
      PUSHs (sv_2mortal (my_newSVll (r->minor)));
      PUSHs (sv_2mortal (newSVpv ("release", 0)));
      PUSHs (sv_2mortal (my_newSVll (r->release)));
      PUSHs (sv_2mortal (newSVpv ("extra", 0)));
      PUSHs (sv_2mortal (newSVpv (r->extra, 0)));
      guestfs_free_version (r);
#line 27473 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_vfs_label); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_vfs_label)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, mountable");
    {
	guestfs_h *	g;
	char *	mountable = (char *)SvPV_nolen(ST(1))
;
#line 11144 "lib/Sys/Guestfs.xs"
      char *r;
#line 27492 "lib/Sys/Guestfs.c"
	SV *	RETVAL;

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::vfs_label(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::vfs_label(): g is not a blessed HV reference");
    }
;
#line 11146 "lib/Sys/Guestfs.xs"
      r = guestfs_vfs_label (g, mountable);
      if (r == NULL)
        croak ("%s", guestfs_last_error (g));
      RETVAL = newSVpv (r, 0);
      free (r);
#line 27513 "lib/Sys/Guestfs.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Guestfs_vfs_minimum_size); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_vfs_minimum_size)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, mountable");
    {
	guestfs_h *	g;
	char *	mountable = (char *)SvPV_nolen(ST(1))
;
#line 11159 "lib/Sys/Guestfs.xs"
      int64_t r;
#line 27533 "lib/Sys/Guestfs.c"
	SV *	RETVAL;

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::vfs_minimum_size(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::vfs_minimum_size(): g is not a blessed HV reference");
    }
;
#line 11161 "lib/Sys/Guestfs.xs"
      r = guestfs_vfs_minimum_size (g, mountable);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
      RETVAL = my_newSVll (r);
#line 27553 "lib/Sys/Guestfs.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Guestfs_vfs_type); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_vfs_type)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, mountable");
    {
	guestfs_h *	g;
	char *	mountable = (char *)SvPV_nolen(ST(1))
;
#line 11173 "lib/Sys/Guestfs.xs"
      char *r;
#line 27573 "lib/Sys/Guestfs.c"
	SV *	RETVAL;

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::vfs_type(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::vfs_type(): g is not a blessed HV reference");
    }
;
#line 11175 "lib/Sys/Guestfs.xs"
      r = guestfs_vfs_type (g, mountable);
      if (r == NULL)
        croak ("%s", guestfs_last_error (g));
      RETVAL = newSVpv (r, 0);
      free (r);
#line 27594 "lib/Sys/Guestfs.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Guestfs_vfs_uuid); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_vfs_uuid)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, mountable");
    {
	guestfs_h *	g;
	char *	mountable = (char *)SvPV_nolen(ST(1))
;
#line 11188 "lib/Sys/Guestfs.xs"
      char *r;
#line 27614 "lib/Sys/Guestfs.c"
	SV *	RETVAL;

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::vfs_uuid(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::vfs_uuid(): g is not a blessed HV reference");
    }
;
#line 11190 "lib/Sys/Guestfs.xs"
      r = guestfs_vfs_uuid (g, mountable);
      if (r == NULL)
        croak ("%s", guestfs_last_error (g));
      RETVAL = newSVpv (r, 0);
      free (r);
#line 27635 "lib/Sys/Guestfs.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Guestfs_vg_activate); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_vg_activate)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "g, activate, volgroups");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	int	activate = (int)SvIV(ST(1))
;
	char **	volgroups = XS_unpack_charPtrPtr(ST(2))
;
#line 11204 "lib/Sys/Guestfs.xs"
      int r;
#line 27659 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::vg_activate(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::vg_activate(): g is not a blessed HV reference");
    }
;
#line 11206 "lib/Sys/Guestfs.xs"
      r = guestfs_vg_activate (g, activate, volgroups);
      free (volgroups);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 27678 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_vg_activate_all); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_vg_activate_all)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, activate");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	int	activate = (int)SvIV(ST(1))
;
#line 11216 "lib/Sys/Guestfs.xs"
      int r;
#line 27699 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::vg_activate_all(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::vg_activate_all(): g is not a blessed HV reference");
    }
;
#line 11218 "lib/Sys/Guestfs.xs"
      r = guestfs_vg_activate_all (g, activate);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 27717 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_vgchange_uuid); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_vgchange_uuid)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, vg");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	vg = (char *)SvPV_nolen(ST(1))
;
#line 11227 "lib/Sys/Guestfs.xs"
      int r;
#line 27738 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::vgchange_uuid(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::vgchange_uuid(): g is not a blessed HV reference");
    }
;
#line 11229 "lib/Sys/Guestfs.xs"
      r = guestfs_vgchange_uuid (g, vg);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 27756 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_vgchange_uuid_all); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_vgchange_uuid_all)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "g");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
#line 11237 "lib/Sys/Guestfs.xs"
      int r;
#line 27775 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::vgchange_uuid_all(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::vgchange_uuid_all(): g is not a blessed HV reference");
    }
;
#line 11239 "lib/Sys/Guestfs.xs"
      r = guestfs_vgchange_uuid_all (g);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 27793 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_vgcreate); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_vgcreate)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "g, volgroup, physvols");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	volgroup = (char *)SvPV_nolen(ST(1))
;
	char **	physvols = XS_unpack_charPtrPtr(ST(2))
;
#line 11249 "lib/Sys/Guestfs.xs"
      int r;
#line 27816 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::vgcreate(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::vgcreate(): g is not a blessed HV reference");
    }
;
#line 11251 "lib/Sys/Guestfs.xs"
      r = guestfs_vgcreate (g, volgroup, physvols);
      free (physvols);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 27835 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_vglvuuids); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_vglvuuids)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, vgname");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	vgname = (char *)SvPV_nolen(ST(1))
;
#line 11261 "lib/Sys/Guestfs.xs"
      char **r;
      size_t i, n;
#line 27857 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::vglvuuids(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::vglvuuids(): g is not a blessed HV reference");
    }
;
#line 11264 "lib/Sys/Guestfs.xs"
      r = guestfs_vglvuuids (g, vgname);
      if (r == NULL)
        croak ("%s", guestfs_last_error (g));
      for (n = 0; r[n] != NULL; ++n) /**/;
      EXTEND (SP, n);
      for (i = 0; i < n; ++i) {
        PUSHs (sv_2mortal (newSVpv (r[i], 0)));
        free (r[i]);
      }
      free (r);
#line 27882 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_vgmeta); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_vgmeta)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, vgname");
    {
	guestfs_h *	g;
	char *	vgname = (char *)SvPV_nolen(ST(1))
;
#line 11280 "lib/Sys/Guestfs.xs"
      char *r;
      size_t size;
#line 27902 "lib/Sys/Guestfs.c"
	SV *	RETVAL;

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::vgmeta(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::vgmeta(): g is not a blessed HV reference");
    }
;
#line 11283 "lib/Sys/Guestfs.xs"
      r = guestfs_vgmeta (g, vgname, &size);
      if (r == NULL)
        croak ("%s", guestfs_last_error (g));
      RETVAL = newSVpvn (r, size);
      free (r);
#line 27923 "lib/Sys/Guestfs.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Guestfs_vgpvuuids); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_vgpvuuids)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, vgname");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	vgname = (char *)SvPV_nolen(ST(1))
;
#line 11296 "lib/Sys/Guestfs.xs"
      char **r;
      size_t i, n;
#line 27946 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::vgpvuuids(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::vgpvuuids(): g is not a blessed HV reference");
    }
;
#line 11299 "lib/Sys/Guestfs.xs"
      r = guestfs_vgpvuuids (g, vgname);
      if (r == NULL)
        croak ("%s", guestfs_last_error (g));
      for (n = 0; r[n] != NULL; ++n) /**/;
      EXTEND (SP, n);
      for (i = 0; i < n; ++i) {
        PUSHs (sv_2mortal (newSVpv (r[i], 0)));
        free (r[i]);
      }
      free (r);
#line 27971 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_vgremove); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_vgremove)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, vgname");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	vgname = (char *)SvPV_nolen(ST(1))
;
#line 11315 "lib/Sys/Guestfs.xs"
      int r;
#line 27992 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::vgremove(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::vgremove(): g is not a blessed HV reference");
    }
;
#line 11317 "lib/Sys/Guestfs.xs"
      r = guestfs_vgremove (g, vgname);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 28010 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_vgrename); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_vgrename)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "g, volgroup, newvolgroup");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	volgroup = (char *)SvPV_nolen(ST(1))
;
	char *	newvolgroup = (char *)SvPV_nolen(ST(2))
;
#line 11327 "lib/Sys/Guestfs.xs"
      int r;
#line 28033 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::vgrename(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::vgrename(): g is not a blessed HV reference");
    }
;
#line 11329 "lib/Sys/Guestfs.xs"
      r = guestfs_vgrename (g, volgroup, newvolgroup);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 28051 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_vgs); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_vgs)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "g");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
#line 11337 "lib/Sys/Guestfs.xs"
      char **r;
      size_t i, n;
#line 28071 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::vgs(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::vgs(): g is not a blessed HV reference");
    }
;
#line 11340 "lib/Sys/Guestfs.xs"
      r = guestfs_vgs (g);
      if (r == NULL)
        croak ("%s", guestfs_last_error (g));
      for (n = 0; r[n] != NULL; ++n) /**/;
      EXTEND (SP, n);
      for (i = 0; i < n; ++i) {
        PUSHs (sv_2mortal (newSVpv (r[i], 0)));
        free (r[i]);
      }
      free (r);
#line 28096 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_vgs_full); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_vgs_full)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "g");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
#line 11355 "lib/Sys/Guestfs.xs"
      struct guestfs_lvm_vg_list *r;
      size_t i;
      HV *hv;
#line 28117 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::vgs_full(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::vgs_full(): g is not a blessed HV reference");
    }
;
#line 11359 "lib/Sys/Guestfs.xs"
      r = guestfs_vgs_full (g);
      if (r == NULL)
        croak ("%s", guestfs_last_error (g));
      EXTEND (SP, r->len);
      for (i = 0; i < r->len; ++i) {
        hv = newHV ();
        (void) hv_store (hv, "vg_name", 7, newSVpv (r->val[i].vg_name, 0), 0);
        (void) hv_store (hv, "vg_uuid", 7, newSVpv (r->val[i].vg_uuid, 32), 0);
        (void) hv_store (hv, "vg_fmt", 6, newSVpv (r->val[i].vg_fmt, 0), 0);
        (void) hv_store (hv, "vg_attr", 7, newSVpv (r->val[i].vg_attr, 0), 0);
        (void) hv_store (hv, "vg_size", 7, my_newSVull (r->val[i].vg_size), 0);
        (void) hv_store (hv, "vg_free", 7, my_newSVull (r->val[i].vg_free), 0);
        (void) hv_store (hv, "vg_sysid", 8, newSVpv (r->val[i].vg_sysid, 0), 0);
        (void) hv_store (hv, "vg_extent_size", 14, my_newSVull (r->val[i].vg_extent_size), 0);
        (void) hv_store (hv, "vg_extent_count", 15, my_newSVll (r->val[i].vg_extent_count), 0);
        (void) hv_store (hv, "vg_free_count", 13, my_newSVll (r->val[i].vg_free_count), 0);
        (void) hv_store (hv, "max_lv", 6, my_newSVll (r->val[i].max_lv), 0);
        (void) hv_store (hv, "max_pv", 6, my_newSVll (r->val[i].max_pv), 0);
        (void) hv_store (hv, "pv_count", 8, my_newSVll (r->val[i].pv_count), 0);
        (void) hv_store (hv, "lv_count", 8, my_newSVll (r->val[i].lv_count), 0);
        (void) hv_store (hv, "snap_count", 10, my_newSVll (r->val[i].snap_count), 0);
        (void) hv_store (hv, "vg_seqno", 8, my_newSVll (r->val[i].vg_seqno), 0);
        (void) hv_store (hv, "vg_tags", 7, newSVpv (r->val[i].vg_tags, 0), 0);
        (void) hv_store (hv, "vg_mda_count", 12, my_newSVll (r->val[i].vg_mda_count), 0);
        (void) hv_store (hv, "vg_mda_free", 11, my_newSVull (r->val[i].vg_mda_free), 0);
        PUSHs (sv_2mortal (newRV ((SV *) hv)));
      }
      guestfs_free_lvm_vg_list (r);
#line 28160 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_vgscan); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_vgscan)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "g");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
#line 11392 "lib/Sys/Guestfs.xs"
      int r;
#line 28179 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::vgscan(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::vgscan(): g is not a blessed HV reference");
    }
;
#line 11394 "lib/Sys/Guestfs.xs"
      Perl_ck_warner (aTHX_ packWARN(WARN_DEPRECATED),
        "Sys::Guestfs::vgscan is deprecated; use Sys::Guestfs::lvm_scan instead");
      r = guestfs_vgscan (g);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 28199 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_vguuid); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_vguuid)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, vgname");
    {
	guestfs_h *	g;
	char *	vgname = (char *)SvPV_nolen(ST(1))
;
#line 11405 "lib/Sys/Guestfs.xs"
      char *r;
#line 28218 "lib/Sys/Guestfs.c"
	SV *	RETVAL;

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::vguuid(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::vguuid(): g is not a blessed HV reference");
    }
;
#line 11407 "lib/Sys/Guestfs.xs"
      r = guestfs_vguuid (g, vgname);
      if (r == NULL)
        croak ("%s", guestfs_last_error (g));
      RETVAL = newSVpv (r, 0);
      free (r);
#line 28239 "lib/Sys/Guestfs.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Guestfs_wait_ready); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_wait_ready)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "g");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
#line 11419 "lib/Sys/Guestfs.xs"
      int r;
#line 28259 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::wait_ready(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::wait_ready(): g is not a blessed HV reference");
    }
;
#line 11421 "lib/Sys/Guestfs.xs"
      Perl_ck_warner (aTHX_ packWARN(WARN_DEPRECATED),
        "Sys::Guestfs::wait_ready is deprecated");
      r = guestfs_wait_ready (g);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 28279 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_wc_c); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_wc_c)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, path");
    {
	guestfs_h *	g;
	char *	path = (char *)SvPV_nolen(ST(1))
;
#line 11432 "lib/Sys/Guestfs.xs"
      int r;
#line 28298 "lib/Sys/Guestfs.c"
	SV *	RETVAL;

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::wc_c(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::wc_c(): g is not a blessed HV reference");
    }
;
#line 11434 "lib/Sys/Guestfs.xs"
      r = guestfs_wc_c (g, path);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
      RETVAL = newSViv (r);
#line 28318 "lib/Sys/Guestfs.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Guestfs_wc_l); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_wc_l)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, path");
    {
	guestfs_h *	g;
	char *	path = (char *)SvPV_nolen(ST(1))
;
#line 11446 "lib/Sys/Guestfs.xs"
      int r;
#line 28338 "lib/Sys/Guestfs.c"
	SV *	RETVAL;

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::wc_l(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::wc_l(): g is not a blessed HV reference");
    }
;
#line 11448 "lib/Sys/Guestfs.xs"
      r = guestfs_wc_l (g, path);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
      RETVAL = newSViv (r);
#line 28358 "lib/Sys/Guestfs.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Guestfs_wc_w); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_wc_w)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, path");
    {
	guestfs_h *	g;
	char *	path = (char *)SvPV_nolen(ST(1))
;
#line 11460 "lib/Sys/Guestfs.xs"
      int r;
#line 28378 "lib/Sys/Guestfs.c"
	SV *	RETVAL;

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::wc_w(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::wc_w(): g is not a blessed HV reference");
    }
;
#line 11462 "lib/Sys/Guestfs.xs"
      r = guestfs_wc_w (g, path);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
      RETVAL = newSViv (r);
#line 28398 "lib/Sys/Guestfs.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Guestfs_wipefs); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_wipefs)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, device");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	device = (char *)SvPV_nolen(ST(1))
;
#line 11474 "lib/Sys/Guestfs.xs"
      int r;
#line 28420 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::wipefs(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::wipefs(): g is not a blessed HV reference");
    }
;
#line 11476 "lib/Sys/Guestfs.xs"
      r = guestfs_wipefs (g, device);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 28438 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_write); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_write)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "g, path, content");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	path = (char *)SvPV_nolen(ST(1))
;
	char *	content = (char *)SvPV_nolen(ST(2))
;
	size_t	content_size = SvCUR (ST(2));
#line 11487 "lib/Sys/Guestfs.xs"
      int r;
#line 28462 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::write(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::write(): g is not a blessed HV reference");
    }
;
#line 11489 "lib/Sys/Guestfs.xs"
      r = guestfs_write (g, path, content, content_size);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 28480 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_write_append); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_write_append)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "g, path, content");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	path = (char *)SvPV_nolen(ST(1))
;
	char *	content = (char *)SvPV_nolen(ST(2))
;
	size_t	content_size = SvCUR (ST(2));
#line 11500 "lib/Sys/Guestfs.xs"
      int r;
#line 28504 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::write_append(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::write_append(): g is not a blessed HV reference");
    }
;
#line 11502 "lib/Sys/Guestfs.xs"
      r = guestfs_write_append (g, path, content, content_size);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 28522 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_write_file); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_write_file)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "g, path, content, size");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	path = (char *)SvPV_nolen(ST(1))
;
	char *	content = (char *)SvPV_nolen(ST(2))
;
	int	size = (int)SvIV(ST(3))
;
#line 11513 "lib/Sys/Guestfs.xs"
      int r;
#line 28547 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::write_file(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::write_file(): g is not a blessed HV reference");
    }
;
#line 11515 "lib/Sys/Guestfs.xs"
      Perl_ck_warner (aTHX_ packWARN(WARN_DEPRECATED),
        "Sys::Guestfs::write_file is deprecated; use Sys::Guestfs::write instead");
      r = guestfs_write_file (g, path, content, size);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 28567 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_xfs_admin); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_xfs_admin)
{
    dVAR; dXSARGS;
    if (items < 2)
       croak_xs_usage(cv,  "g, device, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	device = (char *)SvPV_nolen(ST(1))
;
#line 11526 "lib/Sys/Guestfs.xs"
      int r;
      struct guestfs_xfs_admin_argv optargs_s = { .bitmask = 0 };
      struct guestfs_xfs_admin_argv *optargs = &optargs_s;
      size_t items_i;
#line 28591 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::xfs_admin(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::xfs_admin(): g is not a blessed HV reference");
    }
;
#line 11531 "lib/Sys/Guestfs.xs"
      if (((items - 2) & 1) != 0)
        croak ("expecting an even number of extra parameters");
      for (items_i = 2; items_i < items; items_i += 2) {
        uint64_t this_mask;
        const char *this_arg;

        this_arg = SvPV_nolen (ST (items_i));
        if (STREQ (this_arg, "extunwritten")) {
          optargs_s.extunwritten = SvIV (ST (items_i+1));
          this_mask = GUESTFS_XFS_ADMIN_EXTUNWRITTEN_BITMASK;
        }
        else if (STREQ (this_arg, "imgfile")) {
          optargs_s.imgfile = SvIV (ST (items_i+1));
          this_mask = GUESTFS_XFS_ADMIN_IMGFILE_BITMASK;
        }
        else if (STREQ (this_arg, "v2log")) {
          optargs_s.v2log = SvIV (ST (items_i+1));
          this_mask = GUESTFS_XFS_ADMIN_V2LOG_BITMASK;
        }
        else if (STREQ (this_arg, "projid32bit")) {
          optargs_s.projid32bit = SvIV (ST (items_i+1));
          this_mask = GUESTFS_XFS_ADMIN_PROJID32BIT_BITMASK;
        }
        else if (STREQ (this_arg, "lazycounter")) {
          optargs_s.lazycounter = SvIV (ST (items_i+1));
          this_mask = GUESTFS_XFS_ADMIN_LAZYCOUNTER_BITMASK;
        }
        else if (STREQ (this_arg, "label")) {
          optargs_s.label = SvPV_nolen (ST (items_i+1));
          this_mask = GUESTFS_XFS_ADMIN_LABEL_BITMASK;
        }
        else if (STREQ (this_arg, "uuid")) {
          optargs_s.uuid = SvPV_nolen (ST (items_i+1));
          this_mask = GUESTFS_XFS_ADMIN_UUID_BITMASK;
        }
        else croak ("unknown optional argument '%s'", this_arg);
        if (optargs_s.bitmask & this_mask)
          croak ("optional argument '%s' given more than once",
                 this_arg);
        optargs_s.bitmask |= this_mask;
      }

      r = guestfs_xfs_admin_argv (g, device, optargs);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 28651 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_xfs_growfs); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_xfs_growfs)
{
    dVAR; dXSARGS;
    if (items < 2)
       croak_xs_usage(cv,  "g, path, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	path = (char *)SvPV_nolen(ST(1))
;
#line 11582 "lib/Sys/Guestfs.xs"
      int r;
      struct guestfs_xfs_growfs_argv optargs_s = { .bitmask = 0 };
      struct guestfs_xfs_growfs_argv *optargs = &optargs_s;
      size_t items_i;
#line 28675 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::xfs_growfs(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::xfs_growfs(): g is not a blessed HV reference");
    }
;
#line 11587 "lib/Sys/Guestfs.xs"
      if (((items - 2) & 1) != 0)
        croak ("expecting an even number of extra parameters");
      for (items_i = 2; items_i < items; items_i += 2) {
        uint64_t this_mask;
        const char *this_arg;

        this_arg = SvPV_nolen (ST (items_i));
        if (STREQ (this_arg, "datasec")) {
          optargs_s.datasec = SvIV (ST (items_i+1));
          this_mask = GUESTFS_XFS_GROWFS_DATASEC_BITMASK;
        }
        else if (STREQ (this_arg, "logsec")) {
          optargs_s.logsec = SvIV (ST (items_i+1));
          this_mask = GUESTFS_XFS_GROWFS_LOGSEC_BITMASK;
        }
        else if (STREQ (this_arg, "rtsec")) {
          optargs_s.rtsec = SvIV (ST (items_i+1));
          this_mask = GUESTFS_XFS_GROWFS_RTSEC_BITMASK;
        }
        else if (STREQ (this_arg, "datasize")) {
          optargs_s.datasize = my_SvIV64 (ST (items_i+1));
          this_mask = GUESTFS_XFS_GROWFS_DATASIZE_BITMASK;
        }
        else if (STREQ (this_arg, "logsize")) {
          optargs_s.logsize = my_SvIV64 (ST (items_i+1));
          this_mask = GUESTFS_XFS_GROWFS_LOGSIZE_BITMASK;
        }
        else if (STREQ (this_arg, "rtsize")) {
          optargs_s.rtsize = my_SvIV64 (ST (items_i+1));
          this_mask = GUESTFS_XFS_GROWFS_RTSIZE_BITMASK;
        }
        else if (STREQ (this_arg, "rtextsize")) {
          optargs_s.rtextsize = my_SvIV64 (ST (items_i+1));
          this_mask = GUESTFS_XFS_GROWFS_RTEXTSIZE_BITMASK;
        }
        else if (STREQ (this_arg, "maxpct")) {
          optargs_s.maxpct = SvIV (ST (items_i+1));
          this_mask = GUESTFS_XFS_GROWFS_MAXPCT_BITMASK;
        }
        else croak ("unknown optional argument '%s'", this_arg);
        if (optargs_s.bitmask & this_mask)
          croak ("optional argument '%s' given more than once",
                 this_arg);
        optargs_s.bitmask |= this_mask;
      }

      r = guestfs_xfs_growfs_argv (g, path, optargs);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 28739 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_xfs_info); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_xfs_info)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, pathordevice");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	pathordevice = (char *)SvPV_nolen(ST(1))
;
#line 11642 "lib/Sys/Guestfs.xs"
      struct guestfs_xfsinfo *r;
#line 28760 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::xfs_info(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::xfs_info(): g is not a blessed HV reference");
    }
;
#line 11644 "lib/Sys/Guestfs.xs"
      r = guestfs_xfs_info (g, pathordevice);
      if (r == NULL)
        croak ("%s", guestfs_last_error (g));
      EXTEND (SP, 2 * 25);
      PUSHs (sv_2mortal (newSVpv ("xfs_mntpoint", 0)));
      PUSHs (sv_2mortal (newSVpv (r->xfs_mntpoint, 0)));
      PUSHs (sv_2mortal (newSVpv ("xfs_inodesize", 0)));
      PUSHs (sv_2mortal (newSVnv (r->xfs_inodesize)));
      PUSHs (sv_2mortal (newSVpv ("xfs_agcount", 0)));
      PUSHs (sv_2mortal (newSVnv (r->xfs_agcount)));
      PUSHs (sv_2mortal (newSVpv ("xfs_agsize", 0)));
      PUSHs (sv_2mortal (newSVnv (r->xfs_agsize)));
      PUSHs (sv_2mortal (newSVpv ("xfs_sectsize", 0)));
      PUSHs (sv_2mortal (newSVnv (r->xfs_sectsize)));
      PUSHs (sv_2mortal (newSVpv ("xfs_attr", 0)));
      PUSHs (sv_2mortal (newSVnv (r->xfs_attr)));
      PUSHs (sv_2mortal (newSVpv ("xfs_blocksize", 0)));
      PUSHs (sv_2mortal (newSVnv (r->xfs_blocksize)));
      PUSHs (sv_2mortal (newSVpv ("xfs_datablocks", 0)));
      PUSHs (sv_2mortal (my_newSVull (r->xfs_datablocks)));
      PUSHs (sv_2mortal (newSVpv ("xfs_imaxpct", 0)));
      PUSHs (sv_2mortal (newSVnv (r->xfs_imaxpct)));
      PUSHs (sv_2mortal (newSVpv ("xfs_sunit", 0)));
      PUSHs (sv_2mortal (newSVnv (r->xfs_sunit)));
      PUSHs (sv_2mortal (newSVpv ("xfs_swidth", 0)));
      PUSHs (sv_2mortal (newSVnv (r->xfs_swidth)));
      PUSHs (sv_2mortal (newSVpv ("xfs_dirversion", 0)));
      PUSHs (sv_2mortal (newSVnv (r->xfs_dirversion)));
      PUSHs (sv_2mortal (newSVpv ("xfs_dirblocksize", 0)));
      PUSHs (sv_2mortal (newSVnv (r->xfs_dirblocksize)));
      PUSHs (sv_2mortal (newSVpv ("xfs_cimode", 0)));
      PUSHs (sv_2mortal (newSVnv (r->xfs_cimode)));
      PUSHs (sv_2mortal (newSVpv ("xfs_logname", 0)));
      PUSHs (sv_2mortal (newSVpv (r->xfs_logname, 0)));
      PUSHs (sv_2mortal (newSVpv ("xfs_logblocksize", 0)));
      PUSHs (sv_2mortal (newSVnv (r->xfs_logblocksize)));
      PUSHs (sv_2mortal (newSVpv ("xfs_logblocks", 0)));
      PUSHs (sv_2mortal (newSVnv (r->xfs_logblocks)));
      PUSHs (sv_2mortal (newSVpv ("xfs_logversion", 0)));
      PUSHs (sv_2mortal (newSVnv (r->xfs_logversion)));
      PUSHs (sv_2mortal (newSVpv ("xfs_logsectsize", 0)));
      PUSHs (sv_2mortal (newSVnv (r->xfs_logsectsize)));
      PUSHs (sv_2mortal (newSVpv ("xfs_logsunit", 0)));
      PUSHs (sv_2mortal (newSVnv (r->xfs_logsunit)));
      PUSHs (sv_2mortal (newSVpv ("xfs_lazycount", 0)));
      PUSHs (sv_2mortal (newSVnv (r->xfs_lazycount)));
      PUSHs (sv_2mortal (newSVpv ("xfs_rtname", 0)));
      PUSHs (sv_2mortal (newSVpv (r->xfs_rtname, 0)));
      PUSHs (sv_2mortal (newSVpv ("xfs_rtextsize", 0)));
      PUSHs (sv_2mortal (newSVnv (r->xfs_rtextsize)));
      PUSHs (sv_2mortal (newSVpv ("xfs_rtblocks", 0)));
      PUSHs (sv_2mortal (my_newSVull (r->xfs_rtblocks)));
      PUSHs (sv_2mortal (newSVpv ("xfs_rtextents", 0)));
      PUSHs (sv_2mortal (my_newSVull (r->xfs_rtextents)));
      guestfs_free_xfsinfo (r);
#line 28830 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_xfs_repair); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_xfs_repair)
{
    dVAR; dXSARGS;
    if (items < 2)
       croak_xs_usage(cv,  "g, device, ...");
    {
	guestfs_h *	g;
	char *	device = (char *)SvPV_nolen(ST(1))
;
#line 11705 "lib/Sys/Guestfs.xs"
      int r;
      struct guestfs_xfs_repair_argv optargs_s = { .bitmask = 0 };
      struct guestfs_xfs_repair_argv *optargs = &optargs_s;
      size_t items_i;
#line 28852 "lib/Sys/Guestfs.c"
	SV *	RETVAL;

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::xfs_repair(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::xfs_repair(): g is not a blessed HV reference");
    }
;
#line 11710 "lib/Sys/Guestfs.xs"
      if (((items - 2) & 1) != 0)
        croak ("expecting an even number of extra parameters");
      for (items_i = 2; items_i < items; items_i += 2) {
        uint64_t this_mask;
        const char *this_arg;

        this_arg = SvPV_nolen (ST (items_i));
        if (STREQ (this_arg, "forcelogzero")) {
          optargs_s.forcelogzero = SvIV (ST (items_i+1));
          this_mask = GUESTFS_XFS_REPAIR_FORCELOGZERO_BITMASK;
        }
        else if (STREQ (this_arg, "nomodify")) {
          optargs_s.nomodify = SvIV (ST (items_i+1));
          this_mask = GUESTFS_XFS_REPAIR_NOMODIFY_BITMASK;
        }
        else if (STREQ (this_arg, "noprefetch")) {
          optargs_s.noprefetch = SvIV (ST (items_i+1));
          this_mask = GUESTFS_XFS_REPAIR_NOPREFETCH_BITMASK;
        }
        else if (STREQ (this_arg, "forcegeometry")) {
          optargs_s.forcegeometry = SvIV (ST (items_i+1));
          this_mask = GUESTFS_XFS_REPAIR_FORCEGEOMETRY_BITMASK;
        }
        else if (STREQ (this_arg, "maxmem")) {
          optargs_s.maxmem = my_SvIV64 (ST (items_i+1));
          this_mask = GUESTFS_XFS_REPAIR_MAXMEM_BITMASK;
        }
        else if (STREQ (this_arg, "ihashsize")) {
          optargs_s.ihashsize = my_SvIV64 (ST (items_i+1));
          this_mask = GUESTFS_XFS_REPAIR_IHASHSIZE_BITMASK;
        }
        else if (STREQ (this_arg, "bhashsize")) {
          optargs_s.bhashsize = my_SvIV64 (ST (items_i+1));
          this_mask = GUESTFS_XFS_REPAIR_BHASHSIZE_BITMASK;
        }
        else if (STREQ (this_arg, "agstride")) {
          optargs_s.agstride = my_SvIV64 (ST (items_i+1));
          this_mask = GUESTFS_XFS_REPAIR_AGSTRIDE_BITMASK;
        }
        else if (STREQ (this_arg, "logdev")) {
          optargs_s.logdev = SvPV_nolen (ST (items_i+1));
          this_mask = GUESTFS_XFS_REPAIR_LOGDEV_BITMASK;
        }
        else if (STREQ (this_arg, "rtdev")) {
          optargs_s.rtdev = SvPV_nolen (ST (items_i+1));
          this_mask = GUESTFS_XFS_REPAIR_RTDEV_BITMASK;
        }
        else croak ("unknown optional argument '%s'", this_arg);
        if (optargs_s.bitmask & this_mask)
          croak ("optional argument '%s' given more than once",
                 this_arg);
        optargs_s.bitmask |= this_mask;
      }

      r = guestfs_xfs_repair_argv (g, device, optargs);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
      RETVAL = newSViv (r);
#line 28926 "lib/Sys/Guestfs.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Guestfs_yara_destroy); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_yara_destroy)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "g");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
#line 11775 "lib/Sys/Guestfs.xs"
      int r;
#line 28946 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::yara_destroy(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::yara_destroy(): g is not a blessed HV reference");
    }
;
#line 11777 "lib/Sys/Guestfs.xs"
      r = guestfs_yara_destroy (g);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 28964 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_yara_load); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_yara_load)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, filename");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	filename = (char *)SvPV_nolen(ST(1))
;
#line 11786 "lib/Sys/Guestfs.xs"
      int r;
#line 28985 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::yara_load(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::yara_load(): g is not a blessed HV reference");
    }
;
#line 11788 "lib/Sys/Guestfs.xs"
      r = guestfs_yara_load (g, filename);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 29003 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_yara_scan); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_yara_scan)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, path");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	path = (char *)SvPV_nolen(ST(1))
;
#line 11797 "lib/Sys/Guestfs.xs"
      struct guestfs_yara_detection_list *r;
      size_t i;
      HV *hv;
#line 29026 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::yara_scan(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::yara_scan(): g is not a blessed HV reference");
    }
;
#line 11801 "lib/Sys/Guestfs.xs"
      r = guestfs_yara_scan (g, path);
      if (r == NULL)
        croak ("%s", guestfs_last_error (g));
      EXTEND (SP, r->len);
      for (i = 0; i < r->len; ++i) {
        hv = newHV ();
        (void) hv_store (hv, "yara_name", 9, newSVpv (r->val[i].yara_name, 0), 0);
        (void) hv_store (hv, "yara_rule", 9, newSVpv (r->val[i].yara_rule, 0), 0);
        PUSHs (sv_2mortal (newRV ((SV *) hv)));
      }
      guestfs_free_yara_detection_list (r);
#line 29052 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_zegrep); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_zegrep)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "g, regex, path");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	regex = (char *)SvPV_nolen(ST(1))
;
	char *	path = (char *)SvPV_nolen(ST(2))
;
#line 11819 "lib/Sys/Guestfs.xs"
      char **r;
      size_t i, n;
#line 29076 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::zegrep(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::zegrep(): g is not a blessed HV reference");
    }
;
#line 11822 "lib/Sys/Guestfs.xs"
      Perl_ck_warner (aTHX_ packWARN(WARN_DEPRECATED),
        "Sys::Guestfs::zegrep is deprecated; use Sys::Guestfs::grep instead");
      r = guestfs_zegrep (g, regex, path);
      if (r == NULL)
        croak ("%s", guestfs_last_error (g));
      for (n = 0; r[n] != NULL; ++n) /**/;
      EXTEND (SP, n);
      for (i = 0; i < n; ++i) {
        PUSHs (sv_2mortal (newSVpv (r[i], 0)));
        free (r[i]);
      }
      free (r);
#line 29103 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_zegrepi); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_zegrepi)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "g, regex, path");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	regex = (char *)SvPV_nolen(ST(1))
;
	char *	path = (char *)SvPV_nolen(ST(2))
;
#line 11841 "lib/Sys/Guestfs.xs"
      char **r;
      size_t i, n;
#line 29127 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::zegrepi(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::zegrepi(): g is not a blessed HV reference");
    }
;
#line 11844 "lib/Sys/Guestfs.xs"
      Perl_ck_warner (aTHX_ packWARN(WARN_DEPRECATED),
        "Sys::Guestfs::zegrepi is deprecated; use Sys::Guestfs::grep instead");
      r = guestfs_zegrepi (g, regex, path);
      if (r == NULL)
        croak ("%s", guestfs_last_error (g));
      for (n = 0; r[n] != NULL; ++n) /**/;
      EXTEND (SP, n);
      for (i = 0; i < n; ++i) {
        PUSHs (sv_2mortal (newSVpv (r[i], 0)));
        free (r[i]);
      }
      free (r);
#line 29154 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_zero); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_zero)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, device");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	device = (char *)SvPV_nolen(ST(1))
;
#line 11862 "lib/Sys/Guestfs.xs"
      int r;
#line 29175 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::zero(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::zero(): g is not a blessed HV reference");
    }
;
#line 11864 "lib/Sys/Guestfs.xs"
      r = guestfs_zero (g, device);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 29193 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_zero_device); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_zero_device)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, device");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	device = (char *)SvPV_nolen(ST(1))
;
#line 11873 "lib/Sys/Guestfs.xs"
      int r;
#line 29214 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::zero_device(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::zero_device(): g is not a blessed HV reference");
    }
;
#line 11875 "lib/Sys/Guestfs.xs"
      r = guestfs_zero_device (g, device);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 29232 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_zero_free_space); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_zero_free_space)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, directory");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	directory = (char *)SvPV_nolen(ST(1))
;
#line 11884 "lib/Sys/Guestfs.xs"
      int r;
#line 29253 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::zero_free_space(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::zero_free_space(): g is not a blessed HV reference");
    }
;
#line 11886 "lib/Sys/Guestfs.xs"
      r = guestfs_zero_free_space (g, directory);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 29271 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_zerofree); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_zerofree)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "g, device");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	device = (char *)SvPV_nolen(ST(1))
;
#line 11895 "lib/Sys/Guestfs.xs"
      int r;
#line 29292 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::zerofree(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::zerofree(): g is not a blessed HV reference");
    }
;
#line 11897 "lib/Sys/Guestfs.xs"
      r = guestfs_zerofree (g, device);
      if (r == -1)
        croak ("%s", guestfs_last_error (g));
#line 29310 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_zfgrep); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_zfgrep)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "g, pattern, path");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	pattern = (char *)SvPV_nolen(ST(1))
;
	char *	path = (char *)SvPV_nolen(ST(2))
;
#line 11907 "lib/Sys/Guestfs.xs"
      char **r;
      size_t i, n;
#line 29334 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::zfgrep(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::zfgrep(): g is not a blessed HV reference");
    }
;
#line 11910 "lib/Sys/Guestfs.xs"
      Perl_ck_warner (aTHX_ packWARN(WARN_DEPRECATED),
        "Sys::Guestfs::zfgrep is deprecated; use Sys::Guestfs::grep instead");
      r = guestfs_zfgrep (g, pattern, path);
      if (r == NULL)
        croak ("%s", guestfs_last_error (g));
      for (n = 0; r[n] != NULL; ++n) /**/;
      EXTEND (SP, n);
      for (i = 0; i < n; ++i) {
        PUSHs (sv_2mortal (newSVpv (r[i], 0)));
        free (r[i]);
      }
      free (r);
#line 29361 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_zfgrepi); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_zfgrepi)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "g, pattern, path");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	pattern = (char *)SvPV_nolen(ST(1))
;
	char *	path = (char *)SvPV_nolen(ST(2))
;
#line 11929 "lib/Sys/Guestfs.xs"
      char **r;
      size_t i, n;
#line 29385 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::zfgrepi(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::zfgrepi(): g is not a blessed HV reference");
    }
;
#line 11932 "lib/Sys/Guestfs.xs"
      Perl_ck_warner (aTHX_ packWARN(WARN_DEPRECATED),
        "Sys::Guestfs::zfgrepi is deprecated; use Sys::Guestfs::grep instead");
      r = guestfs_zfgrepi (g, pattern, path);
      if (r == NULL)
        croak ("%s", guestfs_last_error (g));
      for (n = 0; r[n] != NULL; ++n) /**/;
      EXTEND (SP, n);
      for (i = 0; i < n; ++i) {
        PUSHs (sv_2mortal (newSVpv (r[i], 0)));
        free (r[i]);
      }
      free (r);
#line 29412 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_zfile); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_zfile)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "g, meth, path");
    {
	guestfs_h *	g;
	char *	meth = (char *)SvPV_nolen(ST(1))
;
	char *	path = (char *)SvPV_nolen(ST(2))
;
#line 11951 "lib/Sys/Guestfs.xs"
      char *r;
#line 29433 "lib/Sys/Guestfs.c"
	SV *	RETVAL;

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::zfile(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::zfile(): g is not a blessed HV reference");
    }
;
#line 11953 "lib/Sys/Guestfs.xs"
      Perl_ck_warner (aTHX_ packWARN(WARN_DEPRECATED),
        "Sys::Guestfs::zfile is deprecated; use Sys::Guestfs::file instead");
      r = guestfs_zfile (g, meth, path);
      if (r == NULL)
        croak ("%s", guestfs_last_error (g));
      RETVAL = newSVpv (r, 0);
      free (r);
#line 29456 "lib/Sys/Guestfs.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Guestfs_zgrep); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_zgrep)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "g, regex, path");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	regex = (char *)SvPV_nolen(ST(1))
;
	char *	path = (char *)SvPV_nolen(ST(2))
;
#line 11969 "lib/Sys/Guestfs.xs"
      char **r;
      size_t i, n;
#line 29481 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::zgrep(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::zgrep(): g is not a blessed HV reference");
    }
;
#line 11972 "lib/Sys/Guestfs.xs"
      Perl_ck_warner (aTHX_ packWARN(WARN_DEPRECATED),
        "Sys::Guestfs::zgrep is deprecated; use Sys::Guestfs::grep instead");
      r = guestfs_zgrep (g, regex, path);
      if (r == NULL)
        croak ("%s", guestfs_last_error (g));
      for (n = 0; r[n] != NULL; ++n) /**/;
      EXTEND (SP, n);
      for (i = 0; i < n; ++i) {
        PUSHs (sv_2mortal (newSVpv (r[i], 0)));
        free (r[i]);
      }
      free (r);
#line 29508 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Guestfs_zgrepi); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Guestfs_zgrepi)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "g, regex, path");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	guestfs_h *	g;
	char *	regex = (char *)SvPV_nolen(ST(1))
;
	char *	path = (char *)SvPV_nolen(ST(2))
;
#line 11991 "lib/Sys/Guestfs.xs"
      char **r;
      size_t i, n;
#line 29532 "lib/Sys/Guestfs.c"

    if (sv_isobject (ST(0)) && sv_derived_from (ST(0), "Sys::Guestfs") &&
        SvTYPE (ST(0)) == SVt_RV &&
        SvTYPE (SvRV (ST(0))) == SVt_PVHV) {
        HV *hv = (HV *) SvRV (ST(0));
        SV **svp = hv_fetch (hv, "_g", 2, 0);
        if (svp == NULL)
            croak ("Sys::Guestfs::zgrepi(): called on a closed handle");
        g = INT2PTR (guestfs_h *, SvIV (*svp));
    } else {
        croak ("Sys::Guestfs::zgrepi(): g is not a blessed HV reference");
    }
;
#line 11994 "lib/Sys/Guestfs.xs"
      Perl_ck_warner (aTHX_ packWARN(WARN_DEPRECATED),
        "Sys::Guestfs::zgrepi is deprecated; use Sys::Guestfs::grep instead");
      r = guestfs_zgrepi (g, regex, path);
      if (r == NULL)
        croak ("%s", guestfs_last_error (g));
      for (n = 0; r[n] != NULL; ++n) /**/;
      EXTEND (SP, n);
      for (i = 0; i < n; ++i) {
        PUSHs (sv_2mortal (newSVpv (r[i], 0)));
        free (r[i]);
      }
      free (r);
#line 29559 "lib/Sys/Guestfs.c"
	PUTBACK;
	return;
    }
}

#ifdef __cplusplus
extern "C" {
#endif
XS_EXTERNAL(boot_Sys__Guestfs); /* prototype to pass -Wmissing-prototypes */
XS_EXTERNAL(boot_Sys__Guestfs)
{
#if PERL_VERSION_LE(5, 21, 5)
    dVAR; dXSARGS;
#else
    dVAR; dXSBOOTARGSXSAPIVERCHK;
#endif
#if PERL_VERSION_LE(5, 8, 999) /* PERL_VERSION_LT is 5.33+ */
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(file);

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
#if PERL_VERSION_LE(5, 21, 5)
    XS_VERSION_BOOTCHECK;
#  ifdef XS_APIVERSION_BOOTCHECK
    XS_APIVERSION_BOOTCHECK;
#  endif
#endif

        (void)newXSproto_portable("Sys::Guestfs::_create", XS_Sys__Guestfs__create, file, "$");
        (void)newXSproto_portable("Sys::Guestfs::DESTROY", XS_Sys__Guestfs_DESTROY, file, "$");
        (void)newXSproto_portable("Sys::Guestfs::close", XS_Sys__Guestfs_close, file, "$");
        (void)newXSproto_portable("Sys::Guestfs::set_event_callback", XS_Sys__Guestfs_set_event_callback, file, "$$$");
        (void)newXSproto_portable("Sys::Guestfs::delete_event_callback", XS_Sys__Guestfs_delete_event_callback, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::event_to_string", XS_Sys__Guestfs_event_to_string, file, "$");
        (void)newXSproto_portable("Sys::Guestfs::last_errno", XS_Sys__Guestfs_last_errno, file, "$");
        (void)newXSproto_portable("Sys::Guestfs::acl_delete_def_file", XS_Sys__Guestfs_acl_delete_def_file, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::acl_get_file", XS_Sys__Guestfs_acl_get_file, file, "$$$");
        (void)newXSproto_portable("Sys::Guestfs::acl_set_file", XS_Sys__Guestfs_acl_set_file, file, "$$$$");
        (void)newXSproto_portable("Sys::Guestfs::add_cdrom", XS_Sys__Guestfs_add_cdrom, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::add_domain", XS_Sys__Guestfs_add_domain, file, "$$;@");
        (void)newXSproto_portable("Sys::Guestfs::add_drive", XS_Sys__Guestfs_add_drive, file, "$$;@");
        (void)newXSproto_portable("Sys::Guestfs::add_drive_ro", XS_Sys__Guestfs_add_drive_ro, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::add_drive_ro_with_if", XS_Sys__Guestfs_add_drive_ro_with_if, file, "$$$");
        (void)newXSproto_portable("Sys::Guestfs::add_drive_scratch", XS_Sys__Guestfs_add_drive_scratch, file, "$$;@");
        (void)newXSproto_portable("Sys::Guestfs::add_drive_with_if", XS_Sys__Guestfs_add_drive_with_if, file, "$$$");
        (void)newXSproto_portable("Sys::Guestfs::add_libvirt_dom", XS_Sys__Guestfs_add_libvirt_dom, file, "$$;@");
        (void)newXSproto_portable("Sys::Guestfs::aug_clear", XS_Sys__Guestfs_aug_clear, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::aug_close", XS_Sys__Guestfs_aug_close, file, "$");
        (void)newXSproto_portable("Sys::Guestfs::aug_defnode", XS_Sys__Guestfs_aug_defnode, file, "$$$$");
        (void)newXSproto_portable("Sys::Guestfs::aug_defvar", XS_Sys__Guestfs_aug_defvar, file, "$$$");
        (void)newXSproto_portable("Sys::Guestfs::aug_get", XS_Sys__Guestfs_aug_get, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::aug_init", XS_Sys__Guestfs_aug_init, file, "$$$");
        (void)newXSproto_portable("Sys::Guestfs::aug_insert", XS_Sys__Guestfs_aug_insert, file, "$$$$");
        (void)newXSproto_portable("Sys::Guestfs::aug_label", XS_Sys__Guestfs_aug_label, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::aug_load", XS_Sys__Guestfs_aug_load, file, "$");
        (void)newXSproto_portable("Sys::Guestfs::aug_ls", XS_Sys__Guestfs_aug_ls, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::aug_match", XS_Sys__Guestfs_aug_match, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::aug_mv", XS_Sys__Guestfs_aug_mv, file, "$$$");
        (void)newXSproto_portable("Sys::Guestfs::aug_rm", XS_Sys__Guestfs_aug_rm, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::aug_save", XS_Sys__Guestfs_aug_save, file, "$");
        (void)newXSproto_portable("Sys::Guestfs::aug_set", XS_Sys__Guestfs_aug_set, file, "$$$");
        (void)newXSproto_portable("Sys::Guestfs::aug_setm", XS_Sys__Guestfs_aug_setm, file, "$$$$");
        (void)newXSproto_portable("Sys::Guestfs::aug_transform", XS_Sys__Guestfs_aug_transform, file, "$$$;@");
        (void)newXSproto_portable("Sys::Guestfs::available", XS_Sys__Guestfs_available, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::available_all_groups", XS_Sys__Guestfs_available_all_groups, file, "$");
        (void)newXSproto_portable("Sys::Guestfs::base64_in", XS_Sys__Guestfs_base64_in, file, "$$$");
        (void)newXSproto_portable("Sys::Guestfs::base64_out", XS_Sys__Guestfs_base64_out, file, "$$$");
        (void)newXSproto_portable("Sys::Guestfs::blkdiscard", XS_Sys__Guestfs_blkdiscard, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::blkdiscardzeroes", XS_Sys__Guestfs_blkdiscardzeroes, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::blkid", XS_Sys__Guestfs_blkid, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::blockdev_flushbufs", XS_Sys__Guestfs_blockdev_flushbufs, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::blockdev_getbsz", XS_Sys__Guestfs_blockdev_getbsz, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::blockdev_getro", XS_Sys__Guestfs_blockdev_getro, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::blockdev_getsize64", XS_Sys__Guestfs_blockdev_getsize64, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::blockdev_getss", XS_Sys__Guestfs_blockdev_getss, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::blockdev_getsz", XS_Sys__Guestfs_blockdev_getsz, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::blockdev_rereadpt", XS_Sys__Guestfs_blockdev_rereadpt, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::blockdev_setbsz", XS_Sys__Guestfs_blockdev_setbsz, file, "$$$");
        (void)newXSproto_portable("Sys::Guestfs::blockdev_setra", XS_Sys__Guestfs_blockdev_setra, file, "$$$");
        (void)newXSproto_portable("Sys::Guestfs::blockdev_setro", XS_Sys__Guestfs_blockdev_setro, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::blockdev_setrw", XS_Sys__Guestfs_blockdev_setrw, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::btrfs_balance_cancel", XS_Sys__Guestfs_btrfs_balance_cancel, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::btrfs_balance_pause", XS_Sys__Guestfs_btrfs_balance_pause, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::btrfs_balance_resume", XS_Sys__Guestfs_btrfs_balance_resume, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::btrfs_balance_status", XS_Sys__Guestfs_btrfs_balance_status, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::btrfs_device_add", XS_Sys__Guestfs_btrfs_device_add, file, "$$$");
        (void)newXSproto_portable("Sys::Guestfs::btrfs_device_delete", XS_Sys__Guestfs_btrfs_device_delete, file, "$$$");
        (void)newXSproto_portable("Sys::Guestfs::btrfs_filesystem_balance", XS_Sys__Guestfs_btrfs_filesystem_balance, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::btrfs_filesystem_defragment", XS_Sys__Guestfs_btrfs_filesystem_defragment, file, "$$;@");
        (void)newXSproto_portable("Sys::Guestfs::btrfs_filesystem_resize", XS_Sys__Guestfs_btrfs_filesystem_resize, file, "$$;@");
        (void)newXSproto_portable("Sys::Guestfs::btrfs_filesystem_show", XS_Sys__Guestfs_btrfs_filesystem_show, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::btrfs_filesystem_sync", XS_Sys__Guestfs_btrfs_filesystem_sync, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::btrfs_fsck", XS_Sys__Guestfs_btrfs_fsck, file, "$$;@");
        (void)newXSproto_portable("Sys::Guestfs::btrfs_image", XS_Sys__Guestfs_btrfs_image, file, "$$$;@");
        (void)newXSproto_portable("Sys::Guestfs::btrfs_qgroup_assign", XS_Sys__Guestfs_btrfs_qgroup_assign, file, "$$$$");
        (void)newXSproto_portable("Sys::Guestfs::btrfs_qgroup_create", XS_Sys__Guestfs_btrfs_qgroup_create, file, "$$$");
        (void)newXSproto_portable("Sys::Guestfs::btrfs_qgroup_destroy", XS_Sys__Guestfs_btrfs_qgroup_destroy, file, "$$$");
        (void)newXSproto_portable("Sys::Guestfs::btrfs_qgroup_limit", XS_Sys__Guestfs_btrfs_qgroup_limit, file, "$$$");
        (void)newXSproto_portable("Sys::Guestfs::btrfs_qgroup_remove", XS_Sys__Guestfs_btrfs_qgroup_remove, file, "$$$$");
        (void)newXSproto_portable("Sys::Guestfs::btrfs_qgroup_show", XS_Sys__Guestfs_btrfs_qgroup_show, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::btrfs_quota_enable", XS_Sys__Guestfs_btrfs_quota_enable, file, "$$$");
        (void)newXSproto_portable("Sys::Guestfs::btrfs_quota_rescan", XS_Sys__Guestfs_btrfs_quota_rescan, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::btrfs_replace", XS_Sys__Guestfs_btrfs_replace, file, "$$$$");
        (void)newXSproto_portable("Sys::Guestfs::btrfs_rescue_chunk_recover", XS_Sys__Guestfs_btrfs_rescue_chunk_recover, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::btrfs_rescue_super_recover", XS_Sys__Guestfs_btrfs_rescue_super_recover, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::btrfs_scrub_cancel", XS_Sys__Guestfs_btrfs_scrub_cancel, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::btrfs_scrub_resume", XS_Sys__Guestfs_btrfs_scrub_resume, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::btrfs_scrub_start", XS_Sys__Guestfs_btrfs_scrub_start, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::btrfs_scrub_status", XS_Sys__Guestfs_btrfs_scrub_status, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::btrfs_set_seeding", XS_Sys__Guestfs_btrfs_set_seeding, file, "$$$");
        (void)newXSproto_portable("Sys::Guestfs::btrfs_subvolume_create", XS_Sys__Guestfs_btrfs_subvolume_create, file, "$$;@");
        (void)newXSproto_portable("Sys::Guestfs::btrfs_subvolume_delete", XS_Sys__Guestfs_btrfs_subvolume_delete, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::btrfs_subvolume_get_default", XS_Sys__Guestfs_btrfs_subvolume_get_default, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::btrfs_subvolume_list", XS_Sys__Guestfs_btrfs_subvolume_list, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::btrfs_subvolume_set_default", XS_Sys__Guestfs_btrfs_subvolume_set_default, file, "$$$");
        (void)newXSproto_portable("Sys::Guestfs::btrfs_subvolume_show", XS_Sys__Guestfs_btrfs_subvolume_show, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::btrfs_subvolume_snapshot", XS_Sys__Guestfs_btrfs_subvolume_snapshot, file, "$$$;@");
        (void)newXSproto_portable("Sys::Guestfs::btrfstune_enable_extended_inode_refs", XS_Sys__Guestfs_btrfstune_enable_extended_inode_refs, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::btrfstune_enable_skinny_metadata_extent_refs", XS_Sys__Guestfs_btrfstune_enable_skinny_metadata_extent_refs, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::btrfstune_seeding", XS_Sys__Guestfs_btrfstune_seeding, file, "$$$");
        (void)newXSproto_portable("Sys::Guestfs::c_pointer", XS_Sys__Guestfs_c_pointer, file, "$");
        (void)newXSproto_portable("Sys::Guestfs::canonical_device_name", XS_Sys__Guestfs_canonical_device_name, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::cap_get_file", XS_Sys__Guestfs_cap_get_file, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::cap_set_file", XS_Sys__Guestfs_cap_set_file, file, "$$$");
        (void)newXSproto_portable("Sys::Guestfs::case_sensitive_path", XS_Sys__Guestfs_case_sensitive_path, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::cat", XS_Sys__Guestfs_cat, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::checksum", XS_Sys__Guestfs_checksum, file, "$$$");
        (void)newXSproto_portable("Sys::Guestfs::checksum_device", XS_Sys__Guestfs_checksum_device, file, "$$$");
        (void)newXSproto_portable("Sys::Guestfs::checksums_out", XS_Sys__Guestfs_checksums_out, file, "$$$$");
        (void)newXSproto_portable("Sys::Guestfs::chmod", XS_Sys__Guestfs_chmod, file, "$$$");
        (void)newXSproto_portable("Sys::Guestfs::chown", XS_Sys__Guestfs_chown, file, "$$$$");
        (void)newXSproto_portable("Sys::Guestfs::clear_backend_setting", XS_Sys__Guestfs_clear_backend_setting, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::clevis_luks_unlock", XS_Sys__Guestfs_clevis_luks_unlock, file, "$$$");
        (void)newXSproto_portable("Sys::Guestfs::command", XS_Sys__Guestfs_command, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::command_lines", XS_Sys__Guestfs_command_lines, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::compress_device_out", XS_Sys__Guestfs_compress_device_out, file, "$$$$;@");
        (void)newXSproto_portable("Sys::Guestfs::compress_out", XS_Sys__Guestfs_compress_out, file, "$$$$;@");
        (void)newXSproto_portable("Sys::Guestfs::config", XS_Sys__Guestfs_config, file, "$$$");
        (void)newXSproto_portable("Sys::Guestfs::copy_attributes", XS_Sys__Guestfs_copy_attributes, file, "$$$;@");
        (void)newXSproto_portable("Sys::Guestfs::copy_device_to_device", XS_Sys__Guestfs_copy_device_to_device, file, "$$$;@");
        (void)newXSproto_portable("Sys::Guestfs::copy_device_to_file", XS_Sys__Guestfs_copy_device_to_file, file, "$$$;@");
        (void)newXSproto_portable("Sys::Guestfs::copy_file_to_device", XS_Sys__Guestfs_copy_file_to_device, file, "$$$;@");
        (void)newXSproto_portable("Sys::Guestfs::copy_file_to_file", XS_Sys__Guestfs_copy_file_to_file, file, "$$$;@");
        (void)newXSproto_portable("Sys::Guestfs::copy_in", XS_Sys__Guestfs_copy_in, file, "$$$");
        (void)newXSproto_portable("Sys::Guestfs::copy_out", XS_Sys__Guestfs_copy_out, file, "$$$");
        (void)newXSproto_portable("Sys::Guestfs::copy_size", XS_Sys__Guestfs_copy_size, file, "$$$$");
        (void)newXSproto_portable("Sys::Guestfs::cp", XS_Sys__Guestfs_cp, file, "$$$");
        (void)newXSproto_portable("Sys::Guestfs::cp_a", XS_Sys__Guestfs_cp_a, file, "$$$");
        (void)newXSproto_portable("Sys::Guestfs::cp_r", XS_Sys__Guestfs_cp_r, file, "$$$");
        (void)newXSproto_portable("Sys::Guestfs::cpio_out", XS_Sys__Guestfs_cpio_out, file, "$$$;@");
        (void)newXSproto_portable("Sys::Guestfs::cryptsetup_close", XS_Sys__Guestfs_cryptsetup_close, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::cryptsetup_open", XS_Sys__Guestfs_cryptsetup_open, file, "$$$$;@");
        (void)newXSproto_portable("Sys::Guestfs::dd", XS_Sys__Guestfs_dd, file, "$$$");
        (void)newXSproto_portable("Sys::Guestfs::debug", XS_Sys__Guestfs_debug, file, "$$$");
        (void)newXSproto_portable("Sys::Guestfs::debug_drives", XS_Sys__Guestfs_debug_drives, file, "$");
        (void)newXSproto_portable("Sys::Guestfs::debug_upload", XS_Sys__Guestfs_debug_upload, file, "$$$$");
        (void)newXSproto_portable("Sys::Guestfs::device_index", XS_Sys__Guestfs_device_index, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::device_name", XS_Sys__Guestfs_device_name, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::df", XS_Sys__Guestfs_df, file, "$");
        (void)newXSproto_portable("Sys::Guestfs::df_h", XS_Sys__Guestfs_df_h, file, "$");
        (void)newXSproto_portable("Sys::Guestfs::disk_create", XS_Sys__Guestfs_disk_create, file, "$$$$;@");
        (void)newXSproto_portable("Sys::Guestfs::disk_format", XS_Sys__Guestfs_disk_format, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::disk_has_backing_file", XS_Sys__Guestfs_disk_has_backing_file, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::disk_virtual_size", XS_Sys__Guestfs_disk_virtual_size, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::dmesg", XS_Sys__Guestfs_dmesg, file, "$");
        (void)newXSproto_portable("Sys::Guestfs::download", XS_Sys__Guestfs_download, file, "$$$");
        (void)newXSproto_portable("Sys::Guestfs::download_blocks", XS_Sys__Guestfs_download_blocks, file, "$$$$$;@");
        (void)newXSproto_portable("Sys::Guestfs::download_inode", XS_Sys__Guestfs_download_inode, file, "$$$$");
        (void)newXSproto_portable("Sys::Guestfs::download_offset", XS_Sys__Guestfs_download_offset, file, "$$$$$");
        (void)newXSproto_portable("Sys::Guestfs::drop_caches", XS_Sys__Guestfs_drop_caches, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::du", XS_Sys__Guestfs_du, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::e2fsck", XS_Sys__Guestfs_e2fsck, file, "$$;@");
        (void)newXSproto_portable("Sys::Guestfs::e2fsck_f", XS_Sys__Guestfs_e2fsck_f, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::echo_daemon", XS_Sys__Guestfs_echo_daemon, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::egrep", XS_Sys__Guestfs_egrep, file, "$$$");
        (void)newXSproto_portable("Sys::Guestfs::egrepi", XS_Sys__Guestfs_egrepi, file, "$$$");
        (void)newXSproto_portable("Sys::Guestfs::equal", XS_Sys__Guestfs_equal, file, "$$$");
        (void)newXSproto_portable("Sys::Guestfs::exists", XS_Sys__Guestfs_exists, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::extlinux", XS_Sys__Guestfs_extlinux, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::f2fs_expand", XS_Sys__Guestfs_f2fs_expand, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::fallocate", XS_Sys__Guestfs_fallocate, file, "$$$");
        (void)newXSproto_portable("Sys::Guestfs::fallocate64", XS_Sys__Guestfs_fallocate64, file, "$$$");
        (void)newXSproto_portable("Sys::Guestfs::feature_available", XS_Sys__Guestfs_feature_available, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::fgrep", XS_Sys__Guestfs_fgrep, file, "$$$");
        (void)newXSproto_portable("Sys::Guestfs::fgrepi", XS_Sys__Guestfs_fgrepi, file, "$$$");
        (void)newXSproto_portable("Sys::Guestfs::file", XS_Sys__Guestfs_file, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::file_architecture", XS_Sys__Guestfs_file_architecture, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::filesize", XS_Sys__Guestfs_filesize, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::filesystem_available", XS_Sys__Guestfs_filesystem_available, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::filesystem_walk", XS_Sys__Guestfs_filesystem_walk, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::fill", XS_Sys__Guestfs_fill, file, "$$$$");
        (void)newXSproto_portable("Sys::Guestfs::fill_dir", XS_Sys__Guestfs_fill_dir, file, "$$$");
        (void)newXSproto_portable("Sys::Guestfs::fill_pattern", XS_Sys__Guestfs_fill_pattern, file, "$$$$");
        (void)newXSproto_portable("Sys::Guestfs::find", XS_Sys__Guestfs_find, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::find0", XS_Sys__Guestfs_find0, file, "$$$");
        (void)newXSproto_portable("Sys::Guestfs::find_inode", XS_Sys__Guestfs_find_inode, file, "$$$");
        (void)newXSproto_portable("Sys::Guestfs::findfs_label", XS_Sys__Guestfs_findfs_label, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::findfs_partlabel", XS_Sys__Guestfs_findfs_partlabel, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::findfs_partuuid", XS_Sys__Guestfs_findfs_partuuid, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::findfs_uuid", XS_Sys__Guestfs_findfs_uuid, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::fsck", XS_Sys__Guestfs_fsck, file, "$$$");
        (void)newXSproto_portable("Sys::Guestfs::fstrim", XS_Sys__Guestfs_fstrim, file, "$$;@");
        (void)newXSproto_portable("Sys::Guestfs::get_append", XS_Sys__Guestfs_get_append, file, "$");
        (void)newXSproto_portable("Sys::Guestfs::get_attach_method", XS_Sys__Guestfs_get_attach_method, file, "$");
        (void)newXSproto_portable("Sys::Guestfs::get_autosync", XS_Sys__Guestfs_get_autosync, file, "$");
        (void)newXSproto_portable("Sys::Guestfs::get_backend", XS_Sys__Guestfs_get_backend, file, "$");
        (void)newXSproto_portable("Sys::Guestfs::get_backend_setting", XS_Sys__Guestfs_get_backend_setting, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::get_backend_settings", XS_Sys__Guestfs_get_backend_settings, file, "$");
        (void)newXSproto_portable("Sys::Guestfs::get_cachedir", XS_Sys__Guestfs_get_cachedir, file, "$");
        (void)newXSproto_portable("Sys::Guestfs::get_direct", XS_Sys__Guestfs_get_direct, file, "$");
        (void)newXSproto_portable("Sys::Guestfs::get_e2attrs", XS_Sys__Guestfs_get_e2attrs, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::get_e2generation", XS_Sys__Guestfs_get_e2generation, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::get_e2label", XS_Sys__Guestfs_get_e2label, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::get_e2uuid", XS_Sys__Guestfs_get_e2uuid, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::get_hv", XS_Sys__Guestfs_get_hv, file, "$");
        (void)newXSproto_portable("Sys::Guestfs::get_identifier", XS_Sys__Guestfs_get_identifier, file, "$");
        (void)newXSproto_portable("Sys::Guestfs::get_libvirt_requested_credential_challenge", XS_Sys__Guestfs_get_libvirt_requested_credential_challenge, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::get_libvirt_requested_credential_defresult", XS_Sys__Guestfs_get_libvirt_requested_credential_defresult, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::get_libvirt_requested_credential_prompt", XS_Sys__Guestfs_get_libvirt_requested_credential_prompt, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::get_libvirt_requested_credentials", XS_Sys__Guestfs_get_libvirt_requested_credentials, file, "$");
        (void)newXSproto_portable("Sys::Guestfs::get_memsize", XS_Sys__Guestfs_get_memsize, file, "$");
        (void)newXSproto_portable("Sys::Guestfs::get_network", XS_Sys__Guestfs_get_network, file, "$");
        (void)newXSproto_portable("Sys::Guestfs::get_path", XS_Sys__Guestfs_get_path, file, "$");
        (void)newXSproto_portable("Sys::Guestfs::get_pgroup", XS_Sys__Guestfs_get_pgroup, file, "$");
        (void)newXSproto_portable("Sys::Guestfs::get_pid", XS_Sys__Guestfs_get_pid, file, "$");
        (void)newXSproto_portable("Sys::Guestfs::get_program", XS_Sys__Guestfs_get_program, file, "$");
        (void)newXSproto_portable("Sys::Guestfs::get_qemu", XS_Sys__Guestfs_get_qemu, file, "$");
        (void)newXSproto_portable("Sys::Guestfs::get_recovery_proc", XS_Sys__Guestfs_get_recovery_proc, file, "$");
        (void)newXSproto_portable("Sys::Guestfs::get_selinux", XS_Sys__Guestfs_get_selinux, file, "$");
        (void)newXSproto_portable("Sys::Guestfs::get_smp", XS_Sys__Guestfs_get_smp, file, "$");
        (void)newXSproto_portable("Sys::Guestfs::get_sockdir", XS_Sys__Guestfs_get_sockdir, file, "$");
        (void)newXSproto_portable("Sys::Guestfs::get_state", XS_Sys__Guestfs_get_state, file, "$");
        (void)newXSproto_portable("Sys::Guestfs::get_tmpdir", XS_Sys__Guestfs_get_tmpdir, file, "$");
        (void)newXSproto_portable("Sys::Guestfs::get_trace", XS_Sys__Guestfs_get_trace, file, "$");
        (void)newXSproto_portable("Sys::Guestfs::get_umask", XS_Sys__Guestfs_get_umask, file, "$");
        (void)newXSproto_portable("Sys::Guestfs::get_verbose", XS_Sys__Guestfs_get_verbose, file, "$");
        (void)newXSproto_portable("Sys::Guestfs::getcon", XS_Sys__Guestfs_getcon, file, "$");
        (void)newXSproto_portable("Sys::Guestfs::getxattr", XS_Sys__Guestfs_getxattr, file, "$$$");
        (void)newXSproto_portable("Sys::Guestfs::getxattrs", XS_Sys__Guestfs_getxattrs, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::glob_expand", XS_Sys__Guestfs_glob_expand, file, "$$;@");
        (void)newXSproto_portable("Sys::Guestfs::grep", XS_Sys__Guestfs_grep, file, "$$$;@");
        (void)newXSproto_portable("Sys::Guestfs::grepi", XS_Sys__Guestfs_grepi, file, "$$$");
        (void)newXSproto_portable("Sys::Guestfs::grub_install", XS_Sys__Guestfs_grub_install, file, "$$$");
        (void)newXSproto_portable("Sys::Guestfs::head", XS_Sys__Guestfs_head, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::head_n", XS_Sys__Guestfs_head_n, file, "$$$");
        (void)newXSproto_portable("Sys::Guestfs::hexdump", XS_Sys__Guestfs_hexdump, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::hivex_close", XS_Sys__Guestfs_hivex_close, file, "$");
        (void)newXSproto_portable("Sys::Guestfs::hivex_commit", XS_Sys__Guestfs_hivex_commit, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::hivex_node_add_child", XS_Sys__Guestfs_hivex_node_add_child, file, "$$$");
        (void)newXSproto_portable("Sys::Guestfs::hivex_node_children", XS_Sys__Guestfs_hivex_node_children, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::hivex_node_delete_child", XS_Sys__Guestfs_hivex_node_delete_child, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::hivex_node_get_child", XS_Sys__Guestfs_hivex_node_get_child, file, "$$$");
        (void)newXSproto_portable("Sys::Guestfs::hivex_node_get_value", XS_Sys__Guestfs_hivex_node_get_value, file, "$$$");
        (void)newXSproto_portable("Sys::Guestfs::hivex_node_name", XS_Sys__Guestfs_hivex_node_name, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::hivex_node_parent", XS_Sys__Guestfs_hivex_node_parent, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::hivex_node_set_value", XS_Sys__Guestfs_hivex_node_set_value, file, "$$$$$");
        (void)newXSproto_portable("Sys::Guestfs::hivex_node_values", XS_Sys__Guestfs_hivex_node_values, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::hivex_open", XS_Sys__Guestfs_hivex_open, file, "$$;@");
        (void)newXSproto_portable("Sys::Guestfs::hivex_root", XS_Sys__Guestfs_hivex_root, file, "$");
        (void)newXSproto_portable("Sys::Guestfs::hivex_value_key", XS_Sys__Guestfs_hivex_value_key, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::hivex_value_string", XS_Sys__Guestfs_hivex_value_string, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::hivex_value_type", XS_Sys__Guestfs_hivex_value_type, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::hivex_value_utf8", XS_Sys__Guestfs_hivex_value_utf8, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::hivex_value_value", XS_Sys__Guestfs_hivex_value_value, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::initrd_cat", XS_Sys__Guestfs_initrd_cat, file, "$$$");
        (void)newXSproto_portable("Sys::Guestfs::initrd_list", XS_Sys__Guestfs_initrd_list, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::inotify_add_watch", XS_Sys__Guestfs_inotify_add_watch, file, "$$$");
        (void)newXSproto_portable("Sys::Guestfs::inotify_close", XS_Sys__Guestfs_inotify_close, file, "$");
        (void)newXSproto_portable("Sys::Guestfs::inotify_files", XS_Sys__Guestfs_inotify_files, file, "$");
        (void)newXSproto_portable("Sys::Guestfs::inotify_init", XS_Sys__Guestfs_inotify_init, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::inotify_read", XS_Sys__Guestfs_inotify_read, file, "$");
        (void)newXSproto_portable("Sys::Guestfs::inotify_rm_watch", XS_Sys__Guestfs_inotify_rm_watch, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::inspect_get_arch", XS_Sys__Guestfs_inspect_get_arch, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::inspect_get_build_id", XS_Sys__Guestfs_inspect_get_build_id, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::inspect_get_distro", XS_Sys__Guestfs_inspect_get_distro, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::inspect_get_drive_mappings", XS_Sys__Guestfs_inspect_get_drive_mappings, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::inspect_get_filesystems", XS_Sys__Guestfs_inspect_get_filesystems, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::inspect_get_format", XS_Sys__Guestfs_inspect_get_format, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::inspect_get_hostname", XS_Sys__Guestfs_inspect_get_hostname, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::inspect_get_icon", XS_Sys__Guestfs_inspect_get_icon, file, "$$;@");
        (void)newXSproto_portable("Sys::Guestfs::inspect_get_major_version", XS_Sys__Guestfs_inspect_get_major_version, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::inspect_get_minor_version", XS_Sys__Guestfs_inspect_get_minor_version, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::inspect_get_mountpoints", XS_Sys__Guestfs_inspect_get_mountpoints, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::inspect_get_osinfo", XS_Sys__Guestfs_inspect_get_osinfo, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::inspect_get_package_format", XS_Sys__Guestfs_inspect_get_package_format, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::inspect_get_package_management", XS_Sys__Guestfs_inspect_get_package_management, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::inspect_get_product_name", XS_Sys__Guestfs_inspect_get_product_name, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::inspect_get_product_variant", XS_Sys__Guestfs_inspect_get_product_variant, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::inspect_get_roots", XS_Sys__Guestfs_inspect_get_roots, file, "$");
        (void)newXSproto_portable("Sys::Guestfs::inspect_get_type", XS_Sys__Guestfs_inspect_get_type, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::inspect_get_windows_current_control_set", XS_Sys__Guestfs_inspect_get_windows_current_control_set, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::inspect_get_windows_software_hive", XS_Sys__Guestfs_inspect_get_windows_software_hive, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::inspect_get_windows_system_hive", XS_Sys__Guestfs_inspect_get_windows_system_hive, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::inspect_get_windows_systemroot", XS_Sys__Guestfs_inspect_get_windows_systemroot, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::inspect_is_live", XS_Sys__Guestfs_inspect_is_live, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::inspect_is_multipart", XS_Sys__Guestfs_inspect_is_multipart, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::inspect_is_netinst", XS_Sys__Guestfs_inspect_is_netinst, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::inspect_list_applications", XS_Sys__Guestfs_inspect_list_applications, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::inspect_list_applications2", XS_Sys__Guestfs_inspect_list_applications2, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::inspect_os", XS_Sys__Guestfs_inspect_os, file, "$");
        (void)newXSproto_portable("Sys::Guestfs::internal_exit", XS_Sys__Guestfs_internal_exit, file, "$");
        (void)newXSproto_portable("Sys::Guestfs::internal_test", XS_Sys__Guestfs_internal_test, file, "$$$$$$$$$$;@");
        (void)newXSproto_portable("Sys::Guestfs::internal_test_63_optargs", XS_Sys__Guestfs_internal_test_63_optargs, file, "$;@");
        (void)newXSproto_portable("Sys::Guestfs::internal_test_close_output", XS_Sys__Guestfs_internal_test_close_output, file, "$");
        (void)newXSproto_portable("Sys::Guestfs::internal_test_only_optargs", XS_Sys__Guestfs_internal_test_only_optargs, file, "$;@");
        (void)newXSproto_portable("Sys::Guestfs::internal_test_rbool", XS_Sys__Guestfs_internal_test_rbool, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::internal_test_rboolerr", XS_Sys__Guestfs_internal_test_rboolerr, file, "$");
        (void)newXSproto_portable("Sys::Guestfs::internal_test_rbufferout", XS_Sys__Guestfs_internal_test_rbufferout, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::internal_test_rbufferouterr", XS_Sys__Guestfs_internal_test_rbufferouterr, file, "$");
        (void)newXSproto_portable("Sys::Guestfs::internal_test_rconstoptstring", XS_Sys__Guestfs_internal_test_rconstoptstring, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::internal_test_rconstoptstringerr", XS_Sys__Guestfs_internal_test_rconstoptstringerr, file, "$");
        (void)newXSproto_portable("Sys::Guestfs::internal_test_rconststring", XS_Sys__Guestfs_internal_test_rconststring, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::internal_test_rconststringerr", XS_Sys__Guestfs_internal_test_rconststringerr, file, "$");
        (void)newXSproto_portable("Sys::Guestfs::internal_test_rhashtable", XS_Sys__Guestfs_internal_test_rhashtable, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::internal_test_rhashtableerr", XS_Sys__Guestfs_internal_test_rhashtableerr, file, "$");
        (void)newXSproto_portable("Sys::Guestfs::internal_test_rint", XS_Sys__Guestfs_internal_test_rint, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::internal_test_rint64", XS_Sys__Guestfs_internal_test_rint64, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::internal_test_rint64err", XS_Sys__Guestfs_internal_test_rint64err, file, "$");
        (void)newXSproto_portable("Sys::Guestfs::internal_test_rinterr", XS_Sys__Guestfs_internal_test_rinterr, file, "$");
        (void)newXSproto_portable("Sys::Guestfs::internal_test_rstring", XS_Sys__Guestfs_internal_test_rstring, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::internal_test_rstringerr", XS_Sys__Guestfs_internal_test_rstringerr, file, "$");
        (void)newXSproto_portable("Sys::Guestfs::internal_test_rstringlist", XS_Sys__Guestfs_internal_test_rstringlist, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::internal_test_rstringlisterr", XS_Sys__Guestfs_internal_test_rstringlisterr, file, "$");
        (void)newXSproto_portable("Sys::Guestfs::internal_test_rstruct", XS_Sys__Guestfs_internal_test_rstruct, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::internal_test_rstructerr", XS_Sys__Guestfs_internal_test_rstructerr, file, "$");
        (void)newXSproto_portable("Sys::Guestfs::internal_test_rstructlist", XS_Sys__Guestfs_internal_test_rstructlist, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::internal_test_rstructlisterr", XS_Sys__Guestfs_internal_test_rstructlisterr, file, "$");
        (void)newXSproto_portable("Sys::Guestfs::internal_test_set_output", XS_Sys__Guestfs_internal_test_set_output, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::is_blockdev", XS_Sys__Guestfs_is_blockdev, file, "$$;@");
        (void)newXSproto_portable("Sys::Guestfs::is_busy", XS_Sys__Guestfs_is_busy, file, "$");
        (void)newXSproto_portable("Sys::Guestfs::is_chardev", XS_Sys__Guestfs_is_chardev, file, "$$;@");
        (void)newXSproto_portable("Sys::Guestfs::is_config", XS_Sys__Guestfs_is_config, file, "$");
        (void)newXSproto_portable("Sys::Guestfs::is_dir", XS_Sys__Guestfs_is_dir, file, "$$;@");
        (void)newXSproto_portable("Sys::Guestfs::is_fifo", XS_Sys__Guestfs_is_fifo, file, "$$;@");
        (void)newXSproto_portable("Sys::Guestfs::is_file", XS_Sys__Guestfs_is_file, file, "$$;@");
        (void)newXSproto_portable("Sys::Guestfs::is_launching", XS_Sys__Guestfs_is_launching, file, "$");
        (void)newXSproto_portable("Sys::Guestfs::is_lv", XS_Sys__Guestfs_is_lv, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::is_ready", XS_Sys__Guestfs_is_ready, file, "$");
        (void)newXSproto_portable("Sys::Guestfs::is_socket", XS_Sys__Guestfs_is_socket, file, "$$;@");
        (void)newXSproto_portable("Sys::Guestfs::is_symlink", XS_Sys__Guestfs_is_symlink, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::is_whole_device", XS_Sys__Guestfs_is_whole_device, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::is_zero", XS_Sys__Guestfs_is_zero, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::is_zero_device", XS_Sys__Guestfs_is_zero_device, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::isoinfo", XS_Sys__Guestfs_isoinfo, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::isoinfo_device", XS_Sys__Guestfs_isoinfo_device, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::journal_close", XS_Sys__Guestfs_journal_close, file, "$");
        (void)newXSproto_portable("Sys::Guestfs::journal_get", XS_Sys__Guestfs_journal_get, file, "$");
        (void)newXSproto_portable("Sys::Guestfs::journal_get_data_threshold", XS_Sys__Guestfs_journal_get_data_threshold, file, "$");
        (void)newXSproto_portable("Sys::Guestfs::journal_get_realtime_usec", XS_Sys__Guestfs_journal_get_realtime_usec, file, "$");
        (void)newXSproto_portable("Sys::Guestfs::journal_next", XS_Sys__Guestfs_journal_next, file, "$");
        (void)newXSproto_portable("Sys::Guestfs::journal_open", XS_Sys__Guestfs_journal_open, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::journal_set_data_threshold", XS_Sys__Guestfs_journal_set_data_threshold, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::journal_skip", XS_Sys__Guestfs_journal_skip, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::kill_subprocess", XS_Sys__Guestfs_kill_subprocess, file, "$");
        (void)newXSproto_portable("Sys::Guestfs::launch", XS_Sys__Guestfs_launch, file, "$");
        (void)newXSproto_portable("Sys::Guestfs::lchown", XS_Sys__Guestfs_lchown, file, "$$$$");
        (void)newXSproto_portable("Sys::Guestfs::ldmtool_create_all", XS_Sys__Guestfs_ldmtool_create_all, file, "$");
        (void)newXSproto_portable("Sys::Guestfs::ldmtool_diskgroup_disks", XS_Sys__Guestfs_ldmtool_diskgroup_disks, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::ldmtool_diskgroup_name", XS_Sys__Guestfs_ldmtool_diskgroup_name, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::ldmtool_diskgroup_volumes", XS_Sys__Guestfs_ldmtool_diskgroup_volumes, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::ldmtool_remove_all", XS_Sys__Guestfs_ldmtool_remove_all, file, "$");
        (void)newXSproto_portable("Sys::Guestfs::ldmtool_scan", XS_Sys__Guestfs_ldmtool_scan, file, "$");
        (void)newXSproto_portable("Sys::Guestfs::ldmtool_scan_devices", XS_Sys__Guestfs_ldmtool_scan_devices, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::ldmtool_volume_hint", XS_Sys__Guestfs_ldmtool_volume_hint, file, "$$$");
        (void)newXSproto_portable("Sys::Guestfs::ldmtool_volume_partitions", XS_Sys__Guestfs_ldmtool_volume_partitions, file, "$$$");
        (void)newXSproto_portable("Sys::Guestfs::ldmtool_volume_type", XS_Sys__Guestfs_ldmtool_volume_type, file, "$$$");
        (void)newXSproto_portable("Sys::Guestfs::lgetxattr", XS_Sys__Guestfs_lgetxattr, file, "$$$");
        (void)newXSproto_portable("Sys::Guestfs::lgetxattrs", XS_Sys__Guestfs_lgetxattrs, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::list_9p", XS_Sys__Guestfs_list_9p, file, "$");
        (void)newXSproto_portable("Sys::Guestfs::list_devices", XS_Sys__Guestfs_list_devices, file, "$");
        (void)newXSproto_portable("Sys::Guestfs::list_disk_labels", XS_Sys__Guestfs_list_disk_labels, file, "$");
        (void)newXSproto_portable("Sys::Guestfs::list_dm_devices", XS_Sys__Guestfs_list_dm_devices, file, "$");
        (void)newXSproto_portable("Sys::Guestfs::list_filesystems", XS_Sys__Guestfs_list_filesystems, file, "$");
        (void)newXSproto_portable("Sys::Guestfs::list_ldm_partitions", XS_Sys__Guestfs_list_ldm_partitions, file, "$");
        (void)newXSproto_portable("Sys::Guestfs::list_ldm_volumes", XS_Sys__Guestfs_list_ldm_volumes, file, "$");
        (void)newXSproto_portable("Sys::Guestfs::list_md_devices", XS_Sys__Guestfs_list_md_devices, file, "$");
        (void)newXSproto_portable("Sys::Guestfs::list_partitions", XS_Sys__Guestfs_list_partitions, file, "$");
        (void)newXSproto_portable("Sys::Guestfs::ll", XS_Sys__Guestfs_ll, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::llz", XS_Sys__Guestfs_llz, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::ln", XS_Sys__Guestfs_ln, file, "$$$");
        (void)newXSproto_portable("Sys::Guestfs::ln_f", XS_Sys__Guestfs_ln_f, file, "$$$");
        (void)newXSproto_portable("Sys::Guestfs::ln_s", XS_Sys__Guestfs_ln_s, file, "$$$");
        (void)newXSproto_portable("Sys::Guestfs::ln_sf", XS_Sys__Guestfs_ln_sf, file, "$$$");
        (void)newXSproto_portable("Sys::Guestfs::lremovexattr", XS_Sys__Guestfs_lremovexattr, file, "$$$");
        (void)newXSproto_portable("Sys::Guestfs::ls", XS_Sys__Guestfs_ls, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::ls0", XS_Sys__Guestfs_ls0, file, "$$$");
        (void)newXSproto_portable("Sys::Guestfs::lsetxattr", XS_Sys__Guestfs_lsetxattr, file, "$$$$$");
        (void)newXSproto_portable("Sys::Guestfs::lstat", XS_Sys__Guestfs_lstat, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::lstatlist", XS_Sys__Guestfs_lstatlist, file, "$$$");
        (void)newXSproto_portable("Sys::Guestfs::lstatns", XS_Sys__Guestfs_lstatns, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::lstatnslist", XS_Sys__Guestfs_lstatnslist, file, "$$$");
        (void)newXSproto_portable("Sys::Guestfs::luks_add_key", XS_Sys__Guestfs_luks_add_key, file, "$$$$$");
        (void)newXSproto_portable("Sys::Guestfs::luks_close", XS_Sys__Guestfs_luks_close, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::luks_format", XS_Sys__Guestfs_luks_format, file, "$$$$");
        (void)newXSproto_portable("Sys::Guestfs::luks_format_cipher", XS_Sys__Guestfs_luks_format_cipher, file, "$$$$$");
        (void)newXSproto_portable("Sys::Guestfs::luks_kill_slot", XS_Sys__Guestfs_luks_kill_slot, file, "$$$$");
        (void)newXSproto_portable("Sys::Guestfs::luks_open", XS_Sys__Guestfs_luks_open, file, "$$$$");
        (void)newXSproto_portable("Sys::Guestfs::luks_open_ro", XS_Sys__Guestfs_luks_open_ro, file, "$$$$");
        (void)newXSproto_portable("Sys::Guestfs::luks_uuid", XS_Sys__Guestfs_luks_uuid, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::lvcreate", XS_Sys__Guestfs_lvcreate, file, "$$$$");
        (void)newXSproto_portable("Sys::Guestfs::lvcreate_free", XS_Sys__Guestfs_lvcreate_free, file, "$$$$");
        (void)newXSproto_portable("Sys::Guestfs::lvm_canonical_lv_name", XS_Sys__Guestfs_lvm_canonical_lv_name, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::lvm_clear_filter", XS_Sys__Guestfs_lvm_clear_filter, file, "$");
        (void)newXSproto_portable("Sys::Guestfs::lvm_remove_all", XS_Sys__Guestfs_lvm_remove_all, file, "$");
        (void)newXSproto_portable("Sys::Guestfs::lvm_scan", XS_Sys__Guestfs_lvm_scan, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::lvm_set_filter", XS_Sys__Guestfs_lvm_set_filter, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::lvremove", XS_Sys__Guestfs_lvremove, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::lvrename", XS_Sys__Guestfs_lvrename, file, "$$$");
        (void)newXSproto_portable("Sys::Guestfs::lvresize", XS_Sys__Guestfs_lvresize, file, "$$$");
        (void)newXSproto_portable("Sys::Guestfs::lvresize_free", XS_Sys__Guestfs_lvresize_free, file, "$$$");
        (void)newXSproto_portable("Sys::Guestfs::lvs", XS_Sys__Guestfs_lvs, file, "$");
        (void)newXSproto_portable("Sys::Guestfs::lvs_full", XS_Sys__Guestfs_lvs_full, file, "$");
        (void)newXSproto_portable("Sys::Guestfs::lvuuid", XS_Sys__Guestfs_lvuuid, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::lxattrlist", XS_Sys__Guestfs_lxattrlist, file, "$$$");
        (void)newXSproto_portable("Sys::Guestfs::max_disks", XS_Sys__Guestfs_max_disks, file, "$");
        (void)newXSproto_portable("Sys::Guestfs::md_create", XS_Sys__Guestfs_md_create, file, "$$$;@");
        (void)newXSproto_portable("Sys::Guestfs::md_detail", XS_Sys__Guestfs_md_detail, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::md_stat", XS_Sys__Guestfs_md_stat, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::md_stop", XS_Sys__Guestfs_md_stop, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::mkdir", XS_Sys__Guestfs_mkdir, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::mkdir_mode", XS_Sys__Guestfs_mkdir_mode, file, "$$$");
        (void)newXSproto_portable("Sys::Guestfs::mkdir_p", XS_Sys__Guestfs_mkdir_p, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::mkdtemp", XS_Sys__Guestfs_mkdtemp, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::mke2fs", XS_Sys__Guestfs_mke2fs, file, "$$;@");
        (void)newXSproto_portable("Sys::Guestfs::mke2fs_J", XS_Sys__Guestfs_mke2fs_J, file, "$$$$$");
        (void)newXSproto_portable("Sys::Guestfs::mke2fs_JL", XS_Sys__Guestfs_mke2fs_JL, file, "$$$$$");
        (void)newXSproto_portable("Sys::Guestfs::mke2fs_JU", XS_Sys__Guestfs_mke2fs_JU, file, "$$$$$");
        (void)newXSproto_portable("Sys::Guestfs::mke2journal", XS_Sys__Guestfs_mke2journal, file, "$$$");
        (void)newXSproto_portable("Sys::Guestfs::mke2journal_L", XS_Sys__Guestfs_mke2journal_L, file, "$$$$");
        (void)newXSproto_portable("Sys::Guestfs::mke2journal_U", XS_Sys__Guestfs_mke2journal_U, file, "$$$$");
        (void)newXSproto_portable("Sys::Guestfs::mkfifo", XS_Sys__Guestfs_mkfifo, file, "$$$");
        (void)newXSproto_portable("Sys::Guestfs::mkfs", XS_Sys__Guestfs_mkfs, file, "$$$;@");
        (void)newXSproto_portable("Sys::Guestfs::mkfs_b", XS_Sys__Guestfs_mkfs_b, file, "$$$$");
        (void)newXSproto_portable("Sys::Guestfs::mkfs_btrfs", XS_Sys__Guestfs_mkfs_btrfs, file, "$$;@");
        (void)newXSproto_portable("Sys::Guestfs::mklost_and_found", XS_Sys__Guestfs_mklost_and_found, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::mkmountpoint", XS_Sys__Guestfs_mkmountpoint, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::mknod", XS_Sys__Guestfs_mknod, file, "$$$$$");
        (void)newXSproto_portable("Sys::Guestfs::mknod_b", XS_Sys__Guestfs_mknod_b, file, "$$$$$");
        (void)newXSproto_portable("Sys::Guestfs::mknod_c", XS_Sys__Guestfs_mknod_c, file, "$$$$$");
        (void)newXSproto_portable("Sys::Guestfs::mksquashfs", XS_Sys__Guestfs_mksquashfs, file, "$$$;@");
        (void)newXSproto_portable("Sys::Guestfs::mkswap", XS_Sys__Guestfs_mkswap, file, "$$;@");
        (void)newXSproto_portable("Sys::Guestfs::mkswap_L", XS_Sys__Guestfs_mkswap_L, file, "$$$");
        (void)newXSproto_portable("Sys::Guestfs::mkswap_U", XS_Sys__Guestfs_mkswap_U, file, "$$$");
        (void)newXSproto_portable("Sys::Guestfs::mkswap_file", XS_Sys__Guestfs_mkswap_file, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::mktemp", XS_Sys__Guestfs_mktemp, file, "$$;@");
        (void)newXSproto_portable("Sys::Guestfs::modprobe", XS_Sys__Guestfs_modprobe, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::mount", XS_Sys__Guestfs_mount, file, "$$$");
        (void)newXSproto_portable("Sys::Guestfs::mount_9p", XS_Sys__Guestfs_mount_9p, file, "$$$;@");
        (void)newXSproto_portable("Sys::Guestfs::mount_local", XS_Sys__Guestfs_mount_local, file, "$$;@");
        (void)newXSproto_portable("Sys::Guestfs::mount_local_run", XS_Sys__Guestfs_mount_local_run, file, "$");
        (void)newXSproto_portable("Sys::Guestfs::mount_loop", XS_Sys__Guestfs_mount_loop, file, "$$$");
        (void)newXSproto_portable("Sys::Guestfs::mount_options", XS_Sys__Guestfs_mount_options, file, "$$$$");
        (void)newXSproto_portable("Sys::Guestfs::mount_ro", XS_Sys__Guestfs_mount_ro, file, "$$$");
        (void)newXSproto_portable("Sys::Guestfs::mount_vfs", XS_Sys__Guestfs_mount_vfs, file, "$$$$$");
        (void)newXSproto_portable("Sys::Guestfs::mountable_device", XS_Sys__Guestfs_mountable_device, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::mountable_subvolume", XS_Sys__Guestfs_mountable_subvolume, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::mountpoints", XS_Sys__Guestfs_mountpoints, file, "$");
        (void)newXSproto_portable("Sys::Guestfs::mounts", XS_Sys__Guestfs_mounts, file, "$");
        (void)newXSproto_portable("Sys::Guestfs::mv", XS_Sys__Guestfs_mv, file, "$$$");
        (void)newXSproto_portable("Sys::Guestfs::nr_devices", XS_Sys__Guestfs_nr_devices, file, "$");
        (void)newXSproto_portable("Sys::Guestfs::ntfs_3g_probe", XS_Sys__Guestfs_ntfs_3g_probe, file, "$$$");
        (void)newXSproto_portable("Sys::Guestfs::ntfscat_i", XS_Sys__Guestfs_ntfscat_i, file, "$$$$");
        (void)newXSproto_portable("Sys::Guestfs::ntfsclone_in", XS_Sys__Guestfs_ntfsclone_in, file, "$$$");
        (void)newXSproto_portable("Sys::Guestfs::ntfsclone_out", XS_Sys__Guestfs_ntfsclone_out, file, "$$$;@");
        (void)newXSproto_portable("Sys::Guestfs::ntfsfix", XS_Sys__Guestfs_ntfsfix, file, "$$;@");
        (void)newXSproto_portable("Sys::Guestfs::ntfsresize", XS_Sys__Guestfs_ntfsresize, file, "$$;@");
        (void)newXSproto_portable("Sys::Guestfs::ntfsresize_size", XS_Sys__Guestfs_ntfsresize_size, file, "$$$");
        (void)newXSproto_portable("Sys::Guestfs::parse_environment", XS_Sys__Guestfs_parse_environment, file, "$");
        (void)newXSproto_portable("Sys::Guestfs::parse_environment_list", XS_Sys__Guestfs_parse_environment_list, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::part_add", XS_Sys__Guestfs_part_add, file, "$$$$$");
        (void)newXSproto_portable("Sys::Guestfs::part_del", XS_Sys__Guestfs_part_del, file, "$$$");
        (void)newXSproto_portable("Sys::Guestfs::part_disk", XS_Sys__Guestfs_part_disk, file, "$$$");
        (void)newXSproto_portable("Sys::Guestfs::part_expand_gpt", XS_Sys__Guestfs_part_expand_gpt, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::part_get_bootable", XS_Sys__Guestfs_part_get_bootable, file, "$$$");
        (void)newXSproto_portable("Sys::Guestfs::part_get_disk_guid", XS_Sys__Guestfs_part_get_disk_guid, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::part_get_gpt_attributes", XS_Sys__Guestfs_part_get_gpt_attributes, file, "$$$");
        (void)newXSproto_portable("Sys::Guestfs::part_get_gpt_guid", XS_Sys__Guestfs_part_get_gpt_guid, file, "$$$");
        (void)newXSproto_portable("Sys::Guestfs::part_get_gpt_type", XS_Sys__Guestfs_part_get_gpt_type, file, "$$$");
        (void)newXSproto_portable("Sys::Guestfs::part_get_mbr_id", XS_Sys__Guestfs_part_get_mbr_id, file, "$$$");
        (void)newXSproto_portable("Sys::Guestfs::part_get_mbr_part_type", XS_Sys__Guestfs_part_get_mbr_part_type, file, "$$$");
        (void)newXSproto_portable("Sys::Guestfs::part_get_name", XS_Sys__Guestfs_part_get_name, file, "$$$");
        (void)newXSproto_portable("Sys::Guestfs::part_get_parttype", XS_Sys__Guestfs_part_get_parttype, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::part_init", XS_Sys__Guestfs_part_init, file, "$$$");
        (void)newXSproto_portable("Sys::Guestfs::part_list", XS_Sys__Guestfs_part_list, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::part_resize", XS_Sys__Guestfs_part_resize, file, "$$$$");
        (void)newXSproto_portable("Sys::Guestfs::part_set_bootable", XS_Sys__Guestfs_part_set_bootable, file, "$$$$");
        (void)newXSproto_portable("Sys::Guestfs::part_set_disk_guid", XS_Sys__Guestfs_part_set_disk_guid, file, "$$$");
        (void)newXSproto_portable("Sys::Guestfs::part_set_disk_guid_random", XS_Sys__Guestfs_part_set_disk_guid_random, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::part_set_gpt_attributes", XS_Sys__Guestfs_part_set_gpt_attributes, file, "$$$$");
        (void)newXSproto_portable("Sys::Guestfs::part_set_gpt_guid", XS_Sys__Guestfs_part_set_gpt_guid, file, "$$$$");
        (void)newXSproto_portable("Sys::Guestfs::part_set_gpt_type", XS_Sys__Guestfs_part_set_gpt_type, file, "$$$$");
        (void)newXSproto_portable("Sys::Guestfs::part_set_mbr_id", XS_Sys__Guestfs_part_set_mbr_id, file, "$$$$");
        (void)newXSproto_portable("Sys::Guestfs::part_set_name", XS_Sys__Guestfs_part_set_name, file, "$$$$");
        (void)newXSproto_portable("Sys::Guestfs::part_to_dev", XS_Sys__Guestfs_part_to_dev, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::part_to_partnum", XS_Sys__Guestfs_part_to_partnum, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::ping_daemon", XS_Sys__Guestfs_ping_daemon, file, "$");
        (void)newXSproto_portable("Sys::Guestfs::pread", XS_Sys__Guestfs_pread, file, "$$$$");
        (void)newXSproto_portable("Sys::Guestfs::pread_device", XS_Sys__Guestfs_pread_device, file, "$$$$");
        (void)newXSproto_portable("Sys::Guestfs::pvchange_uuid", XS_Sys__Guestfs_pvchange_uuid, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::pvchange_uuid_all", XS_Sys__Guestfs_pvchange_uuid_all, file, "$");
        (void)newXSproto_portable("Sys::Guestfs::pvcreate", XS_Sys__Guestfs_pvcreate, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::pvremove", XS_Sys__Guestfs_pvremove, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::pvresize", XS_Sys__Guestfs_pvresize, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::pvresize_size", XS_Sys__Guestfs_pvresize_size, file, "$$$");
        (void)newXSproto_portable("Sys::Guestfs::pvs", XS_Sys__Guestfs_pvs, file, "$");
        (void)newXSproto_portable("Sys::Guestfs::pvs_full", XS_Sys__Guestfs_pvs_full, file, "$");
        (void)newXSproto_portable("Sys::Guestfs::pvuuid", XS_Sys__Guestfs_pvuuid, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::pwrite", XS_Sys__Guestfs_pwrite, file, "$$$$");
        (void)newXSproto_portable("Sys::Guestfs::pwrite_device", XS_Sys__Guestfs_pwrite_device, file, "$$$$");
        (void)newXSproto_portable("Sys::Guestfs::read_file", XS_Sys__Guestfs_read_file, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::read_lines", XS_Sys__Guestfs_read_lines, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::readdir", XS_Sys__Guestfs_readdir, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::readlink", XS_Sys__Guestfs_readlink, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::readlinklist", XS_Sys__Guestfs_readlinklist, file, "$$$");
        (void)newXSproto_portable("Sys::Guestfs::realpath", XS_Sys__Guestfs_realpath, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::remount", XS_Sys__Guestfs_remount, file, "$$;@");
        (void)newXSproto_portable("Sys::Guestfs::remove_drive", XS_Sys__Guestfs_remove_drive, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::removexattr", XS_Sys__Guestfs_removexattr, file, "$$$");
        (void)newXSproto_portable("Sys::Guestfs::rename", XS_Sys__Guestfs_rename, file, "$$$");
        (void)newXSproto_portable("Sys::Guestfs::resize2fs", XS_Sys__Guestfs_resize2fs, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::resize2fs_M", XS_Sys__Guestfs_resize2fs_M, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::resize2fs_size", XS_Sys__Guestfs_resize2fs_size, file, "$$$");
        (void)newXSproto_portable("Sys::Guestfs::rm", XS_Sys__Guestfs_rm, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::rm_f", XS_Sys__Guestfs_rm_f, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::rm_rf", XS_Sys__Guestfs_rm_rf, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::rmdir", XS_Sys__Guestfs_rmdir, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::rmmountpoint", XS_Sys__Guestfs_rmmountpoint, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::rsync", XS_Sys__Guestfs_rsync, file, "$$$;@");
        (void)newXSproto_portable("Sys::Guestfs::rsync_in", XS_Sys__Guestfs_rsync_in, file, "$$$;@");
        (void)newXSproto_portable("Sys::Guestfs::rsync_out", XS_Sys__Guestfs_rsync_out, file, "$$$;@");
        (void)newXSproto_portable("Sys::Guestfs::scrub_device", XS_Sys__Guestfs_scrub_device, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::scrub_file", XS_Sys__Guestfs_scrub_file, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::scrub_freespace", XS_Sys__Guestfs_scrub_freespace, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::selinux_relabel", XS_Sys__Guestfs_selinux_relabel, file, "$$$;@");
        (void)newXSproto_portable("Sys::Guestfs::set_append", XS_Sys__Guestfs_set_append, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::set_attach_method", XS_Sys__Guestfs_set_attach_method, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::set_autosync", XS_Sys__Guestfs_set_autosync, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::set_backend", XS_Sys__Guestfs_set_backend, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::set_backend_setting", XS_Sys__Guestfs_set_backend_setting, file, "$$$");
        (void)newXSproto_portable("Sys::Guestfs::set_backend_settings", XS_Sys__Guestfs_set_backend_settings, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::set_cachedir", XS_Sys__Guestfs_set_cachedir, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::set_direct", XS_Sys__Guestfs_set_direct, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::set_e2attrs", XS_Sys__Guestfs_set_e2attrs, file, "$$$;@");
        (void)newXSproto_portable("Sys::Guestfs::set_e2generation", XS_Sys__Guestfs_set_e2generation, file, "$$$");
        (void)newXSproto_portable("Sys::Guestfs::set_e2label", XS_Sys__Guestfs_set_e2label, file, "$$$");
        (void)newXSproto_portable("Sys::Guestfs::set_e2uuid", XS_Sys__Guestfs_set_e2uuid, file, "$$$");
        (void)newXSproto_portable("Sys::Guestfs::set_hv", XS_Sys__Guestfs_set_hv, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::set_identifier", XS_Sys__Guestfs_set_identifier, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::set_label", XS_Sys__Guestfs_set_label, file, "$$$");
        (void)newXSproto_portable("Sys::Guestfs::set_libvirt_requested_credential", XS_Sys__Guestfs_set_libvirt_requested_credential, file, "$$$");
        (void)newXSproto_portable("Sys::Guestfs::set_libvirt_supported_credentials", XS_Sys__Guestfs_set_libvirt_supported_credentials, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::set_memsize", XS_Sys__Guestfs_set_memsize, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::set_network", XS_Sys__Guestfs_set_network, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::set_path", XS_Sys__Guestfs_set_path, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::set_pgroup", XS_Sys__Guestfs_set_pgroup, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::set_program", XS_Sys__Guestfs_set_program, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::set_qemu", XS_Sys__Guestfs_set_qemu, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::set_recovery_proc", XS_Sys__Guestfs_set_recovery_proc, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::set_selinux", XS_Sys__Guestfs_set_selinux, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::set_smp", XS_Sys__Guestfs_set_smp, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::set_tmpdir", XS_Sys__Guestfs_set_tmpdir, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::set_trace", XS_Sys__Guestfs_set_trace, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::set_uuid", XS_Sys__Guestfs_set_uuid, file, "$$$");
        (void)newXSproto_portable("Sys::Guestfs::set_uuid_random", XS_Sys__Guestfs_set_uuid_random, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::set_verbose", XS_Sys__Guestfs_set_verbose, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::setcon", XS_Sys__Guestfs_setcon, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::setxattr", XS_Sys__Guestfs_setxattr, file, "$$$$$");
        (void)newXSproto_portable("Sys::Guestfs::sfdisk", XS_Sys__Guestfs_sfdisk, file, "$$$$$$");
        (void)newXSproto_portable("Sys::Guestfs::sfdiskM", XS_Sys__Guestfs_sfdiskM, file, "$$$");
        (void)newXSproto_portable("Sys::Guestfs::sfdisk_N", XS_Sys__Guestfs_sfdisk_N, file, "$$$$$$$");
        (void)newXSproto_portable("Sys::Guestfs::sfdisk_disk_geometry", XS_Sys__Guestfs_sfdisk_disk_geometry, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::sfdisk_kernel_geometry", XS_Sys__Guestfs_sfdisk_kernel_geometry, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::sfdisk_l", XS_Sys__Guestfs_sfdisk_l, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::sh", XS_Sys__Guestfs_sh, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::sh_lines", XS_Sys__Guestfs_sh_lines, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::shutdown", XS_Sys__Guestfs_shutdown, file, "$");
        (void)newXSproto_portable("Sys::Guestfs::sleep", XS_Sys__Guestfs_sleep, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::stat", XS_Sys__Guestfs_stat, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::statns", XS_Sys__Guestfs_statns, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::statvfs", XS_Sys__Guestfs_statvfs, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::strings", XS_Sys__Guestfs_strings, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::strings_e", XS_Sys__Guestfs_strings_e, file, "$$$");
        (void)newXSproto_portable("Sys::Guestfs::swapoff_device", XS_Sys__Guestfs_swapoff_device, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::swapoff_file", XS_Sys__Guestfs_swapoff_file, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::swapoff_label", XS_Sys__Guestfs_swapoff_label, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::swapoff_uuid", XS_Sys__Guestfs_swapoff_uuid, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::swapon_device", XS_Sys__Guestfs_swapon_device, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::swapon_file", XS_Sys__Guestfs_swapon_file, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::swapon_label", XS_Sys__Guestfs_swapon_label, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::swapon_uuid", XS_Sys__Guestfs_swapon_uuid, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::sync", XS_Sys__Guestfs_sync, file, "$");
        (void)newXSproto_portable("Sys::Guestfs::syslinux", XS_Sys__Guestfs_syslinux, file, "$$;@");
        (void)newXSproto_portable("Sys::Guestfs::tail", XS_Sys__Guestfs_tail, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::tail_n", XS_Sys__Guestfs_tail_n, file, "$$$");
        (void)newXSproto_portable("Sys::Guestfs::tar_in", XS_Sys__Guestfs_tar_in, file, "$$$;@");
        (void)newXSproto_portable("Sys::Guestfs::tar_out", XS_Sys__Guestfs_tar_out, file, "$$$;@");
        (void)newXSproto_portable("Sys::Guestfs::tgz_in", XS_Sys__Guestfs_tgz_in, file, "$$$");
        (void)newXSproto_portable("Sys::Guestfs::tgz_out", XS_Sys__Guestfs_tgz_out, file, "$$$");
        (void)newXSproto_portable("Sys::Guestfs::touch", XS_Sys__Guestfs_touch, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::truncate", XS_Sys__Guestfs_truncate, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::truncate_size", XS_Sys__Guestfs_truncate_size, file, "$$$");
        (void)newXSproto_portable("Sys::Guestfs::tune2fs", XS_Sys__Guestfs_tune2fs, file, "$$;@");
        (void)newXSproto_portable("Sys::Guestfs::tune2fs_l", XS_Sys__Guestfs_tune2fs_l, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::txz_in", XS_Sys__Guestfs_txz_in, file, "$$$");
        (void)newXSproto_portable("Sys::Guestfs::txz_out", XS_Sys__Guestfs_txz_out, file, "$$$");
        (void)newXSproto_portable("Sys::Guestfs::umask", XS_Sys__Guestfs_umask, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::umount", XS_Sys__Guestfs_umount, file, "$$;@");
        (void)newXSproto_portable("Sys::Guestfs::umount_all", XS_Sys__Guestfs_umount_all, file, "$");
        (void)newXSproto_portable("Sys::Guestfs::umount_local", XS_Sys__Guestfs_umount_local, file, "$;@");
        (void)newXSproto_portable("Sys::Guestfs::upload", XS_Sys__Guestfs_upload, file, "$$$");
        (void)newXSproto_portable("Sys::Guestfs::upload_offset", XS_Sys__Guestfs_upload_offset, file, "$$$$");
        (void)newXSproto_portable("Sys::Guestfs::user_cancel", XS_Sys__Guestfs_user_cancel, file, "$");
        (void)newXSproto_portable("Sys::Guestfs::utimens", XS_Sys__Guestfs_utimens, file, "$$$$$$");
        (void)newXSproto_portable("Sys::Guestfs::utsname", XS_Sys__Guestfs_utsname, file, "$");
        (void)newXSproto_portable("Sys::Guestfs::version", XS_Sys__Guestfs_version, file, "$");
        (void)newXSproto_portable("Sys::Guestfs::vfs_label", XS_Sys__Guestfs_vfs_label, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::vfs_minimum_size", XS_Sys__Guestfs_vfs_minimum_size, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::vfs_type", XS_Sys__Guestfs_vfs_type, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::vfs_uuid", XS_Sys__Guestfs_vfs_uuid, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::vg_activate", XS_Sys__Guestfs_vg_activate, file, "$$$");
        (void)newXSproto_portable("Sys::Guestfs::vg_activate_all", XS_Sys__Guestfs_vg_activate_all, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::vgchange_uuid", XS_Sys__Guestfs_vgchange_uuid, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::vgchange_uuid_all", XS_Sys__Guestfs_vgchange_uuid_all, file, "$");
        (void)newXSproto_portable("Sys::Guestfs::vgcreate", XS_Sys__Guestfs_vgcreate, file, "$$$");
        (void)newXSproto_portable("Sys::Guestfs::vglvuuids", XS_Sys__Guestfs_vglvuuids, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::vgmeta", XS_Sys__Guestfs_vgmeta, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::vgpvuuids", XS_Sys__Guestfs_vgpvuuids, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::vgremove", XS_Sys__Guestfs_vgremove, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::vgrename", XS_Sys__Guestfs_vgrename, file, "$$$");
        (void)newXSproto_portable("Sys::Guestfs::vgs", XS_Sys__Guestfs_vgs, file, "$");
        (void)newXSproto_portable("Sys::Guestfs::vgs_full", XS_Sys__Guestfs_vgs_full, file, "$");
        (void)newXSproto_portable("Sys::Guestfs::vgscan", XS_Sys__Guestfs_vgscan, file, "$");
        (void)newXSproto_portable("Sys::Guestfs::vguuid", XS_Sys__Guestfs_vguuid, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::wait_ready", XS_Sys__Guestfs_wait_ready, file, "$");
        (void)newXSproto_portable("Sys::Guestfs::wc_c", XS_Sys__Guestfs_wc_c, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::wc_l", XS_Sys__Guestfs_wc_l, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::wc_w", XS_Sys__Guestfs_wc_w, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::wipefs", XS_Sys__Guestfs_wipefs, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::write", XS_Sys__Guestfs_write, file, "$$$");
        (void)newXSproto_portable("Sys::Guestfs::write_append", XS_Sys__Guestfs_write_append, file, "$$$");
        (void)newXSproto_portable("Sys::Guestfs::write_file", XS_Sys__Guestfs_write_file, file, "$$$$");
        (void)newXSproto_portable("Sys::Guestfs::xfs_admin", XS_Sys__Guestfs_xfs_admin, file, "$$;@");
        (void)newXSproto_portable("Sys::Guestfs::xfs_growfs", XS_Sys__Guestfs_xfs_growfs, file, "$$;@");
        (void)newXSproto_portable("Sys::Guestfs::xfs_info", XS_Sys__Guestfs_xfs_info, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::xfs_repair", XS_Sys__Guestfs_xfs_repair, file, "$$;@");
        (void)newXSproto_portable("Sys::Guestfs::yara_destroy", XS_Sys__Guestfs_yara_destroy, file, "$");
        (void)newXSproto_portable("Sys::Guestfs::yara_load", XS_Sys__Guestfs_yara_load, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::yara_scan", XS_Sys__Guestfs_yara_scan, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::zegrep", XS_Sys__Guestfs_zegrep, file, "$$$");
        (void)newXSproto_portable("Sys::Guestfs::zegrepi", XS_Sys__Guestfs_zegrepi, file, "$$$");
        (void)newXSproto_portable("Sys::Guestfs::zero", XS_Sys__Guestfs_zero, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::zero_device", XS_Sys__Guestfs_zero_device, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::zero_free_space", XS_Sys__Guestfs_zero_free_space, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::zerofree", XS_Sys__Guestfs_zerofree, file, "$$");
        (void)newXSproto_portable("Sys::Guestfs::zfgrep", XS_Sys__Guestfs_zfgrep, file, "$$$");
        (void)newXSproto_portable("Sys::Guestfs::zfgrepi", XS_Sys__Guestfs_zfgrepi, file, "$$$");
        (void)newXSproto_portable("Sys::Guestfs::zfile", XS_Sys__Guestfs_zfile, file, "$$$");
        (void)newXSproto_portable("Sys::Guestfs::zgrep", XS_Sys__Guestfs_zgrep, file, "$$$");
        (void)newXSproto_portable("Sys::Guestfs::zgrepi", XS_Sys__Guestfs_zgrepi, file, "$$$");
#if PERL_VERSION_LE(5, 21, 5)
#  if PERL_VERSION_GE(5, 9, 0)
    if (PL_unitcheckav)
        call_list(PL_scopestack_ix, PL_unitcheckav);
#  endif
    XSRETURN_YES;
#else
    Perl_xs_boot_epilog(aTHX_ ax);
#endif
}

#ifdef __cplusplus
}
#endif
